/* 
 * API Version: 5.0
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v5
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace IO.Swagger.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IDocumentsApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Retrieve Document File Links.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentFileLinkRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>DocumentFileLinkDetailsServiceReturnModel</returns>
        DocumentFileLinkDetailsServiceReturnModel GetDocumentFileLinks (DocumentFileLinkDetailsRequestModel documentFileLinkRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Retrieve Document File Links.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentFileLinkRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of DocumentFileLinkDetailsServiceReturnModel</returns>
        ApiResponse<DocumentFileLinkDetailsServiceReturnModel> GetDocumentFileLinksWithHttpInfo (DocumentFileLinkDetailsRequestModel documentFileLinkRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        /// <summary>
        /// Retrieve Document Files.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentFileRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>DocumentFileDetailsServiceReturnModel</returns>
        DocumentFileDetailsServiceReturnModel GetDocumentFiles (DocumentFileDetailsRequestModel documentFileRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Retrieve Document Files.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentFileRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of DocumentFileDetailsServiceReturnModel</returns>
        ApiResponse<DocumentFileDetailsServiceReturnModel> GetDocumentFilesWithHttpInfo (DocumentFileDetailsRequestModel documentFileRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        /// <summary>
        /// Retrieve Documents in TIFF Format.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentTiffRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>DocumentFileDetailsServiceReturnModel</returns>
        DocumentFileDetailsServiceReturnModel GetDocumentFilesInTiffFormat (DocumentTiffDetailsRequestModel documentTiffRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Retrieve Documents in TIFF Format.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentTiffRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of DocumentFileDetailsServiceReturnModel</returns>
        ApiResponse<DocumentFileDetailsServiceReturnModel> GetDocumentFilesInTiffFormatWithHttpInfo (DocumentTiffDetailsRequestModel documentTiffRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        /// <summary>
        /// Get an existing Document.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentRequestModel"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>DocumentDetailsServiceReturnModel</returns>
        DocumentDetailsServiceReturnModel GetDocuments (DocumentDetailsRequestModel documentRequestModel, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Get an existing Document.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentRequestModel"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of DocumentDetailsServiceReturnModel</returns>
        ApiResponse<DocumentDetailsServiceReturnModel> GetDocumentsWithHttpInfo (DocumentDetailsRequestModel documentRequestModel, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        /// <summary>
        /// Insert a Document.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentInsertRequestModel"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>DocumentDetailsServiceReturnModel</returns>
        DocumentDetailsServiceReturnModel InsertDocuments (DocumentInsertRequestModel documentInsertRequestModel, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Insert a Document.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentInsertRequestModel"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of DocumentDetailsServiceReturnModel</returns>
        ApiResponse<DocumentDetailsServiceReturnModel> InsertDocumentsWithHttpInfo (DocumentInsertRequestModel documentInsertRequestModel, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        /// <summary>
        /// Update Document Form Fields.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentUpdateFormFieldsRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>DefaultServiceReturnModel</returns>
        DefaultServiceReturnModel UpdateDocumentFormFields (DocumentUpdateFormFieldsRequestModel documentUpdateFormFieldsRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Update Document Form Fields.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentUpdateFormFieldsRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of DefaultServiceReturnModel</returns>
        ApiResponse<DefaultServiceReturnModel> UpdateDocumentFormFieldsWithHttpInfo (DocumentUpdateFormFieldsRequestModel documentUpdateFormFieldsRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        /// <summary>
        /// Update Document Text Stamps.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentUpdateTextStampsRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>DefaultServiceReturnModel</returns>
        DefaultServiceReturnModel UpdateDocumentTextStamps (DocumentUpdateTextStampsRequestModel documentUpdateTextStampsRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Update Document Text Stamps.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentUpdateTextStampsRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of DefaultServiceReturnModel</returns>
        ApiResponse<DefaultServiceReturnModel> UpdateDocumentTextStampsWithHttpInfo (DocumentUpdateTextStampsRequestModel documentUpdateTextStampsRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        /// <summary>
        /// Update an existing Document.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentUpdateRequestModel"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>DefaultServiceReturnModel</returns>
        DefaultServiceReturnModel UpdateDocuments (DocumentUpdateRequestModel documentUpdateRequestModel, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Update an existing Document.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentUpdateRequestModel"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of DefaultServiceReturnModel</returns>
        ApiResponse<DefaultServiceReturnModel> UpdateDocumentsWithHttpInfo (DocumentUpdateRequestModel documentUpdateRequestModel, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        /// <summary>
        /// Update Documents Completed.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentCompletedUpdateRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>DefaultServiceReturnModel</returns>
        DefaultServiceReturnModel UpdateDocumentsCompleted (DocumentCompletedUpdateRequestModel documentCompletedUpdateRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Update Documents Completed.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentCompletedUpdateRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of DefaultServiceReturnModel</returns>
        ApiResponse<DefaultServiceReturnModel> UpdateDocumentsCompletedWithHttpInfo (DocumentCompletedUpdateRequestModel documentCompletedUpdateRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        /// <summary>
        /// Verify Completed Document Authenticity.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentVerifyRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>DocumentVerificationServiceReturnModel</returns>
        DocumentVerificationServiceReturnModel VerifyCompletedDocumentsAuthenticity (DocumentVerifyRequestModel documentVerifyRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Verify Completed Document Authenticity.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentVerifyRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of DocumentVerificationServiceReturnModel</returns>
        ApiResponse<DocumentVerificationServiceReturnModel> VerifyCompletedDocumentsAuthenticityWithHttpInfo (DocumentVerifyRequestModel documentVerifyRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        /// <summary>
        /// Void an existing Document.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentVoidRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>DefaultServiceReturnModel</returns>
        DefaultServiceReturnModel VoidDocuments (DocumentVoidRequestModel documentVoidRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Void an existing Document.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentVoidRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of DefaultServiceReturnModel</returns>
        ApiResponse<DefaultServiceReturnModel> VoidDocumentsWithHttpInfo (DocumentVoidRequestModel documentVoidRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Retrieve Document File Links.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentFileLinkRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of DocumentFileLinkDetailsServiceReturnModel</returns>
        System.Threading.Tasks.Task<DocumentFileLinkDetailsServiceReturnModel> GetDocumentFileLinksAsync (DocumentFileLinkDetailsRequestModel documentFileLinkRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Retrieve Document File Links.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentFileLinkRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (DocumentFileLinkDetailsServiceReturnModel)</returns>
        System.Threading.Tasks.Task<ApiResponse<DocumentFileLinkDetailsServiceReturnModel>> GetDocumentFileLinksAsyncWithHttpInfo (DocumentFileLinkDetailsRequestModel documentFileLinkRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        /// <summary>
        /// Retrieve Document Files.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentFileRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of DocumentFileDetailsServiceReturnModel</returns>
        System.Threading.Tasks.Task<DocumentFileDetailsServiceReturnModel> GetDocumentFilesAsync (DocumentFileDetailsRequestModel documentFileRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Retrieve Document Files.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentFileRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (DocumentFileDetailsServiceReturnModel)</returns>
        System.Threading.Tasks.Task<ApiResponse<DocumentFileDetailsServiceReturnModel>> GetDocumentFilesAsyncWithHttpInfo (DocumentFileDetailsRequestModel documentFileRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        /// <summary>
        /// Retrieve Documents in TIFF Format.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentTiffRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of DocumentFileDetailsServiceReturnModel</returns>
        System.Threading.Tasks.Task<DocumentFileDetailsServiceReturnModel> GetDocumentFilesInTiffFormatAsync (DocumentTiffDetailsRequestModel documentTiffRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Retrieve Documents in TIFF Format.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentTiffRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (DocumentFileDetailsServiceReturnModel)</returns>
        System.Threading.Tasks.Task<ApiResponse<DocumentFileDetailsServiceReturnModel>> GetDocumentFilesInTiffFormatAsyncWithHttpInfo (DocumentTiffDetailsRequestModel documentTiffRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        /// <summary>
        /// Get an existing Document.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentRequestModel"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of DocumentDetailsServiceReturnModel</returns>
        System.Threading.Tasks.Task<DocumentDetailsServiceReturnModel> GetDocumentsAsync (DocumentDetailsRequestModel documentRequestModel, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Get an existing Document.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentRequestModel"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (DocumentDetailsServiceReturnModel)</returns>
        System.Threading.Tasks.Task<ApiResponse<DocumentDetailsServiceReturnModel>> GetDocumentsAsyncWithHttpInfo (DocumentDetailsRequestModel documentRequestModel, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        /// <summary>
        /// Insert a Document.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentInsertRequestModel"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of DocumentDetailsServiceReturnModel</returns>
        System.Threading.Tasks.Task<DocumentDetailsServiceReturnModel> InsertDocumentsAsync (DocumentInsertRequestModel documentInsertRequestModel, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Insert a Document.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentInsertRequestModel"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (DocumentDetailsServiceReturnModel)</returns>
        System.Threading.Tasks.Task<ApiResponse<DocumentDetailsServiceReturnModel>> InsertDocumentsAsyncWithHttpInfo (DocumentInsertRequestModel documentInsertRequestModel, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        /// <summary>
        /// Update Document Form Fields.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentUpdateFormFieldsRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of DefaultServiceReturnModel</returns>
        System.Threading.Tasks.Task<DefaultServiceReturnModel> UpdateDocumentFormFieldsAsync (DocumentUpdateFormFieldsRequestModel documentUpdateFormFieldsRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Update Document Form Fields.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentUpdateFormFieldsRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (DefaultServiceReturnModel)</returns>
        System.Threading.Tasks.Task<ApiResponse<DefaultServiceReturnModel>> UpdateDocumentFormFieldsAsyncWithHttpInfo (DocumentUpdateFormFieldsRequestModel documentUpdateFormFieldsRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        /// <summary>
        /// Update Document Text Stamps.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentUpdateTextStampsRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of DefaultServiceReturnModel</returns>
        System.Threading.Tasks.Task<DefaultServiceReturnModel> UpdateDocumentTextStampsAsync (DocumentUpdateTextStampsRequestModel documentUpdateTextStampsRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Update Document Text Stamps.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentUpdateTextStampsRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (DefaultServiceReturnModel)</returns>
        System.Threading.Tasks.Task<ApiResponse<DefaultServiceReturnModel>> UpdateDocumentTextStampsAsyncWithHttpInfo (DocumentUpdateTextStampsRequestModel documentUpdateTextStampsRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        /// <summary>
        /// Update an existing Document.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentUpdateRequestModel"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of DefaultServiceReturnModel</returns>
        System.Threading.Tasks.Task<DefaultServiceReturnModel> UpdateDocumentsAsync (DocumentUpdateRequestModel documentUpdateRequestModel, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Update an existing Document.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentUpdateRequestModel"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (DefaultServiceReturnModel)</returns>
        System.Threading.Tasks.Task<ApiResponse<DefaultServiceReturnModel>> UpdateDocumentsAsyncWithHttpInfo (DocumentUpdateRequestModel documentUpdateRequestModel, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        /// <summary>
        /// Update Documents Completed.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentCompletedUpdateRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of DefaultServiceReturnModel</returns>
        System.Threading.Tasks.Task<DefaultServiceReturnModel> UpdateDocumentsCompletedAsync (DocumentCompletedUpdateRequestModel documentCompletedUpdateRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Update Documents Completed.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentCompletedUpdateRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (DefaultServiceReturnModel)</returns>
        System.Threading.Tasks.Task<ApiResponse<DefaultServiceReturnModel>> UpdateDocumentsCompletedAsyncWithHttpInfo (DocumentCompletedUpdateRequestModel documentCompletedUpdateRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        /// <summary>
        /// Verify Completed Document Authenticity.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentVerifyRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of DocumentVerificationServiceReturnModel</returns>
        System.Threading.Tasks.Task<DocumentVerificationServiceReturnModel> VerifyCompletedDocumentsAuthenticityAsync (DocumentVerifyRequestModel documentVerifyRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Verify Completed Document Authenticity.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentVerifyRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (DocumentVerificationServiceReturnModel)</returns>
        System.Threading.Tasks.Task<ApiResponse<DocumentVerificationServiceReturnModel>> VerifyCompletedDocumentsAuthenticityAsyncWithHttpInfo (DocumentVerifyRequestModel documentVerifyRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        /// <summary>
        /// Void an existing Document.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentVoidRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of DefaultServiceReturnModel</returns>
        System.Threading.Tasks.Task<DefaultServiceReturnModel> VoidDocumentsAsync (DocumentVoidRequestModel documentVoidRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Void an existing Document.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentVoidRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (DefaultServiceReturnModel)</returns>
        System.Threading.Tasks.Task<ApiResponse<DefaultServiceReturnModel>> VoidDocumentsAsyncWithHttpInfo (DocumentVoidRequestModel documentVoidRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public partial class DocumentsApi : IDocumentsApi
    {
        private IO.Swagger.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="DocumentsApi"/> class.
        /// </summary>
        /// <returns></returns>
        public DocumentsApi(String basePath)
        {
            this.Configuration = new IO.Swagger.Client.Configuration { BasePath = basePath };

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="DocumentsApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public DocumentsApi(IO.Swagger.Client.Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = IO.Swagger.Client.Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public IO.Swagger.Client.Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public IO.Swagger.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Retrieve Document File Links. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentFileLinkRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>DocumentFileLinkDetailsServiceReturnModel</returns>
        public DocumentFileLinkDetailsServiceReturnModel GetDocumentFileLinks (DocumentFileLinkDetailsRequestModel documentFileLinkRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<DocumentFileLinkDetailsServiceReturnModel> localVarResponse = GetDocumentFileLinksWithHttpInfo(documentFileLinkRequest, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Retrieve Document File Links. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentFileLinkRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of DocumentFileLinkDetailsServiceReturnModel</returns>
        public ApiResponse< DocumentFileLinkDetailsServiceReturnModel > GetDocumentFileLinksWithHttpInfo (DocumentFileLinkDetailsRequestModel documentFileLinkRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'documentFileLinkRequest' is set
            if (documentFileLinkRequest == null)
                throw new ApiException(400, "Missing required parameter 'documentFileLinkRequest' when calling DocumentsApi->GetDocumentFileLinks");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling DocumentsApi->GetDocumentFileLinks");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling DocumentsApi->GetDocumentFileLinks");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling DocumentsApi->GetDocumentFileLinks");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling DocumentsApi->GetDocumentFileLinks");

            var localVarPath = "/api/v5/documents/filelinks";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (documentFileLinkRequest != null && documentFileLinkRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(documentFileLinkRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = documentFileLinkRequest; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetDocumentFileLinks", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<DocumentFileLinkDetailsServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (DocumentFileLinkDetailsServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(DocumentFileLinkDetailsServiceReturnModel)));
        }

        /// <summary>
        /// Retrieve Document File Links. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentFileLinkRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of DocumentFileLinkDetailsServiceReturnModel</returns>
        public async System.Threading.Tasks.Task<DocumentFileLinkDetailsServiceReturnModel> GetDocumentFileLinksAsync (DocumentFileLinkDetailsRequestModel documentFileLinkRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<DocumentFileLinkDetailsServiceReturnModel> localVarResponse = await GetDocumentFileLinksAsyncWithHttpInfo(documentFileLinkRequest, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Retrieve Document File Links. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentFileLinkRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (DocumentFileLinkDetailsServiceReturnModel)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<DocumentFileLinkDetailsServiceReturnModel>> GetDocumentFileLinksAsyncWithHttpInfo (DocumentFileLinkDetailsRequestModel documentFileLinkRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'documentFileLinkRequest' is set
            if (documentFileLinkRequest == null)
                throw new ApiException(400, "Missing required parameter 'documentFileLinkRequest' when calling DocumentsApi->GetDocumentFileLinks");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling DocumentsApi->GetDocumentFileLinks");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling DocumentsApi->GetDocumentFileLinks");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling DocumentsApi->GetDocumentFileLinks");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling DocumentsApi->GetDocumentFileLinks");

            var localVarPath = "/api/v5/documents/filelinks";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (documentFileLinkRequest != null && documentFileLinkRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(documentFileLinkRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = documentFileLinkRequest; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetDocumentFileLinks", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<DocumentFileLinkDetailsServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (DocumentFileLinkDetailsServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(DocumentFileLinkDetailsServiceReturnModel)));
        }

        /// <summary>
        /// Retrieve Document Files. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentFileRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>DocumentFileDetailsServiceReturnModel</returns>
        public DocumentFileDetailsServiceReturnModel GetDocumentFiles (DocumentFileDetailsRequestModel documentFileRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<DocumentFileDetailsServiceReturnModel> localVarResponse = GetDocumentFilesWithHttpInfo(documentFileRequest, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Retrieve Document Files. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentFileRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of DocumentFileDetailsServiceReturnModel</returns>
        public ApiResponse< DocumentFileDetailsServiceReturnModel > GetDocumentFilesWithHttpInfo (DocumentFileDetailsRequestModel documentFileRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'documentFileRequest' is set
            if (documentFileRequest == null)
                throw new ApiException(400, "Missing required parameter 'documentFileRequest' when calling DocumentsApi->GetDocumentFiles");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling DocumentsApi->GetDocumentFiles");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling DocumentsApi->GetDocumentFiles");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling DocumentsApi->GetDocumentFiles");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling DocumentsApi->GetDocumentFiles");

            var localVarPath = "/api/v5/documents/files";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (documentFileRequest != null && documentFileRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(documentFileRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = documentFileRequest; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetDocumentFiles", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<DocumentFileDetailsServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (DocumentFileDetailsServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(DocumentFileDetailsServiceReturnModel)));
        }

        /// <summary>
        /// Retrieve Document Files. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentFileRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of DocumentFileDetailsServiceReturnModel</returns>
        public async System.Threading.Tasks.Task<DocumentFileDetailsServiceReturnModel> GetDocumentFilesAsync (DocumentFileDetailsRequestModel documentFileRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<DocumentFileDetailsServiceReturnModel> localVarResponse = await GetDocumentFilesAsyncWithHttpInfo(documentFileRequest, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Retrieve Document Files. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentFileRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (DocumentFileDetailsServiceReturnModel)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<DocumentFileDetailsServiceReturnModel>> GetDocumentFilesAsyncWithHttpInfo (DocumentFileDetailsRequestModel documentFileRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'documentFileRequest' is set
            if (documentFileRequest == null)
                throw new ApiException(400, "Missing required parameter 'documentFileRequest' when calling DocumentsApi->GetDocumentFiles");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling DocumentsApi->GetDocumentFiles");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling DocumentsApi->GetDocumentFiles");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling DocumentsApi->GetDocumentFiles");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling DocumentsApi->GetDocumentFiles");

            var localVarPath = "/api/v5/documents/files";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (documentFileRequest != null && documentFileRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(documentFileRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = documentFileRequest; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetDocumentFiles", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<DocumentFileDetailsServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (DocumentFileDetailsServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(DocumentFileDetailsServiceReturnModel)));
        }

        /// <summary>
        /// Retrieve Documents in TIFF Format. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentTiffRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>DocumentFileDetailsServiceReturnModel</returns>
        public DocumentFileDetailsServiceReturnModel GetDocumentFilesInTiffFormat (DocumentTiffDetailsRequestModel documentTiffRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<DocumentFileDetailsServiceReturnModel> localVarResponse = GetDocumentFilesInTiffFormatWithHttpInfo(documentTiffRequest, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Retrieve Documents in TIFF Format. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentTiffRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of DocumentFileDetailsServiceReturnModel</returns>
        public ApiResponse< DocumentFileDetailsServiceReturnModel > GetDocumentFilesInTiffFormatWithHttpInfo (DocumentTiffDetailsRequestModel documentTiffRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'documentTiffRequest' is set
            if (documentTiffRequest == null)
                throw new ApiException(400, "Missing required parameter 'documentTiffRequest' when calling DocumentsApi->GetDocumentFilesInTiffFormat");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling DocumentsApi->GetDocumentFilesInTiffFormat");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling DocumentsApi->GetDocumentFilesInTiffFormat");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling DocumentsApi->GetDocumentFilesInTiffFormat");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling DocumentsApi->GetDocumentFilesInTiffFormat");

            var localVarPath = "/api/v5/documents/tiffformat";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (documentTiffRequest != null && documentTiffRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(documentTiffRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = documentTiffRequest; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetDocumentFilesInTiffFormat", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<DocumentFileDetailsServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (DocumentFileDetailsServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(DocumentFileDetailsServiceReturnModel)));
        }

        /// <summary>
        /// Retrieve Documents in TIFF Format. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentTiffRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of DocumentFileDetailsServiceReturnModel</returns>
        public async System.Threading.Tasks.Task<DocumentFileDetailsServiceReturnModel> GetDocumentFilesInTiffFormatAsync (DocumentTiffDetailsRequestModel documentTiffRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<DocumentFileDetailsServiceReturnModel> localVarResponse = await GetDocumentFilesInTiffFormatAsyncWithHttpInfo(documentTiffRequest, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Retrieve Documents in TIFF Format. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentTiffRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (DocumentFileDetailsServiceReturnModel)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<DocumentFileDetailsServiceReturnModel>> GetDocumentFilesInTiffFormatAsyncWithHttpInfo (DocumentTiffDetailsRequestModel documentTiffRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'documentTiffRequest' is set
            if (documentTiffRequest == null)
                throw new ApiException(400, "Missing required parameter 'documentTiffRequest' when calling DocumentsApi->GetDocumentFilesInTiffFormat");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling DocumentsApi->GetDocumentFilesInTiffFormat");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling DocumentsApi->GetDocumentFilesInTiffFormat");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling DocumentsApi->GetDocumentFilesInTiffFormat");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling DocumentsApi->GetDocumentFilesInTiffFormat");

            var localVarPath = "/api/v5/documents/tiffformat";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (documentTiffRequest != null && documentTiffRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(documentTiffRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = documentTiffRequest; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetDocumentFilesInTiffFormat", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<DocumentFileDetailsServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (DocumentFileDetailsServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(DocumentFileDetailsServiceReturnModel)));
        }

        /// <summary>
        /// Get an existing Document. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentRequestModel"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>DocumentDetailsServiceReturnModel</returns>
        public DocumentDetailsServiceReturnModel GetDocuments (DocumentDetailsRequestModel documentRequestModel, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<DocumentDetailsServiceReturnModel> localVarResponse = GetDocumentsWithHttpInfo(documentRequestModel, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get an existing Document. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentRequestModel"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of DocumentDetailsServiceReturnModel</returns>
        public ApiResponse< DocumentDetailsServiceReturnModel > GetDocumentsWithHttpInfo (DocumentDetailsRequestModel documentRequestModel, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'documentRequestModel' is set
            if (documentRequestModel == null)
                throw new ApiException(400, "Missing required parameter 'documentRequestModel' when calling DocumentsApi->GetDocuments");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling DocumentsApi->GetDocuments");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling DocumentsApi->GetDocuments");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling DocumentsApi->GetDocuments");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling DocumentsApi->GetDocuments");

            var localVarPath = "/api/v5/documents";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (documentRequestModel != null && documentRequestModel.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(documentRequestModel); // http body (model) parameter
            }
            else
            {
                localVarPostBody = documentRequestModel; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetDocuments", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<DocumentDetailsServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (DocumentDetailsServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(DocumentDetailsServiceReturnModel)));
        }

        /// <summary>
        /// Get an existing Document. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentRequestModel"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of DocumentDetailsServiceReturnModel</returns>
        public async System.Threading.Tasks.Task<DocumentDetailsServiceReturnModel> GetDocumentsAsync (DocumentDetailsRequestModel documentRequestModel, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<DocumentDetailsServiceReturnModel> localVarResponse = await GetDocumentsAsyncWithHttpInfo(documentRequestModel, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get an existing Document. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentRequestModel"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (DocumentDetailsServiceReturnModel)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<DocumentDetailsServiceReturnModel>> GetDocumentsAsyncWithHttpInfo (DocumentDetailsRequestModel documentRequestModel, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'documentRequestModel' is set
            if (documentRequestModel == null)
                throw new ApiException(400, "Missing required parameter 'documentRequestModel' when calling DocumentsApi->GetDocuments");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling DocumentsApi->GetDocuments");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling DocumentsApi->GetDocuments");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling DocumentsApi->GetDocuments");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling DocumentsApi->GetDocuments");

            var localVarPath = "/api/v5/documents";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (documentRequestModel != null && documentRequestModel.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(documentRequestModel); // http body (model) parameter
            }
            else
            {
                localVarPostBody = documentRequestModel; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetDocuments", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<DocumentDetailsServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (DocumentDetailsServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(DocumentDetailsServiceReturnModel)));
        }

        /// <summary>
        /// Insert a Document. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentInsertRequestModel"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>DocumentDetailsServiceReturnModel</returns>
        public DocumentDetailsServiceReturnModel InsertDocuments (DocumentInsertRequestModel documentInsertRequestModel, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<DocumentDetailsServiceReturnModel> localVarResponse = InsertDocumentsWithHttpInfo(documentInsertRequestModel, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Insert a Document. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentInsertRequestModel"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of DocumentDetailsServiceReturnModel</returns>
        public ApiResponse< DocumentDetailsServiceReturnModel > InsertDocumentsWithHttpInfo (DocumentInsertRequestModel documentInsertRequestModel, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'documentInsertRequestModel' is set
            if (documentInsertRequestModel == null)
                throw new ApiException(400, "Missing required parameter 'documentInsertRequestModel' when calling DocumentsApi->InsertDocuments");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling DocumentsApi->InsertDocuments");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling DocumentsApi->InsertDocuments");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling DocumentsApi->InsertDocuments");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling DocumentsApi->InsertDocuments");

            var localVarPath = "/api/v5/documents/insert";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (documentInsertRequestModel != null && documentInsertRequestModel.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(documentInsertRequestModel); // http body (model) parameter
            }
            else
            {
                localVarPostBody = documentInsertRequestModel; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("InsertDocuments", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<DocumentDetailsServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (DocumentDetailsServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(DocumentDetailsServiceReturnModel)));
        }

        /// <summary>
        /// Insert a Document. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentInsertRequestModel"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of DocumentDetailsServiceReturnModel</returns>
        public async System.Threading.Tasks.Task<DocumentDetailsServiceReturnModel> InsertDocumentsAsync (DocumentInsertRequestModel documentInsertRequestModel, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<DocumentDetailsServiceReturnModel> localVarResponse = await InsertDocumentsAsyncWithHttpInfo(documentInsertRequestModel, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Insert a Document. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentInsertRequestModel"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (DocumentDetailsServiceReturnModel)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<DocumentDetailsServiceReturnModel>> InsertDocumentsAsyncWithHttpInfo (DocumentInsertRequestModel documentInsertRequestModel, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'documentInsertRequestModel' is set
            if (documentInsertRequestModel == null)
                throw new ApiException(400, "Missing required parameter 'documentInsertRequestModel' when calling DocumentsApi->InsertDocuments");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling DocumentsApi->InsertDocuments");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling DocumentsApi->InsertDocuments");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling DocumentsApi->InsertDocuments");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling DocumentsApi->InsertDocuments");

            var localVarPath = "/api/v5/documents/insert";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (documentInsertRequestModel != null && documentInsertRequestModel.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(documentInsertRequestModel); // http body (model) parameter
            }
            else
            {
                localVarPostBody = documentInsertRequestModel; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("InsertDocuments", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<DocumentDetailsServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (DocumentDetailsServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(DocumentDetailsServiceReturnModel)));
        }

        /// <summary>
        /// Update Document Form Fields. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentUpdateFormFieldsRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>DefaultServiceReturnModel</returns>
        public DefaultServiceReturnModel UpdateDocumentFormFields (DocumentUpdateFormFieldsRequestModel documentUpdateFormFieldsRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<DefaultServiceReturnModel> localVarResponse = UpdateDocumentFormFieldsWithHttpInfo(documentUpdateFormFieldsRequest, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Update Document Form Fields. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentUpdateFormFieldsRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of DefaultServiceReturnModel</returns>
        public ApiResponse< DefaultServiceReturnModel > UpdateDocumentFormFieldsWithHttpInfo (DocumentUpdateFormFieldsRequestModel documentUpdateFormFieldsRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'documentUpdateFormFieldsRequest' is set
            if (documentUpdateFormFieldsRequest == null)
                throw new ApiException(400, "Missing required parameter 'documentUpdateFormFieldsRequest' when calling DocumentsApi->UpdateDocumentFormFields");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling DocumentsApi->UpdateDocumentFormFields");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling DocumentsApi->UpdateDocumentFormFields");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling DocumentsApi->UpdateDocumentFormFields");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling DocumentsApi->UpdateDocumentFormFields");

            var localVarPath = "/api/v5/documents/formfields";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (documentUpdateFormFieldsRequest != null && documentUpdateFormFieldsRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(documentUpdateFormFieldsRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = documentUpdateFormFieldsRequest; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UpdateDocumentFormFields", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<DefaultServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (DefaultServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(DefaultServiceReturnModel)));
        }

        /// <summary>
        /// Update Document Form Fields. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentUpdateFormFieldsRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of DefaultServiceReturnModel</returns>
        public async System.Threading.Tasks.Task<DefaultServiceReturnModel> UpdateDocumentFormFieldsAsync (DocumentUpdateFormFieldsRequestModel documentUpdateFormFieldsRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<DefaultServiceReturnModel> localVarResponse = await UpdateDocumentFormFieldsAsyncWithHttpInfo(documentUpdateFormFieldsRequest, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Update Document Form Fields. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentUpdateFormFieldsRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (DefaultServiceReturnModel)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<DefaultServiceReturnModel>> UpdateDocumentFormFieldsAsyncWithHttpInfo (DocumentUpdateFormFieldsRequestModel documentUpdateFormFieldsRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'documentUpdateFormFieldsRequest' is set
            if (documentUpdateFormFieldsRequest == null)
                throw new ApiException(400, "Missing required parameter 'documentUpdateFormFieldsRequest' when calling DocumentsApi->UpdateDocumentFormFields");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling DocumentsApi->UpdateDocumentFormFields");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling DocumentsApi->UpdateDocumentFormFields");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling DocumentsApi->UpdateDocumentFormFields");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling DocumentsApi->UpdateDocumentFormFields");

            var localVarPath = "/api/v5/documents/formfields";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (documentUpdateFormFieldsRequest != null && documentUpdateFormFieldsRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(documentUpdateFormFieldsRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = documentUpdateFormFieldsRequest; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UpdateDocumentFormFields", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<DefaultServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (DefaultServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(DefaultServiceReturnModel)));
        }

        /// <summary>
        /// Update Document Text Stamps. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentUpdateTextStampsRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>DefaultServiceReturnModel</returns>
        public DefaultServiceReturnModel UpdateDocumentTextStamps (DocumentUpdateTextStampsRequestModel documentUpdateTextStampsRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<DefaultServiceReturnModel> localVarResponse = UpdateDocumentTextStampsWithHttpInfo(documentUpdateTextStampsRequest, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Update Document Text Stamps. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentUpdateTextStampsRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of DefaultServiceReturnModel</returns>
        public ApiResponse< DefaultServiceReturnModel > UpdateDocumentTextStampsWithHttpInfo (DocumentUpdateTextStampsRequestModel documentUpdateTextStampsRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'documentUpdateTextStampsRequest' is set
            if (documentUpdateTextStampsRequest == null)
                throw new ApiException(400, "Missing required parameter 'documentUpdateTextStampsRequest' when calling DocumentsApi->UpdateDocumentTextStamps");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling DocumentsApi->UpdateDocumentTextStamps");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling DocumentsApi->UpdateDocumentTextStamps");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling DocumentsApi->UpdateDocumentTextStamps");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling DocumentsApi->UpdateDocumentTextStamps");

            var localVarPath = "/api/v5/documents/textstamps";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (documentUpdateTextStampsRequest != null && documentUpdateTextStampsRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(documentUpdateTextStampsRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = documentUpdateTextStampsRequest; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UpdateDocumentTextStamps", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<DefaultServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (DefaultServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(DefaultServiceReturnModel)));
        }

        /// <summary>
        /// Update Document Text Stamps. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentUpdateTextStampsRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of DefaultServiceReturnModel</returns>
        public async System.Threading.Tasks.Task<DefaultServiceReturnModel> UpdateDocumentTextStampsAsync (DocumentUpdateTextStampsRequestModel documentUpdateTextStampsRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<DefaultServiceReturnModel> localVarResponse = await UpdateDocumentTextStampsAsyncWithHttpInfo(documentUpdateTextStampsRequest, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Update Document Text Stamps. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentUpdateTextStampsRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (DefaultServiceReturnModel)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<DefaultServiceReturnModel>> UpdateDocumentTextStampsAsyncWithHttpInfo (DocumentUpdateTextStampsRequestModel documentUpdateTextStampsRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'documentUpdateTextStampsRequest' is set
            if (documentUpdateTextStampsRequest == null)
                throw new ApiException(400, "Missing required parameter 'documentUpdateTextStampsRequest' when calling DocumentsApi->UpdateDocumentTextStamps");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling DocumentsApi->UpdateDocumentTextStamps");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling DocumentsApi->UpdateDocumentTextStamps");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling DocumentsApi->UpdateDocumentTextStamps");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling DocumentsApi->UpdateDocumentTextStamps");

            var localVarPath = "/api/v5/documents/textstamps";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (documentUpdateTextStampsRequest != null && documentUpdateTextStampsRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(documentUpdateTextStampsRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = documentUpdateTextStampsRequest; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UpdateDocumentTextStamps", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<DefaultServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (DefaultServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(DefaultServiceReturnModel)));
        }

        /// <summary>
        /// Update an existing Document. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentUpdateRequestModel"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>DefaultServiceReturnModel</returns>
        public DefaultServiceReturnModel UpdateDocuments (DocumentUpdateRequestModel documentUpdateRequestModel, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<DefaultServiceReturnModel> localVarResponse = UpdateDocumentsWithHttpInfo(documentUpdateRequestModel, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Update an existing Document. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentUpdateRequestModel"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of DefaultServiceReturnModel</returns>
        public ApiResponse< DefaultServiceReturnModel > UpdateDocumentsWithHttpInfo (DocumentUpdateRequestModel documentUpdateRequestModel, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'documentUpdateRequestModel' is set
            if (documentUpdateRequestModel == null)
                throw new ApiException(400, "Missing required parameter 'documentUpdateRequestModel' when calling DocumentsApi->UpdateDocuments");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling DocumentsApi->UpdateDocuments");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling DocumentsApi->UpdateDocuments");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling DocumentsApi->UpdateDocuments");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling DocumentsApi->UpdateDocuments");

            var localVarPath = "/api/v5/documents";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (documentUpdateRequestModel != null && documentUpdateRequestModel.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(documentUpdateRequestModel); // http body (model) parameter
            }
            else
            {
                localVarPostBody = documentUpdateRequestModel; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UpdateDocuments", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<DefaultServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (DefaultServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(DefaultServiceReturnModel)));
        }

        /// <summary>
        /// Update an existing Document. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentUpdateRequestModel"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of DefaultServiceReturnModel</returns>
        public async System.Threading.Tasks.Task<DefaultServiceReturnModel> UpdateDocumentsAsync (DocumentUpdateRequestModel documentUpdateRequestModel, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<DefaultServiceReturnModel> localVarResponse = await UpdateDocumentsAsyncWithHttpInfo(documentUpdateRequestModel, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Update an existing Document. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentUpdateRequestModel"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (DefaultServiceReturnModel)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<DefaultServiceReturnModel>> UpdateDocumentsAsyncWithHttpInfo (DocumentUpdateRequestModel documentUpdateRequestModel, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'documentUpdateRequestModel' is set
            if (documentUpdateRequestModel == null)
                throw new ApiException(400, "Missing required parameter 'documentUpdateRequestModel' when calling DocumentsApi->UpdateDocuments");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling DocumentsApi->UpdateDocuments");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling DocumentsApi->UpdateDocuments");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling DocumentsApi->UpdateDocuments");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling DocumentsApi->UpdateDocuments");

            var localVarPath = "/api/v5/documents";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (documentUpdateRequestModel != null && documentUpdateRequestModel.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(documentUpdateRequestModel); // http body (model) parameter
            }
            else
            {
                localVarPostBody = documentUpdateRequestModel; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UpdateDocuments", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<DefaultServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (DefaultServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(DefaultServiceReturnModel)));
        }

        /// <summary>
        /// Update Documents Completed. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentCompletedUpdateRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>DefaultServiceReturnModel</returns>
        public DefaultServiceReturnModel UpdateDocumentsCompleted (DocumentCompletedUpdateRequestModel documentCompletedUpdateRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<DefaultServiceReturnModel> localVarResponse = UpdateDocumentsCompletedWithHttpInfo(documentCompletedUpdateRequest, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Update Documents Completed. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentCompletedUpdateRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of DefaultServiceReturnModel</returns>
        public ApiResponse< DefaultServiceReturnModel > UpdateDocumentsCompletedWithHttpInfo (DocumentCompletedUpdateRequestModel documentCompletedUpdateRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'documentCompletedUpdateRequest' is set
            if (documentCompletedUpdateRequest == null)
                throw new ApiException(400, "Missing required parameter 'documentCompletedUpdateRequest' when calling DocumentsApi->UpdateDocumentsCompleted");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling DocumentsApi->UpdateDocumentsCompleted");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling DocumentsApi->UpdateDocumentsCompleted");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling DocumentsApi->UpdateDocumentsCompleted");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling DocumentsApi->UpdateDocumentsCompleted");

            var localVarPath = "/api/v5/documents/completed";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (documentCompletedUpdateRequest != null && documentCompletedUpdateRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(documentCompletedUpdateRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = documentCompletedUpdateRequest; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UpdateDocumentsCompleted", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<DefaultServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (DefaultServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(DefaultServiceReturnModel)));
        }

        /// <summary>
        /// Update Documents Completed. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentCompletedUpdateRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of DefaultServiceReturnModel</returns>
        public async System.Threading.Tasks.Task<DefaultServiceReturnModel> UpdateDocumentsCompletedAsync (DocumentCompletedUpdateRequestModel documentCompletedUpdateRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<DefaultServiceReturnModel> localVarResponse = await UpdateDocumentsCompletedAsyncWithHttpInfo(documentCompletedUpdateRequest, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Update Documents Completed. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentCompletedUpdateRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (DefaultServiceReturnModel)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<DefaultServiceReturnModel>> UpdateDocumentsCompletedAsyncWithHttpInfo (DocumentCompletedUpdateRequestModel documentCompletedUpdateRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'documentCompletedUpdateRequest' is set
            if (documentCompletedUpdateRequest == null)
                throw new ApiException(400, "Missing required parameter 'documentCompletedUpdateRequest' when calling DocumentsApi->UpdateDocumentsCompleted");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling DocumentsApi->UpdateDocumentsCompleted");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling DocumentsApi->UpdateDocumentsCompleted");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling DocumentsApi->UpdateDocumentsCompleted");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling DocumentsApi->UpdateDocumentsCompleted");

            var localVarPath = "/api/v5/documents/completed";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (documentCompletedUpdateRequest != null && documentCompletedUpdateRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(documentCompletedUpdateRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = documentCompletedUpdateRequest; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UpdateDocumentsCompleted", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<DefaultServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (DefaultServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(DefaultServiceReturnModel)));
        }

        /// <summary>
        /// Verify Completed Document Authenticity. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentVerifyRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>DocumentVerificationServiceReturnModel</returns>
        public DocumentVerificationServiceReturnModel VerifyCompletedDocumentsAuthenticity (DocumentVerifyRequestModel documentVerifyRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<DocumentVerificationServiceReturnModel> localVarResponse = VerifyCompletedDocumentsAuthenticityWithHttpInfo(documentVerifyRequest, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Verify Completed Document Authenticity. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentVerifyRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of DocumentVerificationServiceReturnModel</returns>
        public ApiResponse< DocumentVerificationServiceReturnModel > VerifyCompletedDocumentsAuthenticityWithHttpInfo (DocumentVerifyRequestModel documentVerifyRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'documentVerifyRequest' is set
            if (documentVerifyRequest == null)
                throw new ApiException(400, "Missing required parameter 'documentVerifyRequest' when calling DocumentsApi->VerifyCompletedDocumentsAuthenticity");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling DocumentsApi->VerifyCompletedDocumentsAuthenticity");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling DocumentsApi->VerifyCompletedDocumentsAuthenticity");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling DocumentsApi->VerifyCompletedDocumentsAuthenticity");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling DocumentsApi->VerifyCompletedDocumentsAuthenticity");

            var localVarPath = "/api/v5/documents/completedstatusauthenticity";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (documentVerifyRequest != null && documentVerifyRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(documentVerifyRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = documentVerifyRequest; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("VerifyCompletedDocumentsAuthenticity", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<DocumentVerificationServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (DocumentVerificationServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(DocumentVerificationServiceReturnModel)));
        }

        /// <summary>
        /// Verify Completed Document Authenticity. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentVerifyRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of DocumentVerificationServiceReturnModel</returns>
        public async System.Threading.Tasks.Task<DocumentVerificationServiceReturnModel> VerifyCompletedDocumentsAuthenticityAsync (DocumentVerifyRequestModel documentVerifyRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<DocumentVerificationServiceReturnModel> localVarResponse = await VerifyCompletedDocumentsAuthenticityAsyncWithHttpInfo(documentVerifyRequest, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Verify Completed Document Authenticity. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentVerifyRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (DocumentVerificationServiceReturnModel)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<DocumentVerificationServiceReturnModel>> VerifyCompletedDocumentsAuthenticityAsyncWithHttpInfo (DocumentVerifyRequestModel documentVerifyRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'documentVerifyRequest' is set
            if (documentVerifyRequest == null)
                throw new ApiException(400, "Missing required parameter 'documentVerifyRequest' when calling DocumentsApi->VerifyCompletedDocumentsAuthenticity");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling DocumentsApi->VerifyCompletedDocumentsAuthenticity");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling DocumentsApi->VerifyCompletedDocumentsAuthenticity");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling DocumentsApi->VerifyCompletedDocumentsAuthenticity");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling DocumentsApi->VerifyCompletedDocumentsAuthenticity");

            var localVarPath = "/api/v5/documents/completedstatusauthenticity";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (documentVerifyRequest != null && documentVerifyRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(documentVerifyRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = documentVerifyRequest; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("VerifyCompletedDocumentsAuthenticity", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<DocumentVerificationServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (DocumentVerificationServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(DocumentVerificationServiceReturnModel)));
        }

        /// <summary>
        /// Void an existing Document. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentVoidRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>DefaultServiceReturnModel</returns>
        public DefaultServiceReturnModel VoidDocuments (DocumentVoidRequestModel documentVoidRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<DefaultServiceReturnModel> localVarResponse = VoidDocumentsWithHttpInfo(documentVoidRequest, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Void an existing Document. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentVoidRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of DefaultServiceReturnModel</returns>
        public ApiResponse< DefaultServiceReturnModel > VoidDocumentsWithHttpInfo (DocumentVoidRequestModel documentVoidRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'documentVoidRequest' is set
            if (documentVoidRequest == null)
                throw new ApiException(400, "Missing required parameter 'documentVoidRequest' when calling DocumentsApi->VoidDocuments");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling DocumentsApi->VoidDocuments");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling DocumentsApi->VoidDocuments");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling DocumentsApi->VoidDocuments");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling DocumentsApi->VoidDocuments");

            var localVarPath = "/api/v5/documents/void";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (documentVoidRequest != null && documentVoidRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(documentVoidRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = documentVoidRequest; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("VoidDocuments", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<DefaultServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (DefaultServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(DefaultServiceReturnModel)));
        }

        /// <summary>
        /// Void an existing Document. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentVoidRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of DefaultServiceReturnModel</returns>
        public async System.Threading.Tasks.Task<DefaultServiceReturnModel> VoidDocumentsAsync (DocumentVoidRequestModel documentVoidRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<DefaultServiceReturnModel> localVarResponse = await VoidDocumentsAsyncWithHttpInfo(documentVoidRequest, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Void an existing Document. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentVoidRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (DefaultServiceReturnModel)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<DefaultServiceReturnModel>> VoidDocumentsAsyncWithHttpInfo (DocumentVoidRequestModel documentVoidRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'documentVoidRequest' is set
            if (documentVoidRequest == null)
                throw new ApiException(400, "Missing required parameter 'documentVoidRequest' when calling DocumentsApi->VoidDocuments");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling DocumentsApi->VoidDocuments");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling DocumentsApi->VoidDocuments");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling DocumentsApi->VoidDocuments");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling DocumentsApi->VoidDocuments");

            var localVarPath = "/api/v5/documents/void";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (documentVoidRequest != null && documentVoidRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(documentVoidRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = documentVoidRequest; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("VoidDocuments", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<DefaultServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (DefaultServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(DefaultServiceReturnModel)));
        }

    }
}
