/* 
 * API Version: 5.0
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v5
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace IO.Swagger.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IDocumentsUpdateableApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Get the Document object that&#39;s in the &#39;Completed&#39; status that you can use to update with the UpdateDocuments() method.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentCompletedUpdateableRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>DocumentCompletedUpdateableServiceReturnModel</returns>
        DocumentCompletedUpdateableServiceReturnModel GetDocumentsCompletedUpdateable (DocumentCompletedUpdateableRequestModel documentCompletedUpdateableRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Get the Document object that&#39;s in the &#39;Completed&#39; status that you can use to update with the UpdateDocuments() method.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentCompletedUpdateableRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of DocumentCompletedUpdateableServiceReturnModel</returns>
        ApiResponse<DocumentCompletedUpdateableServiceReturnModel> GetDocumentsCompletedUpdateableWithHttpInfo (DocumentCompletedUpdateableRequestModel documentCompletedUpdateableRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        /// <summary>
        /// Get the Document object that you can use to update with the UpdateDocuments() method.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>DocumentUpdateableServiceReturnModel</returns>
        DocumentUpdateableServiceReturnModel GetDocumentsUpdateable (DocumentUpdateableRequestModel documentRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Get the Document object that you can use to update with the UpdateDocuments() method.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of DocumentUpdateableServiceReturnModel</returns>
        ApiResponse<DocumentUpdateableServiceReturnModel> GetDocumentsUpdateableWithHttpInfo (DocumentUpdateableRequestModel documentRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Get the Document object that&#39;s in the &#39;Completed&#39; status that you can use to update with the UpdateDocuments() method.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentCompletedUpdateableRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of DocumentCompletedUpdateableServiceReturnModel</returns>
        System.Threading.Tasks.Task<DocumentCompletedUpdateableServiceReturnModel> GetDocumentsCompletedUpdateableAsync (DocumentCompletedUpdateableRequestModel documentCompletedUpdateableRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Get the Document object that&#39;s in the &#39;Completed&#39; status that you can use to update with the UpdateDocuments() method.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentCompletedUpdateableRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (DocumentCompletedUpdateableServiceReturnModel)</returns>
        System.Threading.Tasks.Task<ApiResponse<DocumentCompletedUpdateableServiceReturnModel>> GetDocumentsCompletedUpdateableAsyncWithHttpInfo (DocumentCompletedUpdateableRequestModel documentCompletedUpdateableRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        /// <summary>
        /// Get the Document object that you can use to update with the UpdateDocuments() method.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of DocumentUpdateableServiceReturnModel</returns>
        System.Threading.Tasks.Task<DocumentUpdateableServiceReturnModel> GetDocumentsUpdateableAsync (DocumentUpdateableRequestModel documentRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Get the Document object that you can use to update with the UpdateDocuments() method.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (DocumentUpdateableServiceReturnModel)</returns>
        System.Threading.Tasks.Task<ApiResponse<DocumentUpdateableServiceReturnModel>> GetDocumentsUpdateableAsyncWithHttpInfo (DocumentUpdateableRequestModel documentRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public partial class DocumentsUpdateableApi : IDocumentsUpdateableApi
    {
        private IO.Swagger.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="DocumentsUpdateableApi"/> class.
        /// </summary>
        /// <returns></returns>
        public DocumentsUpdateableApi(String basePath)
        {
            this.Configuration = new IO.Swagger.Client.Configuration { BasePath = basePath };

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="DocumentsUpdateableApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public DocumentsUpdateableApi(IO.Swagger.Client.Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = IO.Swagger.Client.Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public IO.Swagger.Client.Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public IO.Swagger.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Get the Document object that&#39;s in the &#39;Completed&#39; status that you can use to update with the UpdateDocuments() method. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentCompletedUpdateableRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>DocumentCompletedUpdateableServiceReturnModel</returns>
        public DocumentCompletedUpdateableServiceReturnModel GetDocumentsCompletedUpdateable (DocumentCompletedUpdateableRequestModel documentCompletedUpdateableRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<DocumentCompletedUpdateableServiceReturnModel> localVarResponse = GetDocumentsCompletedUpdateableWithHttpInfo(documentCompletedUpdateableRequest, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get the Document object that&#39;s in the &#39;Completed&#39; status that you can use to update with the UpdateDocuments() method. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentCompletedUpdateableRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of DocumentCompletedUpdateableServiceReturnModel</returns>
        public ApiResponse< DocumentCompletedUpdateableServiceReturnModel > GetDocumentsCompletedUpdateableWithHttpInfo (DocumentCompletedUpdateableRequestModel documentCompletedUpdateableRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'documentCompletedUpdateableRequest' is set
            if (documentCompletedUpdateableRequest == null)
                throw new ApiException(400, "Missing required parameter 'documentCompletedUpdateableRequest' when calling DocumentsUpdateableApi->GetDocumentsCompletedUpdateable");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling DocumentsUpdateableApi->GetDocumentsCompletedUpdateable");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling DocumentsUpdateableApi->GetDocumentsCompletedUpdateable");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling DocumentsUpdateableApi->GetDocumentsCompletedUpdateable");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling DocumentsUpdateableApi->GetDocumentsCompletedUpdateable");

            var localVarPath = "/api/v5/documentsupdateable/completed";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (documentCompletedUpdateableRequest != null && documentCompletedUpdateableRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(documentCompletedUpdateableRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = documentCompletedUpdateableRequest; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetDocumentsCompletedUpdateable", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<DocumentCompletedUpdateableServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (DocumentCompletedUpdateableServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(DocumentCompletedUpdateableServiceReturnModel)));
        }

        /// <summary>
        /// Get the Document object that&#39;s in the &#39;Completed&#39; status that you can use to update with the UpdateDocuments() method. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentCompletedUpdateableRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of DocumentCompletedUpdateableServiceReturnModel</returns>
        public async System.Threading.Tasks.Task<DocumentCompletedUpdateableServiceReturnModel> GetDocumentsCompletedUpdateableAsync (DocumentCompletedUpdateableRequestModel documentCompletedUpdateableRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<DocumentCompletedUpdateableServiceReturnModel> localVarResponse = await GetDocumentsCompletedUpdateableAsyncWithHttpInfo(documentCompletedUpdateableRequest, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get the Document object that&#39;s in the &#39;Completed&#39; status that you can use to update with the UpdateDocuments() method. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentCompletedUpdateableRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (DocumentCompletedUpdateableServiceReturnModel)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<DocumentCompletedUpdateableServiceReturnModel>> GetDocumentsCompletedUpdateableAsyncWithHttpInfo (DocumentCompletedUpdateableRequestModel documentCompletedUpdateableRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'documentCompletedUpdateableRequest' is set
            if (documentCompletedUpdateableRequest == null)
                throw new ApiException(400, "Missing required parameter 'documentCompletedUpdateableRequest' when calling DocumentsUpdateableApi->GetDocumentsCompletedUpdateable");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling DocumentsUpdateableApi->GetDocumentsCompletedUpdateable");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling DocumentsUpdateableApi->GetDocumentsCompletedUpdateable");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling DocumentsUpdateableApi->GetDocumentsCompletedUpdateable");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling DocumentsUpdateableApi->GetDocumentsCompletedUpdateable");

            var localVarPath = "/api/v5/documentsupdateable/completed";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (documentCompletedUpdateableRequest != null && documentCompletedUpdateableRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(documentCompletedUpdateableRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = documentCompletedUpdateableRequest; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetDocumentsCompletedUpdateable", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<DocumentCompletedUpdateableServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (DocumentCompletedUpdateableServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(DocumentCompletedUpdateableServiceReturnModel)));
        }

        /// <summary>
        /// Get the Document object that you can use to update with the UpdateDocuments() method. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>DocumentUpdateableServiceReturnModel</returns>
        public DocumentUpdateableServiceReturnModel GetDocumentsUpdateable (DocumentUpdateableRequestModel documentRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<DocumentUpdateableServiceReturnModel> localVarResponse = GetDocumentsUpdateableWithHttpInfo(documentRequest, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get the Document object that you can use to update with the UpdateDocuments() method. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of DocumentUpdateableServiceReturnModel</returns>
        public ApiResponse< DocumentUpdateableServiceReturnModel > GetDocumentsUpdateableWithHttpInfo (DocumentUpdateableRequestModel documentRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'documentRequest' is set
            if (documentRequest == null)
                throw new ApiException(400, "Missing required parameter 'documentRequest' when calling DocumentsUpdateableApi->GetDocumentsUpdateable");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling DocumentsUpdateableApi->GetDocumentsUpdateable");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling DocumentsUpdateableApi->GetDocumentsUpdateable");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling DocumentsUpdateableApi->GetDocumentsUpdateable");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling DocumentsUpdateableApi->GetDocumentsUpdateable");

            var localVarPath = "/api/v5/documentsupdateable";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (documentRequest != null && documentRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(documentRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = documentRequest; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetDocumentsUpdateable", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<DocumentUpdateableServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (DocumentUpdateableServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(DocumentUpdateableServiceReturnModel)));
        }

        /// <summary>
        /// Get the Document object that you can use to update with the UpdateDocuments() method. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of DocumentUpdateableServiceReturnModel</returns>
        public async System.Threading.Tasks.Task<DocumentUpdateableServiceReturnModel> GetDocumentsUpdateableAsync (DocumentUpdateableRequestModel documentRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<DocumentUpdateableServiceReturnModel> localVarResponse = await GetDocumentsUpdateableAsyncWithHttpInfo(documentRequest, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get the Document object that you can use to update with the UpdateDocuments() method. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="documentRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (DocumentUpdateableServiceReturnModel)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<DocumentUpdateableServiceReturnModel>> GetDocumentsUpdateableAsyncWithHttpInfo (DocumentUpdateableRequestModel documentRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'documentRequest' is set
            if (documentRequest == null)
                throw new ApiException(400, "Missing required parameter 'documentRequest' when calling DocumentsUpdateableApi->GetDocumentsUpdateable");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling DocumentsUpdateableApi->GetDocumentsUpdateable");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling DocumentsUpdateableApi->GetDocumentsUpdateable");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling DocumentsUpdateableApi->GetDocumentsUpdateable");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling DocumentsUpdateableApi->GetDocumentsUpdateable");

            var localVarPath = "/api/v5/documentsupdateable";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (documentRequest != null && documentRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(documentRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = documentRequest; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetDocumentsUpdateable", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<DocumentUpdateableServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (DocumentUpdateableServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(DocumentUpdateableServiceReturnModel)));
        }

    }
}
