/* 
 * API Version: 5.0
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v5
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace IO.Swagger.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IGroupsApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Delete a Group.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupDeleteRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>DefaultServiceReturnModel</returns>
        DefaultServiceReturnModel DeleteGroupsAsync (GroupDeleteRequestModel groupDeleteRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Delete a Group.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupDeleteRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of DefaultServiceReturnModel</returns>
        ApiResponse<DefaultServiceReturnModel> DeleteGroupsAsyncWithHttpInfo (GroupDeleteRequestModel groupDeleteRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        /// <summary>
        /// Get group information.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>GroupDetailsServiceReturnModel</returns>
        GroupDetailsServiceReturnModel GetGroups (GroupDetailsRequestModel groupRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Get group information.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of GroupDetailsServiceReturnModel</returns>
        ApiResponse<GroupDetailsServiceReturnModel> GetGroupsWithHttpInfo (GroupDetailsRequestModel groupRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        /// <summary>
        /// insert a Group.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupInsertRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>GroupDetailsServiceReturnModel</returns>
        GroupDetailsServiceReturnModel InsertGroupsAsync (GroupInsertRequestModel groupInsertRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// insert a Group.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupInsertRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of GroupDetailsServiceReturnModel</returns>
        ApiResponse<GroupDetailsServiceReturnModel> InsertGroupsAsyncWithHttpInfo (GroupInsertRequestModel groupInsertRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        /// <summary>
        /// Update an existing Group.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupUpdateRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>DefaultServiceReturnModel</returns>
        DefaultServiceReturnModel UpdateGroupsAsync (GroupUpdateRequestModel groupUpdateRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Update an existing Group.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupUpdateRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of DefaultServiceReturnModel</returns>
        ApiResponse<DefaultServiceReturnModel> UpdateGroupsAsyncWithHttpInfo (GroupUpdateRequestModel groupUpdateRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Delete a Group.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupDeleteRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of DefaultServiceReturnModel</returns>
        System.Threading.Tasks.Task<DefaultServiceReturnModel> DeleteGroupsAsyncAsync (GroupDeleteRequestModel groupDeleteRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Delete a Group.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupDeleteRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (DefaultServiceReturnModel)</returns>
        System.Threading.Tasks.Task<ApiResponse<DefaultServiceReturnModel>> DeleteGroupsAsyncAsyncWithHttpInfo (GroupDeleteRequestModel groupDeleteRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        /// <summary>
        /// Get group information.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of GroupDetailsServiceReturnModel</returns>
        System.Threading.Tasks.Task<GroupDetailsServiceReturnModel> GetGroupsAsync (GroupDetailsRequestModel groupRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Get group information.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (GroupDetailsServiceReturnModel)</returns>
        System.Threading.Tasks.Task<ApiResponse<GroupDetailsServiceReturnModel>> GetGroupsAsyncWithHttpInfo (GroupDetailsRequestModel groupRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        /// <summary>
        /// insert a Group.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupInsertRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of GroupDetailsServiceReturnModel</returns>
        System.Threading.Tasks.Task<GroupDetailsServiceReturnModel> InsertGroupsAsyncAsync (GroupInsertRequestModel groupInsertRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// insert a Group.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupInsertRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (GroupDetailsServiceReturnModel)</returns>
        System.Threading.Tasks.Task<ApiResponse<GroupDetailsServiceReturnModel>> InsertGroupsAsyncAsyncWithHttpInfo (GroupInsertRequestModel groupInsertRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        /// <summary>
        /// Update an existing Group.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupUpdateRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of DefaultServiceReturnModel</returns>
        System.Threading.Tasks.Task<DefaultServiceReturnModel> UpdateGroupsAsyncAsync (GroupUpdateRequestModel groupUpdateRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Update an existing Group.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupUpdateRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (DefaultServiceReturnModel)</returns>
        System.Threading.Tasks.Task<ApiResponse<DefaultServiceReturnModel>> UpdateGroupsAsyncAsyncWithHttpInfo (GroupUpdateRequestModel groupUpdateRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public partial class GroupsApi : IGroupsApi
    {
        private IO.Swagger.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="GroupsApi"/> class.
        /// </summary>
        /// <returns></returns>
        public GroupsApi(String basePath)
        {
            this.Configuration = new IO.Swagger.Client.Configuration { BasePath = basePath };

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="GroupsApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public GroupsApi(IO.Swagger.Client.Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = IO.Swagger.Client.Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public IO.Swagger.Client.Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public IO.Swagger.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Delete a Group. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupDeleteRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>DefaultServiceReturnModel</returns>
        public DefaultServiceReturnModel DeleteGroupsAsync (GroupDeleteRequestModel groupDeleteRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<DefaultServiceReturnModel> localVarResponse = DeleteGroupsAsyncWithHttpInfo(groupDeleteRequest, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Delete a Group. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupDeleteRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of DefaultServiceReturnModel</returns>
        public ApiResponse< DefaultServiceReturnModel > DeleteGroupsAsyncWithHttpInfo (GroupDeleteRequestModel groupDeleteRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'groupDeleteRequest' is set
            if (groupDeleteRequest == null)
                throw new ApiException(400, "Missing required parameter 'groupDeleteRequest' when calling GroupsApi->DeleteGroupsAsync");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling GroupsApi->DeleteGroupsAsync");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling GroupsApi->DeleteGroupsAsync");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling GroupsApi->DeleteGroupsAsync");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling GroupsApi->DeleteGroupsAsync");

            var localVarPath = "/api/v5/groups";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (groupDeleteRequest != null && groupDeleteRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(groupDeleteRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = groupDeleteRequest; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("DeleteGroupsAsync", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<DefaultServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (DefaultServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(DefaultServiceReturnModel)));
        }

        /// <summary>
        /// Delete a Group. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupDeleteRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of DefaultServiceReturnModel</returns>
        public async System.Threading.Tasks.Task<DefaultServiceReturnModel> DeleteGroupsAsyncAsync (GroupDeleteRequestModel groupDeleteRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<DefaultServiceReturnModel> localVarResponse = await DeleteGroupsAsyncAsyncWithHttpInfo(groupDeleteRequest, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Delete a Group. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupDeleteRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (DefaultServiceReturnModel)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<DefaultServiceReturnModel>> DeleteGroupsAsyncAsyncWithHttpInfo (GroupDeleteRequestModel groupDeleteRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'groupDeleteRequest' is set
            if (groupDeleteRequest == null)
                throw new ApiException(400, "Missing required parameter 'groupDeleteRequest' when calling GroupsApi->DeleteGroupsAsync");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling GroupsApi->DeleteGroupsAsync");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling GroupsApi->DeleteGroupsAsync");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling GroupsApi->DeleteGroupsAsync");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling GroupsApi->DeleteGroupsAsync");

            var localVarPath = "/api/v5/groups";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (groupDeleteRequest != null && groupDeleteRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(groupDeleteRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = groupDeleteRequest; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("DeleteGroupsAsync", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<DefaultServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (DefaultServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(DefaultServiceReturnModel)));
        }

        /// <summary>
        /// Get group information. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>GroupDetailsServiceReturnModel</returns>
        public GroupDetailsServiceReturnModel GetGroups (GroupDetailsRequestModel groupRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<GroupDetailsServiceReturnModel> localVarResponse = GetGroupsWithHttpInfo(groupRequest, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get group information. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of GroupDetailsServiceReturnModel</returns>
        public ApiResponse< GroupDetailsServiceReturnModel > GetGroupsWithHttpInfo (GroupDetailsRequestModel groupRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'groupRequest' is set
            if (groupRequest == null)
                throw new ApiException(400, "Missing required parameter 'groupRequest' when calling GroupsApi->GetGroups");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling GroupsApi->GetGroups");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling GroupsApi->GetGroups");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling GroupsApi->GetGroups");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling GroupsApi->GetGroups");

            var localVarPath = "/api/v5/groups";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (groupRequest != null && groupRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(groupRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = groupRequest; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetGroups", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<GroupDetailsServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (GroupDetailsServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(GroupDetailsServiceReturnModel)));
        }

        /// <summary>
        /// Get group information. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of GroupDetailsServiceReturnModel</returns>
        public async System.Threading.Tasks.Task<GroupDetailsServiceReturnModel> GetGroupsAsync (GroupDetailsRequestModel groupRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<GroupDetailsServiceReturnModel> localVarResponse = await GetGroupsAsyncWithHttpInfo(groupRequest, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get group information. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (GroupDetailsServiceReturnModel)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<GroupDetailsServiceReturnModel>> GetGroupsAsyncWithHttpInfo (GroupDetailsRequestModel groupRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'groupRequest' is set
            if (groupRequest == null)
                throw new ApiException(400, "Missing required parameter 'groupRequest' when calling GroupsApi->GetGroups");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling GroupsApi->GetGroups");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling GroupsApi->GetGroups");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling GroupsApi->GetGroups");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling GroupsApi->GetGroups");

            var localVarPath = "/api/v5/groups";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (groupRequest != null && groupRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(groupRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = groupRequest; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetGroups", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<GroupDetailsServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (GroupDetailsServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(GroupDetailsServiceReturnModel)));
        }

        /// <summary>
        /// insert a Group. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupInsertRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>GroupDetailsServiceReturnModel</returns>
        public GroupDetailsServiceReturnModel InsertGroupsAsync (GroupInsertRequestModel groupInsertRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<GroupDetailsServiceReturnModel> localVarResponse = InsertGroupsAsyncWithHttpInfo(groupInsertRequest, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;
        }

        /// <summary>
        /// insert a Group. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupInsertRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of GroupDetailsServiceReturnModel</returns>
        public ApiResponse< GroupDetailsServiceReturnModel > InsertGroupsAsyncWithHttpInfo (GroupInsertRequestModel groupInsertRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'groupInsertRequest' is set
            if (groupInsertRequest == null)
                throw new ApiException(400, "Missing required parameter 'groupInsertRequest' when calling GroupsApi->InsertGroupsAsync");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling GroupsApi->InsertGroupsAsync");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling GroupsApi->InsertGroupsAsync");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling GroupsApi->InsertGroupsAsync");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling GroupsApi->InsertGroupsAsync");

            var localVarPath = "/api/v5/groups/insert";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (groupInsertRequest != null && groupInsertRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(groupInsertRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = groupInsertRequest; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("InsertGroupsAsync", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<GroupDetailsServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (GroupDetailsServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(GroupDetailsServiceReturnModel)));
        }

        /// <summary>
        /// insert a Group. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupInsertRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of GroupDetailsServiceReturnModel</returns>
        public async System.Threading.Tasks.Task<GroupDetailsServiceReturnModel> InsertGroupsAsyncAsync (GroupInsertRequestModel groupInsertRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<GroupDetailsServiceReturnModel> localVarResponse = await InsertGroupsAsyncAsyncWithHttpInfo(groupInsertRequest, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;

        }

        /// <summary>
        /// insert a Group. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupInsertRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (GroupDetailsServiceReturnModel)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<GroupDetailsServiceReturnModel>> InsertGroupsAsyncAsyncWithHttpInfo (GroupInsertRequestModel groupInsertRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'groupInsertRequest' is set
            if (groupInsertRequest == null)
                throw new ApiException(400, "Missing required parameter 'groupInsertRequest' when calling GroupsApi->InsertGroupsAsync");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling GroupsApi->InsertGroupsAsync");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling GroupsApi->InsertGroupsAsync");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling GroupsApi->InsertGroupsAsync");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling GroupsApi->InsertGroupsAsync");

            var localVarPath = "/api/v5/groups/insert";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (groupInsertRequest != null && groupInsertRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(groupInsertRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = groupInsertRequest; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("InsertGroupsAsync", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<GroupDetailsServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (GroupDetailsServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(GroupDetailsServiceReturnModel)));
        }

        /// <summary>
        /// Update an existing Group. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupUpdateRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>DefaultServiceReturnModel</returns>
        public DefaultServiceReturnModel UpdateGroupsAsync (GroupUpdateRequestModel groupUpdateRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<DefaultServiceReturnModel> localVarResponse = UpdateGroupsAsyncWithHttpInfo(groupUpdateRequest, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Update an existing Group. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupUpdateRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of DefaultServiceReturnModel</returns>
        public ApiResponse< DefaultServiceReturnModel > UpdateGroupsAsyncWithHttpInfo (GroupUpdateRequestModel groupUpdateRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'groupUpdateRequest' is set
            if (groupUpdateRequest == null)
                throw new ApiException(400, "Missing required parameter 'groupUpdateRequest' when calling GroupsApi->UpdateGroupsAsync");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling GroupsApi->UpdateGroupsAsync");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling GroupsApi->UpdateGroupsAsync");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling GroupsApi->UpdateGroupsAsync");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling GroupsApi->UpdateGroupsAsync");

            var localVarPath = "/api/v5/groups";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (groupUpdateRequest != null && groupUpdateRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(groupUpdateRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = groupUpdateRequest; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UpdateGroupsAsync", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<DefaultServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (DefaultServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(DefaultServiceReturnModel)));
        }

        /// <summary>
        /// Update an existing Group. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupUpdateRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of DefaultServiceReturnModel</returns>
        public async System.Threading.Tasks.Task<DefaultServiceReturnModel> UpdateGroupsAsyncAsync (GroupUpdateRequestModel groupUpdateRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<DefaultServiceReturnModel> localVarResponse = await UpdateGroupsAsyncAsyncWithHttpInfo(groupUpdateRequest, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Update an existing Group. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="groupUpdateRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (DefaultServiceReturnModel)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<DefaultServiceReturnModel>> UpdateGroupsAsyncAsyncWithHttpInfo (GroupUpdateRequestModel groupUpdateRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'groupUpdateRequest' is set
            if (groupUpdateRequest == null)
                throw new ApiException(400, "Missing required parameter 'groupUpdateRequest' when calling GroupsApi->UpdateGroupsAsync");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling GroupsApi->UpdateGroupsAsync");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling GroupsApi->UpdateGroupsAsync");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling GroupsApi->UpdateGroupsAsync");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling GroupsApi->UpdateGroupsAsync");

            var localVarPath = "/api/v5/groups";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (groupUpdateRequest != null && groupUpdateRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(groupUpdateRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = groupUpdateRequest; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UpdateGroupsAsync", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<DefaultServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (DefaultServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(DefaultServiceReturnModel)));
        }

    }
}
