/* 
 * API Version: 5.0
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v5
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace IO.Swagger.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IParticipantsApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Get Participant Encrypted Credentials.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="participantEncryptedCredentialsRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ParticipantEncryptedCredentialsServiceReturnModel</returns>
        ParticipantEncryptedCredentialsServiceReturnModel GetParticipantEncryptedCredentials (ParticipantEncryptedCredentialsRequestModel participantEncryptedCredentialsRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Get Participant Encrypted Credentials.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="participantEncryptedCredentialsRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of ParticipantEncryptedCredentialsServiceReturnModel</returns>
        ApiResponse<ParticipantEncryptedCredentialsServiceReturnModel> GetParticipantEncryptedCredentialsWithHttpInfo (ParticipantEncryptedCredentialsRequestModel participantEncryptedCredentialsRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        /// <summary>
        /// Get a Participant.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="participantRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ParticipantDetailsServiceReturnModel</returns>
        ParticipantDetailsServiceReturnModel GetParticipants (ParticipantDetailsRequestModel participantRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Get a Participant.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="participantRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of ParticipantDetailsServiceReturnModel</returns>
        ApiResponse<ParticipantDetailsServiceReturnModel> GetParticipantsWithHttpInfo (ParticipantDetailsRequestModel participantRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        /// <summary>
        /// Insert a Participant.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="participantInsertRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ParticipantDetailsServiceReturnModel</returns>
        ParticipantDetailsServiceReturnModel InsertParticipants (ParticipantInsertRequestModel participantInsertRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Insert a Participant.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="participantInsertRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of ParticipantDetailsServiceReturnModel</returns>
        ApiResponse<ParticipantDetailsServiceReturnModel> InsertParticipantsWithHttpInfo (ParticipantInsertRequestModel participantInsertRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        /// <summary>
        /// Re-send Participant Email Notification.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="participantResendNotificationRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>DefaultServiceReturnModel</returns>
        DefaultServiceReturnModel ResendParticipantEmailNotifications (ParticipantResendNotificationRequestModel participantResendNotificationRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Re-send Participant Email Notification.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="participantResendNotificationRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of DefaultServiceReturnModel</returns>
        ApiResponse<DefaultServiceReturnModel> ResendParticipantEmailNotificationsWithHttpInfo (ParticipantResendNotificationRequestModel participantResendNotificationRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        /// <summary>
        /// Update Participant Workflow Action Status.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="participantWorkflowActionUpdateRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ParticipantWorkflowActionServiceReturnModel</returns>
        ParticipantWorkflowActionServiceReturnModel UpdateParticipantWorkflowActionStatus (ParticipantWorkflowActionUpdateRequestModel participantWorkflowActionUpdateRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Update Participant Workflow Action Status.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="participantWorkflowActionUpdateRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of ParticipantWorkflowActionServiceReturnModel</returns>
        ApiResponse<ParticipantWorkflowActionServiceReturnModel> UpdateParticipantWorkflowActionStatusWithHttpInfo (ParticipantWorkflowActionUpdateRequestModel participantWorkflowActionUpdateRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        /// <summary>
        /// Update Participant.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="participantUpdateRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>DefaultServiceReturnModel</returns>
        DefaultServiceReturnModel UpdateParticipants (ParticipantUpdateRequestModel participantUpdateRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Update Participant.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="participantUpdateRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of DefaultServiceReturnModel</returns>
        ApiResponse<DefaultServiceReturnModel> UpdateParticipantsWithHttpInfo (ParticipantUpdateRequestModel participantUpdateRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Get Participant Encrypted Credentials.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="participantEncryptedCredentialsRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ParticipantEncryptedCredentialsServiceReturnModel</returns>
        System.Threading.Tasks.Task<ParticipantEncryptedCredentialsServiceReturnModel> GetParticipantEncryptedCredentialsAsync (ParticipantEncryptedCredentialsRequestModel participantEncryptedCredentialsRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Get Participant Encrypted Credentials.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="participantEncryptedCredentialsRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (ParticipantEncryptedCredentialsServiceReturnModel)</returns>
        System.Threading.Tasks.Task<ApiResponse<ParticipantEncryptedCredentialsServiceReturnModel>> GetParticipantEncryptedCredentialsAsyncWithHttpInfo (ParticipantEncryptedCredentialsRequestModel participantEncryptedCredentialsRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        /// <summary>
        /// Get a Participant.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="participantRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ParticipantDetailsServiceReturnModel</returns>
        System.Threading.Tasks.Task<ParticipantDetailsServiceReturnModel> GetParticipantsAsync (ParticipantDetailsRequestModel participantRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Get a Participant.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="participantRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (ParticipantDetailsServiceReturnModel)</returns>
        System.Threading.Tasks.Task<ApiResponse<ParticipantDetailsServiceReturnModel>> GetParticipantsAsyncWithHttpInfo (ParticipantDetailsRequestModel participantRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        /// <summary>
        /// Insert a Participant.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="participantInsertRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ParticipantDetailsServiceReturnModel</returns>
        System.Threading.Tasks.Task<ParticipantDetailsServiceReturnModel> InsertParticipantsAsync (ParticipantInsertRequestModel participantInsertRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Insert a Participant.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="participantInsertRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (ParticipantDetailsServiceReturnModel)</returns>
        System.Threading.Tasks.Task<ApiResponse<ParticipantDetailsServiceReturnModel>> InsertParticipantsAsyncWithHttpInfo (ParticipantInsertRequestModel participantInsertRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        /// <summary>
        /// Re-send Participant Email Notification.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="participantResendNotificationRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of DefaultServiceReturnModel</returns>
        System.Threading.Tasks.Task<DefaultServiceReturnModel> ResendParticipantEmailNotificationsAsync (ParticipantResendNotificationRequestModel participantResendNotificationRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Re-send Participant Email Notification.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="participantResendNotificationRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (DefaultServiceReturnModel)</returns>
        System.Threading.Tasks.Task<ApiResponse<DefaultServiceReturnModel>> ResendParticipantEmailNotificationsAsyncWithHttpInfo (ParticipantResendNotificationRequestModel participantResendNotificationRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        /// <summary>
        /// Update Participant Workflow Action Status.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="participantWorkflowActionUpdateRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ParticipantWorkflowActionServiceReturnModel</returns>
        System.Threading.Tasks.Task<ParticipantWorkflowActionServiceReturnModel> UpdateParticipantWorkflowActionStatusAsync (ParticipantWorkflowActionUpdateRequestModel participantWorkflowActionUpdateRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Update Participant Workflow Action Status.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="participantWorkflowActionUpdateRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (ParticipantWorkflowActionServiceReturnModel)</returns>
        System.Threading.Tasks.Task<ApiResponse<ParticipantWorkflowActionServiceReturnModel>> UpdateParticipantWorkflowActionStatusAsyncWithHttpInfo (ParticipantWorkflowActionUpdateRequestModel participantWorkflowActionUpdateRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        /// <summary>
        /// Update Participant.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="participantUpdateRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of DefaultServiceReturnModel</returns>
        System.Threading.Tasks.Task<DefaultServiceReturnModel> UpdateParticipantsAsync (ParticipantUpdateRequestModel participantUpdateRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Update Participant.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="participantUpdateRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (DefaultServiceReturnModel)</returns>
        System.Threading.Tasks.Task<ApiResponse<DefaultServiceReturnModel>> UpdateParticipantsAsyncWithHttpInfo (ParticipantUpdateRequestModel participantUpdateRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public partial class ParticipantsApi : IParticipantsApi
    {
        private IO.Swagger.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="ParticipantsApi"/> class.
        /// </summary>
        /// <returns></returns>
        public ParticipantsApi(String basePath)
        {
            this.Configuration = new IO.Swagger.Client.Configuration { BasePath = basePath };

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="ParticipantsApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public ParticipantsApi(IO.Swagger.Client.Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = IO.Swagger.Client.Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public IO.Swagger.Client.Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public IO.Swagger.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Get Participant Encrypted Credentials. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="participantEncryptedCredentialsRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ParticipantEncryptedCredentialsServiceReturnModel</returns>
        public ParticipantEncryptedCredentialsServiceReturnModel GetParticipantEncryptedCredentials (ParticipantEncryptedCredentialsRequestModel participantEncryptedCredentialsRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<ParticipantEncryptedCredentialsServiceReturnModel> localVarResponse = GetParticipantEncryptedCredentialsWithHttpInfo(participantEncryptedCredentialsRequest, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get Participant Encrypted Credentials. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="participantEncryptedCredentialsRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of ParticipantEncryptedCredentialsServiceReturnModel</returns>
        public ApiResponse< ParticipantEncryptedCredentialsServiceReturnModel > GetParticipantEncryptedCredentialsWithHttpInfo (ParticipantEncryptedCredentialsRequestModel participantEncryptedCredentialsRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'participantEncryptedCredentialsRequest' is set
            if (participantEncryptedCredentialsRequest == null)
                throw new ApiException(400, "Missing required parameter 'participantEncryptedCredentialsRequest' when calling ParticipantsApi->GetParticipantEncryptedCredentials");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling ParticipantsApi->GetParticipantEncryptedCredentials");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling ParticipantsApi->GetParticipantEncryptedCredentials");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling ParticipantsApi->GetParticipantEncryptedCredentials");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling ParticipantsApi->GetParticipantEncryptedCredentials");

            var localVarPath = "/api/v5/participants/encryptedcredentials";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (participantEncryptedCredentialsRequest != null && participantEncryptedCredentialsRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(participantEncryptedCredentialsRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = participantEncryptedCredentialsRequest; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetParticipantEncryptedCredentials", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ParticipantEncryptedCredentialsServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ParticipantEncryptedCredentialsServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ParticipantEncryptedCredentialsServiceReturnModel)));
        }

        /// <summary>
        /// Get Participant Encrypted Credentials. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="participantEncryptedCredentialsRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ParticipantEncryptedCredentialsServiceReturnModel</returns>
        public async System.Threading.Tasks.Task<ParticipantEncryptedCredentialsServiceReturnModel> GetParticipantEncryptedCredentialsAsync (ParticipantEncryptedCredentialsRequestModel participantEncryptedCredentialsRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<ParticipantEncryptedCredentialsServiceReturnModel> localVarResponse = await GetParticipantEncryptedCredentialsAsyncWithHttpInfo(participantEncryptedCredentialsRequest, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get Participant Encrypted Credentials. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="participantEncryptedCredentialsRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (ParticipantEncryptedCredentialsServiceReturnModel)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ParticipantEncryptedCredentialsServiceReturnModel>> GetParticipantEncryptedCredentialsAsyncWithHttpInfo (ParticipantEncryptedCredentialsRequestModel participantEncryptedCredentialsRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'participantEncryptedCredentialsRequest' is set
            if (participantEncryptedCredentialsRequest == null)
                throw new ApiException(400, "Missing required parameter 'participantEncryptedCredentialsRequest' when calling ParticipantsApi->GetParticipantEncryptedCredentials");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling ParticipantsApi->GetParticipantEncryptedCredentials");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling ParticipantsApi->GetParticipantEncryptedCredentials");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling ParticipantsApi->GetParticipantEncryptedCredentials");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling ParticipantsApi->GetParticipantEncryptedCredentials");

            var localVarPath = "/api/v5/participants/encryptedcredentials";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (participantEncryptedCredentialsRequest != null && participantEncryptedCredentialsRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(participantEncryptedCredentialsRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = participantEncryptedCredentialsRequest; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetParticipantEncryptedCredentials", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ParticipantEncryptedCredentialsServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ParticipantEncryptedCredentialsServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ParticipantEncryptedCredentialsServiceReturnModel)));
        }

        /// <summary>
        /// Get a Participant. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="participantRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ParticipantDetailsServiceReturnModel</returns>
        public ParticipantDetailsServiceReturnModel GetParticipants (ParticipantDetailsRequestModel participantRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<ParticipantDetailsServiceReturnModel> localVarResponse = GetParticipantsWithHttpInfo(participantRequest, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get a Participant. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="participantRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of ParticipantDetailsServiceReturnModel</returns>
        public ApiResponse< ParticipantDetailsServiceReturnModel > GetParticipantsWithHttpInfo (ParticipantDetailsRequestModel participantRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'participantRequest' is set
            if (participantRequest == null)
                throw new ApiException(400, "Missing required parameter 'participantRequest' when calling ParticipantsApi->GetParticipants");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling ParticipantsApi->GetParticipants");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling ParticipantsApi->GetParticipants");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling ParticipantsApi->GetParticipants");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling ParticipantsApi->GetParticipants");

            var localVarPath = "/api/v5/participants";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (participantRequest != null && participantRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(participantRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = participantRequest; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetParticipants", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ParticipantDetailsServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ParticipantDetailsServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ParticipantDetailsServiceReturnModel)));
        }

        /// <summary>
        /// Get a Participant. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="participantRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ParticipantDetailsServiceReturnModel</returns>
        public async System.Threading.Tasks.Task<ParticipantDetailsServiceReturnModel> GetParticipantsAsync (ParticipantDetailsRequestModel participantRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<ParticipantDetailsServiceReturnModel> localVarResponse = await GetParticipantsAsyncWithHttpInfo(participantRequest, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get a Participant. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="participantRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (ParticipantDetailsServiceReturnModel)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ParticipantDetailsServiceReturnModel>> GetParticipantsAsyncWithHttpInfo (ParticipantDetailsRequestModel participantRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'participantRequest' is set
            if (participantRequest == null)
                throw new ApiException(400, "Missing required parameter 'participantRequest' when calling ParticipantsApi->GetParticipants");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling ParticipantsApi->GetParticipants");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling ParticipantsApi->GetParticipants");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling ParticipantsApi->GetParticipants");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling ParticipantsApi->GetParticipants");

            var localVarPath = "/api/v5/participants";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (participantRequest != null && participantRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(participantRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = participantRequest; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetParticipants", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ParticipantDetailsServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ParticipantDetailsServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ParticipantDetailsServiceReturnModel)));
        }

        /// <summary>
        /// Insert a Participant. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="participantInsertRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ParticipantDetailsServiceReturnModel</returns>
        public ParticipantDetailsServiceReturnModel InsertParticipants (ParticipantInsertRequestModel participantInsertRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<ParticipantDetailsServiceReturnModel> localVarResponse = InsertParticipantsWithHttpInfo(participantInsertRequest, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Insert a Participant. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="participantInsertRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of ParticipantDetailsServiceReturnModel</returns>
        public ApiResponse< ParticipantDetailsServiceReturnModel > InsertParticipantsWithHttpInfo (ParticipantInsertRequestModel participantInsertRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'participantInsertRequest' is set
            if (participantInsertRequest == null)
                throw new ApiException(400, "Missing required parameter 'participantInsertRequest' when calling ParticipantsApi->InsertParticipants");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling ParticipantsApi->InsertParticipants");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling ParticipantsApi->InsertParticipants");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling ParticipantsApi->InsertParticipants");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling ParticipantsApi->InsertParticipants");

            var localVarPath = "/api/v5/participants/insert";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (participantInsertRequest != null && participantInsertRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(participantInsertRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = participantInsertRequest; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("InsertParticipants", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ParticipantDetailsServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ParticipantDetailsServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ParticipantDetailsServiceReturnModel)));
        }

        /// <summary>
        /// Insert a Participant. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="participantInsertRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ParticipantDetailsServiceReturnModel</returns>
        public async System.Threading.Tasks.Task<ParticipantDetailsServiceReturnModel> InsertParticipantsAsync (ParticipantInsertRequestModel participantInsertRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<ParticipantDetailsServiceReturnModel> localVarResponse = await InsertParticipantsAsyncWithHttpInfo(participantInsertRequest, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Insert a Participant. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="participantInsertRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (ParticipantDetailsServiceReturnModel)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ParticipantDetailsServiceReturnModel>> InsertParticipantsAsyncWithHttpInfo (ParticipantInsertRequestModel participantInsertRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'participantInsertRequest' is set
            if (participantInsertRequest == null)
                throw new ApiException(400, "Missing required parameter 'participantInsertRequest' when calling ParticipantsApi->InsertParticipants");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling ParticipantsApi->InsertParticipants");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling ParticipantsApi->InsertParticipants");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling ParticipantsApi->InsertParticipants");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling ParticipantsApi->InsertParticipants");

            var localVarPath = "/api/v5/participants/insert";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (participantInsertRequest != null && participantInsertRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(participantInsertRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = participantInsertRequest; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("InsertParticipants", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ParticipantDetailsServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ParticipantDetailsServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ParticipantDetailsServiceReturnModel)));
        }

        /// <summary>
        /// Re-send Participant Email Notification. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="participantResendNotificationRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>DefaultServiceReturnModel</returns>
        public DefaultServiceReturnModel ResendParticipantEmailNotifications (ParticipantResendNotificationRequestModel participantResendNotificationRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<DefaultServiceReturnModel> localVarResponse = ResendParticipantEmailNotificationsWithHttpInfo(participantResendNotificationRequest, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Re-send Participant Email Notification. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="participantResendNotificationRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of DefaultServiceReturnModel</returns>
        public ApiResponse< DefaultServiceReturnModel > ResendParticipantEmailNotificationsWithHttpInfo (ParticipantResendNotificationRequestModel participantResendNotificationRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'participantResendNotificationRequest' is set
            if (participantResendNotificationRequest == null)
                throw new ApiException(400, "Missing required parameter 'participantResendNotificationRequest' when calling ParticipantsApi->ResendParticipantEmailNotifications");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling ParticipantsApi->ResendParticipantEmailNotifications");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling ParticipantsApi->ResendParticipantEmailNotifications");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling ParticipantsApi->ResendParticipantEmailNotifications");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling ParticipantsApi->ResendParticipantEmailNotifications");

            var localVarPath = "/api/v5/participants/emailnotification";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (participantResendNotificationRequest != null && participantResendNotificationRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(participantResendNotificationRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = participantResendNotificationRequest; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ResendParticipantEmailNotifications", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<DefaultServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (DefaultServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(DefaultServiceReturnModel)));
        }

        /// <summary>
        /// Re-send Participant Email Notification. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="participantResendNotificationRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of DefaultServiceReturnModel</returns>
        public async System.Threading.Tasks.Task<DefaultServiceReturnModel> ResendParticipantEmailNotificationsAsync (ParticipantResendNotificationRequestModel participantResendNotificationRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<DefaultServiceReturnModel> localVarResponse = await ResendParticipantEmailNotificationsAsyncWithHttpInfo(participantResendNotificationRequest, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Re-send Participant Email Notification. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="participantResendNotificationRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (DefaultServiceReturnModel)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<DefaultServiceReturnModel>> ResendParticipantEmailNotificationsAsyncWithHttpInfo (ParticipantResendNotificationRequestModel participantResendNotificationRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'participantResendNotificationRequest' is set
            if (participantResendNotificationRequest == null)
                throw new ApiException(400, "Missing required parameter 'participantResendNotificationRequest' when calling ParticipantsApi->ResendParticipantEmailNotifications");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling ParticipantsApi->ResendParticipantEmailNotifications");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling ParticipantsApi->ResendParticipantEmailNotifications");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling ParticipantsApi->ResendParticipantEmailNotifications");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling ParticipantsApi->ResendParticipantEmailNotifications");

            var localVarPath = "/api/v5/participants/emailnotification";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (participantResendNotificationRequest != null && participantResendNotificationRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(participantResendNotificationRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = participantResendNotificationRequest; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("ResendParticipantEmailNotifications", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<DefaultServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (DefaultServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(DefaultServiceReturnModel)));
        }

        /// <summary>
        /// Update Participant Workflow Action Status. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="participantWorkflowActionUpdateRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ParticipantWorkflowActionServiceReturnModel</returns>
        public ParticipantWorkflowActionServiceReturnModel UpdateParticipantWorkflowActionStatus (ParticipantWorkflowActionUpdateRequestModel participantWorkflowActionUpdateRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<ParticipantWorkflowActionServiceReturnModel> localVarResponse = UpdateParticipantWorkflowActionStatusWithHttpInfo(participantWorkflowActionUpdateRequest, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Update Participant Workflow Action Status. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="participantWorkflowActionUpdateRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of ParticipantWorkflowActionServiceReturnModel</returns>
        public ApiResponse< ParticipantWorkflowActionServiceReturnModel > UpdateParticipantWorkflowActionStatusWithHttpInfo (ParticipantWorkflowActionUpdateRequestModel participantWorkflowActionUpdateRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'participantWorkflowActionUpdateRequest' is set
            if (participantWorkflowActionUpdateRequest == null)
                throw new ApiException(400, "Missing required parameter 'participantWorkflowActionUpdateRequest' when calling ParticipantsApi->UpdateParticipantWorkflowActionStatus");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling ParticipantsApi->UpdateParticipantWorkflowActionStatus");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling ParticipantsApi->UpdateParticipantWorkflowActionStatus");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling ParticipantsApi->UpdateParticipantWorkflowActionStatus");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling ParticipantsApi->UpdateParticipantWorkflowActionStatus");

            var localVarPath = "/api/v5/participants/workflowactionstatus";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (participantWorkflowActionUpdateRequest != null && participantWorkflowActionUpdateRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(participantWorkflowActionUpdateRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = participantWorkflowActionUpdateRequest; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UpdateParticipantWorkflowActionStatus", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ParticipantWorkflowActionServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ParticipantWorkflowActionServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ParticipantWorkflowActionServiceReturnModel)));
        }

        /// <summary>
        /// Update Participant Workflow Action Status. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="participantWorkflowActionUpdateRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ParticipantWorkflowActionServiceReturnModel</returns>
        public async System.Threading.Tasks.Task<ParticipantWorkflowActionServiceReturnModel> UpdateParticipantWorkflowActionStatusAsync (ParticipantWorkflowActionUpdateRequestModel participantWorkflowActionUpdateRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<ParticipantWorkflowActionServiceReturnModel> localVarResponse = await UpdateParticipantWorkflowActionStatusAsyncWithHttpInfo(participantWorkflowActionUpdateRequest, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Update Participant Workflow Action Status. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="participantWorkflowActionUpdateRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (ParticipantWorkflowActionServiceReturnModel)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<ParticipantWorkflowActionServiceReturnModel>> UpdateParticipantWorkflowActionStatusAsyncWithHttpInfo (ParticipantWorkflowActionUpdateRequestModel participantWorkflowActionUpdateRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'participantWorkflowActionUpdateRequest' is set
            if (participantWorkflowActionUpdateRequest == null)
                throw new ApiException(400, "Missing required parameter 'participantWorkflowActionUpdateRequest' when calling ParticipantsApi->UpdateParticipantWorkflowActionStatus");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling ParticipantsApi->UpdateParticipantWorkflowActionStatus");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling ParticipantsApi->UpdateParticipantWorkflowActionStatus");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling ParticipantsApi->UpdateParticipantWorkflowActionStatus");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling ParticipantsApi->UpdateParticipantWorkflowActionStatus");

            var localVarPath = "/api/v5/participants/workflowactionstatus";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (participantWorkflowActionUpdateRequest != null && participantWorkflowActionUpdateRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(participantWorkflowActionUpdateRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = participantWorkflowActionUpdateRequest; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UpdateParticipantWorkflowActionStatus", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<ParticipantWorkflowActionServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (ParticipantWorkflowActionServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(ParticipantWorkflowActionServiceReturnModel)));
        }

        /// <summary>
        /// Update Participant. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="participantUpdateRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>DefaultServiceReturnModel</returns>
        public DefaultServiceReturnModel UpdateParticipants (ParticipantUpdateRequestModel participantUpdateRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<DefaultServiceReturnModel> localVarResponse = UpdateParticipantsWithHttpInfo(participantUpdateRequest, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Update Participant. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="participantUpdateRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of DefaultServiceReturnModel</returns>
        public ApiResponse< DefaultServiceReturnModel > UpdateParticipantsWithHttpInfo (ParticipantUpdateRequestModel participantUpdateRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'participantUpdateRequest' is set
            if (participantUpdateRequest == null)
                throw new ApiException(400, "Missing required parameter 'participantUpdateRequest' when calling ParticipantsApi->UpdateParticipants");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling ParticipantsApi->UpdateParticipants");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling ParticipantsApi->UpdateParticipants");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling ParticipantsApi->UpdateParticipants");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling ParticipantsApi->UpdateParticipants");

            var localVarPath = "/api/v5/participants";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (participantUpdateRequest != null && participantUpdateRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(participantUpdateRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = participantUpdateRequest; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UpdateParticipants", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<DefaultServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (DefaultServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(DefaultServiceReturnModel)));
        }

        /// <summary>
        /// Update Participant. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="participantUpdateRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of DefaultServiceReturnModel</returns>
        public async System.Threading.Tasks.Task<DefaultServiceReturnModel> UpdateParticipantsAsync (ParticipantUpdateRequestModel participantUpdateRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<DefaultServiceReturnModel> localVarResponse = await UpdateParticipantsAsyncWithHttpInfo(participantUpdateRequest, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Update Participant. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="participantUpdateRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (DefaultServiceReturnModel)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<DefaultServiceReturnModel>> UpdateParticipantsAsyncWithHttpInfo (ParticipantUpdateRequestModel participantUpdateRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'participantUpdateRequest' is set
            if (participantUpdateRequest == null)
                throw new ApiException(400, "Missing required parameter 'participantUpdateRequest' when calling ParticipantsApi->UpdateParticipants");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling ParticipantsApi->UpdateParticipants");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling ParticipantsApi->UpdateParticipants");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling ParticipantsApi->UpdateParticipants");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling ParticipantsApi->UpdateParticipants");

            var localVarPath = "/api/v5/participants";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (participantUpdateRequest != null && participantUpdateRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(participantUpdateRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = participantUpdateRequest; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UpdateParticipants", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<DefaultServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (DefaultServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(DefaultServiceReturnModel)));
        }

    }
}
