/* 
 * API Version: 5.0
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v5
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using RestSharp;
using IO.Swagger.Client;
using IO.Swagger.Model;

namespace IO.Swagger.Api
{
    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IUsersApi : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Delete a User.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="userDeleteRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>DefaultServiceReturnModel</returns>
        DefaultServiceReturnModel DeleteUsersAsync (UserDeleteRequestModel userDeleteRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Delete a User.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="userDeleteRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of DefaultServiceReturnModel</returns>
        ApiResponse<DefaultServiceReturnModel> DeleteUsersAsyncWithHttpInfo (UserDeleteRequestModel userDeleteRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        /// <summary>
        /// Get User.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="userRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>UserDetailsServiceReturnModel</returns>
        UserDetailsServiceReturnModel GetUsers (UserDetailsRequestModel userRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Get User.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="userRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of UserDetailsServiceReturnModel</returns>
        ApiResponse<UserDetailsServiceReturnModel> GetUsersWithHttpInfo (UserDetailsRequestModel userRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        /// <summary>
        /// Insert User.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="userInsertRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>UserDetailsServiceReturnModel</returns>
        UserDetailsServiceReturnModel InsertUsersAsync (UserInsertRequestModel userInsertRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Insert User.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="userInsertRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of UserDetailsServiceReturnModel</returns>
        ApiResponse<UserDetailsServiceReturnModel> InsertUsersAsyncWithHttpInfo (UserInsertRequestModel userInsertRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        /// <summary>
        /// Update an existing User.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="userUpdateRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>DefaultServiceReturnModel</returns>
        DefaultServiceReturnModel UpdateUsersAsync (UserUpdateRequestModel userUpdateRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Update an existing User.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="userUpdateRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of DefaultServiceReturnModel</returns>
        ApiResponse<DefaultServiceReturnModel> UpdateUsersAsyncWithHttpInfo (UserUpdateRequestModel userUpdateRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        #endregion Synchronous Operations
        #region Asynchronous Operations
        /// <summary>
        /// Delete a User.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="userDeleteRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of DefaultServiceReturnModel</returns>
        System.Threading.Tasks.Task<DefaultServiceReturnModel> DeleteUsersAsyncAsync (UserDeleteRequestModel userDeleteRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Delete a User.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="userDeleteRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (DefaultServiceReturnModel)</returns>
        System.Threading.Tasks.Task<ApiResponse<DefaultServiceReturnModel>> DeleteUsersAsyncAsyncWithHttpInfo (UserDeleteRequestModel userDeleteRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        /// <summary>
        /// Get User.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="userRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of UserDetailsServiceReturnModel</returns>
        System.Threading.Tasks.Task<UserDetailsServiceReturnModel> GetUsersAsync (UserDetailsRequestModel userRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Get User.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="userRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (UserDetailsServiceReturnModel)</returns>
        System.Threading.Tasks.Task<ApiResponse<UserDetailsServiceReturnModel>> GetUsersAsyncWithHttpInfo (UserDetailsRequestModel userRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        /// <summary>
        /// Insert User.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="userInsertRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of UserDetailsServiceReturnModel</returns>
        System.Threading.Tasks.Task<UserDetailsServiceReturnModel> InsertUsersAsyncAsync (UserInsertRequestModel userInsertRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Insert User.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="userInsertRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (UserDetailsServiceReturnModel)</returns>
        System.Threading.Tasks.Task<ApiResponse<UserDetailsServiceReturnModel>> InsertUsersAsyncAsyncWithHttpInfo (UserInsertRequestModel userInsertRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        /// <summary>
        /// Update an existing User.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="userUpdateRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of DefaultServiceReturnModel</returns>
        System.Threading.Tasks.Task<DefaultServiceReturnModel> UpdateUsersAsyncAsync (UserUpdateRequestModel userUpdateRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);

        /// <summary>
        /// Update an existing User.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="userUpdateRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (DefaultServiceReturnModel)</returns>
        System.Threading.Tasks.Task<ApiResponse<DefaultServiceReturnModel>> UpdateUsersAsyncAsyncWithHttpInfo (UserUpdateRequestModel userUpdateRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword);
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public partial class UsersApi : IUsersApi
    {
        private IO.Swagger.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="UsersApi"/> class.
        /// </summary>
        /// <returns></returns>
        public UsersApi(String basePath)
        {
            this.Configuration = new IO.Swagger.Client.Configuration { BasePath = basePath };

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="UsersApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public UsersApi(IO.Swagger.Client.Configuration configuration = null)
        {
            if (configuration == null) // use the default one in Configuration
                this.Configuration = IO.Swagger.Client.Configuration.Default;
            else
                this.Configuration = configuration;

            ExceptionFactory = IO.Swagger.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public String GetBasePath()
        {
            return this.Configuration.ApiClient.RestClient.BaseUrl.ToString();
        }

        /// <summary>
        /// Sets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        [Obsolete("SetBasePath is deprecated, please do 'Configuration.ApiClient = new ApiClient(\"http://new-path\")' instead.")]
        public void SetBasePath(String basePath)
        {
            // do nothing
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public IO.Swagger.Client.Configuration Configuration {get; set;}

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public IO.Swagger.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Gets the default header.
        /// </summary>
        /// <returns>Dictionary of HTTP header</returns>
        [Obsolete("DefaultHeader is deprecated, please use Configuration.DefaultHeader instead.")]
        public IDictionary<String, String> DefaultHeader()
        {
            return new ReadOnlyDictionary<string, string>(this.Configuration.DefaultHeader);
        }

        /// <summary>
        /// Add default header.
        /// </summary>
        /// <param name="key">Header field name.</param>
        /// <param name="value">Header field value.</param>
        /// <returns></returns>
        [Obsolete("AddDefaultHeader is deprecated, please use Configuration.AddDefaultHeader instead.")]
        public void AddDefaultHeader(string key, string value)
        {
            this.Configuration.AddDefaultHeader(key, value);
        }

        /// <summary>
        /// Delete a User. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="userDeleteRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>DefaultServiceReturnModel</returns>
        public DefaultServiceReturnModel DeleteUsersAsync (UserDeleteRequestModel userDeleteRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<DefaultServiceReturnModel> localVarResponse = DeleteUsersAsyncWithHttpInfo(userDeleteRequest, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Delete a User. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="userDeleteRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of DefaultServiceReturnModel</returns>
        public ApiResponse< DefaultServiceReturnModel > DeleteUsersAsyncWithHttpInfo (UserDeleteRequestModel userDeleteRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'userDeleteRequest' is set
            if (userDeleteRequest == null)
                throw new ApiException(400, "Missing required parameter 'userDeleteRequest' when calling UsersApi->DeleteUsersAsync");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling UsersApi->DeleteUsersAsync");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling UsersApi->DeleteUsersAsync");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling UsersApi->DeleteUsersAsync");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling UsersApi->DeleteUsersAsync");

            var localVarPath = "/api/v5/users";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (userDeleteRequest != null && userDeleteRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(userDeleteRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = userDeleteRequest; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("DeleteUsersAsync", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<DefaultServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (DefaultServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(DefaultServiceReturnModel)));
        }

        /// <summary>
        /// Delete a User. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="userDeleteRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of DefaultServiceReturnModel</returns>
        public async System.Threading.Tasks.Task<DefaultServiceReturnModel> DeleteUsersAsyncAsync (UserDeleteRequestModel userDeleteRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<DefaultServiceReturnModel> localVarResponse = await DeleteUsersAsyncAsyncWithHttpInfo(userDeleteRequest, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Delete a User. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="userDeleteRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (DefaultServiceReturnModel)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<DefaultServiceReturnModel>> DeleteUsersAsyncAsyncWithHttpInfo (UserDeleteRequestModel userDeleteRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'userDeleteRequest' is set
            if (userDeleteRequest == null)
                throw new ApiException(400, "Missing required parameter 'userDeleteRequest' when calling UsersApi->DeleteUsersAsync");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling UsersApi->DeleteUsersAsync");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling UsersApi->DeleteUsersAsync");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling UsersApi->DeleteUsersAsync");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling UsersApi->DeleteUsersAsync");

            var localVarPath = "/api/v5/users";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (userDeleteRequest != null && userDeleteRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(userDeleteRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = userDeleteRequest; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.DELETE, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("DeleteUsersAsync", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<DefaultServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (DefaultServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(DefaultServiceReturnModel)));
        }

        /// <summary>
        /// Get User. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="userRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>UserDetailsServiceReturnModel</returns>
        public UserDetailsServiceReturnModel GetUsers (UserDetailsRequestModel userRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<UserDetailsServiceReturnModel> localVarResponse = GetUsersWithHttpInfo(userRequest, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Get User. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="userRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of UserDetailsServiceReturnModel</returns>
        public ApiResponse< UserDetailsServiceReturnModel > GetUsersWithHttpInfo (UserDetailsRequestModel userRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'userRequest' is set
            if (userRequest == null)
                throw new ApiException(400, "Missing required parameter 'userRequest' when calling UsersApi->GetUsers");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling UsersApi->GetUsers");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling UsersApi->GetUsers");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling UsersApi->GetUsers");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling UsersApi->GetUsers");

            var localVarPath = "/api/v5/users";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (userRequest != null && userRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(userRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = userRequest; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetUsers", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<UserDetailsServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (UserDetailsServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(UserDetailsServiceReturnModel)));
        }

        /// <summary>
        /// Get User. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="userRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of UserDetailsServiceReturnModel</returns>
        public async System.Threading.Tasks.Task<UserDetailsServiceReturnModel> GetUsersAsync (UserDetailsRequestModel userRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<UserDetailsServiceReturnModel> localVarResponse = await GetUsersAsyncWithHttpInfo(userRequest, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Get User. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="userRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (UserDetailsServiceReturnModel)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<UserDetailsServiceReturnModel>> GetUsersAsyncWithHttpInfo (UserDetailsRequestModel userRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'userRequest' is set
            if (userRequest == null)
                throw new ApiException(400, "Missing required parameter 'userRequest' when calling UsersApi->GetUsers");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling UsersApi->GetUsers");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling UsersApi->GetUsers");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling UsersApi->GetUsers");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling UsersApi->GetUsers");

            var localVarPath = "/api/v5/users";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (userRequest != null && userRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(userRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = userRequest; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("GetUsers", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<UserDetailsServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (UserDetailsServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(UserDetailsServiceReturnModel)));
        }

        /// <summary>
        /// Insert User. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="userInsertRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>UserDetailsServiceReturnModel</returns>
        public UserDetailsServiceReturnModel InsertUsersAsync (UserInsertRequestModel userInsertRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<UserDetailsServiceReturnModel> localVarResponse = InsertUsersAsyncWithHttpInfo(userInsertRequest, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Insert User. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="userInsertRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of UserDetailsServiceReturnModel</returns>
        public ApiResponse< UserDetailsServiceReturnModel > InsertUsersAsyncWithHttpInfo (UserInsertRequestModel userInsertRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'userInsertRequest' is set
            if (userInsertRequest == null)
                throw new ApiException(400, "Missing required parameter 'userInsertRequest' when calling UsersApi->InsertUsersAsync");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling UsersApi->InsertUsersAsync");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling UsersApi->InsertUsersAsync");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling UsersApi->InsertUsersAsync");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling UsersApi->InsertUsersAsync");

            var localVarPath = "/api/v5/users/insert";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (userInsertRequest != null && userInsertRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(userInsertRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = userInsertRequest; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("InsertUsersAsync", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<UserDetailsServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (UserDetailsServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(UserDetailsServiceReturnModel)));
        }

        /// <summary>
        /// Insert User. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="userInsertRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of UserDetailsServiceReturnModel</returns>
        public async System.Threading.Tasks.Task<UserDetailsServiceReturnModel> InsertUsersAsyncAsync (UserInsertRequestModel userInsertRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<UserDetailsServiceReturnModel> localVarResponse = await InsertUsersAsyncAsyncWithHttpInfo(userInsertRequest, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Insert User. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="userInsertRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (UserDetailsServiceReturnModel)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<UserDetailsServiceReturnModel>> InsertUsersAsyncAsyncWithHttpInfo (UserInsertRequestModel userInsertRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'userInsertRequest' is set
            if (userInsertRequest == null)
                throw new ApiException(400, "Missing required parameter 'userInsertRequest' when calling UsersApi->InsertUsersAsync");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling UsersApi->InsertUsersAsync");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling UsersApi->InsertUsersAsync");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling UsersApi->InsertUsersAsync");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling UsersApi->InsertUsersAsync");

            var localVarPath = "/api/v5/users/insert";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (userInsertRequest != null && userInsertRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(userInsertRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = userInsertRequest; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.POST, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("InsertUsersAsync", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<UserDetailsServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (UserDetailsServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(UserDetailsServiceReturnModel)));
        }

        /// <summary>
        /// Update an existing User. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="userUpdateRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>DefaultServiceReturnModel</returns>
        public DefaultServiceReturnModel UpdateUsersAsync (UserUpdateRequestModel userUpdateRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<DefaultServiceReturnModel> localVarResponse = UpdateUsersAsyncWithHttpInfo(userUpdateRequest, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;
        }

        /// <summary>
        /// Update an existing User. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="userUpdateRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>ApiResponse of DefaultServiceReturnModel</returns>
        public ApiResponse< DefaultServiceReturnModel > UpdateUsersAsyncWithHttpInfo (UserUpdateRequestModel userUpdateRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'userUpdateRequest' is set
            if (userUpdateRequest == null)
                throw new ApiException(400, "Missing required parameter 'userUpdateRequest' when calling UsersApi->UpdateUsersAsync");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling UsersApi->UpdateUsersAsync");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling UsersApi->UpdateUsersAsync");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling UsersApi->UpdateUsersAsync");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling UsersApi->UpdateUsersAsync");

            var localVarPath = "/api/v5/users";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (userUpdateRequest != null && userUpdateRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(userUpdateRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = userUpdateRequest; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) this.Configuration.ApiClient.CallApi(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UpdateUsersAsync", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<DefaultServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (DefaultServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(DefaultServiceReturnModel)));
        }

        /// <summary>
        /// Update an existing User. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="userUpdateRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of DefaultServiceReturnModel</returns>
        public async System.Threading.Tasks.Task<DefaultServiceReturnModel> UpdateUsersAsyncAsync (UserUpdateRequestModel userUpdateRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
             ApiResponse<DefaultServiceReturnModel> localVarResponse = await UpdateUsersAsyncAsyncWithHttpInfo(userUpdateRequest, apiKey, apiSecret, apiUsername, apiPassword);
             return localVarResponse.Data;

        }

        /// <summary>
        /// Update an existing User. 
        /// </summary>
        /// <exception cref="IO.Swagger.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="userUpdateRequest"></param>
        /// <param name="apiKey"></param>
        /// <param name="apiSecret"></param>
        /// <param name="apiUsername"></param>
        /// <param name="apiPassword"></param>
        /// <returns>Task of ApiResponse (DefaultServiceReturnModel)</returns>
        public async System.Threading.Tasks.Task<ApiResponse<DefaultServiceReturnModel>> UpdateUsersAsyncAsyncWithHttpInfo (UserUpdateRequestModel userUpdateRequest, string apiKey, string apiSecret, string apiUsername, string apiPassword)
        {
            // verify the required parameter 'userUpdateRequest' is set
            if (userUpdateRequest == null)
                throw new ApiException(400, "Missing required parameter 'userUpdateRequest' when calling UsersApi->UpdateUsersAsync");
            // verify the required parameter 'apiKey' is set
            if (apiKey == null)
                throw new ApiException(400, "Missing required parameter 'apiKey' when calling UsersApi->UpdateUsersAsync");
            // verify the required parameter 'apiSecret' is set
            if (apiSecret == null)
                throw new ApiException(400, "Missing required parameter 'apiSecret' when calling UsersApi->UpdateUsersAsync");
            // verify the required parameter 'apiUsername' is set
            if (apiUsername == null)
                throw new ApiException(400, "Missing required parameter 'apiUsername' when calling UsersApi->UpdateUsersAsync");
            // verify the required parameter 'apiPassword' is set
            if (apiPassword == null)
                throw new ApiException(400, "Missing required parameter 'apiPassword' when calling UsersApi->UpdateUsersAsync");

            var localVarPath = "/api/v5/users";
            var localVarPathParams = new Dictionary<String, String>();
            var localVarQueryParams = new List<KeyValuePair<String, String>>();
            var localVarHeaderParams = new Dictionary<String, String>(this.Configuration.DefaultHeader);
            var localVarFormParams = new Dictionary<String, String>();
            var localVarFileParams = new Dictionary<String, FileParameter>();
            Object localVarPostBody = null;

            // to determine the Content-Type header
            String[] localVarHttpContentTypes = new String[] {
                "application/json", 
                "text/json", 
                "application/xml", 
                "text/xml", 
                "application/x-www-form-urlencoded"
            };
            String localVarHttpContentType = this.Configuration.ApiClient.SelectHeaderContentType(localVarHttpContentTypes);

            // to determine the Accept header
            String[] localVarHttpHeaderAccepts = new String[] {
                "application/json",
                "text/json",
                "application/xml",
                "text/xml"
            };
            String localVarHttpHeaderAccept = this.Configuration.ApiClient.SelectHeaderAccept(localVarHttpHeaderAccepts);
            if (localVarHttpHeaderAccept != null)
                localVarHeaderParams.Add("Accept", localVarHttpHeaderAccept);

            if (apiKey != null) localVarHeaderParams.Add("ApiKey", this.Configuration.ApiClient.ParameterToString(apiKey)); // header parameter
            if (apiSecret != null) localVarHeaderParams.Add("ApiSecret", this.Configuration.ApiClient.ParameterToString(apiSecret)); // header parameter
            if (apiUsername != null) localVarHeaderParams.Add("ApiUsername", this.Configuration.ApiClient.ParameterToString(apiUsername)); // header parameter
            if (apiPassword != null) localVarHeaderParams.Add("ApiPassword", this.Configuration.ApiClient.ParameterToString(apiPassword)); // header parameter
            if (userUpdateRequest != null && userUpdateRequest.GetType() != typeof(byte[]))
            {
                localVarPostBody = this.Configuration.ApiClient.Serialize(userUpdateRequest); // http body (model) parameter
            }
            else
            {
                localVarPostBody = userUpdateRequest; // byte array
            }


            // make the HTTP request
            IRestResponse localVarResponse = (IRestResponse) await this.Configuration.ApiClient.CallApiAsync(localVarPath,
                Method.PUT, localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarFileParams,
                localVarPathParams, localVarHttpContentType);

            int localVarStatusCode = (int) localVarResponse.StatusCode;

            if (ExceptionFactory != null)
            {
                Exception exception = ExceptionFactory("UpdateUsersAsync", localVarResponse);
                if (exception != null) throw exception;
            }

            return new ApiResponse<DefaultServiceReturnModel>(localVarStatusCode,
                localVarResponse.Headers.ToDictionary(x => x.Name, x => x.Value.ToString()),
                (DefaultServiceReturnModel) this.Configuration.ApiClient.Deserialize(localVarResponse, typeof(DefaultServiceReturnModel)));
        }

    }
}
