/* 
 * API Version: 5.0
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v5
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// AdditionalSignaturePageModel
    /// </summary>
    [DataContract]
    public partial class AdditionalSignaturePageModel :  IEquatable<AdditionalSignaturePageModel>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="AdditionalSignaturePageModel" /> class.
        /// </summary>
        /// <param name="headerText">headerText.</param>
        /// <param name="statementText">statementText.</param>
        /// <param name="numberOfPages">numberOfPages.</param>
        public AdditionalSignaturePageModel(string headerText = default(string), string statementText = default(string), int? numberOfPages = default(int?))
        {
            this.HeaderText = headerText;
            this.StatementText = statementText;
            this.NumberOfPages = numberOfPages;
        }
        
        /// <summary>
        /// Gets or Sets HeaderText
        /// </summary>
        [DataMember(Name="HeaderText", EmitDefaultValue=false)]
        public string HeaderText { get; set; }

        /// <summary>
        /// Gets or Sets StatementText
        /// </summary>
        [DataMember(Name="StatementText", EmitDefaultValue=false)]
        public string StatementText { get; set; }

        /// <summary>
        /// Gets or Sets NumberOfPages
        /// </summary>
        [DataMember(Name="NumberOfPages", EmitDefaultValue=false)]
        public int? NumberOfPages { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class AdditionalSignaturePageModel {\n");
            sb.Append("  HeaderText: ").Append(HeaderText).Append("\n");
            sb.Append("  StatementText: ").Append(StatementText).Append("\n");
            sb.Append("  NumberOfPages: ").Append(NumberOfPages).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as AdditionalSignaturePageModel);
        }

        /// <summary>
        /// Returns true if AdditionalSignaturePageModel instances are equal
        /// </summary>
        /// <param name="input">Instance of AdditionalSignaturePageModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(AdditionalSignaturePageModel input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.HeaderText == input.HeaderText ||
                    (this.HeaderText != null &&
                    this.HeaderText.Equals(input.HeaderText))
                ) && 
                (
                    this.StatementText == input.StatementText ||
                    (this.StatementText != null &&
                    this.StatementText.Equals(input.StatementText))
                ) && 
                (
                    this.NumberOfPages == input.NumberOfPages ||
                    (this.NumberOfPages != null &&
                    this.NumberOfPages.Equals(input.NumberOfPages))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.HeaderText != null)
                    hashCode = hashCode * 59 + this.HeaderText.GetHashCode();
                if (this.StatementText != null)
                    hashCode = hashCode * 59 + this.StatementText.GetHashCode();
                if (this.NumberOfPages != null)
                    hashCode = hashCode * 59 + this.NumberOfPages.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // HeaderText (string) maxLength
            if(this.HeaderText != null && this.HeaderText.Length > 80)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for HeaderText, length must be less than 80.", new [] { "HeaderText" });
            }

            // HeaderText (string) minLength
            if(this.HeaderText != null && this.HeaderText.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for HeaderText, length must be greater than 0.", new [] { "HeaderText" });
            }

            yield break;
        }
    }

}
