/* 
 * API Version: 5.0
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v5
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// AuditReportDetailsRequestModel
    /// </summary>
    [DataContract]
    public partial class AuditReportDetailsRequestModel :  IEquatable<AuditReportDetailsRequestModel>, IValidatableObject
    {
        /// <summary>
        /// Defines AuditReportType
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum AuditReportTypeEnum
        {
            
            /// <summary>
            /// Enum Pdf for value: Pdf
            /// </summary>
            [EnumMember(Value = "Pdf")]
            Pdf = 1,
            
            /// <summary>
            /// Enum Xml for value: Xml
            /// </summary>
            [EnumMember(Value = "Xml")]
            Xml = 2
        }

        /// <summary>
        /// Gets or Sets AuditReportType
        /// </summary>
        [DataMember(Name="AuditReportType", EmitDefaultValue=false)]
        public AuditReportTypeEnum? AuditReportType { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="AuditReportDetailsRequestModel" /> class.
        /// </summary>
        /// <param name="iDs">iDs.</param>
        /// <param name="transactionIDs">transactionIDs.</param>
        /// <param name="participantIDs">participantIDs.</param>
        /// <param name="taskIDs">taskIDs.</param>
        /// <param name="auditReportType">auditReportType.</param>
        /// <param name="enableLogging">enableLogging.</param>
        /// <param name="timeZoneID">timeZoneID.</param>
        public AuditReportDetailsRequestModel(List<Object> iDs = default(List<Object>), List<Object> transactionIDs = default(List<Object>), List<Object> participantIDs = default(List<Object>), List<Object> taskIDs = default(List<Object>), AuditReportTypeEnum? auditReportType = default(AuditReportTypeEnum?), bool? enableLogging = default(bool?), string timeZoneID = default(string))
        {
            this.IDs = iDs;
            this.TransactionIDs = transactionIDs;
            this.ParticipantIDs = participantIDs;
            this.TaskIDs = taskIDs;
            this.AuditReportType = auditReportType;
            this.EnableLogging = enableLogging;
            this.TimeZoneID = timeZoneID;
        }
        
        /// <summary>
        /// Gets or Sets IDs
        /// </summary>
        [DataMember(Name="IDs", EmitDefaultValue=false)]
        public List<Object> IDs { get; set; }

        /// <summary>
        /// Gets or Sets TransactionIDs
        /// </summary>
        [DataMember(Name="TransactionIDs", EmitDefaultValue=false)]
        public List<Object> TransactionIDs { get; set; }

        /// <summary>
        /// Gets or Sets ParticipantIDs
        /// </summary>
        [DataMember(Name="ParticipantIDs", EmitDefaultValue=false)]
        public List<Object> ParticipantIDs { get; set; }

        /// <summary>
        /// Gets or Sets TaskIDs
        /// </summary>
        [DataMember(Name="TaskIDs", EmitDefaultValue=false)]
        public List<Object> TaskIDs { get; set; }


        /// <summary>
        /// Gets or Sets EnableLogging
        /// </summary>
        [DataMember(Name="EnableLogging", EmitDefaultValue=false)]
        public bool? EnableLogging { get; set; }

        /// <summary>
        /// Gets or Sets TimeZoneID
        /// </summary>
        [DataMember(Name="TimeZoneID", EmitDefaultValue=false)]
        public string TimeZoneID { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class AuditReportDetailsRequestModel {\n");
            sb.Append("  IDs: ").Append(IDs).Append("\n");
            sb.Append("  TransactionIDs: ").Append(TransactionIDs).Append("\n");
            sb.Append("  ParticipantIDs: ").Append(ParticipantIDs).Append("\n");
            sb.Append("  TaskIDs: ").Append(TaskIDs).Append("\n");
            sb.Append("  AuditReportType: ").Append(AuditReportType).Append("\n");
            sb.Append("  EnableLogging: ").Append(EnableLogging).Append("\n");
            sb.Append("  TimeZoneID: ").Append(TimeZoneID).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as AuditReportDetailsRequestModel);
        }

        /// <summary>
        /// Returns true if AuditReportDetailsRequestModel instances are equal
        /// </summary>
        /// <param name="input">Instance of AuditReportDetailsRequestModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(AuditReportDetailsRequestModel input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.IDs == input.IDs ||
                    this.IDs != null &&
                    this.IDs.SequenceEqual(input.IDs)
                ) && 
                (
                    this.TransactionIDs == input.TransactionIDs ||
                    this.TransactionIDs != null &&
                    this.TransactionIDs.SequenceEqual(input.TransactionIDs)
                ) && 
                (
                    this.ParticipantIDs == input.ParticipantIDs ||
                    this.ParticipantIDs != null &&
                    this.ParticipantIDs.SequenceEqual(input.ParticipantIDs)
                ) && 
                (
                    this.TaskIDs == input.TaskIDs ||
                    this.TaskIDs != null &&
                    this.TaskIDs.SequenceEqual(input.TaskIDs)
                ) && 
                (
                    this.AuditReportType == input.AuditReportType ||
                    (this.AuditReportType != null &&
                    this.AuditReportType.Equals(input.AuditReportType))
                ) && 
                (
                    this.EnableLogging == input.EnableLogging ||
                    (this.EnableLogging != null &&
                    this.EnableLogging.Equals(input.EnableLogging))
                ) && 
                (
                    this.TimeZoneID == input.TimeZoneID ||
                    (this.TimeZoneID != null &&
                    this.TimeZoneID.Equals(input.TimeZoneID))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.IDs != null)
                    hashCode = hashCode * 59 + this.IDs.GetHashCode();
                if (this.TransactionIDs != null)
                    hashCode = hashCode * 59 + this.TransactionIDs.GetHashCode();
                if (this.ParticipantIDs != null)
                    hashCode = hashCode * 59 + this.ParticipantIDs.GetHashCode();
                if (this.TaskIDs != null)
                    hashCode = hashCode * 59 + this.TaskIDs.GetHashCode();
                if (this.AuditReportType != null)
                    hashCode = hashCode * 59 + this.AuditReportType.GetHashCode();
                if (this.EnableLogging != null)
                    hashCode = hashCode * 59 + this.EnableLogging.GetHashCode();
                if (this.TimeZoneID != null)
                    hashCode = hashCode * 59 + this.TimeZoneID.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
