/* 
 * API Version: 5.0
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v5
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// AuthenticationModel
    /// </summary>
    [DataContract]
    public partial class AuthenticationModel :  IEquatable<AuthenticationModel>, IValidatableObject
    {
        /// <summary>
        /// Defines Type
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum TypeEnum
        {
            
            /// <summary>
            /// Enum Password for value: Password
            /// </summary>
            [EnumMember(Value = "Password")]
            Password = 1,
            
            /// <summary>
            /// Enum PasswordHashed for value: PasswordHashed
            /// </summary>
            [EnumMember(Value = "PasswordHashed")]
            PasswordHashed = 2,
            
            /// <summary>
            /// Enum RegisteredUser for value: RegisteredUser
            /// </summary>
            [EnumMember(Value = "RegisteredUser")]
            RegisteredUser = 3,
            
            /// <summary>
            /// Enum Federation for value: Federation
            /// </summary>
            [EnumMember(Value = "Federation")]
            Federation = 4,
            
            /// <summary>
            /// Enum Experian for value: Experian
            /// </summary>
            [EnumMember(Value = "Experian")]
            Experian = 5,
            
            /// <summary>
            /// Enum KBA for value: KBA
            /// </summary>
            [EnumMember(Value = "KBA")]
            KBA = 6,
            
            /// <summary>
            /// Enum Mobile for value: Mobile
            /// </summary>
            [EnumMember(Value = "Mobile")]
            Mobile = 7
        }

        /// <summary>
        /// Gets or Sets Type
        /// </summary>
        [DataMember(Name="Type", EmitDefaultValue=false)]
        public TypeEnum Type { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="AuthenticationModel" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected AuthenticationModel() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="AuthenticationModel" /> class.
        /// </summary>
        /// <param name="type">type (required).</param>
        /// <param name="data">data (required).</param>
        /// <param name="twoFactorAuthentication">twoFactorAuthentication.</param>
        public AuthenticationModel(TypeEnum type = default(TypeEnum), string data = default(string), AuthenticationModel twoFactorAuthentication = default(AuthenticationModel))
        {
            // to ensure "type" is required (not null)
            if (type == null)
            {
                throw new InvalidDataException("type is a required property for AuthenticationModel and cannot be null");
            }
            else
            {
                this.Type = type;
            }
            // to ensure "data" is required (not null)
            if (data == null)
            {
                throw new InvalidDataException("data is a required property for AuthenticationModel and cannot be null");
            }
            else
            {
                this.Data = data;
            }
            this.TwoFactorAuthentication = twoFactorAuthentication;
        }
        

        /// <summary>
        /// Gets or Sets Data
        /// </summary>
        [DataMember(Name="Data", EmitDefaultValue=false)]
        public string Data { get; set; }

        /// <summary>
        /// Gets or Sets TwoFactorAuthentication
        /// </summary>
        [DataMember(Name="TwoFactorAuthentication", EmitDefaultValue=false)]
        public AuthenticationModel TwoFactorAuthentication { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class AuthenticationModel {\n");
            sb.Append("  Type: ").Append(Type).Append("\n");
            sb.Append("  Data: ").Append(Data).Append("\n");
            sb.Append("  TwoFactorAuthentication: ").Append(TwoFactorAuthentication).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as AuthenticationModel);
        }

        /// <summary>
        /// Returns true if AuthenticationModel instances are equal
        /// </summary>
        /// <param name="input">Instance of AuthenticationModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(AuthenticationModel input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Type == input.Type ||
                    (this.Type != null &&
                    this.Type.Equals(input.Type))
                ) && 
                (
                    this.Data == input.Data ||
                    (this.Data != null &&
                    this.Data.Equals(input.Data))
                ) && 
                (
                    this.TwoFactorAuthentication == input.TwoFactorAuthentication ||
                    (this.TwoFactorAuthentication != null &&
                    this.TwoFactorAuthentication.Equals(input.TwoFactorAuthentication))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Type != null)
                    hashCode = hashCode * 59 + this.Type.GetHashCode();
                if (this.Data != null)
                    hashCode = hashCode * 59 + this.Data.GetHashCode();
                if (this.TwoFactorAuthentication != null)
                    hashCode = hashCode * 59 + this.TwoFactorAuthentication.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
