/* 
 * API Version: 5.0
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v5
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// DocumentCompletedUpdateableRequestModel
    /// </summary>
    [DataContract]
    public partial class DocumentCompletedUpdateableRequestModel :  IEquatable<DocumentCompletedUpdateableRequestModel>, IValidatableObject
    {
        /// <summary>
        /// Defines SearchDateType
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum SearchDateTypeEnum
        {
            
            /// <summary>
            /// Enum CreatedDate for value: CreatedDate
            /// </summary>
            [EnumMember(Value = "CreatedDate")]
            CreatedDate = 1,
            
            /// <summary>
            /// Enum ClosedDate for value: ClosedDate
            /// </summary>
            [EnumMember(Value = "ClosedDate")]
            ClosedDate = 2
        }

        /// <summary>
        /// Gets or Sets SearchDateType
        /// </summary>
        [DataMember(Name="SearchDateType", EmitDefaultValue=false)]
        public SearchDateTypeEnum? SearchDateType { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="DocumentCompletedUpdateableRequestModel" /> class.
        /// </summary>
        /// <param name="prontoID">prontoID.</param>
        /// <param name="iDs">iDs.</param>
        /// <param name="transactionIDs">transactionIDs.</param>
        /// <param name="participantIDs">participantIDs.</param>
        /// <param name="taskIDs">taskIDs.</param>
        /// <param name="metaDataName">metaDataName.</param>
        /// <param name="metaDataValue">metaDataValue.</param>
        /// <param name="searchDateType">searchDateType.</param>
        /// <param name="searchDateFrom">searchDateFrom.</param>
        /// <param name="searchDateTo">searchDateTo.</param>
        /// <param name="enableLogging">enableLogging.</param>
        /// <param name="resultsCountLimit">resultsCountLimit.</param>
        /// <param name="resultsCountStart">resultsCountStart.</param>
        public DocumentCompletedUpdateableRequestModel(string prontoID = default(string), List<Object> iDs = default(List<Object>), List<Object> transactionIDs = default(List<Object>), List<Object> participantIDs = default(List<Object>), List<Object> taskIDs = default(List<Object>), string metaDataName = default(string), string metaDataValue = default(string), SearchDateTypeEnum? searchDateType = default(SearchDateTypeEnum?), DateTime? searchDateFrom = default(DateTime?), DateTime? searchDateTo = default(DateTime?), bool? enableLogging = default(bool?), int? resultsCountLimit = default(int?), int? resultsCountStart = default(int?))
        {
            this.ProntoID = prontoID;
            this.IDs = iDs;
            this.TransactionIDs = transactionIDs;
            this.ParticipantIDs = participantIDs;
            this.TaskIDs = taskIDs;
            this.MetaDataName = metaDataName;
            this.MetaDataValue = metaDataValue;
            this.SearchDateType = searchDateType;
            this.SearchDateFrom = searchDateFrom;
            this.SearchDateTo = searchDateTo;
            this.EnableLogging = enableLogging;
            this.ResultsCountLimit = resultsCountLimit;
            this.ResultsCountStart = resultsCountStart;
        }
        
        /// <summary>
        /// Gets or Sets ProntoID
        /// </summary>
        [DataMember(Name="ProntoID", EmitDefaultValue=false)]
        public string ProntoID { get; set; }

        /// <summary>
        /// Gets or Sets IDs
        /// </summary>
        [DataMember(Name="IDs", EmitDefaultValue=false)]
        public List<Object> IDs { get; set; }

        /// <summary>
        /// Gets or Sets TransactionIDs
        /// </summary>
        [DataMember(Name="TransactionIDs", EmitDefaultValue=false)]
        public List<Object> TransactionIDs { get; set; }

        /// <summary>
        /// Gets or Sets ParticipantIDs
        /// </summary>
        [DataMember(Name="ParticipantIDs", EmitDefaultValue=false)]
        public List<Object> ParticipantIDs { get; set; }

        /// <summary>
        /// Gets or Sets TaskIDs
        /// </summary>
        [DataMember(Name="TaskIDs", EmitDefaultValue=false)]
        public List<Object> TaskIDs { get; set; }

        /// <summary>
        /// Gets or Sets MetaDataName
        /// </summary>
        [DataMember(Name="MetaDataName", EmitDefaultValue=false)]
        public string MetaDataName { get; set; }

        /// <summary>
        /// Gets or Sets MetaDataValue
        /// </summary>
        [DataMember(Name="MetaDataValue", EmitDefaultValue=false)]
        public string MetaDataValue { get; set; }


        /// <summary>
        /// Gets or Sets SearchDateFrom
        /// </summary>
        [DataMember(Name="SearchDateFrom", EmitDefaultValue=false)]
        public DateTime? SearchDateFrom { get; set; }

        /// <summary>
        /// Gets or Sets SearchDateTo
        /// </summary>
        [DataMember(Name="SearchDateTo", EmitDefaultValue=false)]
        public DateTime? SearchDateTo { get; set; }

        /// <summary>
        /// Gets or Sets EnableLogging
        /// </summary>
        [DataMember(Name="EnableLogging", EmitDefaultValue=false)]
        public bool? EnableLogging { get; set; }

        /// <summary>
        /// Gets or Sets ResultsCountLimit
        /// </summary>
        [DataMember(Name="ResultsCountLimit", EmitDefaultValue=false)]
        public int? ResultsCountLimit { get; set; }

        /// <summary>
        /// Gets or Sets ResultsCountStart
        /// </summary>
        [DataMember(Name="ResultsCountStart", EmitDefaultValue=false)]
        public int? ResultsCountStart { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class DocumentCompletedUpdateableRequestModel {\n");
            sb.Append("  ProntoID: ").Append(ProntoID).Append("\n");
            sb.Append("  IDs: ").Append(IDs).Append("\n");
            sb.Append("  TransactionIDs: ").Append(TransactionIDs).Append("\n");
            sb.Append("  ParticipantIDs: ").Append(ParticipantIDs).Append("\n");
            sb.Append("  TaskIDs: ").Append(TaskIDs).Append("\n");
            sb.Append("  MetaDataName: ").Append(MetaDataName).Append("\n");
            sb.Append("  MetaDataValue: ").Append(MetaDataValue).Append("\n");
            sb.Append("  SearchDateType: ").Append(SearchDateType).Append("\n");
            sb.Append("  SearchDateFrom: ").Append(SearchDateFrom).Append("\n");
            sb.Append("  SearchDateTo: ").Append(SearchDateTo).Append("\n");
            sb.Append("  EnableLogging: ").Append(EnableLogging).Append("\n");
            sb.Append("  ResultsCountLimit: ").Append(ResultsCountLimit).Append("\n");
            sb.Append("  ResultsCountStart: ").Append(ResultsCountStart).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as DocumentCompletedUpdateableRequestModel);
        }

        /// <summary>
        /// Returns true if DocumentCompletedUpdateableRequestModel instances are equal
        /// </summary>
        /// <param name="input">Instance of DocumentCompletedUpdateableRequestModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(DocumentCompletedUpdateableRequestModel input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ProntoID == input.ProntoID ||
                    (this.ProntoID != null &&
                    this.ProntoID.Equals(input.ProntoID))
                ) && 
                (
                    this.IDs == input.IDs ||
                    this.IDs != null &&
                    this.IDs.SequenceEqual(input.IDs)
                ) && 
                (
                    this.TransactionIDs == input.TransactionIDs ||
                    this.TransactionIDs != null &&
                    this.TransactionIDs.SequenceEqual(input.TransactionIDs)
                ) && 
                (
                    this.ParticipantIDs == input.ParticipantIDs ||
                    this.ParticipantIDs != null &&
                    this.ParticipantIDs.SequenceEqual(input.ParticipantIDs)
                ) && 
                (
                    this.TaskIDs == input.TaskIDs ||
                    this.TaskIDs != null &&
                    this.TaskIDs.SequenceEqual(input.TaskIDs)
                ) && 
                (
                    this.MetaDataName == input.MetaDataName ||
                    (this.MetaDataName != null &&
                    this.MetaDataName.Equals(input.MetaDataName))
                ) && 
                (
                    this.MetaDataValue == input.MetaDataValue ||
                    (this.MetaDataValue != null &&
                    this.MetaDataValue.Equals(input.MetaDataValue))
                ) && 
                (
                    this.SearchDateType == input.SearchDateType ||
                    (this.SearchDateType != null &&
                    this.SearchDateType.Equals(input.SearchDateType))
                ) && 
                (
                    this.SearchDateFrom == input.SearchDateFrom ||
                    (this.SearchDateFrom != null &&
                    this.SearchDateFrom.Equals(input.SearchDateFrom))
                ) && 
                (
                    this.SearchDateTo == input.SearchDateTo ||
                    (this.SearchDateTo != null &&
                    this.SearchDateTo.Equals(input.SearchDateTo))
                ) && 
                (
                    this.EnableLogging == input.EnableLogging ||
                    (this.EnableLogging != null &&
                    this.EnableLogging.Equals(input.EnableLogging))
                ) && 
                (
                    this.ResultsCountLimit == input.ResultsCountLimit ||
                    (this.ResultsCountLimit != null &&
                    this.ResultsCountLimit.Equals(input.ResultsCountLimit))
                ) && 
                (
                    this.ResultsCountStart == input.ResultsCountStart ||
                    (this.ResultsCountStart != null &&
                    this.ResultsCountStart.Equals(input.ResultsCountStart))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ProntoID != null)
                    hashCode = hashCode * 59 + this.ProntoID.GetHashCode();
                if (this.IDs != null)
                    hashCode = hashCode * 59 + this.IDs.GetHashCode();
                if (this.TransactionIDs != null)
                    hashCode = hashCode * 59 + this.TransactionIDs.GetHashCode();
                if (this.ParticipantIDs != null)
                    hashCode = hashCode * 59 + this.ParticipantIDs.GetHashCode();
                if (this.TaskIDs != null)
                    hashCode = hashCode * 59 + this.TaskIDs.GetHashCode();
                if (this.MetaDataName != null)
                    hashCode = hashCode * 59 + this.MetaDataName.GetHashCode();
                if (this.MetaDataValue != null)
                    hashCode = hashCode * 59 + this.MetaDataValue.GetHashCode();
                if (this.SearchDateType != null)
                    hashCode = hashCode * 59 + this.SearchDateType.GetHashCode();
                if (this.SearchDateFrom != null)
                    hashCode = hashCode * 59 + this.SearchDateFrom.GetHashCode();
                if (this.SearchDateTo != null)
                    hashCode = hashCode * 59 + this.SearchDateTo.GetHashCode();
                if (this.EnableLogging != null)
                    hashCode = hashCode * 59 + this.EnableLogging.GetHashCode();
                if (this.ResultsCountLimit != null)
                    hashCode = hashCode * 59 + this.ResultsCountLimit.GetHashCode();
                if (this.ResultsCountStart != null)
                    hashCode = hashCode * 59 + this.ResultsCountStart.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
