/* 
 * API Version: 5.0
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v5
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// DocumentFileIncludesModel
    /// </summary>
    [DataContract]
    public partial class DocumentFileIncludesModel :  IEquatable<DocumentFileIncludesModel>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="DocumentFileIncludesModel" /> class.
        /// </summary>
        /// <param name="includeNonWatermarkedVersion">includeNonWatermarkedVersion.</param>
        /// <param name="includePdfStampedWithCopyWatermark">includePdfStampedWithCopyWatermark.</param>
        /// <param name="includeFileUnlocked">includeFileUnlocked.</param>
        /// <param name="includeOriginalSourceFile">includeOriginalSourceFile.</param>
        /// <param name="includeSpecificVersion">includeSpecificVersion.</param>
        public DocumentFileIncludesModel(bool? includeNonWatermarkedVersion = default(bool?), bool? includePdfStampedWithCopyWatermark = default(bool?), bool? includeFileUnlocked = default(bool?), bool? includeOriginalSourceFile = default(bool?), int? includeSpecificVersion = default(int?))
        {
            this.IncludeNonWatermarkedVersion = includeNonWatermarkedVersion;
            this.IncludePdfStampedWithCopyWatermark = includePdfStampedWithCopyWatermark;
            this.IncludeFileUnlocked = includeFileUnlocked;
            this.IncludeOriginalSourceFile = includeOriginalSourceFile;
            this.IncludeSpecificVersion = includeSpecificVersion;
        }
        
        /// <summary>
        /// Gets or Sets IncludeNonWatermarkedVersion
        /// </summary>
        [DataMember(Name="IncludeNonWatermarkedVersion", EmitDefaultValue=false)]
        public bool? IncludeNonWatermarkedVersion { get; set; }

        /// <summary>
        /// Gets or Sets IncludePdfStampedWithCopyWatermark
        /// </summary>
        [DataMember(Name="IncludePdfStampedWithCopyWatermark", EmitDefaultValue=false)]
        public bool? IncludePdfStampedWithCopyWatermark { get; set; }

        /// <summary>
        /// Gets or Sets IncludeFileUnlocked
        /// </summary>
        [DataMember(Name="IncludeFileUnlocked", EmitDefaultValue=false)]
        public bool? IncludeFileUnlocked { get; set; }

        /// <summary>
        /// Gets or Sets IncludeOriginalSourceFile
        /// </summary>
        [DataMember(Name="IncludeOriginalSourceFile", EmitDefaultValue=false)]
        public bool? IncludeOriginalSourceFile { get; set; }

        /// <summary>
        /// Gets or Sets IncludeSpecificVersion
        /// </summary>
        [DataMember(Name="IncludeSpecificVersion", EmitDefaultValue=false)]
        public int? IncludeSpecificVersion { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class DocumentFileIncludesModel {\n");
            sb.Append("  IncludeNonWatermarkedVersion: ").Append(IncludeNonWatermarkedVersion).Append("\n");
            sb.Append("  IncludePdfStampedWithCopyWatermark: ").Append(IncludePdfStampedWithCopyWatermark).Append("\n");
            sb.Append("  IncludeFileUnlocked: ").Append(IncludeFileUnlocked).Append("\n");
            sb.Append("  IncludeOriginalSourceFile: ").Append(IncludeOriginalSourceFile).Append("\n");
            sb.Append("  IncludeSpecificVersion: ").Append(IncludeSpecificVersion).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as DocumentFileIncludesModel);
        }

        /// <summary>
        /// Returns true if DocumentFileIncludesModel instances are equal
        /// </summary>
        /// <param name="input">Instance of DocumentFileIncludesModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(DocumentFileIncludesModel input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.IncludeNonWatermarkedVersion == input.IncludeNonWatermarkedVersion ||
                    (this.IncludeNonWatermarkedVersion != null &&
                    this.IncludeNonWatermarkedVersion.Equals(input.IncludeNonWatermarkedVersion))
                ) && 
                (
                    this.IncludePdfStampedWithCopyWatermark == input.IncludePdfStampedWithCopyWatermark ||
                    (this.IncludePdfStampedWithCopyWatermark != null &&
                    this.IncludePdfStampedWithCopyWatermark.Equals(input.IncludePdfStampedWithCopyWatermark))
                ) && 
                (
                    this.IncludeFileUnlocked == input.IncludeFileUnlocked ||
                    (this.IncludeFileUnlocked != null &&
                    this.IncludeFileUnlocked.Equals(input.IncludeFileUnlocked))
                ) && 
                (
                    this.IncludeOriginalSourceFile == input.IncludeOriginalSourceFile ||
                    (this.IncludeOriginalSourceFile != null &&
                    this.IncludeOriginalSourceFile.Equals(input.IncludeOriginalSourceFile))
                ) && 
                (
                    this.IncludeSpecificVersion == input.IncludeSpecificVersion ||
                    (this.IncludeSpecificVersion != null &&
                    this.IncludeSpecificVersion.Equals(input.IncludeSpecificVersion))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.IncludeNonWatermarkedVersion != null)
                    hashCode = hashCode * 59 + this.IncludeNonWatermarkedVersion.GetHashCode();
                if (this.IncludePdfStampedWithCopyWatermark != null)
                    hashCode = hashCode * 59 + this.IncludePdfStampedWithCopyWatermark.GetHashCode();
                if (this.IncludeFileUnlocked != null)
                    hashCode = hashCode * 59 + this.IncludeFileUnlocked.GetHashCode();
                if (this.IncludeOriginalSourceFile != null)
                    hashCode = hashCode * 59 + this.IncludeOriginalSourceFile.GetHashCode();
                if (this.IncludeSpecificVersion != null)
                    hashCode = hashCode * 59 + this.IncludeSpecificVersion.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
