/* 
 * API Version: 5.0
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v5
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// DocumentFormFieldsModel
    /// </summary>
    [DataContract]
    public partial class DocumentFormFieldsModel :  IEquatable<DocumentFormFieldsModel>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="DocumentFormFieldsModel" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected DocumentFormFieldsModel() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="DocumentFormFieldsModel" /> class.
        /// </summary>
        /// <param name="documentID">documentID (required).</param>
        /// <param name="formFields">formFields (required).</param>
        /// <param name="clearAllFieldsBeforeUpdate">clearAllFieldsBeforeUpdate.</param>
        public DocumentFormFieldsModel(int? documentID = default(int?), List<Object> formFields = default(List<Object>), bool? clearAllFieldsBeforeUpdate = default(bool?))
        {
            // to ensure "documentID" is required (not null)
            if (documentID == null)
            {
                throw new InvalidDataException("documentID is a required property for DocumentFormFieldsModel and cannot be null");
            }
            else
            {
                this.DocumentID = documentID;
            }
            // to ensure "formFields" is required (not null)
            if (formFields == null)
            {
                throw new InvalidDataException("formFields is a required property for DocumentFormFieldsModel and cannot be null");
            }
            else
            {
                this.FormFields = formFields;
            }
            this.ClearAllFieldsBeforeUpdate = clearAllFieldsBeforeUpdate;
        }
        
        /// <summary>
        /// Gets or Sets DocumentID
        /// </summary>
        [DataMember(Name="DocumentID", EmitDefaultValue=false)]
        public int? DocumentID { get; set; }

        /// <summary>
        /// Gets or Sets FormFields
        /// </summary>
        [DataMember(Name="FormFields", EmitDefaultValue=false)]
        public List<Object> FormFields { get; set; }

        /// <summary>
        /// Gets or Sets ClearAllFieldsBeforeUpdate
        /// </summary>
        [DataMember(Name="ClearAllFieldsBeforeUpdate", EmitDefaultValue=false)]
        public bool? ClearAllFieldsBeforeUpdate { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class DocumentFormFieldsModel {\n");
            sb.Append("  DocumentID: ").Append(DocumentID).Append("\n");
            sb.Append("  FormFields: ").Append(FormFields).Append("\n");
            sb.Append("  ClearAllFieldsBeforeUpdate: ").Append(ClearAllFieldsBeforeUpdate).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as DocumentFormFieldsModel);
        }

        /// <summary>
        /// Returns true if DocumentFormFieldsModel instances are equal
        /// </summary>
        /// <param name="input">Instance of DocumentFormFieldsModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(DocumentFormFieldsModel input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.DocumentID == input.DocumentID ||
                    (this.DocumentID != null &&
                    this.DocumentID.Equals(input.DocumentID))
                ) && 
                (
                    this.FormFields == input.FormFields ||
                    this.FormFields != null &&
                    this.FormFields.SequenceEqual(input.FormFields)
                ) && 
                (
                    this.ClearAllFieldsBeforeUpdate == input.ClearAllFieldsBeforeUpdate ||
                    (this.ClearAllFieldsBeforeUpdate != null &&
                    this.ClearAllFieldsBeforeUpdate.Equals(input.ClearAllFieldsBeforeUpdate))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.DocumentID != null)
                    hashCode = hashCode * 59 + this.DocumentID.GetHashCode();
                if (this.FormFields != null)
                    hashCode = hashCode * 59 + this.FormFields.GetHashCode();
                if (this.ClearAllFieldsBeforeUpdate != null)
                    hashCode = hashCode * 59 + this.ClearAllFieldsBeforeUpdate.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
