/* 
 * API Version: 5.0
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v5
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// DocumentIncludesModel
    /// </summary>
    [DataContract]
    public partial class DocumentIncludesModel :  IEquatable<DocumentIncludesModel>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="DocumentIncludesModel" /> class.
        /// </summary>
        /// <param name="includeFile">includeFile.</param>
        /// <param name="fileIncludes">fileIncludes.</param>
        /// <param name="includeMetaData">includeMetaData.</param>
        /// <param name="includeWorkflowActions">includeWorkflowActions.</param>
        /// <param name="includeTasks">includeTasks.</param>
        /// <param name="taskIncludes">taskIncludes.</param>
        /// <param name="includeTests">includeTests.</param>
        /// <param name="includeVersions">includeVersions.</param>
        public DocumentIncludesModel(bool? includeFile = default(bool?), DocumentFileIncludesModel fileIncludes = default(DocumentFileIncludesModel), bool? includeMetaData = default(bool?), bool? includeWorkflowActions = default(bool?), bool? includeTasks = default(bool?), TaskIncludesModel taskIncludes = default(TaskIncludesModel), bool? includeTests = default(bool?), bool? includeVersions = default(bool?))
        {
            this.IncludeFile = includeFile;
            this.FileIncludes = fileIncludes;
            this.IncludeMetaData = includeMetaData;
            this.IncludeWorkflowActions = includeWorkflowActions;
            this.IncludeTasks = includeTasks;
            this.TaskIncludes = taskIncludes;
            this.IncludeTests = includeTests;
            this.IncludeVersions = includeVersions;
        }
        
        /// <summary>
        /// Gets or Sets IncludeFile
        /// </summary>
        [DataMember(Name="IncludeFile", EmitDefaultValue=false)]
        public bool? IncludeFile { get; set; }

        /// <summary>
        /// Gets or Sets FileIncludes
        /// </summary>
        [DataMember(Name="FileIncludes", EmitDefaultValue=false)]
        public DocumentFileIncludesModel FileIncludes { get; set; }

        /// <summary>
        /// Gets or Sets IncludeMetaData
        /// </summary>
        [DataMember(Name="IncludeMetaData", EmitDefaultValue=false)]
        public bool? IncludeMetaData { get; set; }

        /// <summary>
        /// Gets or Sets IncludeWorkflowActions
        /// </summary>
        [DataMember(Name="IncludeWorkflowActions", EmitDefaultValue=false)]
        public bool? IncludeWorkflowActions { get; set; }

        /// <summary>
        /// Gets or Sets IncludeTasks
        /// </summary>
        [DataMember(Name="IncludeTasks", EmitDefaultValue=false)]
        public bool? IncludeTasks { get; set; }

        /// <summary>
        /// Gets or Sets TaskIncludes
        /// </summary>
        [DataMember(Name="TaskIncludes", EmitDefaultValue=false)]
        public TaskIncludesModel TaskIncludes { get; set; }

        /// <summary>
        /// Gets or Sets IncludeTests
        /// </summary>
        [DataMember(Name="IncludeTests", EmitDefaultValue=false)]
        public bool? IncludeTests { get; set; }

        /// <summary>
        /// Gets or Sets IncludeVersions
        /// </summary>
        [DataMember(Name="IncludeVersions", EmitDefaultValue=false)]
        public bool? IncludeVersions { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class DocumentIncludesModel {\n");
            sb.Append("  IncludeFile: ").Append(IncludeFile).Append("\n");
            sb.Append("  FileIncludes: ").Append(FileIncludes).Append("\n");
            sb.Append("  IncludeMetaData: ").Append(IncludeMetaData).Append("\n");
            sb.Append("  IncludeWorkflowActions: ").Append(IncludeWorkflowActions).Append("\n");
            sb.Append("  IncludeTasks: ").Append(IncludeTasks).Append("\n");
            sb.Append("  TaskIncludes: ").Append(TaskIncludes).Append("\n");
            sb.Append("  IncludeTests: ").Append(IncludeTests).Append("\n");
            sb.Append("  IncludeVersions: ").Append(IncludeVersions).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as DocumentIncludesModel);
        }

        /// <summary>
        /// Returns true if DocumentIncludesModel instances are equal
        /// </summary>
        /// <param name="input">Instance of DocumentIncludesModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(DocumentIncludesModel input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.IncludeFile == input.IncludeFile ||
                    (this.IncludeFile != null &&
                    this.IncludeFile.Equals(input.IncludeFile))
                ) && 
                (
                    this.FileIncludes == input.FileIncludes ||
                    (this.FileIncludes != null &&
                    this.FileIncludes.Equals(input.FileIncludes))
                ) && 
                (
                    this.IncludeMetaData == input.IncludeMetaData ||
                    (this.IncludeMetaData != null &&
                    this.IncludeMetaData.Equals(input.IncludeMetaData))
                ) && 
                (
                    this.IncludeWorkflowActions == input.IncludeWorkflowActions ||
                    (this.IncludeWorkflowActions != null &&
                    this.IncludeWorkflowActions.Equals(input.IncludeWorkflowActions))
                ) && 
                (
                    this.IncludeTasks == input.IncludeTasks ||
                    (this.IncludeTasks != null &&
                    this.IncludeTasks.Equals(input.IncludeTasks))
                ) && 
                (
                    this.TaskIncludes == input.TaskIncludes ||
                    (this.TaskIncludes != null &&
                    this.TaskIncludes.Equals(input.TaskIncludes))
                ) && 
                (
                    this.IncludeTests == input.IncludeTests ||
                    (this.IncludeTests != null &&
                    this.IncludeTests.Equals(input.IncludeTests))
                ) && 
                (
                    this.IncludeVersions == input.IncludeVersions ||
                    (this.IncludeVersions != null &&
                    this.IncludeVersions.Equals(input.IncludeVersions))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.IncludeFile != null)
                    hashCode = hashCode * 59 + this.IncludeFile.GetHashCode();
                if (this.FileIncludes != null)
                    hashCode = hashCode * 59 + this.FileIncludes.GetHashCode();
                if (this.IncludeMetaData != null)
                    hashCode = hashCode * 59 + this.IncludeMetaData.GetHashCode();
                if (this.IncludeWorkflowActions != null)
                    hashCode = hashCode * 59 + this.IncludeWorkflowActions.GetHashCode();
                if (this.IncludeTasks != null)
                    hashCode = hashCode * 59 + this.IncludeTasks.GetHashCode();
                if (this.TaskIncludes != null)
                    hashCode = hashCode * 59 + this.TaskIncludes.GetHashCode();
                if (this.IncludeTests != null)
                    hashCode = hashCode * 59 + this.IncludeTests.GetHashCode();
                if (this.IncludeVersions != null)
                    hashCode = hashCode * 59 + this.IncludeVersions.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
