/* 
 * API Version: 5.0
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v5
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// DocumentInsertModel
    /// </summary>
    [DataContract]
    public partial class DocumentInsertModel :  IEquatable<DocumentInsertModel>, IValidatableObject
    {
        /// <summary>
        /// Defines UserFileNameType
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum UserFileNameTypeEnum
        {
            
            /// <summary>
            /// Enum UseDocTitleSlashUserFileNamePlusSignerNamesPlusExtension for value: UseDocTitleSlashUserFileNamePlusSignerNamesPlusExtension
            /// </summary>
            [EnumMember(Value = "UseDocTitleSlashUserFileNamePlusSignerNamesPlusExtension")]
            UseDocTitleSlashUserFileNamePlusSignerNamesPlusExtension = 1,
            
            /// <summary>
            /// Enum UseOldNameFormatOfDocumentIdPlusExtension for value: UseOldNameFormatOfDocumentIdPlusExtension
            /// </summary>
            [EnumMember(Value = "UseOldNameFormatOfDocumentIdPlusExtension")]
            UseOldNameFormatOfDocumentIdPlusExtension = 2,
            
            /// <summary>
            /// Enum UseSignerNamesPlusDocTitleSlashUserFileNamePlusExtension for value: UseSignerNamesPlusDocTitleSlashUserFileNamePlusExtension
            /// </summary>
            [EnumMember(Value = "UseSignerNamesPlusDocTitleSlashUserFileNamePlusExtension")]
            UseSignerNamesPlusDocTitleSlashUserFileNamePlusExtension = 3,
            
            /// <summary>
            /// Enum UseDocTitleSlashUserFileNamePlusSignerNamesInLastCommaFirstOrderPlusExtension for value: UseDocTitleSlashUserFileNamePlusSignerNamesInLastCommaFirstOrderPlusExtension
            /// </summary>
            [EnumMember(Value = "UseDocTitleSlashUserFileNamePlusSignerNamesInLastCommaFirstOrderPlusExtension")]
            UseDocTitleSlashUserFileNamePlusSignerNamesInLastCommaFirstOrderPlusExtension = 4,
            
            /// <summary>
            /// Enum UseSignerNamesInLastCommaFirstOrderPlusDocTitleSlashUserFileNamePlusExtension for value: UseSignerNamesInLastCommaFirstOrderPlusDocTitleSlashUserFileNamePlusExtension
            /// </summary>
            [EnumMember(Value = "UseSignerNamesInLastCommaFirstOrderPlusDocTitleSlashUserFileNamePlusExtension")]
            UseSignerNamesInLastCommaFirstOrderPlusDocTitleSlashUserFileNamePlusExtension = 5,
            
            /// <summary>
            /// Enum UseDocTitleSlashUserFileNameOnly for value: UseDocTitleSlashUserFileNameOnly
            /// </summary>
            [EnumMember(Value = "UseDocTitleSlashUserFileNameOnly")]
            UseDocTitleSlashUserFileNameOnly = 6
        }

        /// <summary>
        /// Gets or Sets UserFileNameType
        /// </summary>
        [DataMember(Name="UserFileNameType", EmitDefaultValue=false)]
        public UserFileNameTypeEnum? UserFileNameType { get; set; }
        /// <summary>
        /// Defines ServiceType
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum ServiceTypeEnum
        {
            
            /// <summary>
            /// Enum Sign for value: Sign
            /// </summary>
            [EnumMember(Value = "Sign")]
            Sign = 1,
            
            /// <summary>
            /// Enum SignAndCertify for value: SignAndCertify
            /// </summary>
            [EnumMember(Value = "SignAndCertify")]
            SignAndCertify = 2,
            
            /// <summary>
            /// Enum SignAndSeal for value: SignAndSeal
            /// </summary>
            [EnumMember(Value = "SignAndSeal")]
            SignAndSeal = 3
        }

        /// <summary>
        /// Gets or Sets ServiceType
        /// </summary>
        [DataMember(Name="ServiceType", EmitDefaultValue=false)]
        public ServiceTypeEnum? ServiceType { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="DocumentInsertModel" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected DocumentInsertModel() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="DocumentInsertModel" /> class.
        /// </summary>
        /// <param name="transactionID">transactionID (required).</param>
        /// <param name="title">title (required).</param>
        /// <param name="source">source (required).</param>
        /// <param name="userFileNameType">userFileNameType.</param>
        /// <param name="userFileName">userFileName.</param>
        /// <param name="informationText">informationText.</param>
        /// <param name="contactText">contactText.</param>
        /// <param name="emailTemplateSetName">emailTemplateSetName.</param>
        /// <param name="enableSignatureInformationAnnotation">enableSignatureInformationAnnotation.</param>
        /// <param name="neverAllowAsEmailAttachment">neverAllowAsEmailAttachment.</param>
        /// <param name="doNotFlattenPdfFormFields">doNotFlattenPdfFormFields.</param>
        /// <param name="isOptional">isOptional.</param>
        /// <param name="pageStamp">pageStamp.</param>
        /// <param name="additionalSignaturePage">additionalSignaturePage.</param>
        /// <param name="serviceType">serviceType.</param>
        /// <param name="pdfPageImageRenderDpi">pdfPageImageRenderDpi.</param>
        /// <param name="deleteDate">deleteDate.</param>
        /// <param name="workflowActions">workflowActions.</param>
        /// <param name="tasks">tasks (required).</param>
        /// <param name="metaData">metaData.</param>
        /// <param name="watermark">watermark.</param>
        /// <param name="displayBitonalPdfPageImages">displayBitonalPdfPageImages.</param>
        /// <param name="fields">fields.</param>
        /// <param name="textStamps">textStamps.</param>
        /// <param name="includeAuditReportWithCompletedDocuments">includeAuditReportWithCompletedDocuments.</param>
        public DocumentInsertModel(int? transactionID = default(int?), string title = default(string), SourceModel source = default(SourceModel), UserFileNameTypeEnum? userFileNameType = default(UserFileNameTypeEnum?), string userFileName = default(string), string informationText = default(string), string contactText = default(string), string emailTemplateSetName = default(string), bool? enableSignatureInformationAnnotation = default(bool?), bool? neverAllowAsEmailAttachment = default(bool?), bool? doNotFlattenPdfFormFields = default(bool?), bool? isOptional = default(bool?), PageStampModel pageStamp = default(PageStampModel), AdditionalSignaturePageModel additionalSignaturePage = default(AdditionalSignaturePageModel), ServiceTypeEnum? serviceType = default(ServiceTypeEnum?), double? pdfPageImageRenderDpi = default(double?), DateTime? deleteDate = default(DateTime?), List<Object> workflowActions = default(List<Object>), List<Object> tasks = default(List<Object>), List<Object> metaData = default(List<Object>), WatermarkModel watermark = default(WatermarkModel), bool? displayBitonalPdfPageImages = default(bool?), List<Object> fields = default(List<Object>), List<Object> textStamps = default(List<Object>), bool? includeAuditReportWithCompletedDocuments = default(bool?))
        {
            // to ensure "transactionID" is required (not null)
            if (transactionID == null)
            {
                throw new InvalidDataException("transactionID is a required property for DocumentInsertModel and cannot be null");
            }
            else
            {
                this.TransactionID = transactionID;
            }
            // to ensure "title" is required (not null)
            if (title == null)
            {
                throw new InvalidDataException("title is a required property for DocumentInsertModel and cannot be null");
            }
            else
            {
                this.Title = title;
            }
            // to ensure "source" is required (not null)
            if (source == null)
            {
                throw new InvalidDataException("source is a required property for DocumentInsertModel and cannot be null");
            }
            else
            {
                this.Source = source;
            }
            // to ensure "tasks" is required (not null)
            if (tasks == null)
            {
                throw new InvalidDataException("tasks is a required property for DocumentInsertModel and cannot be null");
            }
            else
            {
                this.Tasks = tasks;
            }
            this.UserFileNameType = userFileNameType;
            this.UserFileName = userFileName;
            this.InformationText = informationText;
            this.ContactText = contactText;
            this.EmailTemplateSetName = emailTemplateSetName;
            this.EnableSignatureInformationAnnotation = enableSignatureInformationAnnotation;
            this.NeverAllowAsEmailAttachment = neverAllowAsEmailAttachment;
            this.DoNotFlattenPdfFormFields = doNotFlattenPdfFormFields;
            this.IsOptional = isOptional;
            this.PageStamp = pageStamp;
            this.AdditionalSignaturePage = additionalSignaturePage;
            this.ServiceType = serviceType;
            this.PdfPageImageRenderDpi = pdfPageImageRenderDpi;
            this.DeleteDate = deleteDate;
            this.WorkflowActions = workflowActions;
            this.MetaData = metaData;
            this.Watermark = watermark;
            this.DisplayBitonalPdfPageImages = displayBitonalPdfPageImages;
            this.Fields = fields;
            this.TextStamps = textStamps;
            this.IncludeAuditReportWithCompletedDocuments = includeAuditReportWithCompletedDocuments;
        }
        
        /// <summary>
        /// Gets or Sets TransactionID
        /// </summary>
        [DataMember(Name="TransactionID", EmitDefaultValue=false)]
        public int? TransactionID { get; set; }

        /// <summary>
        /// Gets or Sets Title
        /// </summary>
        [DataMember(Name="Title", EmitDefaultValue=false)]
        public string Title { get; set; }

        /// <summary>
        /// Gets or Sets Source
        /// </summary>
        [DataMember(Name="Source", EmitDefaultValue=false)]
        public SourceModel Source { get; set; }


        /// <summary>
        /// Gets or Sets UserFileName
        /// </summary>
        [DataMember(Name="UserFileName", EmitDefaultValue=false)]
        public string UserFileName { get; set; }

        /// <summary>
        /// Gets or Sets InformationText
        /// </summary>
        [DataMember(Name="InformationText", EmitDefaultValue=false)]
        public string InformationText { get; set; }

        /// <summary>
        /// Gets or Sets ContactText
        /// </summary>
        [DataMember(Name="ContactText", EmitDefaultValue=false)]
        public string ContactText { get; set; }

        /// <summary>
        /// Gets or Sets EmailTemplateSetName
        /// </summary>
        [DataMember(Name="EmailTemplateSetName", EmitDefaultValue=false)]
        public string EmailTemplateSetName { get; set; }

        /// <summary>
        /// Gets or Sets EnableSignatureInformationAnnotation
        /// </summary>
        [DataMember(Name="EnableSignatureInformationAnnotation", EmitDefaultValue=false)]
        public bool? EnableSignatureInformationAnnotation { get; set; }

        /// <summary>
        /// Gets or Sets NeverAllowAsEmailAttachment
        /// </summary>
        [DataMember(Name="NeverAllowAsEmailAttachment", EmitDefaultValue=false)]
        public bool? NeverAllowAsEmailAttachment { get; set; }

        /// <summary>
        /// Gets or Sets DoNotFlattenPdfFormFields
        /// </summary>
        [DataMember(Name="DoNotFlattenPdfFormFields", EmitDefaultValue=false)]
        public bool? DoNotFlattenPdfFormFields { get; set; }

        /// <summary>
        /// Gets or Sets IsOptional
        /// </summary>
        [DataMember(Name="IsOptional", EmitDefaultValue=false)]
        public bool? IsOptional { get; set; }

        /// <summary>
        /// Gets or Sets PageStamp
        /// </summary>
        [DataMember(Name="PageStamp", EmitDefaultValue=false)]
        public PageStampModel PageStamp { get; set; }

        /// <summary>
        /// Gets or Sets AdditionalSignaturePage
        /// </summary>
        [DataMember(Name="AdditionalSignaturePage", EmitDefaultValue=false)]
        public AdditionalSignaturePageModel AdditionalSignaturePage { get; set; }


        /// <summary>
        /// Gets or Sets PdfPageImageRenderDpi
        /// </summary>
        [DataMember(Name="PdfPageImageRenderDpi", EmitDefaultValue=false)]
        public double? PdfPageImageRenderDpi { get; set; }

        /// <summary>
        /// Gets or Sets DeleteDate
        /// </summary>
        [DataMember(Name="DeleteDate", EmitDefaultValue=false)]
        public DateTime? DeleteDate { get; set; }

        /// <summary>
        /// Gets or Sets WorkflowActions
        /// </summary>
        [DataMember(Name="WorkflowActions", EmitDefaultValue=false)]
        public List<Object> WorkflowActions { get; set; }

        /// <summary>
        /// Gets or Sets Tasks
        /// </summary>
        [DataMember(Name="Tasks", EmitDefaultValue=false)]
        public List<Object> Tasks { get; set; }

        /// <summary>
        /// Gets or Sets MetaData
        /// </summary>
        [DataMember(Name="MetaData", EmitDefaultValue=false)]
        public List<Object> MetaData { get; set; }

        /// <summary>
        /// Gets or Sets Watermark
        /// </summary>
        [DataMember(Name="Watermark", EmitDefaultValue=false)]
        public WatermarkModel Watermark { get; set; }

        /// <summary>
        /// Gets or Sets DisplayBitonalPdfPageImages
        /// </summary>
        [DataMember(Name="DisplayBitonalPdfPageImages", EmitDefaultValue=false)]
        public bool? DisplayBitonalPdfPageImages { get; set; }

        /// <summary>
        /// Gets or Sets Fields
        /// </summary>
        [DataMember(Name="Fields", EmitDefaultValue=false)]
        public List<Object> Fields { get; set; }

        /// <summary>
        /// Gets or Sets TextStamps
        /// </summary>
        [DataMember(Name="TextStamps", EmitDefaultValue=false)]
        public List<Object> TextStamps { get; set; }

        /// <summary>
        /// Gets or Sets IncludeAuditReportWithCompletedDocuments
        /// </summary>
        [DataMember(Name="IncludeAuditReportWithCompletedDocuments", EmitDefaultValue=false)]
        public bool? IncludeAuditReportWithCompletedDocuments { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class DocumentInsertModel {\n");
            sb.Append("  TransactionID: ").Append(TransactionID).Append("\n");
            sb.Append("  Title: ").Append(Title).Append("\n");
            sb.Append("  Source: ").Append(Source).Append("\n");
            sb.Append("  UserFileNameType: ").Append(UserFileNameType).Append("\n");
            sb.Append("  UserFileName: ").Append(UserFileName).Append("\n");
            sb.Append("  InformationText: ").Append(InformationText).Append("\n");
            sb.Append("  ContactText: ").Append(ContactText).Append("\n");
            sb.Append("  EmailTemplateSetName: ").Append(EmailTemplateSetName).Append("\n");
            sb.Append("  EnableSignatureInformationAnnotation: ").Append(EnableSignatureInformationAnnotation).Append("\n");
            sb.Append("  NeverAllowAsEmailAttachment: ").Append(NeverAllowAsEmailAttachment).Append("\n");
            sb.Append("  DoNotFlattenPdfFormFields: ").Append(DoNotFlattenPdfFormFields).Append("\n");
            sb.Append("  IsOptional: ").Append(IsOptional).Append("\n");
            sb.Append("  PageStamp: ").Append(PageStamp).Append("\n");
            sb.Append("  AdditionalSignaturePage: ").Append(AdditionalSignaturePage).Append("\n");
            sb.Append("  ServiceType: ").Append(ServiceType).Append("\n");
            sb.Append("  PdfPageImageRenderDpi: ").Append(PdfPageImageRenderDpi).Append("\n");
            sb.Append("  DeleteDate: ").Append(DeleteDate).Append("\n");
            sb.Append("  WorkflowActions: ").Append(WorkflowActions).Append("\n");
            sb.Append("  Tasks: ").Append(Tasks).Append("\n");
            sb.Append("  MetaData: ").Append(MetaData).Append("\n");
            sb.Append("  Watermark: ").Append(Watermark).Append("\n");
            sb.Append("  DisplayBitonalPdfPageImages: ").Append(DisplayBitonalPdfPageImages).Append("\n");
            sb.Append("  Fields: ").Append(Fields).Append("\n");
            sb.Append("  TextStamps: ").Append(TextStamps).Append("\n");
            sb.Append("  IncludeAuditReportWithCompletedDocuments: ").Append(IncludeAuditReportWithCompletedDocuments).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as DocumentInsertModel);
        }

        /// <summary>
        /// Returns true if DocumentInsertModel instances are equal
        /// </summary>
        /// <param name="input">Instance of DocumentInsertModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(DocumentInsertModel input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.TransactionID == input.TransactionID ||
                    (this.TransactionID != null &&
                    this.TransactionID.Equals(input.TransactionID))
                ) && 
                (
                    this.Title == input.Title ||
                    (this.Title != null &&
                    this.Title.Equals(input.Title))
                ) && 
                (
                    this.Source == input.Source ||
                    (this.Source != null &&
                    this.Source.Equals(input.Source))
                ) && 
                (
                    this.UserFileNameType == input.UserFileNameType ||
                    (this.UserFileNameType != null &&
                    this.UserFileNameType.Equals(input.UserFileNameType))
                ) && 
                (
                    this.UserFileName == input.UserFileName ||
                    (this.UserFileName != null &&
                    this.UserFileName.Equals(input.UserFileName))
                ) && 
                (
                    this.InformationText == input.InformationText ||
                    (this.InformationText != null &&
                    this.InformationText.Equals(input.InformationText))
                ) && 
                (
                    this.ContactText == input.ContactText ||
                    (this.ContactText != null &&
                    this.ContactText.Equals(input.ContactText))
                ) && 
                (
                    this.EmailTemplateSetName == input.EmailTemplateSetName ||
                    (this.EmailTemplateSetName != null &&
                    this.EmailTemplateSetName.Equals(input.EmailTemplateSetName))
                ) && 
                (
                    this.EnableSignatureInformationAnnotation == input.EnableSignatureInformationAnnotation ||
                    (this.EnableSignatureInformationAnnotation != null &&
                    this.EnableSignatureInformationAnnotation.Equals(input.EnableSignatureInformationAnnotation))
                ) && 
                (
                    this.NeverAllowAsEmailAttachment == input.NeverAllowAsEmailAttachment ||
                    (this.NeverAllowAsEmailAttachment != null &&
                    this.NeverAllowAsEmailAttachment.Equals(input.NeverAllowAsEmailAttachment))
                ) && 
                (
                    this.DoNotFlattenPdfFormFields == input.DoNotFlattenPdfFormFields ||
                    (this.DoNotFlattenPdfFormFields != null &&
                    this.DoNotFlattenPdfFormFields.Equals(input.DoNotFlattenPdfFormFields))
                ) && 
                (
                    this.IsOptional == input.IsOptional ||
                    (this.IsOptional != null &&
                    this.IsOptional.Equals(input.IsOptional))
                ) && 
                (
                    this.PageStamp == input.PageStamp ||
                    (this.PageStamp != null &&
                    this.PageStamp.Equals(input.PageStamp))
                ) && 
                (
                    this.AdditionalSignaturePage == input.AdditionalSignaturePage ||
                    (this.AdditionalSignaturePage != null &&
                    this.AdditionalSignaturePage.Equals(input.AdditionalSignaturePage))
                ) && 
                (
                    this.ServiceType == input.ServiceType ||
                    (this.ServiceType != null &&
                    this.ServiceType.Equals(input.ServiceType))
                ) && 
                (
                    this.PdfPageImageRenderDpi == input.PdfPageImageRenderDpi ||
                    (this.PdfPageImageRenderDpi != null &&
                    this.PdfPageImageRenderDpi.Equals(input.PdfPageImageRenderDpi))
                ) && 
                (
                    this.DeleteDate == input.DeleteDate ||
                    (this.DeleteDate != null &&
                    this.DeleteDate.Equals(input.DeleteDate))
                ) && 
                (
                    this.WorkflowActions == input.WorkflowActions ||
                    this.WorkflowActions != null &&
                    this.WorkflowActions.SequenceEqual(input.WorkflowActions)
                ) && 
                (
                    this.Tasks == input.Tasks ||
                    this.Tasks != null &&
                    this.Tasks.SequenceEqual(input.Tasks)
                ) && 
                (
                    this.MetaData == input.MetaData ||
                    this.MetaData != null &&
                    this.MetaData.SequenceEqual(input.MetaData)
                ) && 
                (
                    this.Watermark == input.Watermark ||
                    (this.Watermark != null &&
                    this.Watermark.Equals(input.Watermark))
                ) && 
                (
                    this.DisplayBitonalPdfPageImages == input.DisplayBitonalPdfPageImages ||
                    (this.DisplayBitonalPdfPageImages != null &&
                    this.DisplayBitonalPdfPageImages.Equals(input.DisplayBitonalPdfPageImages))
                ) && 
                (
                    this.Fields == input.Fields ||
                    this.Fields != null &&
                    this.Fields.SequenceEqual(input.Fields)
                ) && 
                (
                    this.TextStamps == input.TextStamps ||
                    this.TextStamps != null &&
                    this.TextStamps.SequenceEqual(input.TextStamps)
                ) && 
                (
                    this.IncludeAuditReportWithCompletedDocuments == input.IncludeAuditReportWithCompletedDocuments ||
                    (this.IncludeAuditReportWithCompletedDocuments != null &&
                    this.IncludeAuditReportWithCompletedDocuments.Equals(input.IncludeAuditReportWithCompletedDocuments))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.TransactionID != null)
                    hashCode = hashCode * 59 + this.TransactionID.GetHashCode();
                if (this.Title != null)
                    hashCode = hashCode * 59 + this.Title.GetHashCode();
                if (this.Source != null)
                    hashCode = hashCode * 59 + this.Source.GetHashCode();
                if (this.UserFileNameType != null)
                    hashCode = hashCode * 59 + this.UserFileNameType.GetHashCode();
                if (this.UserFileName != null)
                    hashCode = hashCode * 59 + this.UserFileName.GetHashCode();
                if (this.InformationText != null)
                    hashCode = hashCode * 59 + this.InformationText.GetHashCode();
                if (this.ContactText != null)
                    hashCode = hashCode * 59 + this.ContactText.GetHashCode();
                if (this.EmailTemplateSetName != null)
                    hashCode = hashCode * 59 + this.EmailTemplateSetName.GetHashCode();
                if (this.EnableSignatureInformationAnnotation != null)
                    hashCode = hashCode * 59 + this.EnableSignatureInformationAnnotation.GetHashCode();
                if (this.NeverAllowAsEmailAttachment != null)
                    hashCode = hashCode * 59 + this.NeverAllowAsEmailAttachment.GetHashCode();
                if (this.DoNotFlattenPdfFormFields != null)
                    hashCode = hashCode * 59 + this.DoNotFlattenPdfFormFields.GetHashCode();
                if (this.IsOptional != null)
                    hashCode = hashCode * 59 + this.IsOptional.GetHashCode();
                if (this.PageStamp != null)
                    hashCode = hashCode * 59 + this.PageStamp.GetHashCode();
                if (this.AdditionalSignaturePage != null)
                    hashCode = hashCode * 59 + this.AdditionalSignaturePage.GetHashCode();
                if (this.ServiceType != null)
                    hashCode = hashCode * 59 + this.ServiceType.GetHashCode();
                if (this.PdfPageImageRenderDpi != null)
                    hashCode = hashCode * 59 + this.PdfPageImageRenderDpi.GetHashCode();
                if (this.DeleteDate != null)
                    hashCode = hashCode * 59 + this.DeleteDate.GetHashCode();
                if (this.WorkflowActions != null)
                    hashCode = hashCode * 59 + this.WorkflowActions.GetHashCode();
                if (this.Tasks != null)
                    hashCode = hashCode * 59 + this.Tasks.GetHashCode();
                if (this.MetaData != null)
                    hashCode = hashCode * 59 + this.MetaData.GetHashCode();
                if (this.Watermark != null)
                    hashCode = hashCode * 59 + this.Watermark.GetHashCode();
                if (this.DisplayBitonalPdfPageImages != null)
                    hashCode = hashCode * 59 + this.DisplayBitonalPdfPageImages.GetHashCode();
                if (this.Fields != null)
                    hashCode = hashCode * 59 + this.Fields.GetHashCode();
                if (this.TextStamps != null)
                    hashCode = hashCode * 59 + this.TextStamps.GetHashCode();
                if (this.IncludeAuditReportWithCompletedDocuments != null)
                    hashCode = hashCode * 59 + this.IncludeAuditReportWithCompletedDocuments.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
