/* 
 * API Version: 5.0
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v5
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// DocumentLinkRequestModel
    /// </summary>
    [DataContract]
    public partial class DocumentLinkRequestModel :  IEquatable<DocumentLinkRequestModel>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="DocumentLinkRequestModel" /> class.
        /// </summary>
        /// <param name="documentID">documentID.</param>
        /// <param name="participantID">participantID.</param>
        /// <param name="transactionID">transactionID.</param>
        /// <param name="downloadFileName">downloadFileName.</param>
        /// <param name="expiresInSeconds">expiresInSeconds.</param>
        /// <param name="includes">includes.</param>
        /// <param name="displayPdfAsHtmlFormat">displayPdfAsHtmlFormat.</param>
        public DocumentLinkRequestModel(int? documentID = default(int?), int? participantID = default(int?), int? transactionID = default(int?), string downloadFileName = default(string), int? expiresInSeconds = default(int?), DocumentFileLinkIncludesModel includes = default(DocumentFileLinkIncludesModel), bool? displayPdfAsHtmlFormat = default(bool?))
        {
            this.DocumentID = documentID;
            this.ParticipantID = participantID;
            this.TransactionID = transactionID;
            this.DownloadFileName = downloadFileName;
            this.ExpiresInSeconds = expiresInSeconds;
            this.Includes = includes;
            this.DisplayPdfAsHtmlFormat = displayPdfAsHtmlFormat;
        }
        
        /// <summary>
        /// Gets or Sets DocumentID
        /// </summary>
        [DataMember(Name="DocumentID", EmitDefaultValue=false)]
        public int? DocumentID { get; set; }

        /// <summary>
        /// Gets or Sets ParticipantID
        /// </summary>
        [DataMember(Name="ParticipantID", EmitDefaultValue=false)]
        public int? ParticipantID { get; set; }

        /// <summary>
        /// Gets or Sets TransactionID
        /// </summary>
        [DataMember(Name="TransactionID", EmitDefaultValue=false)]
        public int? TransactionID { get; set; }

        /// <summary>
        /// Gets or Sets DownloadFileName
        /// </summary>
        [DataMember(Name="DownloadFileName", EmitDefaultValue=false)]
        public string DownloadFileName { get; set; }

        /// <summary>
        /// Gets or Sets ExpiresInSeconds
        /// </summary>
        [DataMember(Name="ExpiresInSeconds", EmitDefaultValue=false)]
        public int? ExpiresInSeconds { get; set; }

        /// <summary>
        /// Gets or Sets Includes
        /// </summary>
        [DataMember(Name="Includes", EmitDefaultValue=false)]
        public DocumentFileLinkIncludesModel Includes { get; set; }

        /// <summary>
        /// Gets or Sets DisplayPdfAsHtmlFormat
        /// </summary>
        [DataMember(Name="DisplayPdfAsHtmlFormat", EmitDefaultValue=false)]
        public bool? DisplayPdfAsHtmlFormat { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class DocumentLinkRequestModel {\n");
            sb.Append("  DocumentID: ").Append(DocumentID).Append("\n");
            sb.Append("  ParticipantID: ").Append(ParticipantID).Append("\n");
            sb.Append("  TransactionID: ").Append(TransactionID).Append("\n");
            sb.Append("  DownloadFileName: ").Append(DownloadFileName).Append("\n");
            sb.Append("  ExpiresInSeconds: ").Append(ExpiresInSeconds).Append("\n");
            sb.Append("  Includes: ").Append(Includes).Append("\n");
            sb.Append("  DisplayPdfAsHtmlFormat: ").Append(DisplayPdfAsHtmlFormat).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as DocumentLinkRequestModel);
        }

        /// <summary>
        /// Returns true if DocumentLinkRequestModel instances are equal
        /// </summary>
        /// <param name="input">Instance of DocumentLinkRequestModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(DocumentLinkRequestModel input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.DocumentID == input.DocumentID ||
                    (this.DocumentID != null &&
                    this.DocumentID.Equals(input.DocumentID))
                ) && 
                (
                    this.ParticipantID == input.ParticipantID ||
                    (this.ParticipantID != null &&
                    this.ParticipantID.Equals(input.ParticipantID))
                ) && 
                (
                    this.TransactionID == input.TransactionID ||
                    (this.TransactionID != null &&
                    this.TransactionID.Equals(input.TransactionID))
                ) && 
                (
                    this.DownloadFileName == input.DownloadFileName ||
                    (this.DownloadFileName != null &&
                    this.DownloadFileName.Equals(input.DownloadFileName))
                ) && 
                (
                    this.ExpiresInSeconds == input.ExpiresInSeconds ||
                    (this.ExpiresInSeconds != null &&
                    this.ExpiresInSeconds.Equals(input.ExpiresInSeconds))
                ) && 
                (
                    this.Includes == input.Includes ||
                    (this.Includes != null &&
                    this.Includes.Equals(input.Includes))
                ) && 
                (
                    this.DisplayPdfAsHtmlFormat == input.DisplayPdfAsHtmlFormat ||
                    (this.DisplayPdfAsHtmlFormat != null &&
                    this.DisplayPdfAsHtmlFormat.Equals(input.DisplayPdfAsHtmlFormat))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.DocumentID != null)
                    hashCode = hashCode * 59 + this.DocumentID.GetHashCode();
                if (this.ParticipantID != null)
                    hashCode = hashCode * 59 + this.ParticipantID.GetHashCode();
                if (this.TransactionID != null)
                    hashCode = hashCode * 59 + this.TransactionID.GetHashCode();
                if (this.DownloadFileName != null)
                    hashCode = hashCode * 59 + this.DownloadFileName.GetHashCode();
                if (this.ExpiresInSeconds != null)
                    hashCode = hashCode * 59 + this.ExpiresInSeconds.GetHashCode();
                if (this.Includes != null)
                    hashCode = hashCode * 59 + this.Includes.GetHashCode();
                if (this.DisplayPdfAsHtmlFormat != null)
                    hashCode = hashCode * 59 + this.DisplayPdfAsHtmlFormat.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
