/* 
 * API Version: 5.0
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v5
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// DocumentPdfModel
    /// </summary>
    [DataContract]
    public partial class DocumentPdfModel :  IEquatable<DocumentPdfModel>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="DocumentPdfModel" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected DocumentPdfModel() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="DocumentPdfModel" /> class.
        /// </summary>
        /// <param name="title">title (required).</param>
        /// <param name="deletionDate">deletionDate.</param>
        /// <param name="fileBytes">fileBytes.</param>
        /// <param name="fileSystemPath">fileSystemPath.</param>
        /// <param name="notificationUrl">notificationUrl.</param>
        /// <param name="isNotificationTypeGet">isNotificationTypeGet.</param>
        /// <param name="notificationData">notificationData.</param>
        public DocumentPdfModel(string title = default(string), DateTime? deletionDate = default(DateTime?), byte[] fileBytes = default(byte[]), string fileSystemPath = default(string), string notificationUrl = default(string), bool? isNotificationTypeGet = default(bool?), string notificationData = default(string))
        {
            // to ensure "title" is required (not null)
            if (title == null)
            {
                throw new InvalidDataException("title is a required property for DocumentPdfModel and cannot be null");
            }
            else
            {
                this.Title = title;
            }
            this.DeletionDate = deletionDate;
            this.FileBytes = fileBytes;
            this.FileSystemPath = fileSystemPath;
            this.NotificationUrl = notificationUrl;
            this.IsNotificationTypeGet = isNotificationTypeGet;
            this.NotificationData = notificationData;
        }
        
        /// <summary>
        /// Gets or Sets Title
        /// </summary>
        [DataMember(Name="Title", EmitDefaultValue=false)]
        public string Title { get; set; }

        /// <summary>
        /// Gets or Sets DeletionDate
        /// </summary>
        [DataMember(Name="DeletionDate", EmitDefaultValue=false)]
        public DateTime? DeletionDate { get; set; }

        /// <summary>
        /// Gets or Sets FileBytes
        /// </summary>
        [DataMember(Name="FileBytes", EmitDefaultValue=false)]
        public byte[] FileBytes { get; set; }

        /// <summary>
        /// Gets or Sets FileSystemPath
        /// </summary>
        [DataMember(Name="FileSystemPath", EmitDefaultValue=false)]
        public string FileSystemPath { get; set; }

        /// <summary>
        /// Gets or Sets NotificationUrl
        /// </summary>
        [DataMember(Name="NotificationUrl", EmitDefaultValue=false)]
        public string NotificationUrl { get; set; }

        /// <summary>
        /// Gets or Sets IsNotificationTypeGet
        /// </summary>
        [DataMember(Name="IsNotificationTypeGet", EmitDefaultValue=false)]
        public bool? IsNotificationTypeGet { get; set; }

        /// <summary>
        /// Gets or Sets NotificationData
        /// </summary>
        [DataMember(Name="NotificationData", EmitDefaultValue=false)]
        public string NotificationData { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class DocumentPdfModel {\n");
            sb.Append("  Title: ").Append(Title).Append("\n");
            sb.Append("  DeletionDate: ").Append(DeletionDate).Append("\n");
            sb.Append("  FileBytes: ").Append(FileBytes).Append("\n");
            sb.Append("  FileSystemPath: ").Append(FileSystemPath).Append("\n");
            sb.Append("  NotificationUrl: ").Append(NotificationUrl).Append("\n");
            sb.Append("  IsNotificationTypeGet: ").Append(IsNotificationTypeGet).Append("\n");
            sb.Append("  NotificationData: ").Append(NotificationData).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as DocumentPdfModel);
        }

        /// <summary>
        /// Returns true if DocumentPdfModel instances are equal
        /// </summary>
        /// <param name="input">Instance of DocumentPdfModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(DocumentPdfModel input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Title == input.Title ||
                    (this.Title != null &&
                    this.Title.Equals(input.Title))
                ) && 
                (
                    this.DeletionDate == input.DeletionDate ||
                    (this.DeletionDate != null &&
                    this.DeletionDate.Equals(input.DeletionDate))
                ) && 
                (
                    this.FileBytes == input.FileBytes ||
                    (this.FileBytes != null &&
                    this.FileBytes.Equals(input.FileBytes))
                ) && 
                (
                    this.FileSystemPath == input.FileSystemPath ||
                    (this.FileSystemPath != null &&
                    this.FileSystemPath.Equals(input.FileSystemPath))
                ) && 
                (
                    this.NotificationUrl == input.NotificationUrl ||
                    (this.NotificationUrl != null &&
                    this.NotificationUrl.Equals(input.NotificationUrl))
                ) && 
                (
                    this.IsNotificationTypeGet == input.IsNotificationTypeGet ||
                    (this.IsNotificationTypeGet != null &&
                    this.IsNotificationTypeGet.Equals(input.IsNotificationTypeGet))
                ) && 
                (
                    this.NotificationData == input.NotificationData ||
                    (this.NotificationData != null &&
                    this.NotificationData.Equals(input.NotificationData))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Title != null)
                    hashCode = hashCode * 59 + this.Title.GetHashCode();
                if (this.DeletionDate != null)
                    hashCode = hashCode * 59 + this.DeletionDate.GetHashCode();
                if (this.FileBytes != null)
                    hashCode = hashCode * 59 + this.FileBytes.GetHashCode();
                if (this.FileSystemPath != null)
                    hashCode = hashCode * 59 + this.FileSystemPath.GetHashCode();
                if (this.NotificationUrl != null)
                    hashCode = hashCode * 59 + this.NotificationUrl.GetHashCode();
                if (this.IsNotificationTypeGet != null)
                    hashCode = hashCode * 59 + this.IsNotificationTypeGet.GetHashCode();
                if (this.NotificationData != null)
                    hashCode = hashCode * 59 + this.NotificationData.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
