/* 
 * API Version: 5.0
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v5
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// DocumentTextStampsModel
    /// </summary>
    [DataContract]
    public partial class DocumentTextStampsModel :  IEquatable<DocumentTextStampsModel>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="DocumentTextStampsModel" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected DocumentTextStampsModel() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="DocumentTextStampsModel" /> class.
        /// </summary>
        /// <param name="documentID">documentID (required).</param>
        /// <param name="textStamps">textStamps (required).</param>
        public DocumentTextStampsModel(int? documentID = default(int?), List<Object> textStamps = default(List<Object>))
        {
            // to ensure "documentID" is required (not null)
            if (documentID == null)
            {
                throw new InvalidDataException("documentID is a required property for DocumentTextStampsModel and cannot be null");
            }
            else
            {
                this.DocumentID = documentID;
            }
            // to ensure "textStamps" is required (not null)
            if (textStamps == null)
            {
                throw new InvalidDataException("textStamps is a required property for DocumentTextStampsModel and cannot be null");
            }
            else
            {
                this.TextStamps = textStamps;
            }
        }
        
        /// <summary>
        /// Gets or Sets DocumentID
        /// </summary>
        [DataMember(Name="DocumentID", EmitDefaultValue=false)]
        public int? DocumentID { get; set; }

        /// <summary>
        /// Gets or Sets TextStamps
        /// </summary>
        [DataMember(Name="TextStamps", EmitDefaultValue=false)]
        public List<Object> TextStamps { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class DocumentTextStampsModel {\n");
            sb.Append("  DocumentID: ").Append(DocumentID).Append("\n");
            sb.Append("  TextStamps: ").Append(TextStamps).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as DocumentTextStampsModel);
        }

        /// <summary>
        /// Returns true if DocumentTextStampsModel instances are equal
        /// </summary>
        /// <param name="input">Instance of DocumentTextStampsModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(DocumentTextStampsModel input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.DocumentID == input.DocumentID ||
                    (this.DocumentID != null &&
                    this.DocumentID.Equals(input.DocumentID))
                ) && 
                (
                    this.TextStamps == input.TextStamps ||
                    this.TextStamps != null &&
                    this.TextStamps.SequenceEqual(input.TextStamps)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.DocumentID != null)
                    hashCode = hashCode * 59 + this.DocumentID.GetHashCode();
                if (this.TextStamps != null)
                    hashCode = hashCode * 59 + this.TextStamps.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
