/* 
 * API Version: 5.0
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v5
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// DocumentTiffDetailsRequestModel
    /// </summary>
    [DataContract]
    public partial class DocumentTiffDetailsRequestModel :  IEquatable<DocumentTiffDetailsRequestModel>, IValidatableObject
    {
        /// <summary>
        /// Defines StatusType
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum StatusTypeEnum
        {
            
            /// <summary>
            /// Enum All for value: All
            /// </summary>
            [EnumMember(Value = "All")]
            All = 1,
            
            /// <summary>
            /// Enum Pending for value: Pending
            /// </summary>
            [EnumMember(Value = "Pending")]
            Pending = 2,
            
            /// <summary>
            /// Enum Completed for value: Completed
            /// </summary>
            [EnumMember(Value = "Completed")]
            Completed = 3,
            
            /// <summary>
            /// Enum EmailSent for value: EmailSent
            /// </summary>
            [EnumMember(Value = "EmailSent")]
            EmailSent = 4,
            
            /// <summary>
            /// Enum Closed for value: Closed
            /// </summary>
            [EnumMember(Value = "Closed")]
            Closed = 5,
            
            /// <summary>
            /// Enum Cancelled for value: Cancelled
            /// </summary>
            [EnumMember(Value = "Cancelled")]
            Cancelled = 6,
            
            /// <summary>
            /// Enum Expired for value: Expired
            /// </summary>
            [EnumMember(Value = "Expired")]
            Expired = 7,
            
            /// <summary>
            /// Enum Voided for value: Voided
            /// </summary>
            [EnumMember(Value = "Voided")]
            Voided = 8
        }

        /// <summary>
        /// Gets or Sets StatusType
        /// </summary>
        [DataMember(Name="StatusType", EmitDefaultValue=false)]
        public StatusTypeEnum? StatusType { get; set; }
        /// <summary>
        /// Defines SearchDateType
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum SearchDateTypeEnum
        {
            
            /// <summary>
            /// Enum CreatedDate for value: CreatedDate
            /// </summary>
            [EnumMember(Value = "CreatedDate")]
            CreatedDate = 1,
            
            /// <summary>
            /// Enum ClosedDate for value: ClosedDate
            /// </summary>
            [EnumMember(Value = "ClosedDate")]
            ClosedDate = 2
        }

        /// <summary>
        /// Gets or Sets SearchDateType
        /// </summary>
        [DataMember(Name="SearchDateType", EmitDefaultValue=false)]
        public SearchDateTypeEnum? SearchDateType { get; set; }
        /// <summary>
        /// Defines CompressionType
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum CompressionTypeEnum
        {
            
            /// <summary>
            /// Enum Group4 for value: Group4
            /// </summary>
            [EnumMember(Value = "Group4")]
            Group4 = 1,
            
            /// <summary>
            /// Enum Lzw for value: Lzw
            /// </summary>
            [EnumMember(Value = "Lzw")]
            Lzw = 2,
            
            /// <summary>
            /// Enum None for value: None
            /// </summary>
            [EnumMember(Value = "None")]
            None = 3
        }

        /// <summary>
        /// Gets or Sets CompressionType
        /// </summary>
        [DataMember(Name="CompressionType", EmitDefaultValue=false)]
        public CompressionTypeEnum? CompressionType { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="DocumentTiffDetailsRequestModel" /> class.
        /// </summary>
        /// <param name="prontoID">prontoID.</param>
        /// <param name="iDs">iDs.</param>
        /// <param name="transactionIDs">transactionIDs.</param>
        /// <param name="participantIDs">participantIDs.</param>
        /// <param name="taskIDs">taskIDs.</param>
        /// <param name="metaDataName">metaDataName.</param>
        /// <param name="metaDataValue">metaDataValue.</param>
        /// <param name="statusType">statusType.</param>
        /// <param name="searchDateType">searchDateType.</param>
        /// <param name="searchDateFrom">searchDateFrom.</param>
        /// <param name="searchDateTo">searchDateTo.</param>
        /// <param name="enableLogging">enableLogging.</param>
        /// <param name="resultsCountLimit">resultsCountLimit.</param>
        /// <param name="resultsCountStart">resultsCountStart.</param>
        /// <param name="dpi">dpi.</param>
        /// <param name="bitsPerPixel">bitsPerPixel.</param>
        /// <param name="compressionType">compressionType.</param>
        /// <param name="includes">includes.</param>
        /// <param name="timeZoneID">timeZoneID.</param>
        public DocumentTiffDetailsRequestModel(string prontoID = default(string), List<Object> iDs = default(List<Object>), List<Object> transactionIDs = default(List<Object>), List<Object> participantIDs = default(List<Object>), List<Object> taskIDs = default(List<Object>), string metaDataName = default(string), string metaDataValue = default(string), StatusTypeEnum? statusType = default(StatusTypeEnum?), SearchDateTypeEnum? searchDateType = default(SearchDateTypeEnum?), DateTime? searchDateFrom = default(DateTime?), DateTime? searchDateTo = default(DateTime?), bool? enableLogging = default(bool?), int? resultsCountLimit = default(int?), int? resultsCountStart = default(int?), int? dpi = default(int?), int? bitsPerPixel = default(int?), CompressionTypeEnum? compressionType = default(CompressionTypeEnum?), DocumentFileIncludesModel includes = default(DocumentFileIncludesModel), string timeZoneID = default(string))
        {
            this.ProntoID = prontoID;
            this.IDs = iDs;
            this.TransactionIDs = transactionIDs;
            this.ParticipantIDs = participantIDs;
            this.TaskIDs = taskIDs;
            this.MetaDataName = metaDataName;
            this.MetaDataValue = metaDataValue;
            this.StatusType = statusType;
            this.SearchDateType = searchDateType;
            this.SearchDateFrom = searchDateFrom;
            this.SearchDateTo = searchDateTo;
            this.EnableLogging = enableLogging;
            this.ResultsCountLimit = resultsCountLimit;
            this.ResultsCountStart = resultsCountStart;
            this.Dpi = dpi;
            this.BitsPerPixel = bitsPerPixel;
            this.CompressionType = compressionType;
            this.Includes = includes;
            this.TimeZoneID = timeZoneID;
        }
        
        /// <summary>
        /// Gets or Sets ProntoID
        /// </summary>
        [DataMember(Name="ProntoID", EmitDefaultValue=false)]
        public string ProntoID { get; set; }

        /// <summary>
        /// Gets or Sets IDs
        /// </summary>
        [DataMember(Name="IDs", EmitDefaultValue=false)]
        public List<Object> IDs { get; set; }

        /// <summary>
        /// Gets or Sets TransactionIDs
        /// </summary>
        [DataMember(Name="TransactionIDs", EmitDefaultValue=false)]
        public List<Object> TransactionIDs { get; set; }

        /// <summary>
        /// Gets or Sets ParticipantIDs
        /// </summary>
        [DataMember(Name="ParticipantIDs", EmitDefaultValue=false)]
        public List<Object> ParticipantIDs { get; set; }

        /// <summary>
        /// Gets or Sets TaskIDs
        /// </summary>
        [DataMember(Name="TaskIDs", EmitDefaultValue=false)]
        public List<Object> TaskIDs { get; set; }

        /// <summary>
        /// Gets or Sets MetaDataName
        /// </summary>
        [DataMember(Name="MetaDataName", EmitDefaultValue=false)]
        public string MetaDataName { get; set; }

        /// <summary>
        /// Gets or Sets MetaDataValue
        /// </summary>
        [DataMember(Name="MetaDataValue", EmitDefaultValue=false)]
        public string MetaDataValue { get; set; }



        /// <summary>
        /// Gets or Sets SearchDateFrom
        /// </summary>
        [DataMember(Name="SearchDateFrom", EmitDefaultValue=false)]
        public DateTime? SearchDateFrom { get; set; }

        /// <summary>
        /// Gets or Sets SearchDateTo
        /// </summary>
        [DataMember(Name="SearchDateTo", EmitDefaultValue=false)]
        public DateTime? SearchDateTo { get; set; }

        /// <summary>
        /// Gets or Sets EnableLogging
        /// </summary>
        [DataMember(Name="EnableLogging", EmitDefaultValue=false)]
        public bool? EnableLogging { get; set; }

        /// <summary>
        /// Gets or Sets ResultsCountLimit
        /// </summary>
        [DataMember(Name="ResultsCountLimit", EmitDefaultValue=false)]
        public int? ResultsCountLimit { get; set; }

        /// <summary>
        /// Gets or Sets ResultsCountStart
        /// </summary>
        [DataMember(Name="ResultsCountStart", EmitDefaultValue=false)]
        public int? ResultsCountStart { get; set; }

        /// <summary>
        /// Gets or Sets Dpi
        /// </summary>
        [DataMember(Name="Dpi", EmitDefaultValue=false)]
        public int? Dpi { get; set; }

        /// <summary>
        /// Gets or Sets BitsPerPixel
        /// </summary>
        [DataMember(Name="BitsPerPixel", EmitDefaultValue=false)]
        public int? BitsPerPixel { get; set; }


        /// <summary>
        /// Gets or Sets Includes
        /// </summary>
        [DataMember(Name="Includes", EmitDefaultValue=false)]
        public DocumentFileIncludesModel Includes { get; set; }

        /// <summary>
        /// Gets or Sets TimeZoneID
        /// </summary>
        [DataMember(Name="TimeZoneID", EmitDefaultValue=false)]
        public string TimeZoneID { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class DocumentTiffDetailsRequestModel {\n");
            sb.Append("  ProntoID: ").Append(ProntoID).Append("\n");
            sb.Append("  IDs: ").Append(IDs).Append("\n");
            sb.Append("  TransactionIDs: ").Append(TransactionIDs).Append("\n");
            sb.Append("  ParticipantIDs: ").Append(ParticipantIDs).Append("\n");
            sb.Append("  TaskIDs: ").Append(TaskIDs).Append("\n");
            sb.Append("  MetaDataName: ").Append(MetaDataName).Append("\n");
            sb.Append("  MetaDataValue: ").Append(MetaDataValue).Append("\n");
            sb.Append("  StatusType: ").Append(StatusType).Append("\n");
            sb.Append("  SearchDateType: ").Append(SearchDateType).Append("\n");
            sb.Append("  SearchDateFrom: ").Append(SearchDateFrom).Append("\n");
            sb.Append("  SearchDateTo: ").Append(SearchDateTo).Append("\n");
            sb.Append("  EnableLogging: ").Append(EnableLogging).Append("\n");
            sb.Append("  ResultsCountLimit: ").Append(ResultsCountLimit).Append("\n");
            sb.Append("  ResultsCountStart: ").Append(ResultsCountStart).Append("\n");
            sb.Append("  Dpi: ").Append(Dpi).Append("\n");
            sb.Append("  BitsPerPixel: ").Append(BitsPerPixel).Append("\n");
            sb.Append("  CompressionType: ").Append(CompressionType).Append("\n");
            sb.Append("  Includes: ").Append(Includes).Append("\n");
            sb.Append("  TimeZoneID: ").Append(TimeZoneID).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as DocumentTiffDetailsRequestModel);
        }

        /// <summary>
        /// Returns true if DocumentTiffDetailsRequestModel instances are equal
        /// </summary>
        /// <param name="input">Instance of DocumentTiffDetailsRequestModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(DocumentTiffDetailsRequestModel input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ProntoID == input.ProntoID ||
                    (this.ProntoID != null &&
                    this.ProntoID.Equals(input.ProntoID))
                ) && 
                (
                    this.IDs == input.IDs ||
                    this.IDs != null &&
                    this.IDs.SequenceEqual(input.IDs)
                ) && 
                (
                    this.TransactionIDs == input.TransactionIDs ||
                    this.TransactionIDs != null &&
                    this.TransactionIDs.SequenceEqual(input.TransactionIDs)
                ) && 
                (
                    this.ParticipantIDs == input.ParticipantIDs ||
                    this.ParticipantIDs != null &&
                    this.ParticipantIDs.SequenceEqual(input.ParticipantIDs)
                ) && 
                (
                    this.TaskIDs == input.TaskIDs ||
                    this.TaskIDs != null &&
                    this.TaskIDs.SequenceEqual(input.TaskIDs)
                ) && 
                (
                    this.MetaDataName == input.MetaDataName ||
                    (this.MetaDataName != null &&
                    this.MetaDataName.Equals(input.MetaDataName))
                ) && 
                (
                    this.MetaDataValue == input.MetaDataValue ||
                    (this.MetaDataValue != null &&
                    this.MetaDataValue.Equals(input.MetaDataValue))
                ) && 
                (
                    this.StatusType == input.StatusType ||
                    (this.StatusType != null &&
                    this.StatusType.Equals(input.StatusType))
                ) && 
                (
                    this.SearchDateType == input.SearchDateType ||
                    (this.SearchDateType != null &&
                    this.SearchDateType.Equals(input.SearchDateType))
                ) && 
                (
                    this.SearchDateFrom == input.SearchDateFrom ||
                    (this.SearchDateFrom != null &&
                    this.SearchDateFrom.Equals(input.SearchDateFrom))
                ) && 
                (
                    this.SearchDateTo == input.SearchDateTo ||
                    (this.SearchDateTo != null &&
                    this.SearchDateTo.Equals(input.SearchDateTo))
                ) && 
                (
                    this.EnableLogging == input.EnableLogging ||
                    (this.EnableLogging != null &&
                    this.EnableLogging.Equals(input.EnableLogging))
                ) && 
                (
                    this.ResultsCountLimit == input.ResultsCountLimit ||
                    (this.ResultsCountLimit != null &&
                    this.ResultsCountLimit.Equals(input.ResultsCountLimit))
                ) && 
                (
                    this.ResultsCountStart == input.ResultsCountStart ||
                    (this.ResultsCountStart != null &&
                    this.ResultsCountStart.Equals(input.ResultsCountStart))
                ) && 
                (
                    this.Dpi == input.Dpi ||
                    (this.Dpi != null &&
                    this.Dpi.Equals(input.Dpi))
                ) && 
                (
                    this.BitsPerPixel == input.BitsPerPixel ||
                    (this.BitsPerPixel != null &&
                    this.BitsPerPixel.Equals(input.BitsPerPixel))
                ) && 
                (
                    this.CompressionType == input.CompressionType ||
                    (this.CompressionType != null &&
                    this.CompressionType.Equals(input.CompressionType))
                ) && 
                (
                    this.Includes == input.Includes ||
                    (this.Includes != null &&
                    this.Includes.Equals(input.Includes))
                ) && 
                (
                    this.TimeZoneID == input.TimeZoneID ||
                    (this.TimeZoneID != null &&
                    this.TimeZoneID.Equals(input.TimeZoneID))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ProntoID != null)
                    hashCode = hashCode * 59 + this.ProntoID.GetHashCode();
                if (this.IDs != null)
                    hashCode = hashCode * 59 + this.IDs.GetHashCode();
                if (this.TransactionIDs != null)
                    hashCode = hashCode * 59 + this.TransactionIDs.GetHashCode();
                if (this.ParticipantIDs != null)
                    hashCode = hashCode * 59 + this.ParticipantIDs.GetHashCode();
                if (this.TaskIDs != null)
                    hashCode = hashCode * 59 + this.TaskIDs.GetHashCode();
                if (this.MetaDataName != null)
                    hashCode = hashCode * 59 + this.MetaDataName.GetHashCode();
                if (this.MetaDataValue != null)
                    hashCode = hashCode * 59 + this.MetaDataValue.GetHashCode();
                if (this.StatusType != null)
                    hashCode = hashCode * 59 + this.StatusType.GetHashCode();
                if (this.SearchDateType != null)
                    hashCode = hashCode * 59 + this.SearchDateType.GetHashCode();
                if (this.SearchDateFrom != null)
                    hashCode = hashCode * 59 + this.SearchDateFrom.GetHashCode();
                if (this.SearchDateTo != null)
                    hashCode = hashCode * 59 + this.SearchDateTo.GetHashCode();
                if (this.EnableLogging != null)
                    hashCode = hashCode * 59 + this.EnableLogging.GetHashCode();
                if (this.ResultsCountLimit != null)
                    hashCode = hashCode * 59 + this.ResultsCountLimit.GetHashCode();
                if (this.ResultsCountStart != null)
                    hashCode = hashCode * 59 + this.ResultsCountStart.GetHashCode();
                if (this.Dpi != null)
                    hashCode = hashCode * 59 + this.Dpi.GetHashCode();
                if (this.BitsPerPixel != null)
                    hashCode = hashCode * 59 + this.BitsPerPixel.GetHashCode();
                if (this.CompressionType != null)
                    hashCode = hashCode * 59 + this.CompressionType.GetHashCode();
                if (this.Includes != null)
                    hashCode = hashCode * 59 + this.Includes.GetHashCode();
                if (this.TimeZoneID != null)
                    hashCode = hashCode * 59 + this.TimeZoneID.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
