/* 
 * API Version: 5.0
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v5
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// DocumentVerifyRequestModel
    /// </summary>
    [DataContract]
    public partial class DocumentVerifyRequestModel :  IEquatable<DocumentVerifyRequestModel>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="DocumentVerifyRequestModel" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected DocumentVerifyRequestModel() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="DocumentVerifyRequestModel" /> class.
        /// </summary>
        /// <param name="documentFiles">documentFiles (required).</param>
        /// <param name="enableLogging">enableLogging.</param>
        public DocumentVerifyRequestModel(List<Object> documentFiles = default(List<Object>), bool? enableLogging = default(bool?))
        {
            // to ensure "documentFiles" is required (not null)
            if (documentFiles == null)
            {
                throw new InvalidDataException("documentFiles is a required property for DocumentVerifyRequestModel and cannot be null");
            }
            else
            {
                this.DocumentFiles = documentFiles;
            }
            this.EnableLogging = enableLogging;
        }
        
        /// <summary>
        /// Gets or Sets DocumentFiles
        /// </summary>
        [DataMember(Name="DocumentFiles", EmitDefaultValue=false)]
        public List<Object> DocumentFiles { get; set; }

        /// <summary>
        /// Gets or Sets EnableLogging
        /// </summary>
        [DataMember(Name="EnableLogging", EmitDefaultValue=false)]
        public bool? EnableLogging { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class DocumentVerifyRequestModel {\n");
            sb.Append("  DocumentFiles: ").Append(DocumentFiles).Append("\n");
            sb.Append("  EnableLogging: ").Append(EnableLogging).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as DocumentVerifyRequestModel);
        }

        /// <summary>
        /// Returns true if DocumentVerifyRequestModel instances are equal
        /// </summary>
        /// <param name="input">Instance of DocumentVerifyRequestModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(DocumentVerifyRequestModel input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.DocumentFiles == input.DocumentFiles ||
                    this.DocumentFiles != null &&
                    this.DocumentFiles.SequenceEqual(input.DocumentFiles)
                ) && 
                (
                    this.EnableLogging == input.EnableLogging ||
                    (this.EnableLogging != null &&
                    this.EnableLogging.Equals(input.EnableLogging))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.DocumentFiles != null)
                    hashCode = hashCode * 59 + this.DocumentFiles.GetHashCode();
                if (this.EnableLogging != null)
                    hashCode = hashCode * 59 + this.EnableLogging.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
