/* 
 * API Version: 5.0
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v5
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// DocumentVersionDetailModel
    /// </summary>
    [DataContract]
    public partial class DocumentVersionDetailModel :  IEquatable<DocumentVersionDetailModel>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="DocumentVersionDetailModel" /> class.
        /// </summary>
        /// <param name="iD">iD.</param>
        /// <param name="documentID">documentID.</param>
        /// <param name="version">version.</param>
        /// <param name="fileName">fileName.</param>
        /// <param name="createDate">createDate.</param>
        /// <param name="sealedDate">sealedDate.</param>
        /// <param name="certifiedDate">certifiedDate.</param>
        /// <param name="isSealPending">isSealPending.</param>
        /// <param name="isCertifyPending">isCertifyPending.</param>
        /// <param name="documentSHA256Hash">documentSHA256Hash.</param>
        /// <param name="versionInfo">versionInfo.</param>
        /// <param name="isFinal">isFinal.</param>
        public DocumentVersionDetailModel(int? iD = default(int?), int? documentID = default(int?), int? version = default(int?), string fileName = default(string), DateTime? createDate = default(DateTime?), DateTime? sealedDate = default(DateTime?), DateTime? certifiedDate = default(DateTime?), bool? isSealPending = default(bool?), bool? isCertifyPending = default(bool?), string documentSHA256Hash = default(string), string versionInfo = default(string), bool? isFinal = default(bool?))
        {
            this.ID = iD;
            this.DocumentID = documentID;
            this.Version = version;
            this.FileName = fileName;
            this.CreateDate = createDate;
            this.SealedDate = sealedDate;
            this.CertifiedDate = certifiedDate;
            this.IsSealPending = isSealPending;
            this.IsCertifyPending = isCertifyPending;
            this.DocumentSHA256Hash = documentSHA256Hash;
            this.VersionInfo = versionInfo;
            this.IsFinal = isFinal;
        }
        
        /// <summary>
        /// Gets or Sets ID
        /// </summary>
        [DataMember(Name="ID", EmitDefaultValue=false)]
        public int? ID { get; set; }

        /// <summary>
        /// Gets or Sets DocumentID
        /// </summary>
        [DataMember(Name="DocumentID", EmitDefaultValue=false)]
        public int? DocumentID { get; set; }

        /// <summary>
        /// Gets or Sets Version
        /// </summary>
        [DataMember(Name="Version", EmitDefaultValue=false)]
        public int? Version { get; set; }

        /// <summary>
        /// Gets or Sets FileName
        /// </summary>
        [DataMember(Name="FileName", EmitDefaultValue=false)]
        public string FileName { get; set; }

        /// <summary>
        /// Gets or Sets CreateDate
        /// </summary>
        [DataMember(Name="CreateDate", EmitDefaultValue=false)]
        public DateTime? CreateDate { get; set; }

        /// <summary>
        /// Gets or Sets SealedDate
        /// </summary>
        [DataMember(Name="SealedDate", EmitDefaultValue=false)]
        public DateTime? SealedDate { get; set; }

        /// <summary>
        /// Gets or Sets CertifiedDate
        /// </summary>
        [DataMember(Name="CertifiedDate", EmitDefaultValue=false)]
        public DateTime? CertifiedDate { get; set; }

        /// <summary>
        /// Gets or Sets IsSealPending
        /// </summary>
        [DataMember(Name="IsSealPending", EmitDefaultValue=false)]
        public bool? IsSealPending { get; set; }

        /// <summary>
        /// Gets or Sets IsCertifyPending
        /// </summary>
        [DataMember(Name="IsCertifyPending", EmitDefaultValue=false)]
        public bool? IsCertifyPending { get; set; }

        /// <summary>
        /// Gets or Sets DocumentSHA256Hash
        /// </summary>
        [DataMember(Name="DocumentSHA256Hash", EmitDefaultValue=false)]
        public string DocumentSHA256Hash { get; set; }

        /// <summary>
        /// Gets or Sets VersionInfo
        /// </summary>
        [DataMember(Name="VersionInfo", EmitDefaultValue=false)]
        public string VersionInfo { get; set; }

        /// <summary>
        /// Gets or Sets IsFinal
        /// </summary>
        [DataMember(Name="IsFinal", EmitDefaultValue=false)]
        public bool? IsFinal { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class DocumentVersionDetailModel {\n");
            sb.Append("  ID: ").Append(ID).Append("\n");
            sb.Append("  DocumentID: ").Append(DocumentID).Append("\n");
            sb.Append("  Version: ").Append(Version).Append("\n");
            sb.Append("  FileName: ").Append(FileName).Append("\n");
            sb.Append("  CreateDate: ").Append(CreateDate).Append("\n");
            sb.Append("  SealedDate: ").Append(SealedDate).Append("\n");
            sb.Append("  CertifiedDate: ").Append(CertifiedDate).Append("\n");
            sb.Append("  IsSealPending: ").Append(IsSealPending).Append("\n");
            sb.Append("  IsCertifyPending: ").Append(IsCertifyPending).Append("\n");
            sb.Append("  DocumentSHA256Hash: ").Append(DocumentSHA256Hash).Append("\n");
            sb.Append("  VersionInfo: ").Append(VersionInfo).Append("\n");
            sb.Append("  IsFinal: ").Append(IsFinal).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as DocumentVersionDetailModel);
        }

        /// <summary>
        /// Returns true if DocumentVersionDetailModel instances are equal
        /// </summary>
        /// <param name="input">Instance of DocumentVersionDetailModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(DocumentVersionDetailModel input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ID == input.ID ||
                    (this.ID != null &&
                    this.ID.Equals(input.ID))
                ) && 
                (
                    this.DocumentID == input.DocumentID ||
                    (this.DocumentID != null &&
                    this.DocumentID.Equals(input.DocumentID))
                ) && 
                (
                    this.Version == input.Version ||
                    (this.Version != null &&
                    this.Version.Equals(input.Version))
                ) && 
                (
                    this.FileName == input.FileName ||
                    (this.FileName != null &&
                    this.FileName.Equals(input.FileName))
                ) && 
                (
                    this.CreateDate == input.CreateDate ||
                    (this.CreateDate != null &&
                    this.CreateDate.Equals(input.CreateDate))
                ) && 
                (
                    this.SealedDate == input.SealedDate ||
                    (this.SealedDate != null &&
                    this.SealedDate.Equals(input.SealedDate))
                ) && 
                (
                    this.CertifiedDate == input.CertifiedDate ||
                    (this.CertifiedDate != null &&
                    this.CertifiedDate.Equals(input.CertifiedDate))
                ) && 
                (
                    this.IsSealPending == input.IsSealPending ||
                    (this.IsSealPending != null &&
                    this.IsSealPending.Equals(input.IsSealPending))
                ) && 
                (
                    this.IsCertifyPending == input.IsCertifyPending ||
                    (this.IsCertifyPending != null &&
                    this.IsCertifyPending.Equals(input.IsCertifyPending))
                ) && 
                (
                    this.DocumentSHA256Hash == input.DocumentSHA256Hash ||
                    (this.DocumentSHA256Hash != null &&
                    this.DocumentSHA256Hash.Equals(input.DocumentSHA256Hash))
                ) && 
                (
                    this.VersionInfo == input.VersionInfo ||
                    (this.VersionInfo != null &&
                    this.VersionInfo.Equals(input.VersionInfo))
                ) && 
                (
                    this.IsFinal == input.IsFinal ||
                    (this.IsFinal != null &&
                    this.IsFinal.Equals(input.IsFinal))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ID != null)
                    hashCode = hashCode * 59 + this.ID.GetHashCode();
                if (this.DocumentID != null)
                    hashCode = hashCode * 59 + this.DocumentID.GetHashCode();
                if (this.Version != null)
                    hashCode = hashCode * 59 + this.Version.GetHashCode();
                if (this.FileName != null)
                    hashCode = hashCode * 59 + this.FileName.GetHashCode();
                if (this.CreateDate != null)
                    hashCode = hashCode * 59 + this.CreateDate.GetHashCode();
                if (this.SealedDate != null)
                    hashCode = hashCode * 59 + this.SealedDate.GetHashCode();
                if (this.CertifiedDate != null)
                    hashCode = hashCode * 59 + this.CertifiedDate.GetHashCode();
                if (this.IsSealPending != null)
                    hashCode = hashCode * 59 + this.IsSealPending.GetHashCode();
                if (this.IsCertifyPending != null)
                    hashCode = hashCode * 59 + this.IsCertifyPending.GetHashCode();
                if (this.DocumentSHA256Hash != null)
                    hashCode = hashCode * 59 + this.DocumentSHA256Hash.GetHashCode();
                if (this.VersionInfo != null)
                    hashCode = hashCode * 59 + this.VersionInfo.GetHashCode();
                if (this.IsFinal != null)
                    hashCode = hashCode * 59 + this.IsFinal.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
