/* 
 * API Version: 5.0
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v5
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// DocumentVersionModel
    /// </summary>
    [DataContract]
    public partial class DocumentVersionModel :  IEquatable<DocumentVersionModel>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="DocumentVersionModel" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected DocumentVersionModel() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="DocumentVersionModel" /> class.
        /// </summary>
        /// <param name="iD">iD (required).</param>
        /// <param name="documentID">documentID (required).</param>
        /// <param name="version">version (required).</param>
        /// <param name="transID">transID (required).</param>
        /// <param name="prontoID">prontoID (required).</param>
        /// <param name="fileName">fileName (required).</param>
        /// <param name="tSCreate">tSCreate.</param>
        /// <param name="tSSealed">tSSealed.</param>
        /// <param name="tSCertified">tSCertified.</param>
        /// <param name="sealPending">sealPending.</param>
        /// <param name="certifyPending">certifyPending.</param>
        /// <param name="documentSHA256Hash">documentSHA256Hash.</param>
        /// <param name="versionInfo">versionInfo.</param>
        /// <param name="isFinal">isFinal.</param>
        public DocumentVersionModel(int? iD = default(int?), int? documentID = default(int?), int? version = default(int?), int? transID = default(int?), string prontoID = default(string), string fileName = default(string), DateTime? tSCreate = default(DateTime?), DateTime? tSSealed = default(DateTime?), DateTime? tSCertified = default(DateTime?), int? sealPending = default(int?), int? certifyPending = default(int?), string documentSHA256Hash = default(string), string versionInfo = default(string), bool? isFinal = default(bool?))
        {
            // to ensure "iD" is required (not null)
            if (iD == null)
            {
                throw new InvalidDataException("iD is a required property for DocumentVersionModel and cannot be null");
            }
            else
            {
                this.ID = iD;
            }
            // to ensure "documentID" is required (not null)
            if (documentID == null)
            {
                throw new InvalidDataException("documentID is a required property for DocumentVersionModel and cannot be null");
            }
            else
            {
                this.DocumentID = documentID;
            }
            // to ensure "version" is required (not null)
            if (version == null)
            {
                throw new InvalidDataException("version is a required property for DocumentVersionModel and cannot be null");
            }
            else
            {
                this.Version = version;
            }
            // to ensure "transID" is required (not null)
            if (transID == null)
            {
                throw new InvalidDataException("transID is a required property for DocumentVersionModel and cannot be null");
            }
            else
            {
                this.TransID = transID;
            }
            // to ensure "prontoID" is required (not null)
            if (prontoID == null)
            {
                throw new InvalidDataException("prontoID is a required property for DocumentVersionModel and cannot be null");
            }
            else
            {
                this.ProntoID = prontoID;
            }
            // to ensure "fileName" is required (not null)
            if (fileName == null)
            {
                throw new InvalidDataException("fileName is a required property for DocumentVersionModel and cannot be null");
            }
            else
            {
                this.FileName = fileName;
            }
            this.TSCreate = tSCreate;
            this.TSSealed = tSSealed;
            this.TSCertified = tSCertified;
            this.SealPending = sealPending;
            this.CertifyPending = certifyPending;
            this.DocumentSHA256Hash = documentSHA256Hash;
            this.VersionInfo = versionInfo;
            this.IsFinal = isFinal;
        }
        
        /// <summary>
        /// Gets or Sets ID
        /// </summary>
        [DataMember(Name="ID", EmitDefaultValue=false)]
        public int? ID { get; set; }

        /// <summary>
        /// Gets or Sets DocumentID
        /// </summary>
        [DataMember(Name="DocumentID", EmitDefaultValue=false)]
        public int? DocumentID { get; set; }

        /// <summary>
        /// Gets or Sets Version
        /// </summary>
        [DataMember(Name="Version", EmitDefaultValue=false)]
        public int? Version { get; set; }

        /// <summary>
        /// Gets or Sets TransID
        /// </summary>
        [DataMember(Name="TransID", EmitDefaultValue=false)]
        public int? TransID { get; set; }

        /// <summary>
        /// Gets or Sets ProntoID
        /// </summary>
        [DataMember(Name="ProntoID", EmitDefaultValue=false)]
        public string ProntoID { get; set; }

        /// <summary>
        /// Gets or Sets FileName
        /// </summary>
        [DataMember(Name="FileName", EmitDefaultValue=false)]
        public string FileName { get; set; }

        /// <summary>
        /// Gets or Sets TSCreate
        /// </summary>
        [DataMember(Name="TSCreate", EmitDefaultValue=false)]
        public DateTime? TSCreate { get; set; }

        /// <summary>
        /// Gets or Sets TSSealed
        /// </summary>
        [DataMember(Name="TSSealed", EmitDefaultValue=false)]
        public DateTime? TSSealed { get; set; }

        /// <summary>
        /// Gets or Sets TSCertified
        /// </summary>
        [DataMember(Name="TSCertified", EmitDefaultValue=false)]
        public DateTime? TSCertified { get; set; }

        /// <summary>
        /// Gets or Sets SealPending
        /// </summary>
        [DataMember(Name="SealPending", EmitDefaultValue=false)]
        public int? SealPending { get; set; }

        /// <summary>
        /// Gets or Sets CertifyPending
        /// </summary>
        [DataMember(Name="CertifyPending", EmitDefaultValue=false)]
        public int? CertifyPending { get; set; }

        /// <summary>
        /// Gets or Sets DocumentSHA256Hash
        /// </summary>
        [DataMember(Name="DocumentSHA256Hash", EmitDefaultValue=false)]
        public string DocumentSHA256Hash { get; set; }

        /// <summary>
        /// Gets or Sets VersionInfo
        /// </summary>
        [DataMember(Name="VersionInfo", EmitDefaultValue=false)]
        public string VersionInfo { get; set; }

        /// <summary>
        /// Gets or Sets IsFinal
        /// </summary>
        [DataMember(Name="IsFinal", EmitDefaultValue=false)]
        public bool? IsFinal { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class DocumentVersionModel {\n");
            sb.Append("  ID: ").Append(ID).Append("\n");
            sb.Append("  DocumentID: ").Append(DocumentID).Append("\n");
            sb.Append("  Version: ").Append(Version).Append("\n");
            sb.Append("  TransID: ").Append(TransID).Append("\n");
            sb.Append("  ProntoID: ").Append(ProntoID).Append("\n");
            sb.Append("  FileName: ").Append(FileName).Append("\n");
            sb.Append("  TSCreate: ").Append(TSCreate).Append("\n");
            sb.Append("  TSSealed: ").Append(TSSealed).Append("\n");
            sb.Append("  TSCertified: ").Append(TSCertified).Append("\n");
            sb.Append("  SealPending: ").Append(SealPending).Append("\n");
            sb.Append("  CertifyPending: ").Append(CertifyPending).Append("\n");
            sb.Append("  DocumentSHA256Hash: ").Append(DocumentSHA256Hash).Append("\n");
            sb.Append("  VersionInfo: ").Append(VersionInfo).Append("\n");
            sb.Append("  IsFinal: ").Append(IsFinal).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as DocumentVersionModel);
        }

        /// <summary>
        /// Returns true if DocumentVersionModel instances are equal
        /// </summary>
        /// <param name="input">Instance of DocumentVersionModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(DocumentVersionModel input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ID == input.ID ||
                    (this.ID != null &&
                    this.ID.Equals(input.ID))
                ) && 
                (
                    this.DocumentID == input.DocumentID ||
                    (this.DocumentID != null &&
                    this.DocumentID.Equals(input.DocumentID))
                ) && 
                (
                    this.Version == input.Version ||
                    (this.Version != null &&
                    this.Version.Equals(input.Version))
                ) && 
                (
                    this.TransID == input.TransID ||
                    (this.TransID != null &&
                    this.TransID.Equals(input.TransID))
                ) && 
                (
                    this.ProntoID == input.ProntoID ||
                    (this.ProntoID != null &&
                    this.ProntoID.Equals(input.ProntoID))
                ) && 
                (
                    this.FileName == input.FileName ||
                    (this.FileName != null &&
                    this.FileName.Equals(input.FileName))
                ) && 
                (
                    this.TSCreate == input.TSCreate ||
                    (this.TSCreate != null &&
                    this.TSCreate.Equals(input.TSCreate))
                ) && 
                (
                    this.TSSealed == input.TSSealed ||
                    (this.TSSealed != null &&
                    this.TSSealed.Equals(input.TSSealed))
                ) && 
                (
                    this.TSCertified == input.TSCertified ||
                    (this.TSCertified != null &&
                    this.TSCertified.Equals(input.TSCertified))
                ) && 
                (
                    this.SealPending == input.SealPending ||
                    (this.SealPending != null &&
                    this.SealPending.Equals(input.SealPending))
                ) && 
                (
                    this.CertifyPending == input.CertifyPending ||
                    (this.CertifyPending != null &&
                    this.CertifyPending.Equals(input.CertifyPending))
                ) && 
                (
                    this.DocumentSHA256Hash == input.DocumentSHA256Hash ||
                    (this.DocumentSHA256Hash != null &&
                    this.DocumentSHA256Hash.Equals(input.DocumentSHA256Hash))
                ) && 
                (
                    this.VersionInfo == input.VersionInfo ||
                    (this.VersionInfo != null &&
                    this.VersionInfo.Equals(input.VersionInfo))
                ) && 
                (
                    this.IsFinal == input.IsFinal ||
                    (this.IsFinal != null &&
                    this.IsFinal.Equals(input.IsFinal))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ID != null)
                    hashCode = hashCode * 59 + this.ID.GetHashCode();
                if (this.DocumentID != null)
                    hashCode = hashCode * 59 + this.DocumentID.GetHashCode();
                if (this.Version != null)
                    hashCode = hashCode * 59 + this.Version.GetHashCode();
                if (this.TransID != null)
                    hashCode = hashCode * 59 + this.TransID.GetHashCode();
                if (this.ProntoID != null)
                    hashCode = hashCode * 59 + this.ProntoID.GetHashCode();
                if (this.FileName != null)
                    hashCode = hashCode * 59 + this.FileName.GetHashCode();
                if (this.TSCreate != null)
                    hashCode = hashCode * 59 + this.TSCreate.GetHashCode();
                if (this.TSSealed != null)
                    hashCode = hashCode * 59 + this.TSSealed.GetHashCode();
                if (this.TSCertified != null)
                    hashCode = hashCode * 59 + this.TSCertified.GetHashCode();
                if (this.SealPending != null)
                    hashCode = hashCode * 59 + this.SealPending.GetHashCode();
                if (this.CertifyPending != null)
                    hashCode = hashCode * 59 + this.CertifyPending.GetHashCode();
                if (this.DocumentSHA256Hash != null)
                    hashCode = hashCode * 59 + this.DocumentSHA256Hash.GetHashCode();
                if (this.VersionInfo != null)
                    hashCode = hashCode * 59 + this.VersionInfo.GetHashCode();
                if (this.IsFinal != null)
                    hashCode = hashCode * 59 + this.IsFinal.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // ProntoID (string) maxLength
            if(this.ProntoID != null && this.ProntoID.Length > 64)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for ProntoID, length must be less than 64.", new [] { "ProntoID" });
            }

            // ProntoID (string) minLength
            if(this.ProntoID != null && this.ProntoID.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for ProntoID, length must be greater than 0.", new [] { "ProntoID" });
            }

            yield break;
        }
    }

}
