/* 
 * API Version: 5.0
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v5
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// EmailNotificationModel
    /// </summary>
    [DataContract]
    public partial class EmailNotificationModel :  IEquatable<EmailNotificationModel>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EmailNotificationModel" /> class.
        /// </summary>
        /// <param name="subject">subject.</param>
        /// <param name="bodyHtml">bodyHtml.</param>
        /// <param name="placeholders">placeholders.</param>
        /// <param name="sendDelayInMinutes">sendDelayInMinutes.</param>
        public EmailNotificationModel(string subject = default(string), string bodyHtml = default(string), List<Object> placeholders = default(List<Object>), int? sendDelayInMinutes = default(int?))
        {
            this.Subject = subject;
            this.BodyHtml = bodyHtml;
            this.Placeholders = placeholders;
            this.SendDelayInMinutes = sendDelayInMinutes;
        }
        
        /// <summary>
        /// Gets or Sets Subject
        /// </summary>
        [DataMember(Name="Subject", EmitDefaultValue=false)]
        public string Subject { get; set; }

        /// <summary>
        /// Gets or Sets BodyHtml
        /// </summary>
        [DataMember(Name="BodyHtml", EmitDefaultValue=false)]
        public string BodyHtml { get; set; }

        /// <summary>
        /// Gets or Sets Placeholders
        /// </summary>
        [DataMember(Name="Placeholders", EmitDefaultValue=false)]
        public List<Object> Placeholders { get; set; }

        /// <summary>
        /// Gets or Sets SendDelayInMinutes
        /// </summary>
        [DataMember(Name="SendDelayInMinutes", EmitDefaultValue=false)]
        public int? SendDelayInMinutes { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class EmailNotificationModel {\n");
            sb.Append("  Subject: ").Append(Subject).Append("\n");
            sb.Append("  BodyHtml: ").Append(BodyHtml).Append("\n");
            sb.Append("  Placeholders: ").Append(Placeholders).Append("\n");
            sb.Append("  SendDelayInMinutes: ").Append(SendDelayInMinutes).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as EmailNotificationModel);
        }

        /// <summary>
        /// Returns true if EmailNotificationModel instances are equal
        /// </summary>
        /// <param name="input">Instance of EmailNotificationModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(EmailNotificationModel input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Subject == input.Subject ||
                    (this.Subject != null &&
                    this.Subject.Equals(input.Subject))
                ) && 
                (
                    this.BodyHtml == input.BodyHtml ||
                    (this.BodyHtml != null &&
                    this.BodyHtml.Equals(input.BodyHtml))
                ) && 
                (
                    this.Placeholders == input.Placeholders ||
                    this.Placeholders != null &&
                    this.Placeholders.SequenceEqual(input.Placeholders)
                ) && 
                (
                    this.SendDelayInMinutes == input.SendDelayInMinutes ||
                    (this.SendDelayInMinutes != null &&
                    this.SendDelayInMinutes.Equals(input.SendDelayInMinutes))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Subject != null)
                    hashCode = hashCode * 59 + this.Subject.GetHashCode();
                if (this.BodyHtml != null)
                    hashCode = hashCode * 59 + this.BodyHtml.GetHashCode();
                if (this.Placeholders != null)
                    hashCode = hashCode * 59 + this.Placeholders.GetHashCode();
                if (this.SendDelayInMinutes != null)
                    hashCode = hashCode * 59 + this.SendDelayInMinutes.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // Subject (string) maxLength
            if(this.Subject != null && this.Subject.Length > 256)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Subject, length must be less than 256.", new [] { "Subject" });
            }

            // Subject (string) minLength
            if(this.Subject != null && this.Subject.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Subject, length must be greater than 0.", new [] { "Subject" });
            }

            yield break;
        }
    }

}
