/* 
 * API Version: 5.0
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v5
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// FileAttachmentDetailsModel
    /// </summary>
    [DataContract]
    public partial class FileAttachmentDetailsModel :  IEquatable<FileAttachmentDetailsModel>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="FileAttachmentDetailsModel" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected FileAttachmentDetailsModel() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="FileAttachmentDetailsModel" /> class.
        /// </summary>
        /// <param name="iD">iD.</param>
        /// <param name="taskID">taskID (required).</param>
        /// <param name="fileBytes">fileBytes (required).</param>
        /// <param name="fileName">fileName (required).</param>
        /// <param name="fileExtension">fileExtension (required).</param>
        /// <param name="fileMimeType">fileMimeType (required).</param>
        /// <param name="createdDate">createdDate.</param>
        public FileAttachmentDetailsModel(int? iD = default(int?), int? taskID = default(int?), byte[] fileBytes = default(byte[]), string fileName = default(string), string fileExtension = default(string), string fileMimeType = default(string), DateTime? createdDate = default(DateTime?))
        {
            // to ensure "taskID" is required (not null)
            if (taskID == null)
            {
                throw new InvalidDataException("taskID is a required property for FileAttachmentDetailsModel and cannot be null");
            }
            else
            {
                this.TaskID = taskID;
            }
            // to ensure "fileBytes" is required (not null)
            if (fileBytes == null)
            {
                throw new InvalidDataException("fileBytes is a required property for FileAttachmentDetailsModel and cannot be null");
            }
            else
            {
                this.FileBytes = fileBytes;
            }
            // to ensure "fileName" is required (not null)
            if (fileName == null)
            {
                throw new InvalidDataException("fileName is a required property for FileAttachmentDetailsModel and cannot be null");
            }
            else
            {
                this.FileName = fileName;
            }
            // to ensure "fileExtension" is required (not null)
            if (fileExtension == null)
            {
                throw new InvalidDataException("fileExtension is a required property for FileAttachmentDetailsModel and cannot be null");
            }
            else
            {
                this.FileExtension = fileExtension;
            }
            // to ensure "fileMimeType" is required (not null)
            if (fileMimeType == null)
            {
                throw new InvalidDataException("fileMimeType is a required property for FileAttachmentDetailsModel and cannot be null");
            }
            else
            {
                this.FileMimeType = fileMimeType;
            }
            this.ID = iD;
            this.CreatedDate = createdDate;
        }
        
        /// <summary>
        /// Gets or Sets ID
        /// </summary>
        [DataMember(Name="ID", EmitDefaultValue=false)]
        public int? ID { get; set; }

        /// <summary>
        /// Gets or Sets TaskID
        /// </summary>
        [DataMember(Name="TaskID", EmitDefaultValue=false)]
        public int? TaskID { get; set; }

        /// <summary>
        /// Gets or Sets FileBytes
        /// </summary>
        [DataMember(Name="FileBytes", EmitDefaultValue=false)]
        public byte[] FileBytes { get; set; }

        /// <summary>
        /// Gets or Sets FileName
        /// </summary>
        [DataMember(Name="FileName", EmitDefaultValue=false)]
        public string FileName { get; set; }

        /// <summary>
        /// Gets or Sets FileExtension
        /// </summary>
        [DataMember(Name="FileExtension", EmitDefaultValue=false)]
        public string FileExtension { get; set; }

        /// <summary>
        /// Gets or Sets FileMimeType
        /// </summary>
        [DataMember(Name="FileMimeType", EmitDefaultValue=false)]
        public string FileMimeType { get; set; }

        /// <summary>
        /// Gets or Sets CreatedDate
        /// </summary>
        [DataMember(Name="CreatedDate", EmitDefaultValue=false)]
        public DateTime? CreatedDate { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class FileAttachmentDetailsModel {\n");
            sb.Append("  ID: ").Append(ID).Append("\n");
            sb.Append("  TaskID: ").Append(TaskID).Append("\n");
            sb.Append("  FileBytes: ").Append(FileBytes).Append("\n");
            sb.Append("  FileName: ").Append(FileName).Append("\n");
            sb.Append("  FileExtension: ").Append(FileExtension).Append("\n");
            sb.Append("  FileMimeType: ").Append(FileMimeType).Append("\n");
            sb.Append("  CreatedDate: ").Append(CreatedDate).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as FileAttachmentDetailsModel);
        }

        /// <summary>
        /// Returns true if FileAttachmentDetailsModel instances are equal
        /// </summary>
        /// <param name="input">Instance of FileAttachmentDetailsModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(FileAttachmentDetailsModel input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ID == input.ID ||
                    (this.ID != null &&
                    this.ID.Equals(input.ID))
                ) && 
                (
                    this.TaskID == input.TaskID ||
                    (this.TaskID != null &&
                    this.TaskID.Equals(input.TaskID))
                ) && 
                (
                    this.FileBytes == input.FileBytes ||
                    (this.FileBytes != null &&
                    this.FileBytes.Equals(input.FileBytes))
                ) && 
                (
                    this.FileName == input.FileName ||
                    (this.FileName != null &&
                    this.FileName.Equals(input.FileName))
                ) && 
                (
                    this.FileExtension == input.FileExtension ||
                    (this.FileExtension != null &&
                    this.FileExtension.Equals(input.FileExtension))
                ) && 
                (
                    this.FileMimeType == input.FileMimeType ||
                    (this.FileMimeType != null &&
                    this.FileMimeType.Equals(input.FileMimeType))
                ) && 
                (
                    this.CreatedDate == input.CreatedDate ||
                    (this.CreatedDate != null &&
                    this.CreatedDate.Equals(input.CreatedDate))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ID != null)
                    hashCode = hashCode * 59 + this.ID.GetHashCode();
                if (this.TaskID != null)
                    hashCode = hashCode * 59 + this.TaskID.GetHashCode();
                if (this.FileBytes != null)
                    hashCode = hashCode * 59 + this.FileBytes.GetHashCode();
                if (this.FileName != null)
                    hashCode = hashCode * 59 + this.FileName.GetHashCode();
                if (this.FileExtension != null)
                    hashCode = hashCode * 59 + this.FileExtension.GetHashCode();
                if (this.FileMimeType != null)
                    hashCode = hashCode * 59 + this.FileMimeType.GetHashCode();
                if (this.CreatedDate != null)
                    hashCode = hashCode * 59 + this.CreatedDate.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // FileName (string) maxLength
            if(this.FileName != null && this.FileName.Length > 128)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for FileName, length must be less than 128.", new [] { "FileName" });
            }

            // FileName (string) minLength
            if(this.FileName != null && this.FileName.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for FileName, length must be greater than 0.", new [] { "FileName" });
            }

            // FileExtension (string) maxLength
            if(this.FileExtension != null && this.FileExtension.Length > 10)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for FileExtension, length must be less than 10.", new [] { "FileExtension" });
            }

            // FileExtension (string) minLength
            if(this.FileExtension != null && this.FileExtension.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for FileExtension, length must be greater than 0.", new [] { "FileExtension" });
            }

            // FileMimeType (string) maxLength
            if(this.FileMimeType != null && this.FileMimeType.Length > 128)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for FileMimeType, length must be less than 128.", new [] { "FileMimeType" });
            }

            // FileMimeType (string) minLength
            if(this.FileMimeType != null && this.FileMimeType.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for FileMimeType, length must be greater than 0.", new [] { "FileMimeType" });
            }

            yield break;
        }
    }

}
