/* 
 * API Version: 5.0
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v5
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// FileAttachmentInsertModel
    /// </summary>
    [DataContract]
    public partial class FileAttachmentInsertModel :  IEquatable<FileAttachmentInsertModel>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="FileAttachmentInsertModel" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected FileAttachmentInsertModel() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="FileAttachmentInsertModel" /> class.
        /// </summary>
        /// <param name="taskID">taskID (required).</param>
        /// <param name="fileBytes">fileBytes (required).</param>
        /// <param name="fileName">fileName (required).</param>
        /// <param name="fileMimeType">fileMimeType (required).</param>
        public FileAttachmentInsertModel(int? taskID = default(int?), byte[] fileBytes = default(byte[]), string fileName = default(string), string fileMimeType = default(string))
        {
            // to ensure "taskID" is required (not null)
            if (taskID == null)
            {
                throw new InvalidDataException("taskID is a required property for FileAttachmentInsertModel and cannot be null");
            }
            else
            {
                this.TaskID = taskID;
            }
            // to ensure "fileBytes" is required (not null)
            if (fileBytes == null)
            {
                throw new InvalidDataException("fileBytes is a required property for FileAttachmentInsertModel and cannot be null");
            }
            else
            {
                this.FileBytes = fileBytes;
            }
            // to ensure "fileName" is required (not null)
            if (fileName == null)
            {
                throw new InvalidDataException("fileName is a required property for FileAttachmentInsertModel and cannot be null");
            }
            else
            {
                this.FileName = fileName;
            }
            // to ensure "fileMimeType" is required (not null)
            if (fileMimeType == null)
            {
                throw new InvalidDataException("fileMimeType is a required property for FileAttachmentInsertModel and cannot be null");
            }
            else
            {
                this.FileMimeType = fileMimeType;
            }
        }
        
        /// <summary>
        /// Gets or Sets TaskID
        /// </summary>
        [DataMember(Name="TaskID", EmitDefaultValue=false)]
        public int? TaskID { get; set; }

        /// <summary>
        /// Gets or Sets FileBytes
        /// </summary>
        [DataMember(Name="FileBytes", EmitDefaultValue=false)]
        public byte[] FileBytes { get; set; }

        /// <summary>
        /// Gets or Sets FileName
        /// </summary>
        [DataMember(Name="FileName", EmitDefaultValue=false)]
        public string FileName { get; set; }

        /// <summary>
        /// Gets or Sets FileMimeType
        /// </summary>
        [DataMember(Name="FileMimeType", EmitDefaultValue=false)]
        public string FileMimeType { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class FileAttachmentInsertModel {\n");
            sb.Append("  TaskID: ").Append(TaskID).Append("\n");
            sb.Append("  FileBytes: ").Append(FileBytes).Append("\n");
            sb.Append("  FileName: ").Append(FileName).Append("\n");
            sb.Append("  FileMimeType: ").Append(FileMimeType).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as FileAttachmentInsertModel);
        }

        /// <summary>
        /// Returns true if FileAttachmentInsertModel instances are equal
        /// </summary>
        /// <param name="input">Instance of FileAttachmentInsertModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(FileAttachmentInsertModel input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.TaskID == input.TaskID ||
                    (this.TaskID != null &&
                    this.TaskID.Equals(input.TaskID))
                ) && 
                (
                    this.FileBytes == input.FileBytes ||
                    (this.FileBytes != null &&
                    this.FileBytes.Equals(input.FileBytes))
                ) && 
                (
                    this.FileName == input.FileName ||
                    (this.FileName != null &&
                    this.FileName.Equals(input.FileName))
                ) && 
                (
                    this.FileMimeType == input.FileMimeType ||
                    (this.FileMimeType != null &&
                    this.FileMimeType.Equals(input.FileMimeType))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.TaskID != null)
                    hashCode = hashCode * 59 + this.TaskID.GetHashCode();
                if (this.FileBytes != null)
                    hashCode = hashCode * 59 + this.FileBytes.GetHashCode();
                if (this.FileName != null)
                    hashCode = hashCode * 59 + this.FileName.GetHashCode();
                if (this.FileMimeType != null)
                    hashCode = hashCode * 59 + this.FileMimeType.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // FileName (string) maxLength
            if(this.FileName != null && this.FileName.Length > 128)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for FileName, length must be less than 128.", new [] { "FileName" });
            }

            // FileName (string) minLength
            if(this.FileName != null && this.FileName.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for FileName, length must be greater than 0.", new [] { "FileName" });
            }

            // FileName (string) pattern
            Regex regexFileName = new Regex(@".+\\.([^.]+)$", RegexOptions.CultureInvariant);
            if (false == regexFileName.Match(this.FileName).Success)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for FileName, must match a pattern of " + regexFileName, new [] { "FileName" });
            }

            // FileMimeType (string) maxLength
            if(this.FileMimeType != null && this.FileMimeType.Length > 128)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for FileMimeType, length must be less than 128.", new [] { "FileMimeType" });
            }

            // FileMimeType (string) minLength
            if(this.FileMimeType != null && this.FileMimeType.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for FileMimeType, length must be greater than 0.", new [] { "FileMimeType" });
            }

            yield break;
        }
    }

}
