/* 
 * API Version: 5.0
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v5
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// GroupInsertModel
    /// </summary>
    [DataContract]
    public partial class GroupInsertModel :  IEquatable<GroupInsertModel>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="GroupInsertModel" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected GroupInsertModel() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="GroupInsertModel" /> class.
        /// </summary>
        /// <param name="prontoID">prontoID.</param>
        /// <param name="name">name (required).</param>
        /// <param name="ownerName">ownerName (required).</param>
        /// <param name="ownerEmail">ownerEmail (required).</param>
        /// <param name="parentID">parentID.</param>
        /// <param name="isActive">isActive.</param>
        /// <param name="defaultDocumentRetentionInDays">defaultDocumentRetentionInDays.</param>
        /// <param name="processSessionExpirationInMinutes">processSessionExpirationInMinutes.</param>
        /// <param name="defaultUserPasswordChangeInDays">defaultUserPasswordChangeInDays.</param>
        /// <param name="privacyPolicy">privacyPolicy.</param>
        /// <param name="defaultBrand">defaultBrand.</param>
        /// <param name="defaultContentSet">defaultContentSet.</param>
        /// <param name="defaultEmailTemplateSet">defaultEmailTemplateSet.</param>
        /// <param name="isAdminLockedOut">isAdminLockedOut.</param>
        /// <param name="defaultEmailTemplateSetLanguage">defaultEmailTemplateSetLanguage.</param>
        /// <param name="disableSignatureChrome">disableSignatureChrome.</param>
        /// <param name="signatureChromeHeader">signatureChromeHeader.</param>
        /// <param name="signatureChromeFooter">signatureChromeFooter.</param>
        /// <param name="cascadePermissions">cascadePermissions.</param>
        public GroupInsertModel(string prontoID = default(string), string name = default(string), string ownerName = default(string), string ownerEmail = default(string), string parentID = default(string), bool? isActive = default(bool?), int? defaultDocumentRetentionInDays = default(int?), int? processSessionExpirationInMinutes = default(int?), int? defaultUserPasswordChangeInDays = default(int?), GroupPrivacyPolicyModel privacyPolicy = default(GroupPrivacyPolicyModel), string defaultBrand = default(string), string defaultContentSet = default(string), string defaultEmailTemplateSet = default(string), bool? isAdminLockedOut = default(bool?), string defaultEmailTemplateSetLanguage = default(string), bool? disableSignatureChrome = default(bool?), string signatureChromeHeader = default(string), string signatureChromeFooter = default(string), bool? cascadePermissions = default(bool?))
        {
            // to ensure "name" is required (not null)
            if (name == null)
            {
                throw new InvalidDataException("name is a required property for GroupInsertModel and cannot be null");
            }
            else
            {
                this.Name = name;
            }
            // to ensure "ownerName" is required (not null)
            if (ownerName == null)
            {
                throw new InvalidDataException("ownerName is a required property for GroupInsertModel and cannot be null");
            }
            else
            {
                this.OwnerName = ownerName;
            }
            // to ensure "ownerEmail" is required (not null)
            if (ownerEmail == null)
            {
                throw new InvalidDataException("ownerEmail is a required property for GroupInsertModel and cannot be null");
            }
            else
            {
                this.OwnerEmail = ownerEmail;
            }
            this.ProntoID = prontoID;
            this.ParentID = parentID;
            this.IsActive = isActive;
            this.DefaultDocumentRetentionInDays = defaultDocumentRetentionInDays;
            this.ProcessSessionExpirationInMinutes = processSessionExpirationInMinutes;
            this.DefaultUserPasswordChangeInDays = defaultUserPasswordChangeInDays;
            this.PrivacyPolicy = privacyPolicy;
            this.DefaultBrand = defaultBrand;
            this.DefaultContentSet = defaultContentSet;
            this.DefaultEmailTemplateSet = defaultEmailTemplateSet;
            this.IsAdminLockedOut = isAdminLockedOut;
            this.DefaultEmailTemplateSetLanguage = defaultEmailTemplateSetLanguage;
            this.DisableSignatureChrome = disableSignatureChrome;
            this.SignatureChromeHeader = signatureChromeHeader;
            this.SignatureChromeFooter = signatureChromeFooter;
            this.CascadePermissions = cascadePermissions;
        }
        
        /// <summary>
        /// Gets or Sets ProntoID
        /// </summary>
        [DataMember(Name="ProntoID", EmitDefaultValue=false)]
        public string ProntoID { get; set; }

        /// <summary>
        /// Gets or Sets Name
        /// </summary>
        [DataMember(Name="Name", EmitDefaultValue=false)]
        public string Name { get; set; }

        /// <summary>
        /// Gets or Sets OwnerName
        /// </summary>
        [DataMember(Name="OwnerName", EmitDefaultValue=false)]
        public string OwnerName { get; set; }

        /// <summary>
        /// Gets or Sets OwnerEmail
        /// </summary>
        [DataMember(Name="OwnerEmail", EmitDefaultValue=false)]
        public string OwnerEmail { get; set; }

        /// <summary>
        /// Gets or Sets ParentID
        /// </summary>
        [DataMember(Name="ParentID", EmitDefaultValue=false)]
        public string ParentID { get; set; }

        /// <summary>
        /// Gets or Sets IsActive
        /// </summary>
        [DataMember(Name="IsActive", EmitDefaultValue=false)]
        public bool? IsActive { get; set; }

        /// <summary>
        /// Gets or Sets DefaultDocumentRetentionInDays
        /// </summary>
        [DataMember(Name="DefaultDocumentRetentionInDays", EmitDefaultValue=false)]
        public int? DefaultDocumentRetentionInDays { get; set; }

        /// <summary>
        /// Gets or Sets ProcessSessionExpirationInMinutes
        /// </summary>
        [DataMember(Name="ProcessSessionExpirationInMinutes", EmitDefaultValue=false)]
        public int? ProcessSessionExpirationInMinutes { get; set; }

        /// <summary>
        /// Gets or Sets DefaultUserPasswordChangeInDays
        /// </summary>
        [DataMember(Name="DefaultUserPasswordChangeInDays", EmitDefaultValue=false)]
        public int? DefaultUserPasswordChangeInDays { get; set; }

        /// <summary>
        /// Gets or Sets PrivacyPolicy
        /// </summary>
        [DataMember(Name="PrivacyPolicy", EmitDefaultValue=false)]
        public GroupPrivacyPolicyModel PrivacyPolicy { get; set; }

        /// <summary>
        /// Gets or Sets DefaultBrand
        /// </summary>
        [DataMember(Name="DefaultBrand", EmitDefaultValue=false)]
        public string DefaultBrand { get; set; }

        /// <summary>
        /// Gets or Sets DefaultContentSet
        /// </summary>
        [DataMember(Name="DefaultContentSet", EmitDefaultValue=false)]
        public string DefaultContentSet { get; set; }

        /// <summary>
        /// Gets or Sets DefaultEmailTemplateSet
        /// </summary>
        [DataMember(Name="DefaultEmailTemplateSet", EmitDefaultValue=false)]
        public string DefaultEmailTemplateSet { get; set; }

        /// <summary>
        /// Gets or Sets IsAdminLockedOut
        /// </summary>
        [DataMember(Name="IsAdminLockedOut", EmitDefaultValue=false)]
        public bool? IsAdminLockedOut { get; set; }

        /// <summary>
        /// Gets or Sets DefaultEmailTemplateSetLanguage
        /// </summary>
        [DataMember(Name="DefaultEmailTemplateSetLanguage", EmitDefaultValue=false)]
        public string DefaultEmailTemplateSetLanguage { get; set; }

        /// <summary>
        /// Gets or Sets DisableSignatureChrome
        /// </summary>
        [DataMember(Name="DisableSignatureChrome", EmitDefaultValue=false)]
        public bool? DisableSignatureChrome { get; set; }

        /// <summary>
        /// Gets or Sets SignatureChromeHeader
        /// </summary>
        [DataMember(Name="SignatureChromeHeader", EmitDefaultValue=false)]
        public string SignatureChromeHeader { get; set; }

        /// <summary>
        /// Gets or Sets SignatureChromeFooter
        /// </summary>
        [DataMember(Name="SignatureChromeFooter", EmitDefaultValue=false)]
        public string SignatureChromeFooter { get; set; }

        /// <summary>
        /// Gets or Sets CascadePermissions
        /// </summary>
        [DataMember(Name="CascadePermissions", EmitDefaultValue=false)]
        public bool? CascadePermissions { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class GroupInsertModel {\n");
            sb.Append("  ProntoID: ").Append(ProntoID).Append("\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("  OwnerName: ").Append(OwnerName).Append("\n");
            sb.Append("  OwnerEmail: ").Append(OwnerEmail).Append("\n");
            sb.Append("  ParentID: ").Append(ParentID).Append("\n");
            sb.Append("  IsActive: ").Append(IsActive).Append("\n");
            sb.Append("  DefaultDocumentRetentionInDays: ").Append(DefaultDocumentRetentionInDays).Append("\n");
            sb.Append("  ProcessSessionExpirationInMinutes: ").Append(ProcessSessionExpirationInMinutes).Append("\n");
            sb.Append("  DefaultUserPasswordChangeInDays: ").Append(DefaultUserPasswordChangeInDays).Append("\n");
            sb.Append("  PrivacyPolicy: ").Append(PrivacyPolicy).Append("\n");
            sb.Append("  DefaultBrand: ").Append(DefaultBrand).Append("\n");
            sb.Append("  DefaultContentSet: ").Append(DefaultContentSet).Append("\n");
            sb.Append("  DefaultEmailTemplateSet: ").Append(DefaultEmailTemplateSet).Append("\n");
            sb.Append("  IsAdminLockedOut: ").Append(IsAdminLockedOut).Append("\n");
            sb.Append("  DefaultEmailTemplateSetLanguage: ").Append(DefaultEmailTemplateSetLanguage).Append("\n");
            sb.Append("  DisableSignatureChrome: ").Append(DisableSignatureChrome).Append("\n");
            sb.Append("  SignatureChromeHeader: ").Append(SignatureChromeHeader).Append("\n");
            sb.Append("  SignatureChromeFooter: ").Append(SignatureChromeFooter).Append("\n");
            sb.Append("  CascadePermissions: ").Append(CascadePermissions).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as GroupInsertModel);
        }

        /// <summary>
        /// Returns true if GroupInsertModel instances are equal
        /// </summary>
        /// <param name="input">Instance of GroupInsertModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(GroupInsertModel input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ProntoID == input.ProntoID ||
                    (this.ProntoID != null &&
                    this.ProntoID.Equals(input.ProntoID))
                ) && 
                (
                    this.Name == input.Name ||
                    (this.Name != null &&
                    this.Name.Equals(input.Name))
                ) && 
                (
                    this.OwnerName == input.OwnerName ||
                    (this.OwnerName != null &&
                    this.OwnerName.Equals(input.OwnerName))
                ) && 
                (
                    this.OwnerEmail == input.OwnerEmail ||
                    (this.OwnerEmail != null &&
                    this.OwnerEmail.Equals(input.OwnerEmail))
                ) && 
                (
                    this.ParentID == input.ParentID ||
                    (this.ParentID != null &&
                    this.ParentID.Equals(input.ParentID))
                ) && 
                (
                    this.IsActive == input.IsActive ||
                    (this.IsActive != null &&
                    this.IsActive.Equals(input.IsActive))
                ) && 
                (
                    this.DefaultDocumentRetentionInDays == input.DefaultDocumentRetentionInDays ||
                    (this.DefaultDocumentRetentionInDays != null &&
                    this.DefaultDocumentRetentionInDays.Equals(input.DefaultDocumentRetentionInDays))
                ) && 
                (
                    this.ProcessSessionExpirationInMinutes == input.ProcessSessionExpirationInMinutes ||
                    (this.ProcessSessionExpirationInMinutes != null &&
                    this.ProcessSessionExpirationInMinutes.Equals(input.ProcessSessionExpirationInMinutes))
                ) && 
                (
                    this.DefaultUserPasswordChangeInDays == input.DefaultUserPasswordChangeInDays ||
                    (this.DefaultUserPasswordChangeInDays != null &&
                    this.DefaultUserPasswordChangeInDays.Equals(input.DefaultUserPasswordChangeInDays))
                ) && 
                (
                    this.PrivacyPolicy == input.PrivacyPolicy ||
                    (this.PrivacyPolicy != null &&
                    this.PrivacyPolicy.Equals(input.PrivacyPolicy))
                ) && 
                (
                    this.DefaultBrand == input.DefaultBrand ||
                    (this.DefaultBrand != null &&
                    this.DefaultBrand.Equals(input.DefaultBrand))
                ) && 
                (
                    this.DefaultContentSet == input.DefaultContentSet ||
                    (this.DefaultContentSet != null &&
                    this.DefaultContentSet.Equals(input.DefaultContentSet))
                ) && 
                (
                    this.DefaultEmailTemplateSet == input.DefaultEmailTemplateSet ||
                    (this.DefaultEmailTemplateSet != null &&
                    this.DefaultEmailTemplateSet.Equals(input.DefaultEmailTemplateSet))
                ) && 
                (
                    this.IsAdminLockedOut == input.IsAdminLockedOut ||
                    (this.IsAdminLockedOut != null &&
                    this.IsAdminLockedOut.Equals(input.IsAdminLockedOut))
                ) && 
                (
                    this.DefaultEmailTemplateSetLanguage == input.DefaultEmailTemplateSetLanguage ||
                    (this.DefaultEmailTemplateSetLanguage != null &&
                    this.DefaultEmailTemplateSetLanguage.Equals(input.DefaultEmailTemplateSetLanguage))
                ) && 
                (
                    this.DisableSignatureChrome == input.DisableSignatureChrome ||
                    (this.DisableSignatureChrome != null &&
                    this.DisableSignatureChrome.Equals(input.DisableSignatureChrome))
                ) && 
                (
                    this.SignatureChromeHeader == input.SignatureChromeHeader ||
                    (this.SignatureChromeHeader != null &&
                    this.SignatureChromeHeader.Equals(input.SignatureChromeHeader))
                ) && 
                (
                    this.SignatureChromeFooter == input.SignatureChromeFooter ||
                    (this.SignatureChromeFooter != null &&
                    this.SignatureChromeFooter.Equals(input.SignatureChromeFooter))
                ) && 
                (
                    this.CascadePermissions == input.CascadePermissions ||
                    (this.CascadePermissions != null &&
                    this.CascadePermissions.Equals(input.CascadePermissions))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ProntoID != null)
                    hashCode = hashCode * 59 + this.ProntoID.GetHashCode();
                if (this.Name != null)
                    hashCode = hashCode * 59 + this.Name.GetHashCode();
                if (this.OwnerName != null)
                    hashCode = hashCode * 59 + this.OwnerName.GetHashCode();
                if (this.OwnerEmail != null)
                    hashCode = hashCode * 59 + this.OwnerEmail.GetHashCode();
                if (this.ParentID != null)
                    hashCode = hashCode * 59 + this.ParentID.GetHashCode();
                if (this.IsActive != null)
                    hashCode = hashCode * 59 + this.IsActive.GetHashCode();
                if (this.DefaultDocumentRetentionInDays != null)
                    hashCode = hashCode * 59 + this.DefaultDocumentRetentionInDays.GetHashCode();
                if (this.ProcessSessionExpirationInMinutes != null)
                    hashCode = hashCode * 59 + this.ProcessSessionExpirationInMinutes.GetHashCode();
                if (this.DefaultUserPasswordChangeInDays != null)
                    hashCode = hashCode * 59 + this.DefaultUserPasswordChangeInDays.GetHashCode();
                if (this.PrivacyPolicy != null)
                    hashCode = hashCode * 59 + this.PrivacyPolicy.GetHashCode();
                if (this.DefaultBrand != null)
                    hashCode = hashCode * 59 + this.DefaultBrand.GetHashCode();
                if (this.DefaultContentSet != null)
                    hashCode = hashCode * 59 + this.DefaultContentSet.GetHashCode();
                if (this.DefaultEmailTemplateSet != null)
                    hashCode = hashCode * 59 + this.DefaultEmailTemplateSet.GetHashCode();
                if (this.IsAdminLockedOut != null)
                    hashCode = hashCode * 59 + this.IsAdminLockedOut.GetHashCode();
                if (this.DefaultEmailTemplateSetLanguage != null)
                    hashCode = hashCode * 59 + this.DefaultEmailTemplateSetLanguage.GetHashCode();
                if (this.DisableSignatureChrome != null)
                    hashCode = hashCode * 59 + this.DisableSignatureChrome.GetHashCode();
                if (this.SignatureChromeHeader != null)
                    hashCode = hashCode * 59 + this.SignatureChromeHeader.GetHashCode();
                if (this.SignatureChromeFooter != null)
                    hashCode = hashCode * 59 + this.SignatureChromeFooter.GetHashCode();
                if (this.CascadePermissions != null)
                    hashCode = hashCode * 59 + this.CascadePermissions.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // ProntoID (string) maxLength
            if(this.ProntoID != null && this.ProntoID.Length > 64)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for ProntoID, length must be less than 64.", new [] { "ProntoID" });
            }

            // ProntoID (string) minLength
            if(this.ProntoID != null && this.ProntoID.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for ProntoID, length must be greater than 0.", new [] { "ProntoID" });
            }

            // Name (string) maxLength
            if(this.Name != null && this.Name.Length > 128)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Name, length must be less than 128.", new [] { "Name" });
            }

            // Name (string) minLength
            if(this.Name != null && this.Name.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Name, length must be greater than 0.", new [] { "Name" });
            }

            // OwnerName (string) maxLength
            if(this.OwnerName != null && this.OwnerName.Length > 64)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for OwnerName, length must be less than 64.", new [] { "OwnerName" });
            }

            // OwnerName (string) minLength
            if(this.OwnerName != null && this.OwnerName.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for OwnerName, length must be greater than 0.", new [] { "OwnerName" });
            }

            // OwnerEmail (string) maxLength
            if(this.OwnerEmail != null && this.OwnerEmail.Length > 128)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for OwnerEmail, length must be less than 128.", new [] { "OwnerEmail" });
            }

            // OwnerEmail (string) minLength
            if(this.OwnerEmail != null && this.OwnerEmail.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for OwnerEmail, length must be greater than 0.", new [] { "OwnerEmail" });
            }

            // OwnerEmail (string) pattern
            Regex regexOwnerEmail = new Regex(@"^(?![.])([^@,<>\\^]+@[^\\s<>,\\^]+\\.[^\\s<>,\\^]+)$", RegexOptions.CultureInvariant);
            if (false == regexOwnerEmail.Match(this.OwnerEmail).Success)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for OwnerEmail, must match a pattern of " + regexOwnerEmail, new [] { "OwnerEmail" });
            }

            // ParentID (string) maxLength
            if(this.ParentID != null && this.ParentID.Length > 64)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for ParentID, length must be less than 64.", new [] { "ParentID" });
            }

            // ParentID (string) minLength
            if(this.ParentID != null && this.ParentID.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for ParentID, length must be greater than 0.", new [] { "ParentID" });
            }

            // DefaultBrand (string) maxLength
            if(this.DefaultBrand != null && this.DefaultBrand.Length > 128)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for DefaultBrand, length must be less than 128.", new [] { "DefaultBrand" });
            }

            // DefaultBrand (string) minLength
            if(this.DefaultBrand != null && this.DefaultBrand.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for DefaultBrand, length must be greater than 0.", new [] { "DefaultBrand" });
            }

            // DefaultContentSet (string) maxLength
            if(this.DefaultContentSet != null && this.DefaultContentSet.Length > 128)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for DefaultContentSet, length must be less than 128.", new [] { "DefaultContentSet" });
            }

            // DefaultContentSet (string) minLength
            if(this.DefaultContentSet != null && this.DefaultContentSet.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for DefaultContentSet, length must be greater than 0.", new [] { "DefaultContentSet" });
            }

            // DefaultEmailTemplateSet (string) maxLength
            if(this.DefaultEmailTemplateSet != null && this.DefaultEmailTemplateSet.Length > 128)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for DefaultEmailTemplateSet, length must be less than 128.", new [] { "DefaultEmailTemplateSet" });
            }

            // DefaultEmailTemplateSet (string) minLength
            if(this.DefaultEmailTemplateSet != null && this.DefaultEmailTemplateSet.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for DefaultEmailTemplateSet, length must be greater than 0.", new [] { "DefaultEmailTemplateSet" });
            }

            // DefaultEmailTemplateSetLanguage (string) maxLength
            if(this.DefaultEmailTemplateSetLanguage != null && this.DefaultEmailTemplateSetLanguage.Length > 128)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for DefaultEmailTemplateSetLanguage, length must be less than 128.", new [] { "DefaultEmailTemplateSetLanguage" });
            }

            // DefaultEmailTemplateSetLanguage (string) minLength
            if(this.DefaultEmailTemplateSetLanguage != null && this.DefaultEmailTemplateSetLanguage.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for DefaultEmailTemplateSetLanguage, length must be greater than 0.", new [] { "DefaultEmailTemplateSetLanguage" });
            }

            // SignatureChromeHeader (string) maxLength
            if(this.SignatureChromeHeader != null && this.SignatureChromeHeader.Length > 64)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for SignatureChromeHeader, length must be less than 64.", new [] { "SignatureChromeHeader" });
            }

            // SignatureChromeHeader (string) minLength
            if(this.SignatureChromeHeader != null && this.SignatureChromeHeader.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for SignatureChromeHeader, length must be greater than 0.", new [] { "SignatureChromeHeader" });
            }

            // SignatureChromeFooter (string) maxLength
            if(this.SignatureChromeFooter != null && this.SignatureChromeFooter.Length > 64)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for SignatureChromeFooter, length must be less than 64.", new [] { "SignatureChromeFooter" });
            }

            // SignatureChromeFooter (string) minLength
            if(this.SignatureChromeFooter != null && this.SignatureChromeFooter.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for SignatureChromeFooter, length must be greater than 0.", new [] { "SignatureChromeFooter" });
            }

            yield break;
        }
    }

}
