/* 
 * API Version: 5.0
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v5
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// OutgoingEmailDetailsModel
    /// </summary>
    [DataContract]
    public partial class OutgoingEmailDetailsModel :  IEquatable<OutgoingEmailDetailsModel>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="OutgoingEmailDetailsModel" /> class.
        /// </summary>
        /// <param name="fromName">fromName.</param>
        /// <param name="fromEmailAddress">fromEmailAddress.</param>
        /// <param name="footerContent">footerContent.</param>
        public OutgoingEmailDetailsModel(string fromName = default(string), string fromEmailAddress = default(string), string footerContent = default(string))
        {
            this.FromName = fromName;
            this.FromEmailAddress = fromEmailAddress;
            this.FooterContent = footerContent;
        }
        
        /// <summary>
        /// Gets or Sets FromName
        /// </summary>
        [DataMember(Name="FromName", EmitDefaultValue=false)]
        public string FromName { get; set; }

        /// <summary>
        /// Gets or Sets FromEmailAddress
        /// </summary>
        [DataMember(Name="FromEmailAddress", EmitDefaultValue=false)]
        public string FromEmailAddress { get; set; }

        /// <summary>
        /// Gets or Sets FooterContent
        /// </summary>
        [DataMember(Name="FooterContent", EmitDefaultValue=false)]
        public string FooterContent { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class OutgoingEmailDetailsModel {\n");
            sb.Append("  FromName: ").Append(FromName).Append("\n");
            sb.Append("  FromEmailAddress: ").Append(FromEmailAddress).Append("\n");
            sb.Append("  FooterContent: ").Append(FooterContent).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as OutgoingEmailDetailsModel);
        }

        /// <summary>
        /// Returns true if OutgoingEmailDetailsModel instances are equal
        /// </summary>
        /// <param name="input">Instance of OutgoingEmailDetailsModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(OutgoingEmailDetailsModel input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.FromName == input.FromName ||
                    (this.FromName != null &&
                    this.FromName.Equals(input.FromName))
                ) && 
                (
                    this.FromEmailAddress == input.FromEmailAddress ||
                    (this.FromEmailAddress != null &&
                    this.FromEmailAddress.Equals(input.FromEmailAddress))
                ) && 
                (
                    this.FooterContent == input.FooterContent ||
                    (this.FooterContent != null &&
                    this.FooterContent.Equals(input.FooterContent))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.FromName != null)
                    hashCode = hashCode * 59 + this.FromName.GetHashCode();
                if (this.FromEmailAddress != null)
                    hashCode = hashCode * 59 + this.FromEmailAddress.GetHashCode();
                if (this.FooterContent != null)
                    hashCode = hashCode * 59 + this.FooterContent.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // FromName (string) maxLength
            if(this.FromName != null && this.FromName.Length > 64)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for FromName, length must be less than 64.", new [] { "FromName" });
            }

            // FromName (string) minLength
            if(this.FromName != null && this.FromName.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for FromName, length must be greater than 0.", new [] { "FromName" });
            }

            // FromEmailAddress (string) maxLength
            if(this.FromEmailAddress != null && this.FromEmailAddress.Length > 64)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for FromEmailAddress, length must be less than 64.", new [] { "FromEmailAddress" });
            }

            // FromEmailAddress (string) minLength
            if(this.FromEmailAddress != null && this.FromEmailAddress.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for FromEmailAddress, length must be greater than 0.", new [] { "FromEmailAddress" });
            }

            // FromEmailAddress (string) pattern
            Regex regexFromEmailAddress = new Regex(@"^(?![.])([^@,<>\\^]+@[^\\s<>,\\^]+\\.[^\\s<>,\\^]+)$", RegexOptions.CultureInvariant);
            if (false == regexFromEmailAddress.Match(this.FromEmailAddress).Success)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for FromEmailAddress, must match a pattern of " + regexFromEmailAddress, new [] { "FromEmailAddress" });
            }

            yield break;
        }
    }

}
