/* 
 * API Version: 5.0
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v5
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ParticipantCredentialsModel
    /// </summary>
    [DataContract]
    public partial class ParticipantCredentialsModel :  IEquatable<ParticipantCredentialsModel>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ParticipantCredentialsModel" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ParticipantCredentialsModel() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ParticipantCredentialsModel" /> class.
        /// </summary>
        /// <param name="participantID">participantID (required).</param>
        /// <param name="username">username.</param>
        /// <param name="password">password (required).</param>
        /// <param name="expirationInSeconds">expirationInSeconds.</param>
        public ParticipantCredentialsModel(int? participantID = default(int?), string username = default(string), string password = default(string), int? expirationInSeconds = default(int?))
        {
            // to ensure "participantID" is required (not null)
            if (participantID == null)
            {
                throw new InvalidDataException("participantID is a required property for ParticipantCredentialsModel and cannot be null");
            }
            else
            {
                this.ParticipantID = participantID;
            }
            // to ensure "password" is required (not null)
            if (password == null)
            {
                throw new InvalidDataException("password is a required property for ParticipantCredentialsModel and cannot be null");
            }
            else
            {
                this.Password = password;
            }
            this.Username = username;
            this.ExpirationInSeconds = expirationInSeconds;
        }
        
        /// <summary>
        /// Gets or Sets ParticipantID
        /// </summary>
        [DataMember(Name="ParticipantID", EmitDefaultValue=false)]
        public int? ParticipantID { get; set; }

        /// <summary>
        /// Gets or Sets Username
        /// </summary>
        [DataMember(Name="Username", EmitDefaultValue=false)]
        public string Username { get; set; }

        /// <summary>
        /// Gets or Sets Password
        /// </summary>
        [DataMember(Name="Password", EmitDefaultValue=false)]
        public string Password { get; set; }

        /// <summary>
        /// Gets or Sets ExpirationInSeconds
        /// </summary>
        [DataMember(Name="ExpirationInSeconds", EmitDefaultValue=false)]
        public int? ExpirationInSeconds { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ParticipantCredentialsModel {\n");
            sb.Append("  ParticipantID: ").Append(ParticipantID).Append("\n");
            sb.Append("  Username: ").Append(Username).Append("\n");
            sb.Append("  Password: ").Append(Password).Append("\n");
            sb.Append("  ExpirationInSeconds: ").Append(ExpirationInSeconds).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ParticipantCredentialsModel);
        }

        /// <summary>
        /// Returns true if ParticipantCredentialsModel instances are equal
        /// </summary>
        /// <param name="input">Instance of ParticipantCredentialsModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ParticipantCredentialsModel input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ParticipantID == input.ParticipantID ||
                    (this.ParticipantID != null &&
                    this.ParticipantID.Equals(input.ParticipantID))
                ) && 
                (
                    this.Username == input.Username ||
                    (this.Username != null &&
                    this.Username.Equals(input.Username))
                ) && 
                (
                    this.Password == input.Password ||
                    (this.Password != null &&
                    this.Password.Equals(input.Password))
                ) && 
                (
                    this.ExpirationInSeconds == input.ExpirationInSeconds ||
                    (this.ExpirationInSeconds != null &&
                    this.ExpirationInSeconds.Equals(input.ExpirationInSeconds))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ParticipantID != null)
                    hashCode = hashCode * 59 + this.ParticipantID.GetHashCode();
                if (this.Username != null)
                    hashCode = hashCode * 59 + this.Username.GetHashCode();
                if (this.Password != null)
                    hashCode = hashCode * 59 + this.Password.GetHashCode();
                if (this.ExpirationInSeconds != null)
                    hashCode = hashCode * 59 + this.ExpirationInSeconds.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
