/* 
 * API Version: 5.0
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v5
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ParticipantDefinedOptionModel
    /// </summary>
    [DataContract]
    public partial class ParticipantDefinedOptionModel :  IEquatable<ParticipantDefinedOptionModel>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ParticipantDefinedOptionModel" /> class.
        /// </summary>
        /// <param name="isDisplayed">isDisplayed.</param>
        /// <param name="customLabel">customLabel.</param>
        /// <param name="isPrepopulated">isPrepopulated.</param>
        /// <param name="isReadonly">isReadonly.</param>
        /// <param name="isRequired">isRequired.</param>
        public ParticipantDefinedOptionModel(bool? isDisplayed = default(bool?), string customLabel = default(string), bool? isPrepopulated = default(bool?), bool? isReadonly = default(bool?), bool? isRequired = default(bool?))
        {
            this.IsDisplayed = isDisplayed;
            this.CustomLabel = customLabel;
            this.IsPrepopulated = isPrepopulated;
            this.IsReadonly = isReadonly;
            this.IsRequired = isRequired;
        }
        
        /// <summary>
        /// Gets or Sets IsDisplayed
        /// </summary>
        [DataMember(Name="IsDisplayed", EmitDefaultValue=false)]
        public bool? IsDisplayed { get; set; }

        /// <summary>
        /// Gets or Sets CustomLabel
        /// </summary>
        [DataMember(Name="CustomLabel", EmitDefaultValue=false)]
        public string CustomLabel { get; set; }

        /// <summary>
        /// Gets or Sets IsPrepopulated
        /// </summary>
        [DataMember(Name="IsPrepopulated", EmitDefaultValue=false)]
        public bool? IsPrepopulated { get; set; }

        /// <summary>
        /// Gets or Sets IsReadonly
        /// </summary>
        [DataMember(Name="IsReadonly", EmitDefaultValue=false)]
        public bool? IsReadonly { get; set; }

        /// <summary>
        /// Gets or Sets IsRequired
        /// </summary>
        [DataMember(Name="IsRequired", EmitDefaultValue=false)]
        public bool? IsRequired { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ParticipantDefinedOptionModel {\n");
            sb.Append("  IsDisplayed: ").Append(IsDisplayed).Append("\n");
            sb.Append("  CustomLabel: ").Append(CustomLabel).Append("\n");
            sb.Append("  IsPrepopulated: ").Append(IsPrepopulated).Append("\n");
            sb.Append("  IsReadonly: ").Append(IsReadonly).Append("\n");
            sb.Append("  IsRequired: ").Append(IsRequired).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ParticipantDefinedOptionModel);
        }

        /// <summary>
        /// Returns true if ParticipantDefinedOptionModel instances are equal
        /// </summary>
        /// <param name="input">Instance of ParticipantDefinedOptionModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ParticipantDefinedOptionModel input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.IsDisplayed == input.IsDisplayed ||
                    (this.IsDisplayed != null &&
                    this.IsDisplayed.Equals(input.IsDisplayed))
                ) && 
                (
                    this.CustomLabel == input.CustomLabel ||
                    (this.CustomLabel != null &&
                    this.CustomLabel.Equals(input.CustomLabel))
                ) && 
                (
                    this.IsPrepopulated == input.IsPrepopulated ||
                    (this.IsPrepopulated != null &&
                    this.IsPrepopulated.Equals(input.IsPrepopulated))
                ) && 
                (
                    this.IsReadonly == input.IsReadonly ||
                    (this.IsReadonly != null &&
                    this.IsReadonly.Equals(input.IsReadonly))
                ) && 
                (
                    this.IsRequired == input.IsRequired ||
                    (this.IsRequired != null &&
                    this.IsRequired.Equals(input.IsRequired))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.IsDisplayed != null)
                    hashCode = hashCode * 59 + this.IsDisplayed.GetHashCode();
                if (this.CustomLabel != null)
                    hashCode = hashCode * 59 + this.CustomLabel.GetHashCode();
                if (this.IsPrepopulated != null)
                    hashCode = hashCode * 59 + this.IsPrepopulated.GetHashCode();
                if (this.IsReadonly != null)
                    hashCode = hashCode * 59 + this.IsReadonly.GetHashCode();
                if (this.IsRequired != null)
                    hashCode = hashCode * 59 + this.IsRequired.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
