/* 
 * API Version: 5.0
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v5
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ParticipantDetailsRequestModel
    /// </summary>
    [DataContract]
    public partial class ParticipantDetailsRequestModel :  IEquatable<ParticipantDetailsRequestModel>, IValidatableObject
    {
        /// <summary>
        /// Defines StatusType
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum StatusTypeEnum
        {
            
            /// <summary>
            /// Enum All for value: All
            /// </summary>
            [EnumMember(Value = "All")]
            All = 1,
            
            /// <summary>
            /// Enum Pending for value: Pending
            /// </summary>
            [EnumMember(Value = "Pending")]
            Pending = 2,
            
            /// <summary>
            /// Enum Completed for value: Completed
            /// </summary>
            [EnumMember(Value = "Completed")]
            Completed = 3,
            
            /// <summary>
            /// Enum EmailSent for value: EmailSent
            /// </summary>
            [EnumMember(Value = "EmailSent")]
            EmailSent = 4,
            
            /// <summary>
            /// Enum Closed for value: Closed
            /// </summary>
            [EnumMember(Value = "Closed")]
            Closed = 5,
            
            /// <summary>
            /// Enum Cancelled for value: Cancelled
            /// </summary>
            [EnumMember(Value = "Cancelled")]
            Cancelled = 6,
            
            /// <summary>
            /// Enum Expired for value: Expired
            /// </summary>
            [EnumMember(Value = "Expired")]
            Expired = 7,
            
            /// <summary>
            /// Enum Voided for value: Voided
            /// </summary>
            [EnumMember(Value = "Voided")]
            Voided = 8
        }

        /// <summary>
        /// Gets or Sets StatusType
        /// </summary>
        [DataMember(Name="StatusType", EmitDefaultValue=false)]
        public StatusTypeEnum? StatusType { get; set; }
        /// <summary>
        /// Defines SearchDateType
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum SearchDateTypeEnum
        {
            
            /// <summary>
            /// Enum CreatedDate for value: CreatedDate
            /// </summary>
            [EnumMember(Value = "CreatedDate")]
            CreatedDate = 1,
            
            /// <summary>
            /// Enum ClosedDate for value: ClosedDate
            /// </summary>
            [EnumMember(Value = "ClosedDate")]
            ClosedDate = 2
        }

        /// <summary>
        /// Gets or Sets SearchDateType
        /// </summary>
        [DataMember(Name="SearchDateType", EmitDefaultValue=false)]
        public SearchDateTypeEnum? SearchDateType { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="ParticipantDetailsRequestModel" /> class.
        /// </summary>
        /// <param name="iDs">iDs.</param>
        /// <param name="prontoID">prontoID.</param>
        /// <param name="transactionIDs">transactionIDs.</param>
        /// <param name="documentIDs">documentIDs.</param>
        /// <param name="taskIDs">taskIDs.</param>
        /// <param name="statusType">statusType.</param>
        /// <param name="fullName">fullName.</param>
        /// <param name="emailAddress">emailAddress.</param>
        /// <param name="title">title.</param>
        /// <param name="organization">organization.</param>
        /// <param name="searchDateType">searchDateType.</param>
        /// <param name="searchDateFrom">searchDateFrom.</param>
        /// <param name="searchDateTo">searchDateTo.</param>
        /// <param name="includes">includes.</param>
        /// <param name="enableLogging">enableLogging.</param>
        /// <param name="resultsCountLimit">resultsCountLimit.</param>
        /// <param name="resultsCountStart">resultsCountStart.</param>
        /// <param name="timeZoneID">timeZoneID.</param>
        public ParticipantDetailsRequestModel(List<Object> iDs = default(List<Object>), string prontoID = default(string), List<Object> transactionIDs = default(List<Object>), List<Object> documentIDs = default(List<Object>), List<Object> taskIDs = default(List<Object>), StatusTypeEnum? statusType = default(StatusTypeEnum?), string fullName = default(string), string emailAddress = default(string), string title = default(string), string organization = default(string), SearchDateTypeEnum? searchDateType = default(SearchDateTypeEnum?), DateTime? searchDateFrom = default(DateTime?), DateTime? searchDateTo = default(DateTime?), ParticipantIncludesModel includes = default(ParticipantIncludesModel), bool? enableLogging = default(bool?), int? resultsCountLimit = default(int?), int? resultsCountStart = default(int?), string timeZoneID = default(string))
        {
            this.IDs = iDs;
            this.ProntoID = prontoID;
            this.TransactionIDs = transactionIDs;
            this.DocumentIDs = documentIDs;
            this.TaskIDs = taskIDs;
            this.StatusType = statusType;
            this.FullName = fullName;
            this.EmailAddress = emailAddress;
            this.Title = title;
            this.Organization = organization;
            this.SearchDateType = searchDateType;
            this.SearchDateFrom = searchDateFrom;
            this.SearchDateTo = searchDateTo;
            this.Includes = includes;
            this.EnableLogging = enableLogging;
            this.ResultsCountLimit = resultsCountLimit;
            this.ResultsCountStart = resultsCountStart;
            this.TimeZoneID = timeZoneID;
        }
        
        /// <summary>
        /// Gets or Sets IDs
        /// </summary>
        [DataMember(Name="IDs", EmitDefaultValue=false)]
        public List<Object> IDs { get; set; }

        /// <summary>
        /// Gets or Sets ProntoID
        /// </summary>
        [DataMember(Name="ProntoID", EmitDefaultValue=false)]
        public string ProntoID { get; set; }

        /// <summary>
        /// Gets or Sets TransactionIDs
        /// </summary>
        [DataMember(Name="TransactionIDs", EmitDefaultValue=false)]
        public List<Object> TransactionIDs { get; set; }

        /// <summary>
        /// Gets or Sets DocumentIDs
        /// </summary>
        [DataMember(Name="DocumentIDs", EmitDefaultValue=false)]
        public List<Object> DocumentIDs { get; set; }

        /// <summary>
        /// Gets or Sets TaskIDs
        /// </summary>
        [DataMember(Name="TaskIDs", EmitDefaultValue=false)]
        public List<Object> TaskIDs { get; set; }


        /// <summary>
        /// Gets or Sets FullName
        /// </summary>
        [DataMember(Name="FullName", EmitDefaultValue=false)]
        public string FullName { get; set; }

        /// <summary>
        /// Gets or Sets EmailAddress
        /// </summary>
        [DataMember(Name="EmailAddress", EmitDefaultValue=false)]
        public string EmailAddress { get; set; }

        /// <summary>
        /// Gets or Sets Title
        /// </summary>
        [DataMember(Name="Title", EmitDefaultValue=false)]
        public string Title { get; set; }

        /// <summary>
        /// Gets or Sets Organization
        /// </summary>
        [DataMember(Name="Organization", EmitDefaultValue=false)]
        public string Organization { get; set; }


        /// <summary>
        /// Gets or Sets SearchDateFrom
        /// </summary>
        [DataMember(Name="SearchDateFrom", EmitDefaultValue=false)]
        public DateTime? SearchDateFrom { get; set; }

        /// <summary>
        /// Gets or Sets SearchDateTo
        /// </summary>
        [DataMember(Name="SearchDateTo", EmitDefaultValue=false)]
        public DateTime? SearchDateTo { get; set; }

        /// <summary>
        /// Gets or Sets Includes
        /// </summary>
        [DataMember(Name="Includes", EmitDefaultValue=false)]
        public ParticipantIncludesModel Includes { get; set; }

        /// <summary>
        /// Gets or Sets EnableLogging
        /// </summary>
        [DataMember(Name="EnableLogging", EmitDefaultValue=false)]
        public bool? EnableLogging { get; set; }

        /// <summary>
        /// Gets or Sets ResultsCountLimit
        /// </summary>
        [DataMember(Name="ResultsCountLimit", EmitDefaultValue=false)]
        public int? ResultsCountLimit { get; set; }

        /// <summary>
        /// Gets or Sets ResultsCountStart
        /// </summary>
        [DataMember(Name="ResultsCountStart", EmitDefaultValue=false)]
        public int? ResultsCountStart { get; set; }

        /// <summary>
        /// Gets or Sets TimeZoneID
        /// </summary>
        [DataMember(Name="TimeZoneID", EmitDefaultValue=false)]
        public string TimeZoneID { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ParticipantDetailsRequestModel {\n");
            sb.Append("  IDs: ").Append(IDs).Append("\n");
            sb.Append("  ProntoID: ").Append(ProntoID).Append("\n");
            sb.Append("  TransactionIDs: ").Append(TransactionIDs).Append("\n");
            sb.Append("  DocumentIDs: ").Append(DocumentIDs).Append("\n");
            sb.Append("  TaskIDs: ").Append(TaskIDs).Append("\n");
            sb.Append("  StatusType: ").Append(StatusType).Append("\n");
            sb.Append("  FullName: ").Append(FullName).Append("\n");
            sb.Append("  EmailAddress: ").Append(EmailAddress).Append("\n");
            sb.Append("  Title: ").Append(Title).Append("\n");
            sb.Append("  Organization: ").Append(Organization).Append("\n");
            sb.Append("  SearchDateType: ").Append(SearchDateType).Append("\n");
            sb.Append("  SearchDateFrom: ").Append(SearchDateFrom).Append("\n");
            sb.Append("  SearchDateTo: ").Append(SearchDateTo).Append("\n");
            sb.Append("  Includes: ").Append(Includes).Append("\n");
            sb.Append("  EnableLogging: ").Append(EnableLogging).Append("\n");
            sb.Append("  ResultsCountLimit: ").Append(ResultsCountLimit).Append("\n");
            sb.Append("  ResultsCountStart: ").Append(ResultsCountStart).Append("\n");
            sb.Append("  TimeZoneID: ").Append(TimeZoneID).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ParticipantDetailsRequestModel);
        }

        /// <summary>
        /// Returns true if ParticipantDetailsRequestModel instances are equal
        /// </summary>
        /// <param name="input">Instance of ParticipantDetailsRequestModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ParticipantDetailsRequestModel input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.IDs == input.IDs ||
                    this.IDs != null &&
                    this.IDs.SequenceEqual(input.IDs)
                ) && 
                (
                    this.ProntoID == input.ProntoID ||
                    (this.ProntoID != null &&
                    this.ProntoID.Equals(input.ProntoID))
                ) && 
                (
                    this.TransactionIDs == input.TransactionIDs ||
                    this.TransactionIDs != null &&
                    this.TransactionIDs.SequenceEqual(input.TransactionIDs)
                ) && 
                (
                    this.DocumentIDs == input.DocumentIDs ||
                    this.DocumentIDs != null &&
                    this.DocumentIDs.SequenceEqual(input.DocumentIDs)
                ) && 
                (
                    this.TaskIDs == input.TaskIDs ||
                    this.TaskIDs != null &&
                    this.TaskIDs.SequenceEqual(input.TaskIDs)
                ) && 
                (
                    this.StatusType == input.StatusType ||
                    (this.StatusType != null &&
                    this.StatusType.Equals(input.StatusType))
                ) && 
                (
                    this.FullName == input.FullName ||
                    (this.FullName != null &&
                    this.FullName.Equals(input.FullName))
                ) && 
                (
                    this.EmailAddress == input.EmailAddress ||
                    (this.EmailAddress != null &&
                    this.EmailAddress.Equals(input.EmailAddress))
                ) && 
                (
                    this.Title == input.Title ||
                    (this.Title != null &&
                    this.Title.Equals(input.Title))
                ) && 
                (
                    this.Organization == input.Organization ||
                    (this.Organization != null &&
                    this.Organization.Equals(input.Organization))
                ) && 
                (
                    this.SearchDateType == input.SearchDateType ||
                    (this.SearchDateType != null &&
                    this.SearchDateType.Equals(input.SearchDateType))
                ) && 
                (
                    this.SearchDateFrom == input.SearchDateFrom ||
                    (this.SearchDateFrom != null &&
                    this.SearchDateFrom.Equals(input.SearchDateFrom))
                ) && 
                (
                    this.SearchDateTo == input.SearchDateTo ||
                    (this.SearchDateTo != null &&
                    this.SearchDateTo.Equals(input.SearchDateTo))
                ) && 
                (
                    this.Includes == input.Includes ||
                    (this.Includes != null &&
                    this.Includes.Equals(input.Includes))
                ) && 
                (
                    this.EnableLogging == input.EnableLogging ||
                    (this.EnableLogging != null &&
                    this.EnableLogging.Equals(input.EnableLogging))
                ) && 
                (
                    this.ResultsCountLimit == input.ResultsCountLimit ||
                    (this.ResultsCountLimit != null &&
                    this.ResultsCountLimit.Equals(input.ResultsCountLimit))
                ) && 
                (
                    this.ResultsCountStart == input.ResultsCountStart ||
                    (this.ResultsCountStart != null &&
                    this.ResultsCountStart.Equals(input.ResultsCountStart))
                ) && 
                (
                    this.TimeZoneID == input.TimeZoneID ||
                    (this.TimeZoneID != null &&
                    this.TimeZoneID.Equals(input.TimeZoneID))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.IDs != null)
                    hashCode = hashCode * 59 + this.IDs.GetHashCode();
                if (this.ProntoID != null)
                    hashCode = hashCode * 59 + this.ProntoID.GetHashCode();
                if (this.TransactionIDs != null)
                    hashCode = hashCode * 59 + this.TransactionIDs.GetHashCode();
                if (this.DocumentIDs != null)
                    hashCode = hashCode * 59 + this.DocumentIDs.GetHashCode();
                if (this.TaskIDs != null)
                    hashCode = hashCode * 59 + this.TaskIDs.GetHashCode();
                if (this.StatusType != null)
                    hashCode = hashCode * 59 + this.StatusType.GetHashCode();
                if (this.FullName != null)
                    hashCode = hashCode * 59 + this.FullName.GetHashCode();
                if (this.EmailAddress != null)
                    hashCode = hashCode * 59 + this.EmailAddress.GetHashCode();
                if (this.Title != null)
                    hashCode = hashCode * 59 + this.Title.GetHashCode();
                if (this.Organization != null)
                    hashCode = hashCode * 59 + this.Organization.GetHashCode();
                if (this.SearchDateType != null)
                    hashCode = hashCode * 59 + this.SearchDateType.GetHashCode();
                if (this.SearchDateFrom != null)
                    hashCode = hashCode * 59 + this.SearchDateFrom.GetHashCode();
                if (this.SearchDateTo != null)
                    hashCode = hashCode * 59 + this.SearchDateTo.GetHashCode();
                if (this.Includes != null)
                    hashCode = hashCode * 59 + this.Includes.GetHashCode();
                if (this.EnableLogging != null)
                    hashCode = hashCode * 59 + this.EnableLogging.GetHashCode();
                if (this.ResultsCountLimit != null)
                    hashCode = hashCode * 59 + this.ResultsCountLimit.GetHashCode();
                if (this.ResultsCountStart != null)
                    hashCode = hashCode * 59 + this.ResultsCountStart.GetHashCode();
                if (this.TimeZoneID != null)
                    hashCode = hashCode * 59 + this.TimeZoneID.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // FullName (string) maxLength
            if(this.FullName != null && this.FullName.Length > 64)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for FullName, length must be less than 64.", new [] { "FullName" });
            }

            // FullName (string) minLength
            if(this.FullName != null && this.FullName.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for FullName, length must be greater than 0.", new [] { "FullName" });
            }

            // EmailAddress (string) maxLength
            if(this.EmailAddress != null && this.EmailAddress.Length > 128)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for EmailAddress, length must be less than 128.", new [] { "EmailAddress" });
            }

            // EmailAddress (string) minLength
            if(this.EmailAddress != null && this.EmailAddress.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for EmailAddress, length must be greater than 0.", new [] { "EmailAddress" });
            }

            // EmailAddress (string) pattern
            Regex regexEmailAddress = new Regex(@"^(?![.])([^@,<>\\^]+@[^\\s<>,\\^]+\\.[^\\s<>,\\^]+)$", RegexOptions.CultureInvariant);
            if (false == regexEmailAddress.Match(this.EmailAddress).Success)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for EmailAddress, must match a pattern of " + regexEmailAddress, new [] { "EmailAddress" });
            }

            // Title (string) maxLength
            if(this.Title != null && this.Title.Length > 64)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Title, length must be less than 64.", new [] { "Title" });
            }

            // Title (string) minLength
            if(this.Title != null && this.Title.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Title, length must be greater than 0.", new [] { "Title" });
            }

            // Organization (string) maxLength
            if(this.Organization != null && this.Organization.Length > 64)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Organization, length must be less than 64.", new [] { "Organization" });
            }

            // Organization (string) minLength
            if(this.Organization != null && this.Organization.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Organization, length must be greater than 0.", new [] { "Organization" });
            }

            yield break;
        }
    }

}
