/* 
 * API Version: 5.0
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v5
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// ParticipantIncludesModel
    /// </summary>
    [DataContract]
    public partial class ParticipantIncludesModel :  IEquatable<ParticipantIncludesModel>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ParticipantIncludesModel" /> class.
        /// </summary>
        /// <param name="includeEmailNotifications">includeEmailNotifications.</param>
        /// <param name="includeWorkflowActions">includeWorkflowActions.</param>
        /// <param name="includeEmailTemplatePlaceholders">includeEmailTemplatePlaceholders.</param>
        /// <param name="includeTasks">includeTasks.</param>
        /// <param name="taskIncludes">taskIncludes.</param>
        /// <param name="includeTests">includeTests.</param>
        /// <param name="includeContentPlaceholders">includeContentPlaceholders.</param>
        public ParticipantIncludesModel(bool? includeEmailNotifications = default(bool?), bool? includeWorkflowActions = default(bool?), bool? includeEmailTemplatePlaceholders = default(bool?), bool? includeTasks = default(bool?), TaskIncludesModel taskIncludes = default(TaskIncludesModel), bool? includeTests = default(bool?), bool? includeContentPlaceholders = default(bool?))
        {
            this.IncludeEmailNotifications = includeEmailNotifications;
            this.IncludeWorkflowActions = includeWorkflowActions;
            this.IncludeEmailTemplatePlaceholders = includeEmailTemplatePlaceholders;
            this.IncludeTasks = includeTasks;
            this.TaskIncludes = taskIncludes;
            this.IncludeTests = includeTests;
            this.IncludeContentPlaceholders = includeContentPlaceholders;
        }
        
        /// <summary>
        /// Gets or Sets IncludeEmailNotifications
        /// </summary>
        [DataMember(Name="IncludeEmailNotifications", EmitDefaultValue=false)]
        public bool? IncludeEmailNotifications { get; set; }

        /// <summary>
        /// Gets or Sets IncludeWorkflowActions
        /// </summary>
        [DataMember(Name="IncludeWorkflowActions", EmitDefaultValue=false)]
        public bool? IncludeWorkflowActions { get; set; }

        /// <summary>
        /// Gets or Sets IncludeEmailTemplatePlaceholders
        /// </summary>
        [DataMember(Name="IncludeEmailTemplatePlaceholders", EmitDefaultValue=false)]
        public bool? IncludeEmailTemplatePlaceholders { get; set; }

        /// <summary>
        /// Gets or Sets IncludeTasks
        /// </summary>
        [DataMember(Name="IncludeTasks", EmitDefaultValue=false)]
        public bool? IncludeTasks { get; set; }

        /// <summary>
        /// Gets or Sets TaskIncludes
        /// </summary>
        [DataMember(Name="TaskIncludes", EmitDefaultValue=false)]
        public TaskIncludesModel TaskIncludes { get; set; }

        /// <summary>
        /// Gets or Sets IncludeTests
        /// </summary>
        [DataMember(Name="IncludeTests", EmitDefaultValue=false)]
        public bool? IncludeTests { get; set; }

        /// <summary>
        /// Gets or Sets IncludeContentPlaceholders
        /// </summary>
        [DataMember(Name="IncludeContentPlaceholders", EmitDefaultValue=false)]
        public bool? IncludeContentPlaceholders { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ParticipantIncludesModel {\n");
            sb.Append("  IncludeEmailNotifications: ").Append(IncludeEmailNotifications).Append("\n");
            sb.Append("  IncludeWorkflowActions: ").Append(IncludeWorkflowActions).Append("\n");
            sb.Append("  IncludeEmailTemplatePlaceholders: ").Append(IncludeEmailTemplatePlaceholders).Append("\n");
            sb.Append("  IncludeTasks: ").Append(IncludeTasks).Append("\n");
            sb.Append("  TaskIncludes: ").Append(TaskIncludes).Append("\n");
            sb.Append("  IncludeTests: ").Append(IncludeTests).Append("\n");
            sb.Append("  IncludeContentPlaceholders: ").Append(IncludeContentPlaceholders).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ParticipantIncludesModel);
        }

        /// <summary>
        /// Returns true if ParticipantIncludesModel instances are equal
        /// </summary>
        /// <param name="input">Instance of ParticipantIncludesModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ParticipantIncludesModel input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.IncludeEmailNotifications == input.IncludeEmailNotifications ||
                    (this.IncludeEmailNotifications != null &&
                    this.IncludeEmailNotifications.Equals(input.IncludeEmailNotifications))
                ) && 
                (
                    this.IncludeWorkflowActions == input.IncludeWorkflowActions ||
                    (this.IncludeWorkflowActions != null &&
                    this.IncludeWorkflowActions.Equals(input.IncludeWorkflowActions))
                ) && 
                (
                    this.IncludeEmailTemplatePlaceholders == input.IncludeEmailTemplatePlaceholders ||
                    (this.IncludeEmailTemplatePlaceholders != null &&
                    this.IncludeEmailTemplatePlaceholders.Equals(input.IncludeEmailTemplatePlaceholders))
                ) && 
                (
                    this.IncludeTasks == input.IncludeTasks ||
                    (this.IncludeTasks != null &&
                    this.IncludeTasks.Equals(input.IncludeTasks))
                ) && 
                (
                    this.TaskIncludes == input.TaskIncludes ||
                    (this.TaskIncludes != null &&
                    this.TaskIncludes.Equals(input.TaskIncludes))
                ) && 
                (
                    this.IncludeTests == input.IncludeTests ||
                    (this.IncludeTests != null &&
                    this.IncludeTests.Equals(input.IncludeTests))
                ) && 
                (
                    this.IncludeContentPlaceholders == input.IncludeContentPlaceholders ||
                    (this.IncludeContentPlaceholders != null &&
                    this.IncludeContentPlaceholders.Equals(input.IncludeContentPlaceholders))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.IncludeEmailNotifications != null)
                    hashCode = hashCode * 59 + this.IncludeEmailNotifications.GetHashCode();
                if (this.IncludeWorkflowActions != null)
                    hashCode = hashCode * 59 + this.IncludeWorkflowActions.GetHashCode();
                if (this.IncludeEmailTemplatePlaceholders != null)
                    hashCode = hashCode * 59 + this.IncludeEmailTemplatePlaceholders.GetHashCode();
                if (this.IncludeTasks != null)
                    hashCode = hashCode * 59 + this.IncludeTasks.GetHashCode();
                if (this.TaskIncludes != null)
                    hashCode = hashCode * 59 + this.TaskIncludes.GetHashCode();
                if (this.IncludeTests != null)
                    hashCode = hashCode * 59 + this.IncludeTests.GetHashCode();
                if (this.IncludeContentPlaceholders != null)
                    hashCode = hashCode * 59 + this.IncludeContentPlaceholders.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
