/* 
 * API Version: 5.0
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v5
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// SignatureBlockModel
    /// </summary>
    [DataContract]
    public partial class SignatureBlockModel :  IEquatable<SignatureBlockModel>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="SignatureBlockModel" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected SignatureBlockModel() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="SignatureBlockModel" /> class.
        /// </summary>
        /// <param name="signature">signature (required).</param>
        /// <param name="additionalPdfDataPlacements">additionalPdfDataPlacements.</param>
        /// <param name="additionalHtmlDataPlacements">additionalHtmlDataPlacements.</param>
        /// <param name="pdfOpenPromptPageNumber">pdfOpenPromptPageNumber.</param>
        /// <param name="htmlOpenPromptAnchor">htmlOpenPromptAnchor.</param>
        public SignatureBlockModel(SignatureModel signature = default(SignatureModel), List<Object> additionalPdfDataPlacements = default(List<Object>), SignatureBlockHtmlDataPlacementModel additionalHtmlDataPlacements = default(SignatureBlockHtmlDataPlacementModel), int? pdfOpenPromptPageNumber = default(int?), string htmlOpenPromptAnchor = default(string))
        {
            // to ensure "signature" is required (not null)
            if (signature == null)
            {
                throw new InvalidDataException("signature is a required property for SignatureBlockModel and cannot be null");
            }
            else
            {
                this.Signature = signature;
            }
            this.AdditionalPdfDataPlacements = additionalPdfDataPlacements;
            this.AdditionalHtmlDataPlacements = additionalHtmlDataPlacements;
            this.PdfOpenPromptPageNumber = pdfOpenPromptPageNumber;
            this.HtmlOpenPromptAnchor = htmlOpenPromptAnchor;
        }
        
        /// <summary>
        /// Gets or Sets Signature
        /// </summary>
        [DataMember(Name="Signature", EmitDefaultValue=false)]
        public SignatureModel Signature { get; set; }

        /// <summary>
        /// Gets or Sets AdditionalPdfDataPlacements
        /// </summary>
        [DataMember(Name="AdditionalPdfDataPlacements", EmitDefaultValue=false)]
        public List<Object> AdditionalPdfDataPlacements { get; set; }

        /// <summary>
        /// Gets or Sets AdditionalHtmlDataPlacements
        /// </summary>
        [DataMember(Name="AdditionalHtmlDataPlacements", EmitDefaultValue=false)]
        public SignatureBlockHtmlDataPlacementModel AdditionalHtmlDataPlacements { get; set; }

        /// <summary>
        /// Gets or Sets PdfOpenPromptPageNumber
        /// </summary>
        [DataMember(Name="PdfOpenPromptPageNumber", EmitDefaultValue=false)]
        public int? PdfOpenPromptPageNumber { get; set; }

        /// <summary>
        /// Gets or Sets HtmlOpenPromptAnchor
        /// </summary>
        [DataMember(Name="HtmlOpenPromptAnchor", EmitDefaultValue=false)]
        public string HtmlOpenPromptAnchor { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class SignatureBlockModel {\n");
            sb.Append("  Signature: ").Append(Signature).Append("\n");
            sb.Append("  AdditionalPdfDataPlacements: ").Append(AdditionalPdfDataPlacements).Append("\n");
            sb.Append("  AdditionalHtmlDataPlacements: ").Append(AdditionalHtmlDataPlacements).Append("\n");
            sb.Append("  PdfOpenPromptPageNumber: ").Append(PdfOpenPromptPageNumber).Append("\n");
            sb.Append("  HtmlOpenPromptAnchor: ").Append(HtmlOpenPromptAnchor).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as SignatureBlockModel);
        }

        /// <summary>
        /// Returns true if SignatureBlockModel instances are equal
        /// </summary>
        /// <param name="input">Instance of SignatureBlockModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(SignatureBlockModel input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Signature == input.Signature ||
                    (this.Signature != null &&
                    this.Signature.Equals(input.Signature))
                ) && 
                (
                    this.AdditionalPdfDataPlacements == input.AdditionalPdfDataPlacements ||
                    this.AdditionalPdfDataPlacements != null &&
                    this.AdditionalPdfDataPlacements.SequenceEqual(input.AdditionalPdfDataPlacements)
                ) && 
                (
                    this.AdditionalHtmlDataPlacements == input.AdditionalHtmlDataPlacements ||
                    (this.AdditionalHtmlDataPlacements != null &&
                    this.AdditionalHtmlDataPlacements.Equals(input.AdditionalHtmlDataPlacements))
                ) && 
                (
                    this.PdfOpenPromptPageNumber == input.PdfOpenPromptPageNumber ||
                    (this.PdfOpenPromptPageNumber != null &&
                    this.PdfOpenPromptPageNumber.Equals(input.PdfOpenPromptPageNumber))
                ) && 
                (
                    this.HtmlOpenPromptAnchor == input.HtmlOpenPromptAnchor ||
                    (this.HtmlOpenPromptAnchor != null &&
                    this.HtmlOpenPromptAnchor.Equals(input.HtmlOpenPromptAnchor))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Signature != null)
                    hashCode = hashCode * 59 + this.Signature.GetHashCode();
                if (this.AdditionalPdfDataPlacements != null)
                    hashCode = hashCode * 59 + this.AdditionalPdfDataPlacements.GetHashCode();
                if (this.AdditionalHtmlDataPlacements != null)
                    hashCode = hashCode * 59 + this.AdditionalHtmlDataPlacements.GetHashCode();
                if (this.PdfOpenPromptPageNumber != null)
                    hashCode = hashCode * 59 + this.PdfOpenPromptPageNumber.GetHashCode();
                if (this.HtmlOpenPromptAnchor != null)
                    hashCode = hashCode * 59 + this.HtmlOpenPromptAnchor.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
