/* 
 * API Version: 5.0
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v5
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// SignatureModel
    /// </summary>
    [DataContract]
    public partial class SignatureModel :  IEquatable<SignatureModel>, IValidatableObject
    {
        /// <summary>
        /// Defines ApplicationType
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum ApplicationTypeEnum
        {
            
            /// <summary>
            /// Enum FontStamped for value: FontStamped
            /// </summary>
            [EnumMember(Value = "FontStamped")]
            FontStamped = 1,
            
            /// <summary>
            /// Enum ImageStamped for value: ImageStamped
            /// </summary>
            [EnumMember(Value = "ImageStamped")]
            ImageStamped = 2,
            
            /// <summary>
            /// Enum FontStampedUnicode for value: FontStampedUnicode
            /// </summary>
            [EnumMember(Value = "FontStampedUnicode")]
            FontStampedUnicode = 3,
            
            /// <summary>
            /// Enum MouseDrawn for value: MouseDrawn
            /// </summary>
            [EnumMember(Value = "MouseDrawn")]
            MouseDrawn = 4,
            
            /// <summary>
            /// Enum HardwareCaptureDevice for value: HardwareCaptureDevice
            /// </summary>
            [EnumMember(Value = "HardwareCaptureDevice")]
            HardwareCaptureDevice = 5,
            
            /// <summary>
            /// Enum Registered for value: Registered
            /// </summary>
            [EnumMember(Value = "Registered")]
            Registered = 6,
            
            /// <summary>
            /// Enum TouchPreferred for value: TouchPreferred
            /// </summary>
            [EnumMember(Value = "TouchPreferred")]
            TouchPreferred = 7
        }

        /// <summary>
        /// Gets or Sets ApplicationType
        /// </summary>
        [DataMember(Name="ApplicationType", EmitDefaultValue=false)]
        public ApplicationTypeEnum? ApplicationType { get; set; }
        /// <summary>
        /// Defines ApplicationSize
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum ApplicationSizeEnum
        {
            
            /// <summary>
            /// Enum Normal for value: Normal
            /// </summary>
            [EnumMember(Value = "Normal")]
            Normal = 1,
            
            /// <summary>
            /// Enum Small for value: Small
            /// </summary>
            [EnumMember(Value = "Small")]
            Small = 2,
            
            /// <summary>
            /// Enum ExtraSmall for value: ExtraSmall
            /// </summary>
            [EnumMember(Value = "ExtraSmall")]
            ExtraSmall = 3
        }

        /// <summary>
        /// Gets or Sets ApplicationSize
        /// </summary>
        [DataMember(Name="ApplicationSize", EmitDefaultValue=false)]
        public ApplicationSizeEnum? ApplicationSize { get; set; }
        /// <summary>
        /// Defines FontColor
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum FontColorEnum
        {
            
            /// <summary>
            /// Enum Blue for value: Blue
            /// </summary>
            [EnumMember(Value = "Blue")]
            Blue = 1,
            
            /// <summary>
            /// Enum Black for value: Black
            /// </summary>
            [EnumMember(Value = "Black")]
            Black = 2,
            
            /// <summary>
            /// Enum Red for value: Red
            /// </summary>
            [EnumMember(Value = "Red")]
            Red = 3
        }

        /// <summary>
        /// Gets or Sets FontColor
        /// </summary>
        [DataMember(Name="FontColor", EmitDefaultValue=false)]
        public FontColorEnum? FontColor { get; set; }
        /// <summary>
        /// Defines TouchPreferredSecondaryApplicationType
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum TouchPreferredSecondaryApplicationTypeEnum
        {
            
            /// <summary>
            /// Enum FontStamped for value: FontStamped
            /// </summary>
            [EnumMember(Value = "FontStamped")]
            FontStamped = 1,
            
            /// <summary>
            /// Enum Registered for value: Registered
            /// </summary>
            [EnumMember(Value = "Registered")]
            Registered = 2
        }

        /// <summary>
        /// Gets or Sets TouchPreferredSecondaryApplicationType
        /// </summary>
        [DataMember(Name="TouchPreferredSecondaryApplicationType", EmitDefaultValue=false)]
        public TouchPreferredSecondaryApplicationTypeEnum? TouchPreferredSecondaryApplicationType { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="SignatureModel" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected SignatureModel() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="SignatureModel" /> class.
        /// </summary>
        /// <param name="pdfPlacement">pdfPlacement (required).</param>
        /// <param name="applicationType">applicationType.</param>
        /// <param name="applicationSize">applicationSize.</param>
        /// <param name="displaySignHereTagForHardwareCaptureDeviceSignatureOnHtmlDocuments">displaySignHereTagForHardwareCaptureDeviceSignatureOnHtmlDocuments.</param>
        /// <param name="fontName">fontName.</param>
        /// <param name="fontColor">fontColor.</param>
        /// <param name="isBold">isBold.</param>
        /// <param name="isItalic">isItalic.</param>
        /// <param name="imageStampedFontSize">imageStampedFontSize.</param>
        /// <param name="buttonPositiveText">buttonPositiveText.</param>
        /// <param name="buttonNegativeText">buttonNegativeText.</param>
        /// <param name="placeSignatureOnAdditionalPdfSignaturePage">placeSignatureOnAdditionalPdfSignaturePage.</param>
        /// <param name="touchPreferredSecondaryApplicationType">touchPreferredSecondaryApplicationType.</param>
        /// <param name="promptToDrawNewSignature">promptToDrawNewSignature.</param>
        public SignatureModel(PdfSignaturePlacementModel pdfPlacement = default(PdfSignaturePlacementModel), ApplicationTypeEnum? applicationType = default(ApplicationTypeEnum?), ApplicationSizeEnum? applicationSize = default(ApplicationSizeEnum?), bool? displaySignHereTagForHardwareCaptureDeviceSignatureOnHtmlDocuments = default(bool?), string fontName = default(string), FontColorEnum? fontColor = default(FontColorEnum?), bool? isBold = default(bool?), bool? isItalic = default(bool?), int? imageStampedFontSize = default(int?), string buttonPositiveText = default(string), string buttonNegativeText = default(string), bool? placeSignatureOnAdditionalPdfSignaturePage = default(bool?), TouchPreferredSecondaryApplicationTypeEnum? touchPreferredSecondaryApplicationType = default(TouchPreferredSecondaryApplicationTypeEnum?), bool? promptToDrawNewSignature = default(bool?))
        {
            // to ensure "pdfPlacement" is required (not null)
            if (pdfPlacement == null)
            {
                throw new InvalidDataException("pdfPlacement is a required property for SignatureModel and cannot be null");
            }
            else
            {
                this.PdfPlacement = pdfPlacement;
            }
            this.ApplicationType = applicationType;
            this.ApplicationSize = applicationSize;
            this.DisplaySignHereTagForHardwareCaptureDeviceSignatureOnHtmlDocuments = displaySignHereTagForHardwareCaptureDeviceSignatureOnHtmlDocuments;
            this.FontName = fontName;
            this.FontColor = fontColor;
            this.IsBold = isBold;
            this.IsItalic = isItalic;
            this.ImageStampedFontSize = imageStampedFontSize;
            this.ButtonPositiveText = buttonPositiveText;
            this.ButtonNegativeText = buttonNegativeText;
            this.PlaceSignatureOnAdditionalPdfSignaturePage = placeSignatureOnAdditionalPdfSignaturePage;
            this.TouchPreferredSecondaryApplicationType = touchPreferredSecondaryApplicationType;
            this.PromptToDrawNewSignature = promptToDrawNewSignature;
        }
        
        /// <summary>
        /// Gets or Sets PdfPlacement
        /// </summary>
        [DataMember(Name="PdfPlacement", EmitDefaultValue=false)]
        public PdfSignaturePlacementModel PdfPlacement { get; set; }



        /// <summary>
        /// Gets or Sets DisplaySignHereTagForHardwareCaptureDeviceSignatureOnHtmlDocuments
        /// </summary>
        [DataMember(Name="DisplaySignHereTagForHardwareCaptureDeviceSignatureOnHtmlDocuments", EmitDefaultValue=false)]
        public bool? DisplaySignHereTagForHardwareCaptureDeviceSignatureOnHtmlDocuments { get; set; }

        /// <summary>
        /// Gets or Sets FontName
        /// </summary>
        [DataMember(Name="FontName", EmitDefaultValue=false)]
        public string FontName { get; set; }


        /// <summary>
        /// Gets or Sets IsBold
        /// </summary>
        [DataMember(Name="IsBold", EmitDefaultValue=false)]
        public bool? IsBold { get; set; }

        /// <summary>
        /// Gets or Sets IsItalic
        /// </summary>
        [DataMember(Name="IsItalic", EmitDefaultValue=false)]
        public bool? IsItalic { get; set; }

        /// <summary>
        /// Gets or Sets ImageStampedFontSize
        /// </summary>
        [DataMember(Name="ImageStampedFontSize", EmitDefaultValue=false)]
        public int? ImageStampedFontSize { get; set; }

        /// <summary>
        /// Gets or Sets ButtonPositiveText
        /// </summary>
        [DataMember(Name="ButtonPositiveText", EmitDefaultValue=false)]
        public string ButtonPositiveText { get; set; }

        /// <summary>
        /// Gets or Sets ButtonNegativeText
        /// </summary>
        [DataMember(Name="ButtonNegativeText", EmitDefaultValue=false)]
        public string ButtonNegativeText { get; set; }

        /// <summary>
        /// Gets or Sets PlaceSignatureOnAdditionalPdfSignaturePage
        /// </summary>
        [DataMember(Name="PlaceSignatureOnAdditionalPdfSignaturePage", EmitDefaultValue=false)]
        public bool? PlaceSignatureOnAdditionalPdfSignaturePage { get; set; }


        /// <summary>
        /// Gets or Sets PromptToDrawNewSignature
        /// </summary>
        [DataMember(Name="PromptToDrawNewSignature", EmitDefaultValue=false)]
        public bool? PromptToDrawNewSignature { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class SignatureModel {\n");
            sb.Append("  PdfPlacement: ").Append(PdfPlacement).Append("\n");
            sb.Append("  ApplicationType: ").Append(ApplicationType).Append("\n");
            sb.Append("  ApplicationSize: ").Append(ApplicationSize).Append("\n");
            sb.Append("  DisplaySignHereTagForHardwareCaptureDeviceSignatureOnHtmlDocuments: ").Append(DisplaySignHereTagForHardwareCaptureDeviceSignatureOnHtmlDocuments).Append("\n");
            sb.Append("  FontName: ").Append(FontName).Append("\n");
            sb.Append("  FontColor: ").Append(FontColor).Append("\n");
            sb.Append("  IsBold: ").Append(IsBold).Append("\n");
            sb.Append("  IsItalic: ").Append(IsItalic).Append("\n");
            sb.Append("  ImageStampedFontSize: ").Append(ImageStampedFontSize).Append("\n");
            sb.Append("  ButtonPositiveText: ").Append(ButtonPositiveText).Append("\n");
            sb.Append("  ButtonNegativeText: ").Append(ButtonNegativeText).Append("\n");
            sb.Append("  PlaceSignatureOnAdditionalPdfSignaturePage: ").Append(PlaceSignatureOnAdditionalPdfSignaturePage).Append("\n");
            sb.Append("  TouchPreferredSecondaryApplicationType: ").Append(TouchPreferredSecondaryApplicationType).Append("\n");
            sb.Append("  PromptToDrawNewSignature: ").Append(PromptToDrawNewSignature).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as SignatureModel);
        }

        /// <summary>
        /// Returns true if SignatureModel instances are equal
        /// </summary>
        /// <param name="input">Instance of SignatureModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(SignatureModel input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.PdfPlacement == input.PdfPlacement ||
                    (this.PdfPlacement != null &&
                    this.PdfPlacement.Equals(input.PdfPlacement))
                ) && 
                (
                    this.ApplicationType == input.ApplicationType ||
                    (this.ApplicationType != null &&
                    this.ApplicationType.Equals(input.ApplicationType))
                ) && 
                (
                    this.ApplicationSize == input.ApplicationSize ||
                    (this.ApplicationSize != null &&
                    this.ApplicationSize.Equals(input.ApplicationSize))
                ) && 
                (
                    this.DisplaySignHereTagForHardwareCaptureDeviceSignatureOnHtmlDocuments == input.DisplaySignHereTagForHardwareCaptureDeviceSignatureOnHtmlDocuments ||
                    (this.DisplaySignHereTagForHardwareCaptureDeviceSignatureOnHtmlDocuments != null &&
                    this.DisplaySignHereTagForHardwareCaptureDeviceSignatureOnHtmlDocuments.Equals(input.DisplaySignHereTagForHardwareCaptureDeviceSignatureOnHtmlDocuments))
                ) && 
                (
                    this.FontName == input.FontName ||
                    (this.FontName != null &&
                    this.FontName.Equals(input.FontName))
                ) && 
                (
                    this.FontColor == input.FontColor ||
                    (this.FontColor != null &&
                    this.FontColor.Equals(input.FontColor))
                ) && 
                (
                    this.IsBold == input.IsBold ||
                    (this.IsBold != null &&
                    this.IsBold.Equals(input.IsBold))
                ) && 
                (
                    this.IsItalic == input.IsItalic ||
                    (this.IsItalic != null &&
                    this.IsItalic.Equals(input.IsItalic))
                ) && 
                (
                    this.ImageStampedFontSize == input.ImageStampedFontSize ||
                    (this.ImageStampedFontSize != null &&
                    this.ImageStampedFontSize.Equals(input.ImageStampedFontSize))
                ) && 
                (
                    this.ButtonPositiveText == input.ButtonPositiveText ||
                    (this.ButtonPositiveText != null &&
                    this.ButtonPositiveText.Equals(input.ButtonPositiveText))
                ) && 
                (
                    this.ButtonNegativeText == input.ButtonNegativeText ||
                    (this.ButtonNegativeText != null &&
                    this.ButtonNegativeText.Equals(input.ButtonNegativeText))
                ) && 
                (
                    this.PlaceSignatureOnAdditionalPdfSignaturePage == input.PlaceSignatureOnAdditionalPdfSignaturePage ||
                    (this.PlaceSignatureOnAdditionalPdfSignaturePage != null &&
                    this.PlaceSignatureOnAdditionalPdfSignaturePage.Equals(input.PlaceSignatureOnAdditionalPdfSignaturePage))
                ) && 
                (
                    this.TouchPreferredSecondaryApplicationType == input.TouchPreferredSecondaryApplicationType ||
                    (this.TouchPreferredSecondaryApplicationType != null &&
                    this.TouchPreferredSecondaryApplicationType.Equals(input.TouchPreferredSecondaryApplicationType))
                ) && 
                (
                    this.PromptToDrawNewSignature == input.PromptToDrawNewSignature ||
                    (this.PromptToDrawNewSignature != null &&
                    this.PromptToDrawNewSignature.Equals(input.PromptToDrawNewSignature))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.PdfPlacement != null)
                    hashCode = hashCode * 59 + this.PdfPlacement.GetHashCode();
                if (this.ApplicationType != null)
                    hashCode = hashCode * 59 + this.ApplicationType.GetHashCode();
                if (this.ApplicationSize != null)
                    hashCode = hashCode * 59 + this.ApplicationSize.GetHashCode();
                if (this.DisplaySignHereTagForHardwareCaptureDeviceSignatureOnHtmlDocuments != null)
                    hashCode = hashCode * 59 + this.DisplaySignHereTagForHardwareCaptureDeviceSignatureOnHtmlDocuments.GetHashCode();
                if (this.FontName != null)
                    hashCode = hashCode * 59 + this.FontName.GetHashCode();
                if (this.FontColor != null)
                    hashCode = hashCode * 59 + this.FontColor.GetHashCode();
                if (this.IsBold != null)
                    hashCode = hashCode * 59 + this.IsBold.GetHashCode();
                if (this.IsItalic != null)
                    hashCode = hashCode * 59 + this.IsItalic.GetHashCode();
                if (this.ImageStampedFontSize != null)
                    hashCode = hashCode * 59 + this.ImageStampedFontSize.GetHashCode();
                if (this.ButtonPositiveText != null)
                    hashCode = hashCode * 59 + this.ButtonPositiveText.GetHashCode();
                if (this.ButtonNegativeText != null)
                    hashCode = hashCode * 59 + this.ButtonNegativeText.GetHashCode();
                if (this.PlaceSignatureOnAdditionalPdfSignaturePage != null)
                    hashCode = hashCode * 59 + this.PlaceSignatureOnAdditionalPdfSignaturePage.GetHashCode();
                if (this.TouchPreferredSecondaryApplicationType != null)
                    hashCode = hashCode * 59 + this.TouchPreferredSecondaryApplicationType.GetHashCode();
                if (this.PromptToDrawNewSignature != null)
                    hashCode = hashCode * 59 + this.PromptToDrawNewSignature.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
