/* 
 * API Version: 5.0
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v5
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// SourceModel
    /// </summary>
    [DataContract]
    public partial class SourceModel :  IEquatable<SourceModel>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="SourceModel" /> class.
        /// </summary>
        /// <param name="fileBytes">fileBytes.</param>
        /// <param name="filePath">filePath.</param>
        /// <param name="fileUrl">fileUrl.</param>
        public SourceModel(byte[] fileBytes = default(byte[]), string filePath = default(string), string fileUrl = default(string))
        {
            this.FileBytes = fileBytes;
            this.FilePath = filePath;
            this.FileUrl = fileUrl;
        }
        
        /// <summary>
        /// Gets or Sets FileBytes
        /// </summary>
        [DataMember(Name="FileBytes", EmitDefaultValue=false)]
        public byte[] FileBytes { get; set; }

        /// <summary>
        /// Gets or Sets FilePath
        /// </summary>
        [DataMember(Name="FilePath", EmitDefaultValue=false)]
        public string FilePath { get; set; }

        /// <summary>
        /// Gets or Sets FileUrl
        /// </summary>
        [DataMember(Name="FileUrl", EmitDefaultValue=false)]
        public string FileUrl { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class SourceModel {\n");
            sb.Append("  FileBytes: ").Append(FileBytes).Append("\n");
            sb.Append("  FilePath: ").Append(FilePath).Append("\n");
            sb.Append("  FileUrl: ").Append(FileUrl).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as SourceModel);
        }

        /// <summary>
        /// Returns true if SourceModel instances are equal
        /// </summary>
        /// <param name="input">Instance of SourceModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(SourceModel input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.FileBytes == input.FileBytes ||
                    (this.FileBytes != null &&
                    this.FileBytes.Equals(input.FileBytes))
                ) && 
                (
                    this.FilePath == input.FilePath ||
                    (this.FilePath != null &&
                    this.FilePath.Equals(input.FilePath))
                ) && 
                (
                    this.FileUrl == input.FileUrl ||
                    (this.FileUrl != null &&
                    this.FileUrl.Equals(input.FileUrl))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.FileBytes != null)
                    hashCode = hashCode * 59 + this.FileBytes.GetHashCode();
                if (this.FilePath != null)
                    hashCode = hashCode * 59 + this.FilePath.GetHashCode();
                if (this.FileUrl != null)
                    hashCode = hashCode * 59 + this.FileUrl.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // FilePath (string) maxLength
            if(this.FilePath != null && this.FilePath.Length > 255)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for FilePath, length must be less than 255.", new [] { "FilePath" });
            }

            // FilePath (string) minLength
            if(this.FilePath != null && this.FilePath.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for FilePath, length must be greater than 0.", new [] { "FilePath" });
            }

            yield break;
        }
    }

}
