/* 
 * API Version: 5.0
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v5
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// TaskInsertModel
    /// </summary>
    [DataContract]
    public partial class TaskInsertModel :  IEquatable<TaskInsertModel>, IValidatableObject
    {
        /// <summary>
        /// Defines Type
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum TypeEnum
        {
            
            /// <summary>
            /// Enum Signature for value: Signature
            /// </summary>
            [EnumMember(Value = "Signature")]
            Signature = 1,
            
            /// <summary>
            /// Enum Initial for value: Initial
            /// </summary>
            [EnumMember(Value = "Initial")]
            Initial = 2,
            
            /// <summary>
            /// Enum Acknowledgement for value: Acknowledgement
            /// </summary>
            [EnumMember(Value = "Acknowledgement")]
            Acknowledgement = 3,
            
            /// <summary>
            /// Enum Delivery for value: Delivery
            /// </summary>
            [EnumMember(Value = "Delivery")]
            Delivery = 4,
            
            /// <summary>
            /// Enum NoActionRequired for value: NoActionRequired
            /// </summary>
            [EnumMember(Value = "NoActionRequired")]
            NoActionRequired = 5,
            
            /// <summary>
            /// Enum CarbonCopy for value: CarbonCopy
            /// </summary>
            [EnumMember(Value = "CarbonCopy")]
            CarbonCopy = 6,
            
            /// <summary>
            /// Enum FormFiller for value: FormFiller
            /// </summary>
            [EnumMember(Value = "FormFiller")]
            FormFiller = 7
        }

        /// <summary>
        /// Gets or Sets Type
        /// </summary>
        [DataMember(Name="Type", EmitDefaultValue=false)]
        public TypeEnum? Type { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="TaskInsertModel" /> class.
        /// </summary>
        /// <param name="documentID">documentID.</param>
        /// <param name="participantID">participantID.</param>
        /// <param name="type">type.</param>
        /// <param name="pdfFormFillingEnabled">pdfFormFillingEnabled.</param>
        /// <param name="pdfFormFillingFieldPrefix">pdfFormFillingFieldPrefix.</param>
        /// <param name="signatureBlock">signatureBlock.</param>
        /// <param name="workflowActions">workflowActions.</param>
        /// <param name="isOptional">isOptional.</param>
        public TaskInsertModel(int? documentID = default(int?), int? participantID = default(int?), TypeEnum? type = default(TypeEnum?), bool? pdfFormFillingEnabled = default(bool?), string pdfFormFillingFieldPrefix = default(string), SignatureBlockModel signatureBlock = default(SignatureBlockModel), List<Object> workflowActions = default(List<Object>), bool? isOptional = default(bool?))
        {
            this.DocumentID = documentID;
            this.ParticipantID = participantID;
            this.Type = type;
            this.PdfFormFillingEnabled = pdfFormFillingEnabled;
            this.PdfFormFillingFieldPrefix = pdfFormFillingFieldPrefix;
            this.SignatureBlock = signatureBlock;
            this.WorkflowActions = workflowActions;
            this.IsOptional = isOptional;
        }
        
        /// <summary>
        /// Gets or Sets DocumentID
        /// </summary>
        [DataMember(Name="DocumentID", EmitDefaultValue=false)]
        public int? DocumentID { get; set; }

        /// <summary>
        /// Gets or Sets ParticipantID
        /// </summary>
        [DataMember(Name="ParticipantID", EmitDefaultValue=false)]
        public int? ParticipantID { get; set; }


        /// <summary>
        /// Gets or Sets PdfFormFillingEnabled
        /// </summary>
        [DataMember(Name="PdfFormFillingEnabled", EmitDefaultValue=false)]
        public bool? PdfFormFillingEnabled { get; set; }

        /// <summary>
        /// Gets or Sets PdfFormFillingFieldPrefix
        /// </summary>
        [DataMember(Name="PdfFormFillingFieldPrefix", EmitDefaultValue=false)]
        public string PdfFormFillingFieldPrefix { get; set; }

        /// <summary>
        /// Gets or Sets SignatureBlock
        /// </summary>
        [DataMember(Name="SignatureBlock", EmitDefaultValue=false)]
        public SignatureBlockModel SignatureBlock { get; set; }

        /// <summary>
        /// Gets or Sets WorkflowActions
        /// </summary>
        [DataMember(Name="WorkflowActions", EmitDefaultValue=false)]
        public List<Object> WorkflowActions { get; set; }

        /// <summary>
        /// Gets or Sets IsOptional
        /// </summary>
        [DataMember(Name="IsOptional", EmitDefaultValue=false)]
        public bool? IsOptional { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class TaskInsertModel {\n");
            sb.Append("  DocumentID: ").Append(DocumentID).Append("\n");
            sb.Append("  ParticipantID: ").Append(ParticipantID).Append("\n");
            sb.Append("  Type: ").Append(Type).Append("\n");
            sb.Append("  PdfFormFillingEnabled: ").Append(PdfFormFillingEnabled).Append("\n");
            sb.Append("  PdfFormFillingFieldPrefix: ").Append(PdfFormFillingFieldPrefix).Append("\n");
            sb.Append("  SignatureBlock: ").Append(SignatureBlock).Append("\n");
            sb.Append("  WorkflowActions: ").Append(WorkflowActions).Append("\n");
            sb.Append("  IsOptional: ").Append(IsOptional).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as TaskInsertModel);
        }

        /// <summary>
        /// Returns true if TaskInsertModel instances are equal
        /// </summary>
        /// <param name="input">Instance of TaskInsertModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(TaskInsertModel input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.DocumentID == input.DocumentID ||
                    (this.DocumentID != null &&
                    this.DocumentID.Equals(input.DocumentID))
                ) && 
                (
                    this.ParticipantID == input.ParticipantID ||
                    (this.ParticipantID != null &&
                    this.ParticipantID.Equals(input.ParticipantID))
                ) && 
                (
                    this.Type == input.Type ||
                    (this.Type != null &&
                    this.Type.Equals(input.Type))
                ) && 
                (
                    this.PdfFormFillingEnabled == input.PdfFormFillingEnabled ||
                    (this.PdfFormFillingEnabled != null &&
                    this.PdfFormFillingEnabled.Equals(input.PdfFormFillingEnabled))
                ) && 
                (
                    this.PdfFormFillingFieldPrefix == input.PdfFormFillingFieldPrefix ||
                    (this.PdfFormFillingFieldPrefix != null &&
                    this.PdfFormFillingFieldPrefix.Equals(input.PdfFormFillingFieldPrefix))
                ) && 
                (
                    this.SignatureBlock == input.SignatureBlock ||
                    (this.SignatureBlock != null &&
                    this.SignatureBlock.Equals(input.SignatureBlock))
                ) && 
                (
                    this.WorkflowActions == input.WorkflowActions ||
                    this.WorkflowActions != null &&
                    this.WorkflowActions.SequenceEqual(input.WorkflowActions)
                ) && 
                (
                    this.IsOptional == input.IsOptional ||
                    (this.IsOptional != null &&
                    this.IsOptional.Equals(input.IsOptional))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.DocumentID != null)
                    hashCode = hashCode * 59 + this.DocumentID.GetHashCode();
                if (this.ParticipantID != null)
                    hashCode = hashCode * 59 + this.ParticipantID.GetHashCode();
                if (this.Type != null)
                    hashCode = hashCode * 59 + this.Type.GetHashCode();
                if (this.PdfFormFillingEnabled != null)
                    hashCode = hashCode * 59 + this.PdfFormFillingEnabled.GetHashCode();
                if (this.PdfFormFillingFieldPrefix != null)
                    hashCode = hashCode * 59 + this.PdfFormFillingFieldPrefix.GetHashCode();
                if (this.SignatureBlock != null)
                    hashCode = hashCode * 59 + this.SignatureBlock.GetHashCode();
                if (this.WorkflowActions != null)
                    hashCode = hashCode * 59 + this.WorkflowActions.GetHashCode();
                if (this.IsOptional != null)
                    hashCode = hashCode * 59 + this.IsOptional.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // DocumentID (int?) maximum
            if(this.DocumentID > (int?)2147483647)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for DocumentID, must be a value less than or equal to 2147483647.", new [] { "DocumentID" });
            }

            // DocumentID (int?) minimum
            if(this.DocumentID < (int?)0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for DocumentID, must be a value greater than or equal to 0.", new [] { "DocumentID" });
            }

            // ParticipantID (int?) maximum
            if(this.ParticipantID > (int?)2147483647)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for ParticipantID, must be a value less than or equal to 2147483647.", new [] { "ParticipantID" });
            }

            // ParticipantID (int?) minimum
            if(this.ParticipantID < (int?)0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for ParticipantID, must be a value greater than or equal to 0.", new [] { "ParticipantID" });
            }

            yield break;
        }
    }

}
