/* 
 * API Version: 5.0
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v5
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// TaskRemoteSignModel
    /// </summary>
    [DataContract]
    public partial class TaskRemoteSignModel :  IEquatable<TaskRemoteSignModel>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="TaskRemoteSignModel" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected TaskRemoteSignModel() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="TaskRemoteSignModel" /> class.
        /// </summary>
        /// <param name="iD">iD (required).</param>
        /// <param name="username">username.</param>
        /// <param name="password">password.</param>
        /// <param name="ipAddress">ipAddress (required).</param>
        public TaskRemoteSignModel(int? iD = default(int?), string username = default(string), string password = default(string), string ipAddress = default(string))
        {
            // to ensure "iD" is required (not null)
            if (iD == null)
            {
                throw new InvalidDataException("iD is a required property for TaskRemoteSignModel and cannot be null");
            }
            else
            {
                this.ID = iD;
            }
            // to ensure "ipAddress" is required (not null)
            if (ipAddress == null)
            {
                throw new InvalidDataException("ipAddress is a required property for TaskRemoteSignModel and cannot be null");
            }
            else
            {
                this.IpAddress = ipAddress;
            }
            this.Username = username;
            this.Password = password;
        }
        
        /// <summary>
        /// Gets or Sets ID
        /// </summary>
        [DataMember(Name="ID", EmitDefaultValue=false)]
        public int? ID { get; set; }

        /// <summary>
        /// Gets or Sets Username
        /// </summary>
        [DataMember(Name="Username", EmitDefaultValue=false)]
        public string Username { get; set; }

        /// <summary>
        /// Gets or Sets Password
        /// </summary>
        [DataMember(Name="Password", EmitDefaultValue=false)]
        public string Password { get; set; }

        /// <summary>
        /// Gets or Sets IpAddress
        /// </summary>
        [DataMember(Name="IpAddress", EmitDefaultValue=false)]
        public string IpAddress { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class TaskRemoteSignModel {\n");
            sb.Append("  ID: ").Append(ID).Append("\n");
            sb.Append("  Username: ").Append(Username).Append("\n");
            sb.Append("  Password: ").Append(Password).Append("\n");
            sb.Append("  IpAddress: ").Append(IpAddress).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as TaskRemoteSignModel);
        }

        /// <summary>
        /// Returns true if TaskRemoteSignModel instances are equal
        /// </summary>
        /// <param name="input">Instance of TaskRemoteSignModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(TaskRemoteSignModel input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ID == input.ID ||
                    (this.ID != null &&
                    this.ID.Equals(input.ID))
                ) && 
                (
                    this.Username == input.Username ||
                    (this.Username != null &&
                    this.Username.Equals(input.Username))
                ) && 
                (
                    this.Password == input.Password ||
                    (this.Password != null &&
                    this.Password.Equals(input.Password))
                ) && 
                (
                    this.IpAddress == input.IpAddress ||
                    (this.IpAddress != null &&
                    this.IpAddress.Equals(input.IpAddress))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ID != null)
                    hashCode = hashCode * 59 + this.ID.GetHashCode();
                if (this.Username != null)
                    hashCode = hashCode * 59 + this.Username.GetHashCode();
                if (this.Password != null)
                    hashCode = hashCode * 59 + this.Password.GetHashCode();
                if (this.IpAddress != null)
                    hashCode = hashCode * 59 + this.IpAddress.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // IpAddress (string) pattern
            Regex regexIpAddress = new Regex(@"^([\\d]{1,3}\\.){3}[\\d]{1,3}$", RegexOptions.CultureInvariant);
            if (false == regexIpAddress.Match(this.IpAddress).Success)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for IpAddress, must match a pattern of " + regexIpAddress, new [] { "IpAddress" });
            }

            yield break;
        }
    }

}
