/* 
 * API Version: 5.0
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v5
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// TaskUpdateRequestModel
    /// </summary>
    [DataContract]
    public partial class TaskUpdateRequestModel :  IEquatable<TaskUpdateRequestModel>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="TaskUpdateRequestModel" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected TaskUpdateRequestModel() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="TaskUpdateRequestModel" /> class.
        /// </summary>
        /// <param name="tasks">tasks (required).</param>
        /// <param name="enableLogging">enableLogging.</param>
        public TaskUpdateRequestModel(List<Object> tasks = default(List<Object>), bool? enableLogging = default(bool?))
        {
            // to ensure "tasks" is required (not null)
            if (tasks == null)
            {
                throw new InvalidDataException("tasks is a required property for TaskUpdateRequestModel and cannot be null");
            }
            else
            {
                this.Tasks = tasks;
            }
            this.EnableLogging = enableLogging;
        }
        
        /// <summary>
        /// Gets or Sets Tasks
        /// </summary>
        [DataMember(Name="Tasks", EmitDefaultValue=false)]
        public List<Object> Tasks { get; set; }

        /// <summary>
        /// Gets or Sets EnableLogging
        /// </summary>
        [DataMember(Name="EnableLogging", EmitDefaultValue=false)]
        public bool? EnableLogging { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class TaskUpdateRequestModel {\n");
            sb.Append("  Tasks: ").Append(Tasks).Append("\n");
            sb.Append("  EnableLogging: ").Append(EnableLogging).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as TaskUpdateRequestModel);
        }

        /// <summary>
        /// Returns true if TaskUpdateRequestModel instances are equal
        /// </summary>
        /// <param name="input">Instance of TaskUpdateRequestModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(TaskUpdateRequestModel input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Tasks == input.Tasks ||
                    this.Tasks != null &&
                    this.Tasks.SequenceEqual(input.Tasks)
                ) && 
                (
                    this.EnableLogging == input.EnableLogging ||
                    (this.EnableLogging != null &&
                    this.EnableLogging.Equals(input.EnableLogging))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Tasks != null)
                    hashCode = hashCode * 59 + this.Tasks.GetHashCode();
                if (this.EnableLogging != null)
                    hashCode = hashCode * 59 + this.EnableLogging.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
