/* 
 * API Version: 5.0
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v5
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// TaskWorkflowActionModel
    /// </summary>
    [DataContract]
    public partial class TaskWorkflowActionModel :  IEquatable<TaskWorkflowActionModel>, IValidatableObject
    {
        /// <summary>
        /// Defines Type
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum TypeEnum
        {
            
            /// <summary>
            /// Enum Custom for value: Custom
            /// </summary>
            [EnumMember(Value = "Custom")]
            Custom = 1,
            
            /// <summary>
            /// Enum DocumentReview for value: DocumentReview
            /// </summary>
            [EnumMember(Value = "DocumentReview")]
            DocumentReview = 2,
            
            /// <summary>
            /// Enum UploadAdditionalAttachments for value: UploadAdditionalAttachments
            /// </summary>
            [EnumMember(Value = "UploadAdditionalAttachments")]
            UploadAdditionalAttachments = 3,
            
            /// <summary>
            /// Enum Generic for value: Generic
            /// </summary>
            [EnumMember(Value = "Generic")]
            Generic = 4,
            
            /// <summary>
            /// Enum SubscribeToStatusChangeNotificationsByPost for value: SubscribeToStatusChangeNotificationsByPost
            /// </summary>
            [EnumMember(Value = "SubscribeToStatusChangeNotificationsByPost")]
            SubscribeToStatusChangeNotificationsByPost = 5,
            
            /// <summary>
            /// Enum SubscribeToStatusChangeNotificationsByGet for value: SubscribeToStatusChangeNotificationsByGet
            /// </summary>
            [EnumMember(Value = "SubscribeToStatusChangeNotificationsByGet")]
            SubscribeToStatusChangeNotificationsByGet = 6
        }

        /// <summary>
        /// Gets or Sets Type
        /// </summary>
        [DataMember(Name="Type", EmitDefaultValue=false)]
        public TypeEnum? Type { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="TaskWorkflowActionModel" /> class.
        /// </summary>
        /// <param name="data">data.</param>
        /// <param name="url">url.</param>
        /// <param name="description">description.</param>
        /// <param name="type">type.</param>
        /// <param name="actionStatus">actionStatus.</param>
        /// <param name="buttonTextPositive">buttonTextPositive.</param>
        /// <param name="buttonTextNegative">buttonTextNegative.</param>
        /// <param name="content">content.</param>
        /// <param name="notRequiredAfterFirstOccurrence">notRequiredAfterFirstOccurrence.</param>
        public TaskWorkflowActionModel(string data = default(string), string url = default(string), string description = default(string), TypeEnum? type = default(TypeEnum?), int? actionStatus = default(int?), string buttonTextPositive = default(string), string buttonTextNegative = default(string), string content = default(string), bool? notRequiredAfterFirstOccurrence = default(bool?))
        {
            this.Data = data;
            this.Url = url;
            this.Description = description;
            this.Type = type;
            this.ActionStatus = actionStatus;
            this.ButtonTextPositive = buttonTextPositive;
            this.ButtonTextNegative = buttonTextNegative;
            this.Content = content;
            this.NotRequiredAfterFirstOccurrence = notRequiredAfterFirstOccurrence;
        }
        
        /// <summary>
        /// Gets or Sets Data
        /// </summary>
        [DataMember(Name="Data", EmitDefaultValue=false)]
        public string Data { get; set; }

        /// <summary>
        /// Gets or Sets Url
        /// </summary>
        [DataMember(Name="Url", EmitDefaultValue=false)]
        public string Url { get; set; }

        /// <summary>
        /// Gets or Sets Description
        /// </summary>
        [DataMember(Name="Description", EmitDefaultValue=false)]
        public string Description { get; set; }


        /// <summary>
        /// Gets or Sets ActionStatus
        /// </summary>
        [DataMember(Name="ActionStatus", EmitDefaultValue=false)]
        public int? ActionStatus { get; set; }

        /// <summary>
        /// Gets or Sets ButtonTextPositive
        /// </summary>
        [DataMember(Name="ButtonTextPositive", EmitDefaultValue=false)]
        public string ButtonTextPositive { get; set; }

        /// <summary>
        /// Gets or Sets ButtonTextNegative
        /// </summary>
        [DataMember(Name="ButtonTextNegative", EmitDefaultValue=false)]
        public string ButtonTextNegative { get; set; }

        /// <summary>
        /// Gets or Sets Content
        /// </summary>
        [DataMember(Name="Content", EmitDefaultValue=false)]
        public string Content { get; set; }

        /// <summary>
        /// Gets or Sets NotRequiredAfterFirstOccurrence
        /// </summary>
        [DataMember(Name="NotRequiredAfterFirstOccurrence", EmitDefaultValue=false)]
        public bool? NotRequiredAfterFirstOccurrence { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class TaskWorkflowActionModel {\n");
            sb.Append("  Data: ").Append(Data).Append("\n");
            sb.Append("  Url: ").Append(Url).Append("\n");
            sb.Append("  Description: ").Append(Description).Append("\n");
            sb.Append("  Type: ").Append(Type).Append("\n");
            sb.Append("  ActionStatus: ").Append(ActionStatus).Append("\n");
            sb.Append("  ButtonTextPositive: ").Append(ButtonTextPositive).Append("\n");
            sb.Append("  ButtonTextNegative: ").Append(ButtonTextNegative).Append("\n");
            sb.Append("  Content: ").Append(Content).Append("\n");
            sb.Append("  NotRequiredAfterFirstOccurrence: ").Append(NotRequiredAfterFirstOccurrence).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as TaskWorkflowActionModel);
        }

        /// <summary>
        /// Returns true if TaskWorkflowActionModel instances are equal
        /// </summary>
        /// <param name="input">Instance of TaskWorkflowActionModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(TaskWorkflowActionModel input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Data == input.Data ||
                    (this.Data != null &&
                    this.Data.Equals(input.Data))
                ) && 
                (
                    this.Url == input.Url ||
                    (this.Url != null &&
                    this.Url.Equals(input.Url))
                ) && 
                (
                    this.Description == input.Description ||
                    (this.Description != null &&
                    this.Description.Equals(input.Description))
                ) && 
                (
                    this.Type == input.Type ||
                    (this.Type != null &&
                    this.Type.Equals(input.Type))
                ) && 
                (
                    this.ActionStatus == input.ActionStatus ||
                    (this.ActionStatus != null &&
                    this.ActionStatus.Equals(input.ActionStatus))
                ) && 
                (
                    this.ButtonTextPositive == input.ButtonTextPositive ||
                    (this.ButtonTextPositive != null &&
                    this.ButtonTextPositive.Equals(input.ButtonTextPositive))
                ) && 
                (
                    this.ButtonTextNegative == input.ButtonTextNegative ||
                    (this.ButtonTextNegative != null &&
                    this.ButtonTextNegative.Equals(input.ButtonTextNegative))
                ) && 
                (
                    this.Content == input.Content ||
                    (this.Content != null &&
                    this.Content.Equals(input.Content))
                ) && 
                (
                    this.NotRequiredAfterFirstOccurrence == input.NotRequiredAfterFirstOccurrence ||
                    (this.NotRequiredAfterFirstOccurrence != null &&
                    this.NotRequiredAfterFirstOccurrence.Equals(input.NotRequiredAfterFirstOccurrence))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Data != null)
                    hashCode = hashCode * 59 + this.Data.GetHashCode();
                if (this.Url != null)
                    hashCode = hashCode * 59 + this.Url.GetHashCode();
                if (this.Description != null)
                    hashCode = hashCode * 59 + this.Description.GetHashCode();
                if (this.Type != null)
                    hashCode = hashCode * 59 + this.Type.GetHashCode();
                if (this.ActionStatus != null)
                    hashCode = hashCode * 59 + this.ActionStatus.GetHashCode();
                if (this.ButtonTextPositive != null)
                    hashCode = hashCode * 59 + this.ButtonTextPositive.GetHashCode();
                if (this.ButtonTextNegative != null)
                    hashCode = hashCode * 59 + this.ButtonTextNegative.GetHashCode();
                if (this.Content != null)
                    hashCode = hashCode * 59 + this.Content.GetHashCode();
                if (this.NotRequiredAfterFirstOccurrence != null)
                    hashCode = hashCode * 59 + this.NotRequiredAfterFirstOccurrence.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // Url (string) maxLength
            if(this.Url != null && this.Url.Length > 512)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Url, length must be less than 512.", new [] { "Url" });
            }

            // Url (string) minLength
            if(this.Url != null && this.Url.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Url, length must be greater than 0.", new [] { "Url" });
            }

            // Description (string) maxLength
            if(this.Description != null && this.Description.Length > 128)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Description, length must be less than 128.", new [] { "Description" });
            }

            // Description (string) minLength
            if(this.Description != null && this.Description.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Description, length must be greater than 0.", new [] { "Description" });
            }

            // ButtonTextPositive (string) maxLength
            if(this.ButtonTextPositive != null && this.ButtonTextPositive.Length > 128)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for ButtonTextPositive, length must be less than 128.", new [] { "ButtonTextPositive" });
            }

            // ButtonTextPositive (string) minLength
            if(this.ButtonTextPositive != null && this.ButtonTextPositive.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for ButtonTextPositive, length must be greater than 0.", new [] { "ButtonTextPositive" });
            }

            // ButtonTextNegative (string) maxLength
            if(this.ButtonTextNegative != null && this.ButtonTextNegative.Length > 128)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for ButtonTextNegative, length must be less than 128.", new [] { "ButtonTextNegative" });
            }

            // ButtonTextNegative (string) minLength
            if(this.ButtonTextNegative != null && this.ButtonTextNegative.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for ButtonTextNegative, length must be greater than 0.", new [] { "ButtonTextNegative" });
            }

            yield break;
        }
    }

}
