/* 
 * API Version: 5.0
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v5
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// TextStampModel
    /// </summary>
    [DataContract]
    public partial class TextStampModel :  IEquatable<TextStampModel>, IValidatableObject
    {
        /// <summary>
        /// Defines FontColor
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum FontColorEnum
        {
            
            /// <summary>
            /// Enum Black for value: Black
            /// </summary>
            [EnumMember(Value = "Black")]
            Black = 1,
            
            /// <summary>
            /// Enum Blue for value: Blue
            /// </summary>
            [EnumMember(Value = "Blue")]
            Blue = 2,
            
            /// <summary>
            /// Enum Red for value: Red
            /// </summary>
            [EnumMember(Value = "Red")]
            Red = 3
        }

        /// <summary>
        /// Gets or Sets FontColor
        /// </summary>
        [DataMember(Name="FontColor", EmitDefaultValue=false)]
        public FontColorEnum? FontColor { get; set; }
        /// <summary>
        /// Defines SearchTextStartPosition
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum SearchTextStartPositionEnum
        {
            
            /// <summary>
            /// Enum Right for value: Right
            /// </summary>
            [EnumMember(Value = "Right")]
            Right = 1,
            
            /// <summary>
            /// Enum Bottom for value: Bottom
            /// </summary>
            [EnumMember(Value = "Bottom")]
            Bottom = 2,
            
            /// <summary>
            /// Enum Left for value: Left
            /// </summary>
            [EnumMember(Value = "Left")]
            Left = 3,
            
            /// <summary>
            /// Enum Top for value: Top
            /// </summary>
            [EnumMember(Value = "Top")]
            Top = 4
        }

        /// <summary>
        /// Gets or Sets SearchTextStartPosition
        /// </summary>
        [DataMember(Name="SearchText_StartPosition", EmitDefaultValue=false)]
        public SearchTextStartPositionEnum? SearchTextStartPosition { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="TextStampModel" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected TextStampModel() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="TextStampModel" /> class.
        /// </summary>
        /// <param name="textToStamp">textToStamp (required).</param>
        /// <param name="fontSize">fontSize (required).</param>
        /// <param name="fontColor">fontColor.</param>
        /// <param name="fontName">fontName.</param>
        /// <param name="formFieldFieldName">formFieldFieldName.</param>
        /// <param name="formFieldInstance">formFieldInstance.</param>
        /// <param name="searchTextText">searchTextText.</param>
        /// <param name="searchTextStartPosition">searchTextStartPosition.</param>
        /// <param name="searchTextInstance">searchTextInstance.</param>
        /// <param name="pageCoordinatesPageNumber">pageCoordinatesPageNumber.</param>
        /// <param name="xOffset">xOffset.</param>
        /// <param name="yOffset">yOffset.</param>
        public TextStampModel(string textToStamp = default(string), float? fontSize = default(float?), FontColorEnum? fontColor = default(FontColorEnum?), string fontName = default(string), string formFieldFieldName = default(string), int? formFieldInstance = default(int?), string searchTextText = default(string), SearchTextStartPositionEnum? searchTextStartPosition = default(SearchTextStartPositionEnum?), int? searchTextInstance = default(int?), int? pageCoordinatesPageNumber = default(int?), int? xOffset = default(int?), int? yOffset = default(int?))
        {
            // to ensure "textToStamp" is required (not null)
            if (textToStamp == null)
            {
                throw new InvalidDataException("textToStamp is a required property for TextStampModel and cannot be null");
            }
            else
            {
                this.TextToStamp = textToStamp;
            }
            // to ensure "fontSize" is required (not null)
            if (fontSize == null)
            {
                throw new InvalidDataException("fontSize is a required property for TextStampModel and cannot be null");
            }
            else
            {
                this.FontSize = fontSize;
            }
            this.FontColor = fontColor;
            this.FontName = fontName;
            this.FormFieldFieldName = formFieldFieldName;
            this.FormFieldInstance = formFieldInstance;
            this.SearchTextText = searchTextText;
            this.SearchTextStartPosition = searchTextStartPosition;
            this.SearchTextInstance = searchTextInstance;
            this.PageCoordinatesPageNumber = pageCoordinatesPageNumber;
            this.XOffset = xOffset;
            this.YOffset = yOffset;
        }
        
        /// <summary>
        /// Gets or Sets TextToStamp
        /// </summary>
        [DataMember(Name="TextToStamp", EmitDefaultValue=false)]
        public string TextToStamp { get; set; }

        /// <summary>
        /// Gets or Sets FontSize
        /// </summary>
        [DataMember(Name="FontSize", EmitDefaultValue=false)]
        public float? FontSize { get; set; }


        /// <summary>
        /// Gets or Sets FontName
        /// </summary>
        [DataMember(Name="FontName", EmitDefaultValue=false)]
        public string FontName { get; set; }

        /// <summary>
        /// Gets or Sets FormFieldFieldName
        /// </summary>
        [DataMember(Name="FormField_FieldName", EmitDefaultValue=false)]
        public string FormFieldFieldName { get; set; }

        /// <summary>
        /// Gets or Sets FormFieldInstance
        /// </summary>
        [DataMember(Name="FormField_Instance", EmitDefaultValue=false)]
        public int? FormFieldInstance { get; set; }

        /// <summary>
        /// Gets or Sets SearchTextText
        /// </summary>
        [DataMember(Name="SearchText_Text", EmitDefaultValue=false)]
        public string SearchTextText { get; set; }


        /// <summary>
        /// Gets or Sets SearchTextInstance
        /// </summary>
        [DataMember(Name="SearchText_Instance", EmitDefaultValue=false)]
        public int? SearchTextInstance { get; set; }

        /// <summary>
        /// Gets or Sets PageCoordinatesPageNumber
        /// </summary>
        [DataMember(Name="PageCoordinates_PageNumber", EmitDefaultValue=false)]
        public int? PageCoordinatesPageNumber { get; set; }

        /// <summary>
        /// Gets or Sets XOffset
        /// </summary>
        [DataMember(Name="XOffset", EmitDefaultValue=false)]
        public int? XOffset { get; set; }

        /// <summary>
        /// Gets or Sets YOffset
        /// </summary>
        [DataMember(Name="YOffset", EmitDefaultValue=false)]
        public int? YOffset { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class TextStampModel {\n");
            sb.Append("  TextToStamp: ").Append(TextToStamp).Append("\n");
            sb.Append("  FontSize: ").Append(FontSize).Append("\n");
            sb.Append("  FontColor: ").Append(FontColor).Append("\n");
            sb.Append("  FontName: ").Append(FontName).Append("\n");
            sb.Append("  FormFieldFieldName: ").Append(FormFieldFieldName).Append("\n");
            sb.Append("  FormFieldInstance: ").Append(FormFieldInstance).Append("\n");
            sb.Append("  SearchTextText: ").Append(SearchTextText).Append("\n");
            sb.Append("  SearchTextStartPosition: ").Append(SearchTextStartPosition).Append("\n");
            sb.Append("  SearchTextInstance: ").Append(SearchTextInstance).Append("\n");
            sb.Append("  PageCoordinatesPageNumber: ").Append(PageCoordinatesPageNumber).Append("\n");
            sb.Append("  XOffset: ").Append(XOffset).Append("\n");
            sb.Append("  YOffset: ").Append(YOffset).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as TextStampModel);
        }

        /// <summary>
        /// Returns true if TextStampModel instances are equal
        /// </summary>
        /// <param name="input">Instance of TextStampModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(TextStampModel input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.TextToStamp == input.TextToStamp ||
                    (this.TextToStamp != null &&
                    this.TextToStamp.Equals(input.TextToStamp))
                ) && 
                (
                    this.FontSize == input.FontSize ||
                    (this.FontSize != null &&
                    this.FontSize.Equals(input.FontSize))
                ) && 
                (
                    this.FontColor == input.FontColor ||
                    (this.FontColor != null &&
                    this.FontColor.Equals(input.FontColor))
                ) && 
                (
                    this.FontName == input.FontName ||
                    (this.FontName != null &&
                    this.FontName.Equals(input.FontName))
                ) && 
                (
                    this.FormFieldFieldName == input.FormFieldFieldName ||
                    (this.FormFieldFieldName != null &&
                    this.FormFieldFieldName.Equals(input.FormFieldFieldName))
                ) && 
                (
                    this.FormFieldInstance == input.FormFieldInstance ||
                    (this.FormFieldInstance != null &&
                    this.FormFieldInstance.Equals(input.FormFieldInstance))
                ) && 
                (
                    this.SearchTextText == input.SearchTextText ||
                    (this.SearchTextText != null &&
                    this.SearchTextText.Equals(input.SearchTextText))
                ) && 
                (
                    this.SearchTextStartPosition == input.SearchTextStartPosition ||
                    (this.SearchTextStartPosition != null &&
                    this.SearchTextStartPosition.Equals(input.SearchTextStartPosition))
                ) && 
                (
                    this.SearchTextInstance == input.SearchTextInstance ||
                    (this.SearchTextInstance != null &&
                    this.SearchTextInstance.Equals(input.SearchTextInstance))
                ) && 
                (
                    this.PageCoordinatesPageNumber == input.PageCoordinatesPageNumber ||
                    (this.PageCoordinatesPageNumber != null &&
                    this.PageCoordinatesPageNumber.Equals(input.PageCoordinatesPageNumber))
                ) && 
                (
                    this.XOffset == input.XOffset ||
                    (this.XOffset != null &&
                    this.XOffset.Equals(input.XOffset))
                ) && 
                (
                    this.YOffset == input.YOffset ||
                    (this.YOffset != null &&
                    this.YOffset.Equals(input.YOffset))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.TextToStamp != null)
                    hashCode = hashCode * 59 + this.TextToStamp.GetHashCode();
                if (this.FontSize != null)
                    hashCode = hashCode * 59 + this.FontSize.GetHashCode();
                if (this.FontColor != null)
                    hashCode = hashCode * 59 + this.FontColor.GetHashCode();
                if (this.FontName != null)
                    hashCode = hashCode * 59 + this.FontName.GetHashCode();
                if (this.FormFieldFieldName != null)
                    hashCode = hashCode * 59 + this.FormFieldFieldName.GetHashCode();
                if (this.FormFieldInstance != null)
                    hashCode = hashCode * 59 + this.FormFieldInstance.GetHashCode();
                if (this.SearchTextText != null)
                    hashCode = hashCode * 59 + this.SearchTextText.GetHashCode();
                if (this.SearchTextStartPosition != null)
                    hashCode = hashCode * 59 + this.SearchTextStartPosition.GetHashCode();
                if (this.SearchTextInstance != null)
                    hashCode = hashCode * 59 + this.SearchTextInstance.GetHashCode();
                if (this.PageCoordinatesPageNumber != null)
                    hashCode = hashCode * 59 + this.PageCoordinatesPageNumber.GetHashCode();
                if (this.XOffset != null)
                    hashCode = hashCode * 59 + this.XOffset.GetHashCode();
                if (this.YOffset != null)
                    hashCode = hashCode * 59 + this.YOffset.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
