/* 
 * API Version: 5.0
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v5
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// TransactionCertifySealPdfModel
    /// </summary>
    [DataContract]
    public partial class TransactionCertifySealPdfModel :  IEquatable<TransactionCertifySealPdfModel>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="TransactionCertifySealPdfModel" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected TransactionCertifySealPdfModel() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="TransactionCertifySealPdfModel" /> class.
        /// </summary>
        /// <param name="description">description (required).</param>
        /// <param name="pdfs">pdfs (required).</param>
        /// <param name="isTest">isTest.</param>
        /// <param name="isRemoteCertify">isRemoteCertify.</param>
        /// <param name="remoteCertifierName">remoteCertifierName.</param>
        /// <param name="remoteCertifierTitle">remoteCertifierTitle.</param>
        /// <param name="remoteCertifierOrganization">remoteCertifierOrganization.</param>
        /// <param name="remoteCertifierEmail">remoteCertifierEmail.</param>
        public TransactionCertifySealPdfModel(string description = default(string), List<Object> pdfs = default(List<Object>), bool? isTest = default(bool?), bool? isRemoteCertify = default(bool?), string remoteCertifierName = default(string), string remoteCertifierTitle = default(string), string remoteCertifierOrganization = default(string), string remoteCertifierEmail = default(string))
        {
            // to ensure "description" is required (not null)
            if (description == null)
            {
                throw new InvalidDataException("description is a required property for TransactionCertifySealPdfModel and cannot be null");
            }
            else
            {
                this.Description = description;
            }
            // to ensure "pdfs" is required (not null)
            if (pdfs == null)
            {
                throw new InvalidDataException("pdfs is a required property for TransactionCertifySealPdfModel and cannot be null");
            }
            else
            {
                this.Pdfs = pdfs;
            }
            this.IsTest = isTest;
            this.IsRemoteCertify = isRemoteCertify;
            this.RemoteCertifierName = remoteCertifierName;
            this.RemoteCertifierTitle = remoteCertifierTitle;
            this.RemoteCertifierOrganization = remoteCertifierOrganization;
            this.RemoteCertifierEmail = remoteCertifierEmail;
        }
        
        /// <summary>
        /// Gets or Sets Description
        /// </summary>
        [DataMember(Name="Description", EmitDefaultValue=false)]
        public string Description { get; set; }

        /// <summary>
        /// Gets or Sets Pdfs
        /// </summary>
        [DataMember(Name="Pdfs", EmitDefaultValue=false)]
        public List<Object> Pdfs { get; set; }

        /// <summary>
        /// Gets or Sets IsTest
        /// </summary>
        [DataMember(Name="IsTest", EmitDefaultValue=false)]
        public bool? IsTest { get; set; }

        /// <summary>
        /// Gets or Sets IsRemoteCertify
        /// </summary>
        [DataMember(Name="IsRemoteCertify", EmitDefaultValue=false)]
        public bool? IsRemoteCertify { get; set; }

        /// <summary>
        /// Gets or Sets RemoteCertifierName
        /// </summary>
        [DataMember(Name="RemoteCertifierName", EmitDefaultValue=false)]
        public string RemoteCertifierName { get; set; }

        /// <summary>
        /// Gets or Sets RemoteCertifierTitle
        /// </summary>
        [DataMember(Name="RemoteCertifierTitle", EmitDefaultValue=false)]
        public string RemoteCertifierTitle { get; set; }

        /// <summary>
        /// Gets or Sets RemoteCertifierOrganization
        /// </summary>
        [DataMember(Name="RemoteCertifierOrganization", EmitDefaultValue=false)]
        public string RemoteCertifierOrganization { get; set; }

        /// <summary>
        /// Gets or Sets RemoteCertifierEmail
        /// </summary>
        [DataMember(Name="RemoteCertifierEmail", EmitDefaultValue=false)]
        public string RemoteCertifierEmail { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class TransactionCertifySealPdfModel {\n");
            sb.Append("  Description: ").Append(Description).Append("\n");
            sb.Append("  Pdfs: ").Append(Pdfs).Append("\n");
            sb.Append("  IsTest: ").Append(IsTest).Append("\n");
            sb.Append("  IsRemoteCertify: ").Append(IsRemoteCertify).Append("\n");
            sb.Append("  RemoteCertifierName: ").Append(RemoteCertifierName).Append("\n");
            sb.Append("  RemoteCertifierTitle: ").Append(RemoteCertifierTitle).Append("\n");
            sb.Append("  RemoteCertifierOrganization: ").Append(RemoteCertifierOrganization).Append("\n");
            sb.Append("  RemoteCertifierEmail: ").Append(RemoteCertifierEmail).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as TransactionCertifySealPdfModel);
        }

        /// <summary>
        /// Returns true if TransactionCertifySealPdfModel instances are equal
        /// </summary>
        /// <param name="input">Instance of TransactionCertifySealPdfModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(TransactionCertifySealPdfModel input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Description == input.Description ||
                    (this.Description != null &&
                    this.Description.Equals(input.Description))
                ) && 
                (
                    this.Pdfs == input.Pdfs ||
                    this.Pdfs != null &&
                    this.Pdfs.SequenceEqual(input.Pdfs)
                ) && 
                (
                    this.IsTest == input.IsTest ||
                    (this.IsTest != null &&
                    this.IsTest.Equals(input.IsTest))
                ) && 
                (
                    this.IsRemoteCertify == input.IsRemoteCertify ||
                    (this.IsRemoteCertify != null &&
                    this.IsRemoteCertify.Equals(input.IsRemoteCertify))
                ) && 
                (
                    this.RemoteCertifierName == input.RemoteCertifierName ||
                    (this.RemoteCertifierName != null &&
                    this.RemoteCertifierName.Equals(input.RemoteCertifierName))
                ) && 
                (
                    this.RemoteCertifierTitle == input.RemoteCertifierTitle ||
                    (this.RemoteCertifierTitle != null &&
                    this.RemoteCertifierTitle.Equals(input.RemoteCertifierTitle))
                ) && 
                (
                    this.RemoteCertifierOrganization == input.RemoteCertifierOrganization ||
                    (this.RemoteCertifierOrganization != null &&
                    this.RemoteCertifierOrganization.Equals(input.RemoteCertifierOrganization))
                ) && 
                (
                    this.RemoteCertifierEmail == input.RemoteCertifierEmail ||
                    (this.RemoteCertifierEmail != null &&
                    this.RemoteCertifierEmail.Equals(input.RemoteCertifierEmail))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Description != null)
                    hashCode = hashCode * 59 + this.Description.GetHashCode();
                if (this.Pdfs != null)
                    hashCode = hashCode * 59 + this.Pdfs.GetHashCode();
                if (this.IsTest != null)
                    hashCode = hashCode * 59 + this.IsTest.GetHashCode();
                if (this.IsRemoteCertify != null)
                    hashCode = hashCode * 59 + this.IsRemoteCertify.GetHashCode();
                if (this.RemoteCertifierName != null)
                    hashCode = hashCode * 59 + this.RemoteCertifierName.GetHashCode();
                if (this.RemoteCertifierTitle != null)
                    hashCode = hashCode * 59 + this.RemoteCertifierTitle.GetHashCode();
                if (this.RemoteCertifierOrganization != null)
                    hashCode = hashCode * 59 + this.RemoteCertifierOrganization.GetHashCode();
                if (this.RemoteCertifierEmail != null)
                    hashCode = hashCode * 59 + this.RemoteCertifierEmail.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
