/* 
 * API Version: 5.0
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v5
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// TransactionCreateModel
    /// </summary>
    [DataContract]
    public partial class TransactionCreateModel :  IEquatable<TransactionCreateModel>, IValidatableObject
    {
        /// <summary>
        /// Defines EnforceAddDigitalSignaturesForAllPDFDocumentsType
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum EnforceAddDigitalSignaturesForAllPDFDocumentsTypeEnum
        {
            
            /// <summary>
            /// Enum None for value: None
            /// </summary>
            [EnumMember(Value = "None")]
            None = 1,
            
            /// <summary>
            /// Enum Certification for value: Certification
            /// </summary>
            [EnumMember(Value = "Certification")]
            Certification = 2,
            
            /// <summary>
            /// Enum Seal for value: Seal
            /// </summary>
            [EnumMember(Value = "Seal")]
            Seal = 3
        }

        /// <summary>
        /// Gets or Sets EnforceAddDigitalSignaturesForAllPDFDocumentsType
        /// </summary>
        [DataMember(Name="EnforceAddDigitalSignaturesForAllPDFDocumentsType", EmitDefaultValue=false)]
        public EnforceAddDigitalSignaturesForAllPDFDocumentsTypeEnum? EnforceAddDigitalSignaturesForAllPDFDocumentsType { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="TransactionCreateModel" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected TransactionCreateModel() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="TransactionCreateModel" /> class.
        /// </summary>
        /// <param name="prontoID">prontoID (required).</param>
        /// <param name="isTest">isTest.</param>
        /// <param name="description">description (required).</param>
        /// <param name="isParticipantOrderNonSequential">isParticipantOrderNonSequential.</param>
        /// <param name="disableCompleteNotificationAttachments">disableCompleteNotificationAttachments.</param>
        /// <param name="completeNotificationEmailAddresses">completeNotificationEmailAddresses.</param>
        /// <param name="outgoingEmailDetails">outgoingEmailDetails.</param>
        /// <param name="jurisdiction">jurisdiction.</param>
        /// <param name="creatorUserID">creatorUserID.</param>
        /// <param name="expirationDate">expirationDate.</param>
        /// <param name="emailTemplateSetName">emailTemplateSetName.</param>
        /// <param name="sessionExpirationMinutes">sessionExpirationMinutes.</param>
        /// <param name="documents">documents (required).</param>
        /// <param name="participants">participants (required).</param>
        /// <param name="workflowActions">workflowActions.</param>
        /// <param name="metaData">metaData.</param>
        /// <param name="sendCompletedNotification">sendCompletedNotification.</param>
        /// <param name="sendCancelledNotification">sendCancelledNotification.</param>
        /// <param name="sendExpiredNotification">sendExpiredNotification.</param>
        /// <param name="enableMessagePromptOnCancel">enableMessagePromptOnCancel.</param>
        /// <param name="thirdPartyNotifications">thirdPartyNotifications.</param>
        /// <param name="enforceAddDigitalSignaturesForAllPDFDocumentsType">enforceAddDigitalSignaturesForAllPDFDocumentsType.</param>
        /// <param name="includeUploadedAttachmentsInThirdPartyNotifications">includeUploadedAttachmentsInThirdPartyNotifications.</param>
        /// <param name="emailTemplateSetLanguage">emailTemplateSetLanguage.</param>
        public TransactionCreateModel(string prontoID = default(string), bool? isTest = default(bool?), string description = default(string), bool? isParticipantOrderNonSequential = default(bool?), bool? disableCompleteNotificationAttachments = default(bool?), List<Object> completeNotificationEmailAddresses = default(List<Object>), OutgoingEmailDetailsModel outgoingEmailDetails = default(OutgoingEmailDetailsModel), JurisdictionModel jurisdiction = default(JurisdictionModel), int? creatorUserID = default(int?), DateTime? expirationDate = default(DateTime?), string emailTemplateSetName = default(string), int? sessionExpirationMinutes = default(int?), List<Object> documents = default(List<Object>), List<Object> participants = default(List<Object>), List<Object> workflowActions = default(List<Object>), List<Object> metaData = default(List<Object>), bool? sendCompletedNotification = default(bool?), bool? sendCancelledNotification = default(bool?), bool? sendExpiredNotification = default(bool?), bool? enableMessagePromptOnCancel = default(bool?), List<Object> thirdPartyNotifications = default(List<Object>), EnforceAddDigitalSignaturesForAllPDFDocumentsTypeEnum? enforceAddDigitalSignaturesForAllPDFDocumentsType = default(EnforceAddDigitalSignaturesForAllPDFDocumentsTypeEnum?), bool? includeUploadedAttachmentsInThirdPartyNotifications = default(bool?), string emailTemplateSetLanguage = default(string))
        {
            // to ensure "prontoID" is required (not null)
            if (prontoID == null)
            {
                throw new InvalidDataException("prontoID is a required property for TransactionCreateModel and cannot be null");
            }
            else
            {
                this.ProntoID = prontoID;
            }
            // to ensure "description" is required (not null)
            if (description == null)
            {
                throw new InvalidDataException("description is a required property for TransactionCreateModel and cannot be null");
            }
            else
            {
                this.Description = description;
            }
            // to ensure "documents" is required (not null)
            if (documents == null)
            {
                throw new InvalidDataException("documents is a required property for TransactionCreateModel and cannot be null");
            }
            else
            {
                this.Documents = documents;
            }
            // to ensure "participants" is required (not null)
            if (participants == null)
            {
                throw new InvalidDataException("participants is a required property for TransactionCreateModel and cannot be null");
            }
            else
            {
                this.Participants = participants;
            }
            this.IsTest = isTest;
            this.IsParticipantOrderNonSequential = isParticipantOrderNonSequential;
            this.DisableCompleteNotificationAttachments = disableCompleteNotificationAttachments;
            this.CompleteNotificationEmailAddresses = completeNotificationEmailAddresses;
            this.OutgoingEmailDetails = outgoingEmailDetails;
            this.Jurisdiction = jurisdiction;
            this.CreatorUserID = creatorUserID;
            this.ExpirationDate = expirationDate;
            this.EmailTemplateSetName = emailTemplateSetName;
            this.SessionExpirationMinutes = sessionExpirationMinutes;
            this.WorkflowActions = workflowActions;
            this.MetaData = metaData;
            this.SendCompletedNotification = sendCompletedNotification;
            this.SendCancelledNotification = sendCancelledNotification;
            this.SendExpiredNotification = sendExpiredNotification;
            this.EnableMessagePromptOnCancel = enableMessagePromptOnCancel;
            this.ThirdPartyNotifications = thirdPartyNotifications;
            this.EnforceAddDigitalSignaturesForAllPDFDocumentsType = enforceAddDigitalSignaturesForAllPDFDocumentsType;
            this.IncludeUploadedAttachmentsInThirdPartyNotifications = includeUploadedAttachmentsInThirdPartyNotifications;
            this.EmailTemplateSetLanguage = emailTemplateSetLanguage;
        }
        
        /// <summary>
        /// Gets or Sets ProntoID
        /// </summary>
        [DataMember(Name="ProntoID", EmitDefaultValue=false)]
        public string ProntoID { get; set; }

        /// <summary>
        /// Gets or Sets IsTest
        /// </summary>
        [DataMember(Name="IsTest", EmitDefaultValue=false)]
        public bool? IsTest { get; set; }

        /// <summary>
        /// Gets or Sets Description
        /// </summary>
        [DataMember(Name="Description", EmitDefaultValue=false)]
        public string Description { get; set; }

        /// <summary>
        /// Gets or Sets IsParticipantOrderNonSequential
        /// </summary>
        [DataMember(Name="IsParticipantOrderNonSequential", EmitDefaultValue=false)]
        public bool? IsParticipantOrderNonSequential { get; set; }

        /// <summary>
        /// Gets or Sets DisableCompleteNotificationAttachments
        /// </summary>
        [DataMember(Name="DisableCompleteNotificationAttachments", EmitDefaultValue=false)]
        public bool? DisableCompleteNotificationAttachments { get; set; }

        /// <summary>
        /// Gets or Sets CompleteNotificationEmailAddresses
        /// </summary>
        [DataMember(Name="CompleteNotificationEmailAddresses", EmitDefaultValue=false)]
        public List<Object> CompleteNotificationEmailAddresses { get; set; }

        /// <summary>
        /// Gets or Sets OutgoingEmailDetails
        /// </summary>
        [DataMember(Name="OutgoingEmailDetails", EmitDefaultValue=false)]
        public OutgoingEmailDetailsModel OutgoingEmailDetails { get; set; }

        /// <summary>
        /// Gets or Sets Jurisdiction
        /// </summary>
        [DataMember(Name="Jurisdiction", EmitDefaultValue=false)]
        public JurisdictionModel Jurisdiction { get; set; }

        /// <summary>
        /// Gets or Sets CreatorUserID
        /// </summary>
        [DataMember(Name="CreatorUserID", EmitDefaultValue=false)]
        public int? CreatorUserID { get; set; }

        /// <summary>
        /// Gets or Sets ExpirationDate
        /// </summary>
        [DataMember(Name="ExpirationDate", EmitDefaultValue=false)]
        public DateTime? ExpirationDate { get; set; }

        /// <summary>
        /// Gets or Sets EmailTemplateSetName
        /// </summary>
        [DataMember(Name="EmailTemplateSetName", EmitDefaultValue=false)]
        public string EmailTemplateSetName { get; set; }

        /// <summary>
        /// Gets or Sets SessionExpirationMinutes
        /// </summary>
        [DataMember(Name="SessionExpirationMinutes", EmitDefaultValue=false)]
        public int? SessionExpirationMinutes { get; set; }

        /// <summary>
        /// Gets or Sets Documents
        /// </summary>
        [DataMember(Name="Documents", EmitDefaultValue=false)]
        public List<Object> Documents { get; set; }

        /// <summary>
        /// Gets or Sets Participants
        /// </summary>
        [DataMember(Name="Participants", EmitDefaultValue=false)]
        public List<Object> Participants { get; set; }

        /// <summary>
        /// Gets or Sets WorkflowActions
        /// </summary>
        [DataMember(Name="WorkflowActions", EmitDefaultValue=false)]
        public List<Object> WorkflowActions { get; set; }

        /// <summary>
        /// Gets or Sets MetaData
        /// </summary>
        [DataMember(Name="MetaData", EmitDefaultValue=false)]
        public List<Object> MetaData { get; set; }

        /// <summary>
        /// Gets or Sets SendCompletedNotification
        /// </summary>
        [DataMember(Name="SendCompletedNotification", EmitDefaultValue=false)]
        public bool? SendCompletedNotification { get; set; }

        /// <summary>
        /// Gets or Sets SendCancelledNotification
        /// </summary>
        [DataMember(Name="SendCancelledNotification", EmitDefaultValue=false)]
        public bool? SendCancelledNotification { get; set; }

        /// <summary>
        /// Gets or Sets SendExpiredNotification
        /// </summary>
        [DataMember(Name="SendExpiredNotification", EmitDefaultValue=false)]
        public bool? SendExpiredNotification { get; set; }

        /// <summary>
        /// Gets or Sets EnableMessagePromptOnCancel
        /// </summary>
        [DataMember(Name="EnableMessagePromptOnCancel", EmitDefaultValue=false)]
        public bool? EnableMessagePromptOnCancel { get; set; }

        /// <summary>
        /// Gets or Sets ThirdPartyNotifications
        /// </summary>
        [DataMember(Name="ThirdPartyNotifications", EmitDefaultValue=false)]
        public List<Object> ThirdPartyNotifications { get; set; }


        /// <summary>
        /// Gets or Sets IncludeUploadedAttachmentsInThirdPartyNotifications
        /// </summary>
        [DataMember(Name="IncludeUploadedAttachmentsInThirdPartyNotifications", EmitDefaultValue=false)]
        public bool? IncludeUploadedAttachmentsInThirdPartyNotifications { get; set; }

        /// <summary>
        /// Gets or Sets EmailTemplateSetLanguage
        /// </summary>
        [DataMember(Name="EmailTemplateSetLanguage", EmitDefaultValue=false)]
        public string EmailTemplateSetLanguage { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class TransactionCreateModel {\n");
            sb.Append("  ProntoID: ").Append(ProntoID).Append("\n");
            sb.Append("  IsTest: ").Append(IsTest).Append("\n");
            sb.Append("  Description: ").Append(Description).Append("\n");
            sb.Append("  IsParticipantOrderNonSequential: ").Append(IsParticipantOrderNonSequential).Append("\n");
            sb.Append("  DisableCompleteNotificationAttachments: ").Append(DisableCompleteNotificationAttachments).Append("\n");
            sb.Append("  CompleteNotificationEmailAddresses: ").Append(CompleteNotificationEmailAddresses).Append("\n");
            sb.Append("  OutgoingEmailDetails: ").Append(OutgoingEmailDetails).Append("\n");
            sb.Append("  Jurisdiction: ").Append(Jurisdiction).Append("\n");
            sb.Append("  CreatorUserID: ").Append(CreatorUserID).Append("\n");
            sb.Append("  ExpirationDate: ").Append(ExpirationDate).Append("\n");
            sb.Append("  EmailTemplateSetName: ").Append(EmailTemplateSetName).Append("\n");
            sb.Append("  SessionExpirationMinutes: ").Append(SessionExpirationMinutes).Append("\n");
            sb.Append("  Documents: ").Append(Documents).Append("\n");
            sb.Append("  Participants: ").Append(Participants).Append("\n");
            sb.Append("  WorkflowActions: ").Append(WorkflowActions).Append("\n");
            sb.Append("  MetaData: ").Append(MetaData).Append("\n");
            sb.Append("  SendCompletedNotification: ").Append(SendCompletedNotification).Append("\n");
            sb.Append("  SendCancelledNotification: ").Append(SendCancelledNotification).Append("\n");
            sb.Append("  SendExpiredNotification: ").Append(SendExpiredNotification).Append("\n");
            sb.Append("  EnableMessagePromptOnCancel: ").Append(EnableMessagePromptOnCancel).Append("\n");
            sb.Append("  ThirdPartyNotifications: ").Append(ThirdPartyNotifications).Append("\n");
            sb.Append("  EnforceAddDigitalSignaturesForAllPDFDocumentsType: ").Append(EnforceAddDigitalSignaturesForAllPDFDocumentsType).Append("\n");
            sb.Append("  IncludeUploadedAttachmentsInThirdPartyNotifications: ").Append(IncludeUploadedAttachmentsInThirdPartyNotifications).Append("\n");
            sb.Append("  EmailTemplateSetLanguage: ").Append(EmailTemplateSetLanguage).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as TransactionCreateModel);
        }

        /// <summary>
        /// Returns true if TransactionCreateModel instances are equal
        /// </summary>
        /// <param name="input">Instance of TransactionCreateModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(TransactionCreateModel input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ProntoID == input.ProntoID ||
                    (this.ProntoID != null &&
                    this.ProntoID.Equals(input.ProntoID))
                ) && 
                (
                    this.IsTest == input.IsTest ||
                    (this.IsTest != null &&
                    this.IsTest.Equals(input.IsTest))
                ) && 
                (
                    this.Description == input.Description ||
                    (this.Description != null &&
                    this.Description.Equals(input.Description))
                ) && 
                (
                    this.IsParticipantOrderNonSequential == input.IsParticipantOrderNonSequential ||
                    (this.IsParticipantOrderNonSequential != null &&
                    this.IsParticipantOrderNonSequential.Equals(input.IsParticipantOrderNonSequential))
                ) && 
                (
                    this.DisableCompleteNotificationAttachments == input.DisableCompleteNotificationAttachments ||
                    (this.DisableCompleteNotificationAttachments != null &&
                    this.DisableCompleteNotificationAttachments.Equals(input.DisableCompleteNotificationAttachments))
                ) && 
                (
                    this.CompleteNotificationEmailAddresses == input.CompleteNotificationEmailAddresses ||
                    this.CompleteNotificationEmailAddresses != null &&
                    this.CompleteNotificationEmailAddresses.SequenceEqual(input.CompleteNotificationEmailAddresses)
                ) && 
                (
                    this.OutgoingEmailDetails == input.OutgoingEmailDetails ||
                    (this.OutgoingEmailDetails != null &&
                    this.OutgoingEmailDetails.Equals(input.OutgoingEmailDetails))
                ) && 
                (
                    this.Jurisdiction == input.Jurisdiction ||
                    (this.Jurisdiction != null &&
                    this.Jurisdiction.Equals(input.Jurisdiction))
                ) && 
                (
                    this.CreatorUserID == input.CreatorUserID ||
                    (this.CreatorUserID != null &&
                    this.CreatorUserID.Equals(input.CreatorUserID))
                ) && 
                (
                    this.ExpirationDate == input.ExpirationDate ||
                    (this.ExpirationDate != null &&
                    this.ExpirationDate.Equals(input.ExpirationDate))
                ) && 
                (
                    this.EmailTemplateSetName == input.EmailTemplateSetName ||
                    (this.EmailTemplateSetName != null &&
                    this.EmailTemplateSetName.Equals(input.EmailTemplateSetName))
                ) && 
                (
                    this.SessionExpirationMinutes == input.SessionExpirationMinutes ||
                    (this.SessionExpirationMinutes != null &&
                    this.SessionExpirationMinutes.Equals(input.SessionExpirationMinutes))
                ) && 
                (
                    this.Documents == input.Documents ||
                    this.Documents != null &&
                    this.Documents.SequenceEqual(input.Documents)
                ) && 
                (
                    this.Participants == input.Participants ||
                    this.Participants != null &&
                    this.Participants.SequenceEqual(input.Participants)
                ) && 
                (
                    this.WorkflowActions == input.WorkflowActions ||
                    this.WorkflowActions != null &&
                    this.WorkflowActions.SequenceEqual(input.WorkflowActions)
                ) && 
                (
                    this.MetaData == input.MetaData ||
                    this.MetaData != null &&
                    this.MetaData.SequenceEqual(input.MetaData)
                ) && 
                (
                    this.SendCompletedNotification == input.SendCompletedNotification ||
                    (this.SendCompletedNotification != null &&
                    this.SendCompletedNotification.Equals(input.SendCompletedNotification))
                ) && 
                (
                    this.SendCancelledNotification == input.SendCancelledNotification ||
                    (this.SendCancelledNotification != null &&
                    this.SendCancelledNotification.Equals(input.SendCancelledNotification))
                ) && 
                (
                    this.SendExpiredNotification == input.SendExpiredNotification ||
                    (this.SendExpiredNotification != null &&
                    this.SendExpiredNotification.Equals(input.SendExpiredNotification))
                ) && 
                (
                    this.EnableMessagePromptOnCancel == input.EnableMessagePromptOnCancel ||
                    (this.EnableMessagePromptOnCancel != null &&
                    this.EnableMessagePromptOnCancel.Equals(input.EnableMessagePromptOnCancel))
                ) && 
                (
                    this.ThirdPartyNotifications == input.ThirdPartyNotifications ||
                    this.ThirdPartyNotifications != null &&
                    this.ThirdPartyNotifications.SequenceEqual(input.ThirdPartyNotifications)
                ) && 
                (
                    this.EnforceAddDigitalSignaturesForAllPDFDocumentsType == input.EnforceAddDigitalSignaturesForAllPDFDocumentsType ||
                    (this.EnforceAddDigitalSignaturesForAllPDFDocumentsType != null &&
                    this.EnforceAddDigitalSignaturesForAllPDFDocumentsType.Equals(input.EnforceAddDigitalSignaturesForAllPDFDocumentsType))
                ) && 
                (
                    this.IncludeUploadedAttachmentsInThirdPartyNotifications == input.IncludeUploadedAttachmentsInThirdPartyNotifications ||
                    (this.IncludeUploadedAttachmentsInThirdPartyNotifications != null &&
                    this.IncludeUploadedAttachmentsInThirdPartyNotifications.Equals(input.IncludeUploadedAttachmentsInThirdPartyNotifications))
                ) && 
                (
                    this.EmailTemplateSetLanguage == input.EmailTemplateSetLanguage ||
                    (this.EmailTemplateSetLanguage != null &&
                    this.EmailTemplateSetLanguage.Equals(input.EmailTemplateSetLanguage))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ProntoID != null)
                    hashCode = hashCode * 59 + this.ProntoID.GetHashCode();
                if (this.IsTest != null)
                    hashCode = hashCode * 59 + this.IsTest.GetHashCode();
                if (this.Description != null)
                    hashCode = hashCode * 59 + this.Description.GetHashCode();
                if (this.IsParticipantOrderNonSequential != null)
                    hashCode = hashCode * 59 + this.IsParticipantOrderNonSequential.GetHashCode();
                if (this.DisableCompleteNotificationAttachments != null)
                    hashCode = hashCode * 59 + this.DisableCompleteNotificationAttachments.GetHashCode();
                if (this.CompleteNotificationEmailAddresses != null)
                    hashCode = hashCode * 59 + this.CompleteNotificationEmailAddresses.GetHashCode();
                if (this.OutgoingEmailDetails != null)
                    hashCode = hashCode * 59 + this.OutgoingEmailDetails.GetHashCode();
                if (this.Jurisdiction != null)
                    hashCode = hashCode * 59 + this.Jurisdiction.GetHashCode();
                if (this.CreatorUserID != null)
                    hashCode = hashCode * 59 + this.CreatorUserID.GetHashCode();
                if (this.ExpirationDate != null)
                    hashCode = hashCode * 59 + this.ExpirationDate.GetHashCode();
                if (this.EmailTemplateSetName != null)
                    hashCode = hashCode * 59 + this.EmailTemplateSetName.GetHashCode();
                if (this.SessionExpirationMinutes != null)
                    hashCode = hashCode * 59 + this.SessionExpirationMinutes.GetHashCode();
                if (this.Documents != null)
                    hashCode = hashCode * 59 + this.Documents.GetHashCode();
                if (this.Participants != null)
                    hashCode = hashCode * 59 + this.Participants.GetHashCode();
                if (this.WorkflowActions != null)
                    hashCode = hashCode * 59 + this.WorkflowActions.GetHashCode();
                if (this.MetaData != null)
                    hashCode = hashCode * 59 + this.MetaData.GetHashCode();
                if (this.SendCompletedNotification != null)
                    hashCode = hashCode * 59 + this.SendCompletedNotification.GetHashCode();
                if (this.SendCancelledNotification != null)
                    hashCode = hashCode * 59 + this.SendCancelledNotification.GetHashCode();
                if (this.SendExpiredNotification != null)
                    hashCode = hashCode * 59 + this.SendExpiredNotification.GetHashCode();
                if (this.EnableMessagePromptOnCancel != null)
                    hashCode = hashCode * 59 + this.EnableMessagePromptOnCancel.GetHashCode();
                if (this.ThirdPartyNotifications != null)
                    hashCode = hashCode * 59 + this.ThirdPartyNotifications.GetHashCode();
                if (this.EnforceAddDigitalSignaturesForAllPDFDocumentsType != null)
                    hashCode = hashCode * 59 + this.EnforceAddDigitalSignaturesForAllPDFDocumentsType.GetHashCode();
                if (this.IncludeUploadedAttachmentsInThirdPartyNotifications != null)
                    hashCode = hashCode * 59 + this.IncludeUploadedAttachmentsInThirdPartyNotifications.GetHashCode();
                if (this.EmailTemplateSetLanguage != null)
                    hashCode = hashCode * 59 + this.EmailTemplateSetLanguage.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // Description (string) maxLength
            if(this.Description != null && this.Description.Length > 256)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Description, length must be less than 256.", new [] { "Description" });
            }

            // Description (string) minLength
            if(this.Description != null && this.Description.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Description, length must be greater than 0.", new [] { "Description" });
            }

            yield break;
        }
    }

}
