/* 
 * API Version: 5.0
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v5
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// TransactionCreateRequestModel
    /// </summary>
    [DataContract]
    public partial class TransactionCreateRequestModel :  IEquatable<TransactionCreateRequestModel>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="TransactionCreateRequestModel" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected TransactionCreateRequestModel() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="TransactionCreateRequestModel" /> class.
        /// </summary>
        /// <param name="transactions">transactions (required).</param>
        /// <param name="responseIncludes">responseIncludes.</param>
        /// <param name="enableLogging">enableLogging.</param>
        /// <param name="timeZoneID">timeZoneID.</param>
        public TransactionCreateRequestModel(List<Object> transactions = default(List<Object>), TransactionIncludesModel responseIncludes = default(TransactionIncludesModel), bool? enableLogging = default(bool?), string timeZoneID = default(string))
        {
            // to ensure "transactions" is required (not null)
            if (transactions == null)
            {
                throw new InvalidDataException("transactions is a required property for TransactionCreateRequestModel and cannot be null");
            }
            else
            {
                this.Transactions = transactions;
            }
            this.ResponseIncludes = responseIncludes;
            this.EnableLogging = enableLogging;
            this.TimeZoneID = timeZoneID;
        }
        
        /// <summary>
        /// Gets or Sets Transactions
        /// </summary>
        [DataMember(Name="Transactions", EmitDefaultValue=false)]
        public List<Object> Transactions { get; set; }

        /// <summary>
        /// Gets or Sets ResponseIncludes
        /// </summary>
        [DataMember(Name="ResponseIncludes", EmitDefaultValue=false)]
        public TransactionIncludesModel ResponseIncludes { get; set; }

        /// <summary>
        /// Gets or Sets EnableLogging
        /// </summary>
        [DataMember(Name="EnableLogging", EmitDefaultValue=false)]
        public bool? EnableLogging { get; set; }

        /// <summary>
        /// Gets or Sets TimeZoneID
        /// </summary>
        [DataMember(Name="TimeZoneID", EmitDefaultValue=false)]
        public string TimeZoneID { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class TransactionCreateRequestModel {\n");
            sb.Append("  Transactions: ").Append(Transactions).Append("\n");
            sb.Append("  ResponseIncludes: ").Append(ResponseIncludes).Append("\n");
            sb.Append("  EnableLogging: ").Append(EnableLogging).Append("\n");
            sb.Append("  TimeZoneID: ").Append(TimeZoneID).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as TransactionCreateRequestModel);
        }

        /// <summary>
        /// Returns true if TransactionCreateRequestModel instances are equal
        /// </summary>
        /// <param name="input">Instance of TransactionCreateRequestModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(TransactionCreateRequestModel input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Transactions == input.Transactions ||
                    this.Transactions != null &&
                    this.Transactions.SequenceEqual(input.Transactions)
                ) && 
                (
                    this.ResponseIncludes == input.ResponseIncludes ||
                    (this.ResponseIncludes != null &&
                    this.ResponseIncludes.Equals(input.ResponseIncludes))
                ) && 
                (
                    this.EnableLogging == input.EnableLogging ||
                    (this.EnableLogging != null &&
                    this.EnableLogging.Equals(input.EnableLogging))
                ) && 
                (
                    this.TimeZoneID == input.TimeZoneID ||
                    (this.TimeZoneID != null &&
                    this.TimeZoneID.Equals(input.TimeZoneID))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Transactions != null)
                    hashCode = hashCode * 59 + this.Transactions.GetHashCode();
                if (this.ResponseIncludes != null)
                    hashCode = hashCode * 59 + this.ResponseIncludes.GetHashCode();
                if (this.EnableLogging != null)
                    hashCode = hashCode * 59 + this.EnableLogging.GetHashCode();
                if (this.TimeZoneID != null)
                    hashCode = hashCode * 59 + this.TimeZoneID.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
