/* 
 * API Version: 5.0
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v5
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// TransactionDetailsModel
    /// </summary>
    [DataContract]
    public partial class TransactionDetailsModel :  IEquatable<TransactionDetailsModel>, IValidatableObject
    {
        /// <summary>
        /// Defines Status
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum StatusEnum
        {
            
            /// <summary>
            /// Enum All for value: All
            /// </summary>
            [EnumMember(Value = "All")]
            All = 1,
            
            /// <summary>
            /// Enum Pending for value: Pending
            /// </summary>
            [EnumMember(Value = "Pending")]
            Pending = 2,
            
            /// <summary>
            /// Enum Completed for value: Completed
            /// </summary>
            [EnumMember(Value = "Completed")]
            Completed = 3,
            
            /// <summary>
            /// Enum EmailSent for value: EmailSent
            /// </summary>
            [EnumMember(Value = "EmailSent")]
            EmailSent = 4,
            
            /// <summary>
            /// Enum Closed for value: Closed
            /// </summary>
            [EnumMember(Value = "Closed")]
            Closed = 5,
            
            /// <summary>
            /// Enum Cancelled for value: Cancelled
            /// </summary>
            [EnumMember(Value = "Cancelled")]
            Cancelled = 6,
            
            /// <summary>
            /// Enum Expired for value: Expired
            /// </summary>
            [EnumMember(Value = "Expired")]
            Expired = 7,
            
            /// <summary>
            /// Enum Voided for value: Voided
            /// </summary>
            [EnumMember(Value = "Voided")]
            Voided = 8
        }

        /// <summary>
        /// Gets or Sets Status
        /// </summary>
        [DataMember(Name="Status", EmitDefaultValue=false)]
        public StatusEnum? Status { get; set; }
        /// <summary>
        /// Defines EnforceAddDigitalSignaturesForAllPDFDocumentsType
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum EnforceAddDigitalSignaturesForAllPDFDocumentsTypeEnum
        {
            
            /// <summary>
            /// Enum None for value: None
            /// </summary>
            [EnumMember(Value = "None")]
            None = 1,
            
            /// <summary>
            /// Enum Certification for value: Certification
            /// </summary>
            [EnumMember(Value = "Certification")]
            Certification = 2,
            
            /// <summary>
            /// Enum Seal for value: Seal
            /// </summary>
            [EnumMember(Value = "Seal")]
            Seal = 3
        }

        /// <summary>
        /// Gets or Sets EnforceAddDigitalSignaturesForAllPDFDocumentsType
        /// </summary>
        [DataMember(Name="EnforceAddDigitalSignaturesForAllPDFDocumentsType", EmitDefaultValue=false)]
        public EnforceAddDigitalSignaturesForAllPDFDocumentsTypeEnum? EnforceAddDigitalSignaturesForAllPDFDocumentsType { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="TransactionDetailsModel" /> class.
        /// </summary>
        /// <param name="iD">iD.</param>
        /// <param name="prontoID">prontoID.</param>
        /// <param name="isTest">isTest.</param>
        /// <param name="statusID">statusID.</param>
        /// <param name="isParticipantOrderNonSequential">isParticipantOrderNonSequential.</param>
        /// <param name="disableCompleteNotificationAttachments">disableCompleteNotificationAttachments.</param>
        /// <param name="completeNotificationEmailAddresses">completeNotificationEmailAddresses.</param>
        /// <param name="outgoingEmailDetails">outgoingEmailDetails.</param>
        /// <param name="jurisdiction">jurisdiction.</param>
        /// <param name="creatorUserID">creatorUserID.</param>
        /// <param name="expirationDate">expirationDate.</param>
        /// <param name="description">description.</param>
        /// <param name="createdDate">createdDate.</param>
        /// <param name="closedDate">closedDate.</param>
        /// <param name="filesDeletedDate">filesDeletedDate.</param>
        /// <param name="emailTemplateSetName">emailTemplateSetName.</param>
        /// <param name="sessionExpirationMinutes">sessionExpirationMinutes.</param>
        /// <param name="documents">documents.</param>
        /// <param name="participants">participants.</param>
        /// <param name="workflowActions">workflowActions.</param>
        /// <param name="metaData">metaData.</param>
        /// <param name="sendCompletedNotification">sendCompletedNotification.</param>
        /// <param name="sendCancelledNotification">sendCancelledNotification.</param>
        /// <param name="sendExpiredNotification">sendExpiredNotification.</param>
        /// <param name="enableMessagePromptOnCancel">enableMessagePromptOnCancel.</param>
        /// <param name="status">status.</param>
        /// <param name="accountName">accountName.</param>
        /// <param name="thirdPartyNotifications">thirdPartyNotifications.</param>
        /// <param name="enforceAddDigitalSignaturesForAllPDFDocumentsType">enforceAddDigitalSignaturesForAllPDFDocumentsType.</param>
        /// <param name="includeUploadedAttachmentsInThirdPartyNotifications">includeUploadedAttachmentsInThirdPartyNotifications.</param>
        /// <param name="timeZone">timeZone.</param>
        /// <param name="voidedDate">voidedDate.</param>
        /// <param name="emailTemplateSetLanguage">emailTemplateSetLanguage.</param>
        /// <param name="isAccountAdminLockedOut">isAccountAdminLockedOut.</param>
        public TransactionDetailsModel(int? iD = default(int?), string prontoID = default(string), bool? isTest = default(bool?), int? statusID = default(int?), bool? isParticipantOrderNonSequential = default(bool?), bool? disableCompleteNotificationAttachments = default(bool?), List<Object> completeNotificationEmailAddresses = default(List<Object>), OutgoingEmailDetailsModel outgoingEmailDetails = default(OutgoingEmailDetailsModel), JurisdictionModel jurisdiction = default(JurisdictionModel), int? creatorUserID = default(int?), DateTime? expirationDate = default(DateTime?), string description = default(string), DateTime? createdDate = default(DateTime?), DateTime? closedDate = default(DateTime?), DateTime? filesDeletedDate = default(DateTime?), string emailTemplateSetName = default(string), int? sessionExpirationMinutes = default(int?), List<Object> documents = default(List<Object>), List<Object> participants = default(List<Object>), List<Object> workflowActions = default(List<Object>), List<Object> metaData = default(List<Object>), bool? sendCompletedNotification = default(bool?), bool? sendCancelledNotification = default(bool?), bool? sendExpiredNotification = default(bool?), bool? enableMessagePromptOnCancel = default(bool?), StatusEnum? status = default(StatusEnum?), string accountName = default(string), List<Object> thirdPartyNotifications = default(List<Object>), EnforceAddDigitalSignaturesForAllPDFDocumentsTypeEnum? enforceAddDigitalSignaturesForAllPDFDocumentsType = default(EnforceAddDigitalSignaturesForAllPDFDocumentsTypeEnum?), bool? includeUploadedAttachmentsInThirdPartyNotifications = default(bool?), string timeZone = default(string), DateTime? voidedDate = default(DateTime?), string emailTemplateSetLanguage = default(string), bool? isAccountAdminLockedOut = default(bool?))
        {
            this.ID = iD;
            this.ProntoID = prontoID;
            this.IsTest = isTest;
            this.StatusID = statusID;
            this.IsParticipantOrderNonSequential = isParticipantOrderNonSequential;
            this.DisableCompleteNotificationAttachments = disableCompleteNotificationAttachments;
            this.CompleteNotificationEmailAddresses = completeNotificationEmailAddresses;
            this.OutgoingEmailDetails = outgoingEmailDetails;
            this.Jurisdiction = jurisdiction;
            this.CreatorUserID = creatorUserID;
            this.ExpirationDate = expirationDate;
            this.Description = description;
            this.CreatedDate = createdDate;
            this.ClosedDate = closedDate;
            this.FilesDeletedDate = filesDeletedDate;
            this.EmailTemplateSetName = emailTemplateSetName;
            this.SessionExpirationMinutes = sessionExpirationMinutes;
            this.Documents = documents;
            this.Participants = participants;
            this.WorkflowActions = workflowActions;
            this.MetaData = metaData;
            this.SendCompletedNotification = sendCompletedNotification;
            this.SendCancelledNotification = sendCancelledNotification;
            this.SendExpiredNotification = sendExpiredNotification;
            this.EnableMessagePromptOnCancel = enableMessagePromptOnCancel;
            this.Status = status;
            this.AccountName = accountName;
            this.ThirdPartyNotifications = thirdPartyNotifications;
            this.EnforceAddDigitalSignaturesForAllPDFDocumentsType = enforceAddDigitalSignaturesForAllPDFDocumentsType;
            this.IncludeUploadedAttachmentsInThirdPartyNotifications = includeUploadedAttachmentsInThirdPartyNotifications;
            this.TimeZone = timeZone;
            this.VoidedDate = voidedDate;
            this.EmailTemplateSetLanguage = emailTemplateSetLanguage;
            this.IsAccountAdminLockedOut = isAccountAdminLockedOut;
        }
        
        /// <summary>
        /// Gets or Sets ID
        /// </summary>
        [DataMember(Name="ID", EmitDefaultValue=false)]
        public int? ID { get; set; }

        /// <summary>
        /// Gets or Sets ProntoID
        /// </summary>
        [DataMember(Name="ProntoID", EmitDefaultValue=false)]
        public string ProntoID { get; set; }

        /// <summary>
        /// Gets or Sets IsTest
        /// </summary>
        [DataMember(Name="IsTest", EmitDefaultValue=false)]
        public bool? IsTest { get; set; }

        /// <summary>
        /// Gets or Sets StatusID
        /// </summary>
        [DataMember(Name="StatusID", EmitDefaultValue=false)]
        public int? StatusID { get; set; }

        /// <summary>
        /// Gets or Sets IsParticipantOrderNonSequential
        /// </summary>
        [DataMember(Name="IsParticipantOrderNonSequential", EmitDefaultValue=false)]
        public bool? IsParticipantOrderNonSequential { get; set; }

        /// <summary>
        /// Gets or Sets DisableCompleteNotificationAttachments
        /// </summary>
        [DataMember(Name="DisableCompleteNotificationAttachments", EmitDefaultValue=false)]
        public bool? DisableCompleteNotificationAttachments { get; set; }

        /// <summary>
        /// Gets or Sets CompleteNotificationEmailAddresses
        /// </summary>
        [DataMember(Name="CompleteNotificationEmailAddresses", EmitDefaultValue=false)]
        public List<Object> CompleteNotificationEmailAddresses { get; set; }

        /// <summary>
        /// Gets or Sets OutgoingEmailDetails
        /// </summary>
        [DataMember(Name="OutgoingEmailDetails", EmitDefaultValue=false)]
        public OutgoingEmailDetailsModel OutgoingEmailDetails { get; set; }

        /// <summary>
        /// Gets or Sets Jurisdiction
        /// </summary>
        [DataMember(Name="Jurisdiction", EmitDefaultValue=false)]
        public JurisdictionModel Jurisdiction { get; set; }

        /// <summary>
        /// Gets or Sets CreatorUserID
        /// </summary>
        [DataMember(Name="CreatorUserID", EmitDefaultValue=false)]
        public int? CreatorUserID { get; set; }

        /// <summary>
        /// Gets or Sets ExpirationDate
        /// </summary>
        [DataMember(Name="ExpirationDate", EmitDefaultValue=false)]
        public DateTime? ExpirationDate { get; set; }

        /// <summary>
        /// Gets or Sets Description
        /// </summary>
        [DataMember(Name="Description", EmitDefaultValue=false)]
        public string Description { get; set; }

        /// <summary>
        /// Gets or Sets CreatedDate
        /// </summary>
        [DataMember(Name="CreatedDate", EmitDefaultValue=false)]
        public DateTime? CreatedDate { get; set; }

        /// <summary>
        /// Gets or Sets ClosedDate
        /// </summary>
        [DataMember(Name="ClosedDate", EmitDefaultValue=false)]
        public DateTime? ClosedDate { get; set; }

        /// <summary>
        /// Gets or Sets FilesDeletedDate
        /// </summary>
        [DataMember(Name="FilesDeletedDate", EmitDefaultValue=false)]
        public DateTime? FilesDeletedDate { get; set; }

        /// <summary>
        /// Gets or Sets EmailTemplateSetName
        /// </summary>
        [DataMember(Name="EmailTemplateSetName", EmitDefaultValue=false)]
        public string EmailTemplateSetName { get; set; }

        /// <summary>
        /// Gets or Sets SessionExpirationMinutes
        /// </summary>
        [DataMember(Name="SessionExpirationMinutes", EmitDefaultValue=false)]
        public int? SessionExpirationMinutes { get; set; }

        /// <summary>
        /// Gets or Sets Documents
        /// </summary>
        [DataMember(Name="Documents", EmitDefaultValue=false)]
        public List<Object> Documents { get; set; }

        /// <summary>
        /// Gets or Sets Participants
        /// </summary>
        [DataMember(Name="Participants", EmitDefaultValue=false)]
        public List<Object> Participants { get; set; }

        /// <summary>
        /// Gets or Sets WorkflowActions
        /// </summary>
        [DataMember(Name="WorkflowActions", EmitDefaultValue=false)]
        public List<Object> WorkflowActions { get; set; }

        /// <summary>
        /// Gets or Sets MetaData
        /// </summary>
        [DataMember(Name="MetaData", EmitDefaultValue=false)]
        public List<Object> MetaData { get; set; }

        /// <summary>
        /// Gets or Sets SendCompletedNotification
        /// </summary>
        [DataMember(Name="SendCompletedNotification", EmitDefaultValue=false)]
        public bool? SendCompletedNotification { get; set; }

        /// <summary>
        /// Gets or Sets SendCancelledNotification
        /// </summary>
        [DataMember(Name="SendCancelledNotification", EmitDefaultValue=false)]
        public bool? SendCancelledNotification { get; set; }

        /// <summary>
        /// Gets or Sets SendExpiredNotification
        /// </summary>
        [DataMember(Name="SendExpiredNotification", EmitDefaultValue=false)]
        public bool? SendExpiredNotification { get; set; }

        /// <summary>
        /// Gets or Sets EnableMessagePromptOnCancel
        /// </summary>
        [DataMember(Name="EnableMessagePromptOnCancel", EmitDefaultValue=false)]
        public bool? EnableMessagePromptOnCancel { get; set; }


        /// <summary>
        /// Gets or Sets AccountName
        /// </summary>
        [DataMember(Name="AccountName", EmitDefaultValue=false)]
        public string AccountName { get; set; }

        /// <summary>
        /// Gets or Sets ThirdPartyNotifications
        /// </summary>
        [DataMember(Name="ThirdPartyNotifications", EmitDefaultValue=false)]
        public List<Object> ThirdPartyNotifications { get; set; }


        /// <summary>
        /// Gets or Sets IncludeUploadedAttachmentsInThirdPartyNotifications
        /// </summary>
        [DataMember(Name="IncludeUploadedAttachmentsInThirdPartyNotifications", EmitDefaultValue=false)]
        public bool? IncludeUploadedAttachmentsInThirdPartyNotifications { get; set; }

        /// <summary>
        /// Gets or Sets TimeZone
        /// </summary>
        [DataMember(Name="TimeZone", EmitDefaultValue=false)]
        public string TimeZone { get; set; }

        /// <summary>
        /// Gets or Sets VoidedDate
        /// </summary>
        [DataMember(Name="VoidedDate", EmitDefaultValue=false)]
        public DateTime? VoidedDate { get; set; }

        /// <summary>
        /// Gets or Sets EmailTemplateSetLanguage
        /// </summary>
        [DataMember(Name="EmailTemplateSetLanguage", EmitDefaultValue=false)]
        public string EmailTemplateSetLanguage { get; set; }

        /// <summary>
        /// Gets or Sets IsAccountAdminLockedOut
        /// </summary>
        [DataMember(Name="IsAccountAdminLockedOut", EmitDefaultValue=false)]
        public bool? IsAccountAdminLockedOut { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class TransactionDetailsModel {\n");
            sb.Append("  ID: ").Append(ID).Append("\n");
            sb.Append("  ProntoID: ").Append(ProntoID).Append("\n");
            sb.Append("  IsTest: ").Append(IsTest).Append("\n");
            sb.Append("  StatusID: ").Append(StatusID).Append("\n");
            sb.Append("  IsParticipantOrderNonSequential: ").Append(IsParticipantOrderNonSequential).Append("\n");
            sb.Append("  DisableCompleteNotificationAttachments: ").Append(DisableCompleteNotificationAttachments).Append("\n");
            sb.Append("  CompleteNotificationEmailAddresses: ").Append(CompleteNotificationEmailAddresses).Append("\n");
            sb.Append("  OutgoingEmailDetails: ").Append(OutgoingEmailDetails).Append("\n");
            sb.Append("  Jurisdiction: ").Append(Jurisdiction).Append("\n");
            sb.Append("  CreatorUserID: ").Append(CreatorUserID).Append("\n");
            sb.Append("  ExpirationDate: ").Append(ExpirationDate).Append("\n");
            sb.Append("  Description: ").Append(Description).Append("\n");
            sb.Append("  CreatedDate: ").Append(CreatedDate).Append("\n");
            sb.Append("  ClosedDate: ").Append(ClosedDate).Append("\n");
            sb.Append("  FilesDeletedDate: ").Append(FilesDeletedDate).Append("\n");
            sb.Append("  EmailTemplateSetName: ").Append(EmailTemplateSetName).Append("\n");
            sb.Append("  SessionExpirationMinutes: ").Append(SessionExpirationMinutes).Append("\n");
            sb.Append("  Documents: ").Append(Documents).Append("\n");
            sb.Append("  Participants: ").Append(Participants).Append("\n");
            sb.Append("  WorkflowActions: ").Append(WorkflowActions).Append("\n");
            sb.Append("  MetaData: ").Append(MetaData).Append("\n");
            sb.Append("  SendCompletedNotification: ").Append(SendCompletedNotification).Append("\n");
            sb.Append("  SendCancelledNotification: ").Append(SendCancelledNotification).Append("\n");
            sb.Append("  SendExpiredNotification: ").Append(SendExpiredNotification).Append("\n");
            sb.Append("  EnableMessagePromptOnCancel: ").Append(EnableMessagePromptOnCancel).Append("\n");
            sb.Append("  Status: ").Append(Status).Append("\n");
            sb.Append("  AccountName: ").Append(AccountName).Append("\n");
            sb.Append("  ThirdPartyNotifications: ").Append(ThirdPartyNotifications).Append("\n");
            sb.Append("  EnforceAddDigitalSignaturesForAllPDFDocumentsType: ").Append(EnforceAddDigitalSignaturesForAllPDFDocumentsType).Append("\n");
            sb.Append("  IncludeUploadedAttachmentsInThirdPartyNotifications: ").Append(IncludeUploadedAttachmentsInThirdPartyNotifications).Append("\n");
            sb.Append("  TimeZone: ").Append(TimeZone).Append("\n");
            sb.Append("  VoidedDate: ").Append(VoidedDate).Append("\n");
            sb.Append("  EmailTemplateSetLanguage: ").Append(EmailTemplateSetLanguage).Append("\n");
            sb.Append("  IsAccountAdminLockedOut: ").Append(IsAccountAdminLockedOut).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as TransactionDetailsModel);
        }

        /// <summary>
        /// Returns true if TransactionDetailsModel instances are equal
        /// </summary>
        /// <param name="input">Instance of TransactionDetailsModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(TransactionDetailsModel input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ID == input.ID ||
                    (this.ID != null &&
                    this.ID.Equals(input.ID))
                ) && 
                (
                    this.ProntoID == input.ProntoID ||
                    (this.ProntoID != null &&
                    this.ProntoID.Equals(input.ProntoID))
                ) && 
                (
                    this.IsTest == input.IsTest ||
                    (this.IsTest != null &&
                    this.IsTest.Equals(input.IsTest))
                ) && 
                (
                    this.StatusID == input.StatusID ||
                    (this.StatusID != null &&
                    this.StatusID.Equals(input.StatusID))
                ) && 
                (
                    this.IsParticipantOrderNonSequential == input.IsParticipantOrderNonSequential ||
                    (this.IsParticipantOrderNonSequential != null &&
                    this.IsParticipantOrderNonSequential.Equals(input.IsParticipantOrderNonSequential))
                ) && 
                (
                    this.DisableCompleteNotificationAttachments == input.DisableCompleteNotificationAttachments ||
                    (this.DisableCompleteNotificationAttachments != null &&
                    this.DisableCompleteNotificationAttachments.Equals(input.DisableCompleteNotificationAttachments))
                ) && 
                (
                    this.CompleteNotificationEmailAddresses == input.CompleteNotificationEmailAddresses ||
                    this.CompleteNotificationEmailAddresses != null &&
                    this.CompleteNotificationEmailAddresses.SequenceEqual(input.CompleteNotificationEmailAddresses)
                ) && 
                (
                    this.OutgoingEmailDetails == input.OutgoingEmailDetails ||
                    (this.OutgoingEmailDetails != null &&
                    this.OutgoingEmailDetails.Equals(input.OutgoingEmailDetails))
                ) && 
                (
                    this.Jurisdiction == input.Jurisdiction ||
                    (this.Jurisdiction != null &&
                    this.Jurisdiction.Equals(input.Jurisdiction))
                ) && 
                (
                    this.CreatorUserID == input.CreatorUserID ||
                    (this.CreatorUserID != null &&
                    this.CreatorUserID.Equals(input.CreatorUserID))
                ) && 
                (
                    this.ExpirationDate == input.ExpirationDate ||
                    (this.ExpirationDate != null &&
                    this.ExpirationDate.Equals(input.ExpirationDate))
                ) && 
                (
                    this.Description == input.Description ||
                    (this.Description != null &&
                    this.Description.Equals(input.Description))
                ) && 
                (
                    this.CreatedDate == input.CreatedDate ||
                    (this.CreatedDate != null &&
                    this.CreatedDate.Equals(input.CreatedDate))
                ) && 
                (
                    this.ClosedDate == input.ClosedDate ||
                    (this.ClosedDate != null &&
                    this.ClosedDate.Equals(input.ClosedDate))
                ) && 
                (
                    this.FilesDeletedDate == input.FilesDeletedDate ||
                    (this.FilesDeletedDate != null &&
                    this.FilesDeletedDate.Equals(input.FilesDeletedDate))
                ) && 
                (
                    this.EmailTemplateSetName == input.EmailTemplateSetName ||
                    (this.EmailTemplateSetName != null &&
                    this.EmailTemplateSetName.Equals(input.EmailTemplateSetName))
                ) && 
                (
                    this.SessionExpirationMinutes == input.SessionExpirationMinutes ||
                    (this.SessionExpirationMinutes != null &&
                    this.SessionExpirationMinutes.Equals(input.SessionExpirationMinutes))
                ) && 
                (
                    this.Documents == input.Documents ||
                    this.Documents != null &&
                    this.Documents.SequenceEqual(input.Documents)
                ) && 
                (
                    this.Participants == input.Participants ||
                    this.Participants != null &&
                    this.Participants.SequenceEqual(input.Participants)
                ) && 
                (
                    this.WorkflowActions == input.WorkflowActions ||
                    this.WorkflowActions != null &&
                    this.WorkflowActions.SequenceEqual(input.WorkflowActions)
                ) && 
                (
                    this.MetaData == input.MetaData ||
                    this.MetaData != null &&
                    this.MetaData.SequenceEqual(input.MetaData)
                ) && 
                (
                    this.SendCompletedNotification == input.SendCompletedNotification ||
                    (this.SendCompletedNotification != null &&
                    this.SendCompletedNotification.Equals(input.SendCompletedNotification))
                ) && 
                (
                    this.SendCancelledNotification == input.SendCancelledNotification ||
                    (this.SendCancelledNotification != null &&
                    this.SendCancelledNotification.Equals(input.SendCancelledNotification))
                ) && 
                (
                    this.SendExpiredNotification == input.SendExpiredNotification ||
                    (this.SendExpiredNotification != null &&
                    this.SendExpiredNotification.Equals(input.SendExpiredNotification))
                ) && 
                (
                    this.EnableMessagePromptOnCancel == input.EnableMessagePromptOnCancel ||
                    (this.EnableMessagePromptOnCancel != null &&
                    this.EnableMessagePromptOnCancel.Equals(input.EnableMessagePromptOnCancel))
                ) && 
                (
                    this.Status == input.Status ||
                    (this.Status != null &&
                    this.Status.Equals(input.Status))
                ) && 
                (
                    this.AccountName == input.AccountName ||
                    (this.AccountName != null &&
                    this.AccountName.Equals(input.AccountName))
                ) && 
                (
                    this.ThirdPartyNotifications == input.ThirdPartyNotifications ||
                    this.ThirdPartyNotifications != null &&
                    this.ThirdPartyNotifications.SequenceEqual(input.ThirdPartyNotifications)
                ) && 
                (
                    this.EnforceAddDigitalSignaturesForAllPDFDocumentsType == input.EnforceAddDigitalSignaturesForAllPDFDocumentsType ||
                    (this.EnforceAddDigitalSignaturesForAllPDFDocumentsType != null &&
                    this.EnforceAddDigitalSignaturesForAllPDFDocumentsType.Equals(input.EnforceAddDigitalSignaturesForAllPDFDocumentsType))
                ) && 
                (
                    this.IncludeUploadedAttachmentsInThirdPartyNotifications == input.IncludeUploadedAttachmentsInThirdPartyNotifications ||
                    (this.IncludeUploadedAttachmentsInThirdPartyNotifications != null &&
                    this.IncludeUploadedAttachmentsInThirdPartyNotifications.Equals(input.IncludeUploadedAttachmentsInThirdPartyNotifications))
                ) && 
                (
                    this.TimeZone == input.TimeZone ||
                    (this.TimeZone != null &&
                    this.TimeZone.Equals(input.TimeZone))
                ) && 
                (
                    this.VoidedDate == input.VoidedDate ||
                    (this.VoidedDate != null &&
                    this.VoidedDate.Equals(input.VoidedDate))
                ) && 
                (
                    this.EmailTemplateSetLanguage == input.EmailTemplateSetLanguage ||
                    (this.EmailTemplateSetLanguage != null &&
                    this.EmailTemplateSetLanguage.Equals(input.EmailTemplateSetLanguage))
                ) && 
                (
                    this.IsAccountAdminLockedOut == input.IsAccountAdminLockedOut ||
                    (this.IsAccountAdminLockedOut != null &&
                    this.IsAccountAdminLockedOut.Equals(input.IsAccountAdminLockedOut))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ID != null)
                    hashCode = hashCode * 59 + this.ID.GetHashCode();
                if (this.ProntoID != null)
                    hashCode = hashCode * 59 + this.ProntoID.GetHashCode();
                if (this.IsTest != null)
                    hashCode = hashCode * 59 + this.IsTest.GetHashCode();
                if (this.StatusID != null)
                    hashCode = hashCode * 59 + this.StatusID.GetHashCode();
                if (this.IsParticipantOrderNonSequential != null)
                    hashCode = hashCode * 59 + this.IsParticipantOrderNonSequential.GetHashCode();
                if (this.DisableCompleteNotificationAttachments != null)
                    hashCode = hashCode * 59 + this.DisableCompleteNotificationAttachments.GetHashCode();
                if (this.CompleteNotificationEmailAddresses != null)
                    hashCode = hashCode * 59 + this.CompleteNotificationEmailAddresses.GetHashCode();
                if (this.OutgoingEmailDetails != null)
                    hashCode = hashCode * 59 + this.OutgoingEmailDetails.GetHashCode();
                if (this.Jurisdiction != null)
                    hashCode = hashCode * 59 + this.Jurisdiction.GetHashCode();
                if (this.CreatorUserID != null)
                    hashCode = hashCode * 59 + this.CreatorUserID.GetHashCode();
                if (this.ExpirationDate != null)
                    hashCode = hashCode * 59 + this.ExpirationDate.GetHashCode();
                if (this.Description != null)
                    hashCode = hashCode * 59 + this.Description.GetHashCode();
                if (this.CreatedDate != null)
                    hashCode = hashCode * 59 + this.CreatedDate.GetHashCode();
                if (this.ClosedDate != null)
                    hashCode = hashCode * 59 + this.ClosedDate.GetHashCode();
                if (this.FilesDeletedDate != null)
                    hashCode = hashCode * 59 + this.FilesDeletedDate.GetHashCode();
                if (this.EmailTemplateSetName != null)
                    hashCode = hashCode * 59 + this.EmailTemplateSetName.GetHashCode();
                if (this.SessionExpirationMinutes != null)
                    hashCode = hashCode * 59 + this.SessionExpirationMinutes.GetHashCode();
                if (this.Documents != null)
                    hashCode = hashCode * 59 + this.Documents.GetHashCode();
                if (this.Participants != null)
                    hashCode = hashCode * 59 + this.Participants.GetHashCode();
                if (this.WorkflowActions != null)
                    hashCode = hashCode * 59 + this.WorkflowActions.GetHashCode();
                if (this.MetaData != null)
                    hashCode = hashCode * 59 + this.MetaData.GetHashCode();
                if (this.SendCompletedNotification != null)
                    hashCode = hashCode * 59 + this.SendCompletedNotification.GetHashCode();
                if (this.SendCancelledNotification != null)
                    hashCode = hashCode * 59 + this.SendCancelledNotification.GetHashCode();
                if (this.SendExpiredNotification != null)
                    hashCode = hashCode * 59 + this.SendExpiredNotification.GetHashCode();
                if (this.EnableMessagePromptOnCancel != null)
                    hashCode = hashCode * 59 + this.EnableMessagePromptOnCancel.GetHashCode();
                if (this.Status != null)
                    hashCode = hashCode * 59 + this.Status.GetHashCode();
                if (this.AccountName != null)
                    hashCode = hashCode * 59 + this.AccountName.GetHashCode();
                if (this.ThirdPartyNotifications != null)
                    hashCode = hashCode * 59 + this.ThirdPartyNotifications.GetHashCode();
                if (this.EnforceAddDigitalSignaturesForAllPDFDocumentsType != null)
                    hashCode = hashCode * 59 + this.EnforceAddDigitalSignaturesForAllPDFDocumentsType.GetHashCode();
                if (this.IncludeUploadedAttachmentsInThirdPartyNotifications != null)
                    hashCode = hashCode * 59 + this.IncludeUploadedAttachmentsInThirdPartyNotifications.GetHashCode();
                if (this.TimeZone != null)
                    hashCode = hashCode * 59 + this.TimeZone.GetHashCode();
                if (this.VoidedDate != null)
                    hashCode = hashCode * 59 + this.VoidedDate.GetHashCode();
                if (this.EmailTemplateSetLanguage != null)
                    hashCode = hashCode * 59 + this.EmailTemplateSetLanguage.GetHashCode();
                if (this.IsAccountAdminLockedOut != null)
                    hashCode = hashCode * 59 + this.IsAccountAdminLockedOut.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
