/* 
 * API Version: 5.0
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v5
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// TransactionIncludesModel
    /// </summary>
    [DataContract]
    public partial class TransactionIncludesModel :  IEquatable<TransactionIncludesModel>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="TransactionIncludesModel" /> class.
        /// </summary>
        /// <param name="includeWorkflowActions">includeWorkflowActions.</param>
        /// <param name="includeMetaData">includeMetaData.</param>
        /// <param name="includeParticipants">includeParticipants.</param>
        /// <param name="participantIncludes">participantIncludes.</param>
        /// <param name="includeDocuments">includeDocuments.</param>
        /// <param name="documentIncludes">documentIncludes.</param>
        /// <param name="includeTests">includeTests.</param>
        /// <param name="includeThirdPartyNotifications">includeThirdPartyNotifications.</param>
        public TransactionIncludesModel(bool? includeWorkflowActions = default(bool?), bool? includeMetaData = default(bool?), bool? includeParticipants = default(bool?), ParticipantIncludesModel participantIncludes = default(ParticipantIncludesModel), bool? includeDocuments = default(bool?), DocumentIncludesModel documentIncludes = default(DocumentIncludesModel), bool? includeTests = default(bool?), bool? includeThirdPartyNotifications = default(bool?))
        {
            this.IncludeWorkflowActions = includeWorkflowActions;
            this.IncludeMetaData = includeMetaData;
            this.IncludeParticipants = includeParticipants;
            this.ParticipantIncludes = participantIncludes;
            this.IncludeDocuments = includeDocuments;
            this.DocumentIncludes = documentIncludes;
            this.IncludeTests = includeTests;
            this.IncludeThirdPartyNotifications = includeThirdPartyNotifications;
        }
        
        /// <summary>
        /// Gets or Sets IncludeWorkflowActions
        /// </summary>
        [DataMember(Name="IncludeWorkflowActions", EmitDefaultValue=false)]
        public bool? IncludeWorkflowActions { get; set; }

        /// <summary>
        /// Gets or Sets IncludeMetaData
        /// </summary>
        [DataMember(Name="IncludeMetaData", EmitDefaultValue=false)]
        public bool? IncludeMetaData { get; set; }

        /// <summary>
        /// Gets or Sets IncludeParticipants
        /// </summary>
        [DataMember(Name="IncludeParticipants", EmitDefaultValue=false)]
        public bool? IncludeParticipants { get; set; }

        /// <summary>
        /// Gets or Sets ParticipantIncludes
        /// </summary>
        [DataMember(Name="ParticipantIncludes", EmitDefaultValue=false)]
        public ParticipantIncludesModel ParticipantIncludes { get; set; }

        /// <summary>
        /// Gets or Sets IncludeDocuments
        /// </summary>
        [DataMember(Name="IncludeDocuments", EmitDefaultValue=false)]
        public bool? IncludeDocuments { get; set; }

        /// <summary>
        /// Gets or Sets DocumentIncludes
        /// </summary>
        [DataMember(Name="DocumentIncludes", EmitDefaultValue=false)]
        public DocumentIncludesModel DocumentIncludes { get; set; }

        /// <summary>
        /// Gets or Sets IncludeTests
        /// </summary>
        [DataMember(Name="IncludeTests", EmitDefaultValue=false)]
        public bool? IncludeTests { get; set; }

        /// <summary>
        /// Gets or Sets IncludeThirdPartyNotifications
        /// </summary>
        [DataMember(Name="IncludeThirdPartyNotifications", EmitDefaultValue=false)]
        public bool? IncludeThirdPartyNotifications { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class TransactionIncludesModel {\n");
            sb.Append("  IncludeWorkflowActions: ").Append(IncludeWorkflowActions).Append("\n");
            sb.Append("  IncludeMetaData: ").Append(IncludeMetaData).Append("\n");
            sb.Append("  IncludeParticipants: ").Append(IncludeParticipants).Append("\n");
            sb.Append("  ParticipantIncludes: ").Append(ParticipantIncludes).Append("\n");
            sb.Append("  IncludeDocuments: ").Append(IncludeDocuments).Append("\n");
            sb.Append("  DocumentIncludes: ").Append(DocumentIncludes).Append("\n");
            sb.Append("  IncludeTests: ").Append(IncludeTests).Append("\n");
            sb.Append("  IncludeThirdPartyNotifications: ").Append(IncludeThirdPartyNotifications).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as TransactionIncludesModel);
        }

        /// <summary>
        /// Returns true if TransactionIncludesModel instances are equal
        /// </summary>
        /// <param name="input">Instance of TransactionIncludesModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(TransactionIncludesModel input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.IncludeWorkflowActions == input.IncludeWorkflowActions ||
                    (this.IncludeWorkflowActions != null &&
                    this.IncludeWorkflowActions.Equals(input.IncludeWorkflowActions))
                ) && 
                (
                    this.IncludeMetaData == input.IncludeMetaData ||
                    (this.IncludeMetaData != null &&
                    this.IncludeMetaData.Equals(input.IncludeMetaData))
                ) && 
                (
                    this.IncludeParticipants == input.IncludeParticipants ||
                    (this.IncludeParticipants != null &&
                    this.IncludeParticipants.Equals(input.IncludeParticipants))
                ) && 
                (
                    this.ParticipantIncludes == input.ParticipantIncludes ||
                    (this.ParticipantIncludes != null &&
                    this.ParticipantIncludes.Equals(input.ParticipantIncludes))
                ) && 
                (
                    this.IncludeDocuments == input.IncludeDocuments ||
                    (this.IncludeDocuments != null &&
                    this.IncludeDocuments.Equals(input.IncludeDocuments))
                ) && 
                (
                    this.DocumentIncludes == input.DocumentIncludes ||
                    (this.DocumentIncludes != null &&
                    this.DocumentIncludes.Equals(input.DocumentIncludes))
                ) && 
                (
                    this.IncludeTests == input.IncludeTests ||
                    (this.IncludeTests != null &&
                    this.IncludeTests.Equals(input.IncludeTests))
                ) && 
                (
                    this.IncludeThirdPartyNotifications == input.IncludeThirdPartyNotifications ||
                    (this.IncludeThirdPartyNotifications != null &&
                    this.IncludeThirdPartyNotifications.Equals(input.IncludeThirdPartyNotifications))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.IncludeWorkflowActions != null)
                    hashCode = hashCode * 59 + this.IncludeWorkflowActions.GetHashCode();
                if (this.IncludeMetaData != null)
                    hashCode = hashCode * 59 + this.IncludeMetaData.GetHashCode();
                if (this.IncludeParticipants != null)
                    hashCode = hashCode * 59 + this.IncludeParticipants.GetHashCode();
                if (this.ParticipantIncludes != null)
                    hashCode = hashCode * 59 + this.ParticipantIncludes.GetHashCode();
                if (this.IncludeDocuments != null)
                    hashCode = hashCode * 59 + this.IncludeDocuments.GetHashCode();
                if (this.DocumentIncludes != null)
                    hashCode = hashCode * 59 + this.DocumentIncludes.GetHashCode();
                if (this.IncludeTests != null)
                    hashCode = hashCode * 59 + this.IncludeTests.GetHashCode();
                if (this.IncludeThirdPartyNotifications != null)
                    hashCode = hashCode * 59 + this.IncludeThirdPartyNotifications.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
