/* 
 * API Version: 5.0
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v5
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// TransactionNotificationDetailsModel
    /// </summary>
    [DataContract]
    public partial class TransactionNotificationDetailsModel :  IEquatable<TransactionNotificationDetailsModel>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="TransactionNotificationDetailsModel" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected TransactionNotificationDetailsModel() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="TransactionNotificationDetailsModel" /> class.
        /// </summary>
        /// <param name="fullName">fullName.</param>
        /// <param name="emailAddress">emailAddress (required).</param>
        /// <param name="language">language.</param>
        /// <param name="placeholders">placeholders.</param>
        public TransactionNotificationDetailsModel(string fullName = default(string), string emailAddress = default(string), string language = default(string), List<Object> placeholders = default(List<Object>))
        {
            // to ensure "emailAddress" is required (not null)
            if (emailAddress == null)
            {
                throw new InvalidDataException("emailAddress is a required property for TransactionNotificationDetailsModel and cannot be null");
            }
            else
            {
                this.EmailAddress = emailAddress;
            }
            this.FullName = fullName;
            this.Language = language;
            this.Placeholders = placeholders;
        }
        
        /// <summary>
        /// Gets or Sets FullName
        /// </summary>
        [DataMember(Name="FullName", EmitDefaultValue=false)]
        public string FullName { get; set; }

        /// <summary>
        /// Gets or Sets EmailAddress
        /// </summary>
        [DataMember(Name="EmailAddress", EmitDefaultValue=false)]
        public string EmailAddress { get; set; }

        /// <summary>
        /// Gets or Sets Language
        /// </summary>
        [DataMember(Name="Language", EmitDefaultValue=false)]
        public string Language { get; set; }

        /// <summary>
        /// Gets or Sets Placeholders
        /// </summary>
        [DataMember(Name="Placeholders", EmitDefaultValue=false)]
        public List<Object> Placeholders { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class TransactionNotificationDetailsModel {\n");
            sb.Append("  FullName: ").Append(FullName).Append("\n");
            sb.Append("  EmailAddress: ").Append(EmailAddress).Append("\n");
            sb.Append("  Language: ").Append(Language).Append("\n");
            sb.Append("  Placeholders: ").Append(Placeholders).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as TransactionNotificationDetailsModel);
        }

        /// <summary>
        /// Returns true if TransactionNotificationDetailsModel instances are equal
        /// </summary>
        /// <param name="input">Instance of TransactionNotificationDetailsModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(TransactionNotificationDetailsModel input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.FullName == input.FullName ||
                    (this.FullName != null &&
                    this.FullName.Equals(input.FullName))
                ) && 
                (
                    this.EmailAddress == input.EmailAddress ||
                    (this.EmailAddress != null &&
                    this.EmailAddress.Equals(input.EmailAddress))
                ) && 
                (
                    this.Language == input.Language ||
                    (this.Language != null &&
                    this.Language.Equals(input.Language))
                ) && 
                (
                    this.Placeholders == input.Placeholders ||
                    this.Placeholders != null &&
                    this.Placeholders.SequenceEqual(input.Placeholders)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.FullName != null)
                    hashCode = hashCode * 59 + this.FullName.GetHashCode();
                if (this.EmailAddress != null)
                    hashCode = hashCode * 59 + this.EmailAddress.GetHashCode();
                if (this.Language != null)
                    hashCode = hashCode * 59 + this.Language.GetHashCode();
                if (this.Placeholders != null)
                    hashCode = hashCode * 59 + this.Placeholders.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // FullName (string) maxLength
            if(this.FullName != null && this.FullName.Length > 64)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for FullName, length must be less than 64.", new [] { "FullName" });
            }

            // FullName (string) minLength
            if(this.FullName != null && this.FullName.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for FullName, length must be greater than 0.", new [] { "FullName" });
            }

            // EmailAddress (string) maxLength
            if(this.EmailAddress != null && this.EmailAddress.Length > 128)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for EmailAddress, length must be less than 128.", new [] { "EmailAddress" });
            }

            // EmailAddress (string) minLength
            if(this.EmailAddress != null && this.EmailAddress.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for EmailAddress, length must be greater than 0.", new [] { "EmailAddress" });
            }

            // EmailAddress (string) pattern
            Regex regexEmailAddress = new Regex(@"^(?![.])([^@,<>\\^]+@[^\\s<>,\\^]+\\.[^\\s<>,\\^]+)$", RegexOptions.CultureInvariant);
            if (false == regexEmailAddress.Match(this.EmailAddress).Success)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for EmailAddress, must match a pattern of " + regexEmailAddress, new [] { "EmailAddress" });
            }

            // Language (string) maxLength
            if(this.Language != null && this.Language.Length > 8)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Language, length must be less than 8.", new [] { "Language" });
            }

            // Language (string) minLength
            if(this.Language != null && this.Language.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Language, length must be greater than 0.", new [] { "Language" });
            }

            yield break;
        }
    }

}
