/* 
 * API Version: 5.0
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v5
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// TransactionTokenDataRequestModel
    /// </summary>
    [DataContract]
    public partial class TransactionTokenDataRequestModel :  IEquatable<TransactionTokenDataRequestModel>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="TransactionTokenDataRequestModel" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected TransactionTokenDataRequestModel() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="TransactionTokenDataRequestModel" /> class.
        /// </summary>
        /// <param name="securityToken">securityToken (required).</param>
        /// <param name="enableLogging">enableLogging.</param>
        public TransactionTokenDataRequestModel(string securityToken = default(string), bool? enableLogging = default(bool?))
        {
            // to ensure "securityToken" is required (not null)
            if (securityToken == null)
            {
                throw new InvalidDataException("securityToken is a required property for TransactionTokenDataRequestModel and cannot be null");
            }
            else
            {
                this.SecurityToken = securityToken;
            }
            this.EnableLogging = enableLogging;
        }
        
        /// <summary>
        /// Gets or Sets SecurityToken
        /// </summary>
        [DataMember(Name="SecurityToken", EmitDefaultValue=false)]
        public string SecurityToken { get; set; }

        /// <summary>
        /// Gets or Sets EnableLogging
        /// </summary>
        [DataMember(Name="EnableLogging", EmitDefaultValue=false)]
        public bool? EnableLogging { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class TransactionTokenDataRequestModel {\n");
            sb.Append("  SecurityToken: ").Append(SecurityToken).Append("\n");
            sb.Append("  EnableLogging: ").Append(EnableLogging).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as TransactionTokenDataRequestModel);
        }

        /// <summary>
        /// Returns true if TransactionTokenDataRequestModel instances are equal
        /// </summary>
        /// <param name="input">Instance of TransactionTokenDataRequestModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(TransactionTokenDataRequestModel input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.SecurityToken == input.SecurityToken ||
                    (this.SecurityToken != null &&
                    this.SecurityToken.Equals(input.SecurityToken))
                ) && 
                (
                    this.EnableLogging == input.EnableLogging ||
                    (this.EnableLogging != null &&
                    this.EnableLogging.Equals(input.EnableLogging))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.SecurityToken != null)
                    hashCode = hashCode * 59 + this.SecurityToken.GetHashCode();
                if (this.EnableLogging != null)
                    hashCode = hashCode * 59 + this.EnableLogging.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // SecurityToken (string) pattern
            Regex regexSecurityToken = new Regex(@"^[A-Fa-f0-9]{8}(?:-[A-Fa-f0-9]{4}){3}-[A-Fa-f0-9]{12}$", RegexOptions.CultureInvariant);
            if (false == regexSecurityToken.Match(this.SecurityToken).Success)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for SecurityToken, must match a pattern of " + regexSecurityToken, new [] { "SecurityToken" });
            }

            yield break;
        }
    }

}
