/* 
 * API Version: 5.0
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v5
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// UserDetailsRequestModel
    /// </summary>
    [DataContract]
    public partial class UserDetailsRequestModel :  IEquatable<UserDetailsRequestModel>, IValidatableObject
    {
        /// <summary>
        /// Defines SigningAuthorityType
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum SigningAuthorityTypeEnum
        {
            
            /// <summary>
            /// Enum DirectlyAssignedInThisGroupOnly for value: DirectlyAssignedInThisGroupOnly
            /// </summary>
            [EnumMember(Value = "DirectlyAssignedInThisGroupOnly")]
            DirectlyAssignedInThisGroupOnly = 1,
            
            /// <summary>
            /// Enum DirectlyAssignedInAllGroups for value: DirectlyAssignedInAllGroups
            /// </summary>
            [EnumMember(Value = "DirectlyAssignedInAllGroups")]
            DirectlyAssignedInAllGroups = 2,
            
            /// <summary>
            /// Enum ThisGroupOnly for value: ThisGroupOnly
            /// </summary>
            [EnumMember(Value = "ThisGroupOnly")]
            ThisGroupOnly = 3,
            
            /// <summary>
            /// Enum AllGroups for value: AllGroups
            /// </summary>
            [EnumMember(Value = "AllGroups")]
            AllGroups = 4,
            
            /// <summary>
            /// Enum SystemWide for value: SystemWide
            /// </summary>
            [EnumMember(Value = "SystemWide")]
            SystemWide = 5,
            
            /// <summary>
            /// Enum NotAllowed for value: NotAllowed
            /// </summary>
            [EnumMember(Value = "NotAllowed")]
            NotAllowed = 6
        }

        /// <summary>
        /// Gets or Sets SigningAuthorityType
        /// </summary>
        [DataMember(Name="SigningAuthorityType", EmitDefaultValue=false)]
        public SigningAuthorityTypeEnum? SigningAuthorityType { get; set; }
        /// <summary>
        /// Defines ControlPanelAuthorityType
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum ControlPanelAuthorityTypeEnum
        {
            
            /// <summary>
            /// Enum SigningOnly for value: SigningOnly
            /// </summary>
            [EnumMember(Value = "SigningOnly")]
            SigningOnly = 1,
            
            /// <summary>
            /// Enum GroupUser for value: GroupUser
            /// </summary>
            [EnumMember(Value = "GroupUser")]
            GroupUser = 2,
            
            /// <summary>
            /// Enum AccountWideUser for value: AccountWideUser
            /// </summary>
            [EnumMember(Value = "AccountWideUser")]
            AccountWideUser = 3,
            
            /// <summary>
            /// Enum GroupManager for value: GroupManager
            /// </summary>
            [EnumMember(Value = "GroupManager")]
            GroupManager = 4,
            
            /// <summary>
            /// Enum AccountWideManager for value: AccountWideManager
            /// </summary>
            [EnumMember(Value = "AccountWideManager")]
            AccountWideManager = 5,
            
            /// <summary>
            /// Enum GroupAdmin for value: GroupAdmin
            /// </summary>
            [EnumMember(Value = "GroupAdmin")]
            GroupAdmin = 6,
            
            /// <summary>
            /// Enum AccountWideAdmin for value: AccountWideAdmin
            /// </summary>
            [EnumMember(Value = "AccountWideAdmin")]
            AccountWideAdmin = 7,
            
            /// <summary>
            /// Enum SystemWideAdmin for value: SystemWideAdmin
            /// </summary>
            [EnumMember(Value = "SystemWideAdmin")]
            SystemWideAdmin = 8,
            
            /// <summary>
            /// Enum ApiOnly for value: ApiOnly
            /// </summary>
            [EnumMember(Value = "ApiOnly")]
            ApiOnly = 9,
            
            /// <summary>
            /// Enum SystemWideApi for value: SystemWideApi
            /// </summary>
            [EnumMember(Value = "SystemWideApi")]
            SystemWideApi = 10
        }

        /// <summary>
        /// Gets or Sets ControlPanelAuthorityType
        /// </summary>
        [DataMember(Name="ControlPanelAuthorityType", EmitDefaultValue=false)]
        public ControlPanelAuthorityTypeEnum? ControlPanelAuthorityType { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="UserDetailsRequestModel" /> class.
        /// </summary>
        /// <param name="prontoIDs">prontoIDs.</param>
        /// <param name="iDs">iDs.</param>
        /// <param name="usernames">usernames.</param>
        /// <param name="emailAddresses">emailAddresses.</param>
        /// <param name="isLockedOut">isLockedOut.</param>
        /// <param name="isExpired">isExpired.</param>
        /// <param name="signingAuthorityType">signingAuthorityType.</param>
        /// <param name="controlPanelAuthorityType">controlPanelAuthorityType.</param>
        /// <param name="enableLogging">enableLogging.</param>
        /// <param name="resultsCountLimit">resultsCountLimit.</param>
        /// <param name="resultsCountStart">resultsCountStart.</param>
        /// <param name="federationUsernames">federationUsernames.</param>
        public UserDetailsRequestModel(List<Object> prontoIDs = default(List<Object>), List<Object> iDs = default(List<Object>), List<Object> usernames = default(List<Object>), List<Object> emailAddresses = default(List<Object>), bool? isLockedOut = default(bool?), bool? isExpired = default(bool?), SigningAuthorityTypeEnum? signingAuthorityType = default(SigningAuthorityTypeEnum?), ControlPanelAuthorityTypeEnum? controlPanelAuthorityType = default(ControlPanelAuthorityTypeEnum?), bool? enableLogging = default(bool?), int? resultsCountLimit = default(int?), int? resultsCountStart = default(int?), List<Object> federationUsernames = default(List<Object>))
        {
            this.ProntoIDs = prontoIDs;
            this.IDs = iDs;
            this.Usernames = usernames;
            this.EmailAddresses = emailAddresses;
            this.IsLockedOut = isLockedOut;
            this.IsExpired = isExpired;
            this.SigningAuthorityType = signingAuthorityType;
            this.ControlPanelAuthorityType = controlPanelAuthorityType;
            this.EnableLogging = enableLogging;
            this.ResultsCountLimit = resultsCountLimit;
            this.ResultsCountStart = resultsCountStart;
            this.FederationUsernames = federationUsernames;
        }
        
        /// <summary>
        /// Gets or Sets ProntoIDs
        /// </summary>
        [DataMember(Name="ProntoIDs", EmitDefaultValue=false)]
        public List<Object> ProntoIDs { get; set; }

        /// <summary>
        /// Gets or Sets IDs
        /// </summary>
        [DataMember(Name="IDs", EmitDefaultValue=false)]
        public List<Object> IDs { get; set; }

        /// <summary>
        /// Gets or Sets Usernames
        /// </summary>
        [DataMember(Name="Usernames", EmitDefaultValue=false)]
        public List<Object> Usernames { get; set; }

        /// <summary>
        /// Gets or Sets EmailAddresses
        /// </summary>
        [DataMember(Name="EmailAddresses", EmitDefaultValue=false)]
        public List<Object> EmailAddresses { get; set; }

        /// <summary>
        /// Gets or Sets IsLockedOut
        /// </summary>
        [DataMember(Name="IsLockedOut", EmitDefaultValue=false)]
        public bool? IsLockedOut { get; set; }

        /// <summary>
        /// Gets or Sets IsExpired
        /// </summary>
        [DataMember(Name="IsExpired", EmitDefaultValue=false)]
        public bool? IsExpired { get; set; }



        /// <summary>
        /// Gets or Sets EnableLogging
        /// </summary>
        [DataMember(Name="EnableLogging", EmitDefaultValue=false)]
        public bool? EnableLogging { get; set; }

        /// <summary>
        /// Gets or Sets ResultsCountLimit
        /// </summary>
        [DataMember(Name="ResultsCountLimit", EmitDefaultValue=false)]
        public int? ResultsCountLimit { get; set; }

        /// <summary>
        /// Gets or Sets ResultsCountStart
        /// </summary>
        [DataMember(Name="ResultsCountStart", EmitDefaultValue=false)]
        public int? ResultsCountStart { get; set; }

        /// <summary>
        /// Gets or Sets FederationUsernames
        /// </summary>
        [DataMember(Name="FederationUsernames", EmitDefaultValue=false)]
        public List<Object> FederationUsernames { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class UserDetailsRequestModel {\n");
            sb.Append("  ProntoIDs: ").Append(ProntoIDs).Append("\n");
            sb.Append("  IDs: ").Append(IDs).Append("\n");
            sb.Append("  Usernames: ").Append(Usernames).Append("\n");
            sb.Append("  EmailAddresses: ").Append(EmailAddresses).Append("\n");
            sb.Append("  IsLockedOut: ").Append(IsLockedOut).Append("\n");
            sb.Append("  IsExpired: ").Append(IsExpired).Append("\n");
            sb.Append("  SigningAuthorityType: ").Append(SigningAuthorityType).Append("\n");
            sb.Append("  ControlPanelAuthorityType: ").Append(ControlPanelAuthorityType).Append("\n");
            sb.Append("  EnableLogging: ").Append(EnableLogging).Append("\n");
            sb.Append("  ResultsCountLimit: ").Append(ResultsCountLimit).Append("\n");
            sb.Append("  ResultsCountStart: ").Append(ResultsCountStart).Append("\n");
            sb.Append("  FederationUsernames: ").Append(FederationUsernames).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as UserDetailsRequestModel);
        }

        /// <summary>
        /// Returns true if UserDetailsRequestModel instances are equal
        /// </summary>
        /// <param name="input">Instance of UserDetailsRequestModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(UserDetailsRequestModel input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ProntoIDs == input.ProntoIDs ||
                    this.ProntoIDs != null &&
                    this.ProntoIDs.SequenceEqual(input.ProntoIDs)
                ) && 
                (
                    this.IDs == input.IDs ||
                    this.IDs != null &&
                    this.IDs.SequenceEqual(input.IDs)
                ) && 
                (
                    this.Usernames == input.Usernames ||
                    this.Usernames != null &&
                    this.Usernames.SequenceEqual(input.Usernames)
                ) && 
                (
                    this.EmailAddresses == input.EmailAddresses ||
                    this.EmailAddresses != null &&
                    this.EmailAddresses.SequenceEqual(input.EmailAddresses)
                ) && 
                (
                    this.IsLockedOut == input.IsLockedOut ||
                    (this.IsLockedOut != null &&
                    this.IsLockedOut.Equals(input.IsLockedOut))
                ) && 
                (
                    this.IsExpired == input.IsExpired ||
                    (this.IsExpired != null &&
                    this.IsExpired.Equals(input.IsExpired))
                ) && 
                (
                    this.SigningAuthorityType == input.SigningAuthorityType ||
                    (this.SigningAuthorityType != null &&
                    this.SigningAuthorityType.Equals(input.SigningAuthorityType))
                ) && 
                (
                    this.ControlPanelAuthorityType == input.ControlPanelAuthorityType ||
                    (this.ControlPanelAuthorityType != null &&
                    this.ControlPanelAuthorityType.Equals(input.ControlPanelAuthorityType))
                ) && 
                (
                    this.EnableLogging == input.EnableLogging ||
                    (this.EnableLogging != null &&
                    this.EnableLogging.Equals(input.EnableLogging))
                ) && 
                (
                    this.ResultsCountLimit == input.ResultsCountLimit ||
                    (this.ResultsCountLimit != null &&
                    this.ResultsCountLimit.Equals(input.ResultsCountLimit))
                ) && 
                (
                    this.ResultsCountStart == input.ResultsCountStart ||
                    (this.ResultsCountStart != null &&
                    this.ResultsCountStart.Equals(input.ResultsCountStart))
                ) && 
                (
                    this.FederationUsernames == input.FederationUsernames ||
                    this.FederationUsernames != null &&
                    this.FederationUsernames.SequenceEqual(input.FederationUsernames)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ProntoIDs != null)
                    hashCode = hashCode * 59 + this.ProntoIDs.GetHashCode();
                if (this.IDs != null)
                    hashCode = hashCode * 59 + this.IDs.GetHashCode();
                if (this.Usernames != null)
                    hashCode = hashCode * 59 + this.Usernames.GetHashCode();
                if (this.EmailAddresses != null)
                    hashCode = hashCode * 59 + this.EmailAddresses.GetHashCode();
                if (this.IsLockedOut != null)
                    hashCode = hashCode * 59 + this.IsLockedOut.GetHashCode();
                if (this.IsExpired != null)
                    hashCode = hashCode * 59 + this.IsExpired.GetHashCode();
                if (this.SigningAuthorityType != null)
                    hashCode = hashCode * 59 + this.SigningAuthorityType.GetHashCode();
                if (this.ControlPanelAuthorityType != null)
                    hashCode = hashCode * 59 + this.ControlPanelAuthorityType.GetHashCode();
                if (this.EnableLogging != null)
                    hashCode = hashCode * 59 + this.EnableLogging.GetHashCode();
                if (this.ResultsCountLimit != null)
                    hashCode = hashCode * 59 + this.ResultsCountLimit.GetHashCode();
                if (this.ResultsCountStart != null)
                    hashCode = hashCode * 59 + this.ResultsCountStart.GetHashCode();
                if (this.FederationUsernames != null)
                    hashCode = hashCode * 59 + this.FederationUsernames.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
