/* 
 * API Version: 5.0
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v5
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// UserInsertModel
    /// </summary>
    [DataContract]
    public partial class UserInsertModel :  IEquatable<UserInsertModel>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="UserInsertModel" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected UserInsertModel() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="UserInsertModel" /> class.
        /// </summary>
        /// <param name="prontoID">prontoID (required).</param>
        /// <param name="username">username (required).</param>
        /// <param name="firstName">firstName (required).</param>
        /// <param name="lastName">lastName (required).</param>
        /// <param name="emailAddress">emailAddress (required).</param>
        /// <param name="securityQuestion">securityQuestion.</param>
        /// <param name="securityAnswer">securityAnswer.</param>
        /// <param name="title">title.</param>
        /// <param name="organization">organization.</param>
        /// <param name="signatureImage">signatureImage.</param>
        /// <param name="federatedUsername">federatedUsername.</param>
        /// <param name="requirePasswordChangeOnFirstUse">requirePasswordChangeOnFirstUse.</param>
        /// <param name="password">password (required).</param>
        /// <param name="isLockedOut">isLockedOut.</param>
        /// <param name="isExpired">isExpired.</param>
        /// <param name="passwordChangeInDays">passwordChangeInDays.</param>
        /// <param name="permissions">permissions.</param>
        /// <param name="middleName">middleName.</param>
        /// <param name="suffix">suffix.</param>
        public UserInsertModel(string prontoID = default(string), string username = default(string), string firstName = default(string), string lastName = default(string), string emailAddress = default(string), string securityQuestion = default(string), string securityAnswer = default(string), string title = default(string), string organization = default(string), byte[] signatureImage = default(byte[]), string federatedUsername = default(string), bool? requirePasswordChangeOnFirstUse = default(bool?), string password = default(string), bool? isLockedOut = default(bool?), bool? isExpired = default(bool?), int? passwordChangeInDays = default(int?), List<Object> permissions = default(List<Object>), string middleName = default(string), string suffix = default(string))
        {
            // to ensure "prontoID" is required (not null)
            if (prontoID == null)
            {
                throw new InvalidDataException("prontoID is a required property for UserInsertModel and cannot be null");
            }
            else
            {
                this.ProntoID = prontoID;
            }
            // to ensure "username" is required (not null)
            if (username == null)
            {
                throw new InvalidDataException("username is a required property for UserInsertModel and cannot be null");
            }
            else
            {
                this.Username = username;
            }
            // to ensure "firstName" is required (not null)
            if (firstName == null)
            {
                throw new InvalidDataException("firstName is a required property for UserInsertModel and cannot be null");
            }
            else
            {
                this.FirstName = firstName;
            }
            // to ensure "lastName" is required (not null)
            if (lastName == null)
            {
                throw new InvalidDataException("lastName is a required property for UserInsertModel and cannot be null");
            }
            else
            {
                this.LastName = lastName;
            }
            // to ensure "emailAddress" is required (not null)
            if (emailAddress == null)
            {
                throw new InvalidDataException("emailAddress is a required property for UserInsertModel and cannot be null");
            }
            else
            {
                this.EmailAddress = emailAddress;
            }
            // to ensure "password" is required (not null)
            if (password == null)
            {
                throw new InvalidDataException("password is a required property for UserInsertModel and cannot be null");
            }
            else
            {
                this.Password = password;
            }
            this.SecurityQuestion = securityQuestion;
            this.SecurityAnswer = securityAnswer;
            this.Title = title;
            this.Organization = organization;
            this.SignatureImage = signatureImage;
            this.FederatedUsername = federatedUsername;
            this.RequirePasswordChangeOnFirstUse = requirePasswordChangeOnFirstUse;
            this.IsLockedOut = isLockedOut;
            this.IsExpired = isExpired;
            this.PasswordChangeInDays = passwordChangeInDays;
            this.Permissions = permissions;
            this.MiddleName = middleName;
            this.Suffix = suffix;
        }
        
        /// <summary>
        /// Gets or Sets ProntoID
        /// </summary>
        [DataMember(Name="ProntoID", EmitDefaultValue=false)]
        public string ProntoID { get; set; }

        /// <summary>
        /// Gets or Sets Username
        /// </summary>
        [DataMember(Name="Username", EmitDefaultValue=false)]
        public string Username { get; set; }

        /// <summary>
        /// Gets or Sets FirstName
        /// </summary>
        [DataMember(Name="FirstName", EmitDefaultValue=false)]
        public string FirstName { get; set; }

        /// <summary>
        /// Gets or Sets LastName
        /// </summary>
        [DataMember(Name="LastName", EmitDefaultValue=false)]
        public string LastName { get; set; }

        /// <summary>
        /// Gets or Sets EmailAddress
        /// </summary>
        [DataMember(Name="EmailAddress", EmitDefaultValue=false)]
        public string EmailAddress { get; set; }

        /// <summary>
        /// Gets or Sets SecurityQuestion
        /// </summary>
        [DataMember(Name="SecurityQuestion", EmitDefaultValue=false)]
        public string SecurityQuestion { get; set; }

        /// <summary>
        /// Gets or Sets SecurityAnswer
        /// </summary>
        [DataMember(Name="SecurityAnswer", EmitDefaultValue=false)]
        public string SecurityAnswer { get; set; }

        /// <summary>
        /// Gets or Sets Title
        /// </summary>
        [DataMember(Name="Title", EmitDefaultValue=false)]
        public string Title { get; set; }

        /// <summary>
        /// Gets or Sets Organization
        /// </summary>
        [DataMember(Name="Organization", EmitDefaultValue=false)]
        public string Organization { get; set; }

        /// <summary>
        /// Gets or Sets SignatureImage
        /// </summary>
        [DataMember(Name="SignatureImage", EmitDefaultValue=false)]
        public byte[] SignatureImage { get; set; }

        /// <summary>
        /// Gets or Sets FederatedUsername
        /// </summary>
        [DataMember(Name="FederatedUsername", EmitDefaultValue=false)]
        public string FederatedUsername { get; set; }

        /// <summary>
        /// Gets or Sets RequirePasswordChangeOnFirstUse
        /// </summary>
        [DataMember(Name="RequirePasswordChangeOnFirstUse", EmitDefaultValue=false)]
        public bool? RequirePasswordChangeOnFirstUse { get; set; }

        /// <summary>
        /// Gets or Sets Password
        /// </summary>
        [DataMember(Name="Password", EmitDefaultValue=false)]
        public string Password { get; set; }

        /// <summary>
        /// Gets or Sets IsLockedOut
        /// </summary>
        [DataMember(Name="IsLockedOut", EmitDefaultValue=false)]
        public bool? IsLockedOut { get; set; }

        /// <summary>
        /// Gets or Sets IsExpired
        /// </summary>
        [DataMember(Name="IsExpired", EmitDefaultValue=false)]
        public bool? IsExpired { get; set; }

        /// <summary>
        /// Gets or Sets PasswordChangeInDays
        /// </summary>
        [DataMember(Name="PasswordChangeInDays", EmitDefaultValue=false)]
        public int? PasswordChangeInDays { get; set; }

        /// <summary>
        /// Gets or Sets Permissions
        /// </summary>
        [DataMember(Name="Permissions", EmitDefaultValue=false)]
        public List<Object> Permissions { get; set; }

        /// <summary>
        /// Gets or Sets MiddleName
        /// </summary>
        [DataMember(Name="MiddleName", EmitDefaultValue=false)]
        public string MiddleName { get; set; }

        /// <summary>
        /// Gets or Sets Suffix
        /// </summary>
        [DataMember(Name="Suffix", EmitDefaultValue=false)]
        public string Suffix { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class UserInsertModel {\n");
            sb.Append("  ProntoID: ").Append(ProntoID).Append("\n");
            sb.Append("  Username: ").Append(Username).Append("\n");
            sb.Append("  FirstName: ").Append(FirstName).Append("\n");
            sb.Append("  LastName: ").Append(LastName).Append("\n");
            sb.Append("  EmailAddress: ").Append(EmailAddress).Append("\n");
            sb.Append("  SecurityQuestion: ").Append(SecurityQuestion).Append("\n");
            sb.Append("  SecurityAnswer: ").Append(SecurityAnswer).Append("\n");
            sb.Append("  Title: ").Append(Title).Append("\n");
            sb.Append("  Organization: ").Append(Organization).Append("\n");
            sb.Append("  SignatureImage: ").Append(SignatureImage).Append("\n");
            sb.Append("  FederatedUsername: ").Append(FederatedUsername).Append("\n");
            sb.Append("  RequirePasswordChangeOnFirstUse: ").Append(RequirePasswordChangeOnFirstUse).Append("\n");
            sb.Append("  Password: ").Append(Password).Append("\n");
            sb.Append("  IsLockedOut: ").Append(IsLockedOut).Append("\n");
            sb.Append("  IsExpired: ").Append(IsExpired).Append("\n");
            sb.Append("  PasswordChangeInDays: ").Append(PasswordChangeInDays).Append("\n");
            sb.Append("  Permissions: ").Append(Permissions).Append("\n");
            sb.Append("  MiddleName: ").Append(MiddleName).Append("\n");
            sb.Append("  Suffix: ").Append(Suffix).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as UserInsertModel);
        }

        /// <summary>
        /// Returns true if UserInsertModel instances are equal
        /// </summary>
        /// <param name="input">Instance of UserInsertModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(UserInsertModel input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ProntoID == input.ProntoID ||
                    (this.ProntoID != null &&
                    this.ProntoID.Equals(input.ProntoID))
                ) && 
                (
                    this.Username == input.Username ||
                    (this.Username != null &&
                    this.Username.Equals(input.Username))
                ) && 
                (
                    this.FirstName == input.FirstName ||
                    (this.FirstName != null &&
                    this.FirstName.Equals(input.FirstName))
                ) && 
                (
                    this.LastName == input.LastName ||
                    (this.LastName != null &&
                    this.LastName.Equals(input.LastName))
                ) && 
                (
                    this.EmailAddress == input.EmailAddress ||
                    (this.EmailAddress != null &&
                    this.EmailAddress.Equals(input.EmailAddress))
                ) && 
                (
                    this.SecurityQuestion == input.SecurityQuestion ||
                    (this.SecurityQuestion != null &&
                    this.SecurityQuestion.Equals(input.SecurityQuestion))
                ) && 
                (
                    this.SecurityAnswer == input.SecurityAnswer ||
                    (this.SecurityAnswer != null &&
                    this.SecurityAnswer.Equals(input.SecurityAnswer))
                ) && 
                (
                    this.Title == input.Title ||
                    (this.Title != null &&
                    this.Title.Equals(input.Title))
                ) && 
                (
                    this.Organization == input.Organization ||
                    (this.Organization != null &&
                    this.Organization.Equals(input.Organization))
                ) && 
                (
                    this.SignatureImage == input.SignatureImage ||
                    (this.SignatureImage != null &&
                    this.SignatureImage.Equals(input.SignatureImage))
                ) && 
                (
                    this.FederatedUsername == input.FederatedUsername ||
                    (this.FederatedUsername != null &&
                    this.FederatedUsername.Equals(input.FederatedUsername))
                ) && 
                (
                    this.RequirePasswordChangeOnFirstUse == input.RequirePasswordChangeOnFirstUse ||
                    (this.RequirePasswordChangeOnFirstUse != null &&
                    this.RequirePasswordChangeOnFirstUse.Equals(input.RequirePasswordChangeOnFirstUse))
                ) && 
                (
                    this.Password == input.Password ||
                    (this.Password != null &&
                    this.Password.Equals(input.Password))
                ) && 
                (
                    this.IsLockedOut == input.IsLockedOut ||
                    (this.IsLockedOut != null &&
                    this.IsLockedOut.Equals(input.IsLockedOut))
                ) && 
                (
                    this.IsExpired == input.IsExpired ||
                    (this.IsExpired != null &&
                    this.IsExpired.Equals(input.IsExpired))
                ) && 
                (
                    this.PasswordChangeInDays == input.PasswordChangeInDays ||
                    (this.PasswordChangeInDays != null &&
                    this.PasswordChangeInDays.Equals(input.PasswordChangeInDays))
                ) && 
                (
                    this.Permissions == input.Permissions ||
                    this.Permissions != null &&
                    this.Permissions.SequenceEqual(input.Permissions)
                ) && 
                (
                    this.MiddleName == input.MiddleName ||
                    (this.MiddleName != null &&
                    this.MiddleName.Equals(input.MiddleName))
                ) && 
                (
                    this.Suffix == input.Suffix ||
                    (this.Suffix != null &&
                    this.Suffix.Equals(input.Suffix))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ProntoID != null)
                    hashCode = hashCode * 59 + this.ProntoID.GetHashCode();
                if (this.Username != null)
                    hashCode = hashCode * 59 + this.Username.GetHashCode();
                if (this.FirstName != null)
                    hashCode = hashCode * 59 + this.FirstName.GetHashCode();
                if (this.LastName != null)
                    hashCode = hashCode * 59 + this.LastName.GetHashCode();
                if (this.EmailAddress != null)
                    hashCode = hashCode * 59 + this.EmailAddress.GetHashCode();
                if (this.SecurityQuestion != null)
                    hashCode = hashCode * 59 + this.SecurityQuestion.GetHashCode();
                if (this.SecurityAnswer != null)
                    hashCode = hashCode * 59 + this.SecurityAnswer.GetHashCode();
                if (this.Title != null)
                    hashCode = hashCode * 59 + this.Title.GetHashCode();
                if (this.Organization != null)
                    hashCode = hashCode * 59 + this.Organization.GetHashCode();
                if (this.SignatureImage != null)
                    hashCode = hashCode * 59 + this.SignatureImage.GetHashCode();
                if (this.FederatedUsername != null)
                    hashCode = hashCode * 59 + this.FederatedUsername.GetHashCode();
                if (this.RequirePasswordChangeOnFirstUse != null)
                    hashCode = hashCode * 59 + this.RequirePasswordChangeOnFirstUse.GetHashCode();
                if (this.Password != null)
                    hashCode = hashCode * 59 + this.Password.GetHashCode();
                if (this.IsLockedOut != null)
                    hashCode = hashCode * 59 + this.IsLockedOut.GetHashCode();
                if (this.IsExpired != null)
                    hashCode = hashCode * 59 + this.IsExpired.GetHashCode();
                if (this.PasswordChangeInDays != null)
                    hashCode = hashCode * 59 + this.PasswordChangeInDays.GetHashCode();
                if (this.Permissions != null)
                    hashCode = hashCode * 59 + this.Permissions.GetHashCode();
                if (this.MiddleName != null)
                    hashCode = hashCode * 59 + this.MiddleName.GetHashCode();
                if (this.Suffix != null)
                    hashCode = hashCode * 59 + this.Suffix.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // ProntoID (string) maxLength
            if(this.ProntoID != null && this.ProntoID.Length > 64)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for ProntoID, length must be less than 64.", new [] { "ProntoID" });
            }

            // ProntoID (string) minLength
            if(this.ProntoID != null && this.ProntoID.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for ProntoID, length must be greater than 0.", new [] { "ProntoID" });
            }

            // Username (string) maxLength
            if(this.Username != null && this.Username.Length > 63)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Username, length must be less than 63.", new [] { "Username" });
            }

            // Username (string) minLength
            if(this.Username != null && this.Username.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Username, length must be greater than 0.", new [] { "Username" });
            }

            // FirstName (string) maxLength
            if(this.FirstName != null && this.FirstName.Length > 16)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for FirstName, length must be less than 16.", new [] { "FirstName" });
            }

            // FirstName (string) minLength
            if(this.FirstName != null && this.FirstName.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for FirstName, length must be greater than 0.", new [] { "FirstName" });
            }

            // LastName (string) maxLength
            if(this.LastName != null && this.LastName.Length > 30)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for LastName, length must be less than 30.", new [] { "LastName" });
            }

            // LastName (string) minLength
            if(this.LastName != null && this.LastName.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for LastName, length must be greater than 0.", new [] { "LastName" });
            }

            // EmailAddress (string) maxLength
            if(this.EmailAddress != null && this.EmailAddress.Length > 128)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for EmailAddress, length must be less than 128.", new [] { "EmailAddress" });
            }

            // EmailAddress (string) minLength
            if(this.EmailAddress != null && this.EmailAddress.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for EmailAddress, length must be greater than 0.", new [] { "EmailAddress" });
            }

            // EmailAddress (string) pattern
            Regex regexEmailAddress = new Regex(@"^(?![.])([^@,<>\\^]+@[^\\s<>,\\^]+\\.[^\\s<>,\\^]+)$", RegexOptions.CultureInvariant);
            if (false == regexEmailAddress.Match(this.EmailAddress).Success)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for EmailAddress, must match a pattern of " + regexEmailAddress, new [] { "EmailAddress" });
            }

            // SecurityQuestion (string) maxLength
            if(this.SecurityQuestion != null && this.SecurityQuestion.Length > 256)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for SecurityQuestion, length must be less than 256.", new [] { "SecurityQuestion" });
            }

            // SecurityQuestion (string) minLength
            if(this.SecurityQuestion != null && this.SecurityQuestion.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for SecurityQuestion, length must be greater than 0.", new [] { "SecurityQuestion" });
            }

            // SecurityAnswer (string) maxLength
            if(this.SecurityAnswer != null && this.SecurityAnswer.Length > 256)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for SecurityAnswer, length must be less than 256.", new [] { "SecurityAnswer" });
            }

            // SecurityAnswer (string) minLength
            if(this.SecurityAnswer != null && this.SecurityAnswer.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for SecurityAnswer, length must be greater than 0.", new [] { "SecurityAnswer" });
            }

            // Title (string) maxLength
            if(this.Title != null && this.Title.Length > 64)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Title, length must be less than 64.", new [] { "Title" });
            }

            // Title (string) minLength
            if(this.Title != null && this.Title.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Title, length must be greater than 0.", new [] { "Title" });
            }

            // Organization (string) maxLength
            if(this.Organization != null && this.Organization.Length > 64)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Organization, length must be less than 64.", new [] { "Organization" });
            }

            // Organization (string) minLength
            if(this.Organization != null && this.Organization.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Organization, length must be greater than 0.", new [] { "Organization" });
            }

            // FederatedUsername (string) maxLength
            if(this.FederatedUsername != null && this.FederatedUsername.Length > 150)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for FederatedUsername, length must be less than 150.", new [] { "FederatedUsername" });
            }

            // FederatedUsername (string) minLength
            if(this.FederatedUsername != null && this.FederatedUsername.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for FederatedUsername, length must be greater than 0.", new [] { "FederatedUsername" });
            }

            // Password (string) maxLength
            if(this.Password != null && this.Password.Length > 128)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Password, length must be less than 128.", new [] { "Password" });
            }

            // Password (string) minLength
            if(this.Password != null && this.Password.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Password, length must be greater than 0.", new [] { "Password" });
            }

            // MiddleName (string) maxLength
            if(this.MiddleName != null && this.MiddleName.Length > 16)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for MiddleName, length must be less than 16.", new [] { "MiddleName" });
            }

            // MiddleName (string) minLength
            if(this.MiddleName != null && this.MiddleName.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for MiddleName, length must be greater than 0.", new [] { "MiddleName" });
            }

            yield break;
        }
    }

}
