/* 
 * API Version: 5.0
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v5
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// UserPermissionInsertModel
    /// </summary>
    [DataContract]
    public partial class UserPermissionInsertModel :  IEquatable<UserPermissionInsertModel>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="UserPermissionInsertModel" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected UserPermissionInsertModel() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="UserPermissionInsertModel" /> class.
        /// </summary>
        /// <param name="prontoID">prontoID (required).</param>
        /// <param name="permissionSetID">permissionSetID (required).</param>
        /// <param name="allowSigning">allowSigning.</param>
        /// <param name="allowOpenSigning">allowOpenSigning.</param>
        /// <param name="allowOpenSigningQueue">allowOpenSigningQueue.</param>
        public UserPermissionInsertModel(string prontoID = default(string), int? permissionSetID = default(int?), bool? allowSigning = default(bool?), bool? allowOpenSigning = default(bool?), bool? allowOpenSigningQueue = default(bool?))
        {
            // to ensure "prontoID" is required (not null)
            if (prontoID == null)
            {
                throw new InvalidDataException("prontoID is a required property for UserPermissionInsertModel and cannot be null");
            }
            else
            {
                this.ProntoID = prontoID;
            }
            // to ensure "permissionSetID" is required (not null)
            if (permissionSetID == null)
            {
                throw new InvalidDataException("permissionSetID is a required property for UserPermissionInsertModel and cannot be null");
            }
            else
            {
                this.PermissionSetID = permissionSetID;
            }
            this.AllowSigning = allowSigning;
            this.AllowOpenSigning = allowOpenSigning;
            this.AllowOpenSigningQueue = allowOpenSigningQueue;
        }
        
        /// <summary>
        /// Gets or Sets ProntoID
        /// </summary>
        [DataMember(Name="ProntoID", EmitDefaultValue=false)]
        public string ProntoID { get; set; }

        /// <summary>
        /// Gets or Sets PermissionSetID
        /// </summary>
        [DataMember(Name="PermissionSetID", EmitDefaultValue=false)]
        public int? PermissionSetID { get; set; }

        /// <summary>
        /// Gets or Sets AllowSigning
        /// </summary>
        [DataMember(Name="AllowSigning", EmitDefaultValue=false)]
        public bool? AllowSigning { get; set; }

        /// <summary>
        /// Gets or Sets AllowOpenSigning
        /// </summary>
        [DataMember(Name="AllowOpenSigning", EmitDefaultValue=false)]
        public bool? AllowOpenSigning { get; set; }

        /// <summary>
        /// Gets or Sets AllowOpenSigningQueue
        /// </summary>
        [DataMember(Name="AllowOpenSigningQueue", EmitDefaultValue=false)]
        public bool? AllowOpenSigningQueue { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class UserPermissionInsertModel {\n");
            sb.Append("  ProntoID: ").Append(ProntoID).Append("\n");
            sb.Append("  PermissionSetID: ").Append(PermissionSetID).Append("\n");
            sb.Append("  AllowSigning: ").Append(AllowSigning).Append("\n");
            sb.Append("  AllowOpenSigning: ").Append(AllowOpenSigning).Append("\n");
            sb.Append("  AllowOpenSigningQueue: ").Append(AllowOpenSigningQueue).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as UserPermissionInsertModel);
        }

        /// <summary>
        /// Returns true if UserPermissionInsertModel instances are equal
        /// </summary>
        /// <param name="input">Instance of UserPermissionInsertModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(UserPermissionInsertModel input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ProntoID == input.ProntoID ||
                    (this.ProntoID != null &&
                    this.ProntoID.Equals(input.ProntoID))
                ) && 
                (
                    this.PermissionSetID == input.PermissionSetID ||
                    (this.PermissionSetID != null &&
                    this.PermissionSetID.Equals(input.PermissionSetID))
                ) && 
                (
                    this.AllowSigning == input.AllowSigning ||
                    (this.AllowSigning != null &&
                    this.AllowSigning.Equals(input.AllowSigning))
                ) && 
                (
                    this.AllowOpenSigning == input.AllowOpenSigning ||
                    (this.AllowOpenSigning != null &&
                    this.AllowOpenSigning.Equals(input.AllowOpenSigning))
                ) && 
                (
                    this.AllowOpenSigningQueue == input.AllowOpenSigningQueue ||
                    (this.AllowOpenSigningQueue != null &&
                    this.AllowOpenSigningQueue.Equals(input.AllowOpenSigningQueue))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ProntoID != null)
                    hashCode = hashCode * 59 + this.ProntoID.GetHashCode();
                if (this.PermissionSetID != null)
                    hashCode = hashCode * 59 + this.PermissionSetID.GetHashCode();
                if (this.AllowSigning != null)
                    hashCode = hashCode * 59 + this.AllowSigning.GetHashCode();
                if (this.AllowOpenSigning != null)
                    hashCode = hashCode * 59 + this.AllowOpenSigning.GetHashCode();
                if (this.AllowOpenSigningQueue != null)
                    hashCode = hashCode * 59 + this.AllowOpenSigningQueue.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // ProntoID (string) maxLength
            if(this.ProntoID != null && this.ProntoID.Length > 64)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for ProntoID, length must be less than 64.", new [] { "ProntoID" });
            }

            // ProntoID (string) minLength
            if(this.ProntoID != null && this.ProntoID.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for ProntoID, length must be greater than 0.", new [] { "ProntoID" });
            }

            yield break;
        }
    }

}
