/* 
 * API Version: 5.0
 *
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: v5
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = IO.Swagger.Client.SwaggerDateConverter;

namespace IO.Swagger.Model
{
    /// <summary>
    /// UserUpdateModel
    /// </summary>
    [DataContract]
    public partial class UserUpdateModel :  IEquatable<UserUpdateModel>, IValidatableObject
    {
        /// <summary>
        /// Defines SigningAuthorityType
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum SigningAuthorityTypeEnum
        {
            
            /// <summary>
            /// Enum DirectlyAssignedInThisGroupOnly for value: DirectlyAssignedInThisGroupOnly
            /// </summary>
            [EnumMember(Value = "DirectlyAssignedInThisGroupOnly")]
            DirectlyAssignedInThisGroupOnly = 1,
            
            /// <summary>
            /// Enum DirectlyAssignedInAllGroups for value: DirectlyAssignedInAllGroups
            /// </summary>
            [EnumMember(Value = "DirectlyAssignedInAllGroups")]
            DirectlyAssignedInAllGroups = 2,
            
            /// <summary>
            /// Enum ThisGroupOnly for value: ThisGroupOnly
            /// </summary>
            [EnumMember(Value = "ThisGroupOnly")]
            ThisGroupOnly = 3,
            
            /// <summary>
            /// Enum AllGroups for value: AllGroups
            /// </summary>
            [EnumMember(Value = "AllGroups")]
            AllGroups = 4,
            
            /// <summary>
            /// Enum SystemWide for value: SystemWide
            /// </summary>
            [EnumMember(Value = "SystemWide")]
            SystemWide = 5,
            
            /// <summary>
            /// Enum NotAllowed for value: NotAllowed
            /// </summary>
            [EnumMember(Value = "NotAllowed")]
            NotAllowed = 6
        }

        /// <summary>
        /// Gets or Sets SigningAuthorityType
        /// </summary>
        [DataMember(Name="SigningAuthorityType", EmitDefaultValue=false)]
        public SigningAuthorityTypeEnum SigningAuthorityType { get; set; }
        /// <summary>
        /// Defines ControlPanelAuthorityType
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum ControlPanelAuthorityTypeEnum
        {
            
            /// <summary>
            /// Enum SigningOnly for value: SigningOnly
            /// </summary>
            [EnumMember(Value = "SigningOnly")]
            SigningOnly = 1,
            
            /// <summary>
            /// Enum GroupUser for value: GroupUser
            /// </summary>
            [EnumMember(Value = "GroupUser")]
            GroupUser = 2,
            
            /// <summary>
            /// Enum AccountWideUser for value: AccountWideUser
            /// </summary>
            [EnumMember(Value = "AccountWideUser")]
            AccountWideUser = 3,
            
            /// <summary>
            /// Enum GroupManager for value: GroupManager
            /// </summary>
            [EnumMember(Value = "GroupManager")]
            GroupManager = 4,
            
            /// <summary>
            /// Enum AccountWideManager for value: AccountWideManager
            /// </summary>
            [EnumMember(Value = "AccountWideManager")]
            AccountWideManager = 5,
            
            /// <summary>
            /// Enum GroupAdmin for value: GroupAdmin
            /// </summary>
            [EnumMember(Value = "GroupAdmin")]
            GroupAdmin = 6,
            
            /// <summary>
            /// Enum AccountWideAdmin for value: AccountWideAdmin
            /// </summary>
            [EnumMember(Value = "AccountWideAdmin")]
            AccountWideAdmin = 7,
            
            /// <summary>
            /// Enum SystemWideAdmin for value: SystemWideAdmin
            /// </summary>
            [EnumMember(Value = "SystemWideAdmin")]
            SystemWideAdmin = 8,
            
            /// <summary>
            /// Enum ApiOnly for value: ApiOnly
            /// </summary>
            [EnumMember(Value = "ApiOnly")]
            ApiOnly = 9,
            
            /// <summary>
            /// Enum SystemWideApi for value: SystemWideApi
            /// </summary>
            [EnumMember(Value = "SystemWideApi")]
            SystemWideApi = 10
        }

        /// <summary>
        /// Gets or Sets ControlPanelAuthorityType
        /// </summary>
        [DataMember(Name="ControlPanelAuthorityType", EmitDefaultValue=false)]
        public ControlPanelAuthorityTypeEnum ControlPanelAuthorityType { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="UserUpdateModel" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected UserUpdateModel() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="UserUpdateModel" /> class.
        /// </summary>
        /// <param name="iD">iD (required).</param>
        /// <param name="prontoID">prontoID (required).</param>
        /// <param name="username">username (required).</param>
        /// <param name="signingAuthorityType">signingAuthorityType (required).</param>
        /// <param name="firstName">firstName (required).</param>
        /// <param name="lastName">lastName (required).</param>
        /// <param name="emailAddress">emailAddress (required).</param>
        /// <param name="securityQuestion">securityQuestion (required).</param>
        /// <param name="securityAnswer">securityAnswer (required).</param>
        /// <param name="title">title.</param>
        /// <param name="organization">organization.</param>
        /// <param name="signatureImage">signatureImage.</param>
        /// <param name="controlPanelAuthorityType">controlPanelAuthorityType (required).</param>
        /// <param name="viewUnassignedRegUserTransactions">viewUnassignedRegUserTransactions.</param>
        /// <param name="federatedUsername">federatedUsername.</param>
        /// <param name="requirePasswordChangeOnFirstUse">requirePasswordChangeOnFirstUse.</param>
        /// <param name="password">password.</param>
        /// <param name="isLockedOut">isLockedOut.</param>
        /// <param name="isExpired">isExpired.</param>
        /// <param name="passwordChangeInDays">passwordChangeInDays.</param>
        /// <param name="permissions">permissions.</param>
        public UserUpdateModel(int? iD = default(int?), string prontoID = default(string), string username = default(string), SigningAuthorityTypeEnum signingAuthorityType = default(SigningAuthorityTypeEnum), string firstName = default(string), string lastName = default(string), string emailAddress = default(string), string securityQuestion = default(string), string securityAnswer = default(string), string title = default(string), string organization = default(string), byte[] signatureImage = default(byte[]), ControlPanelAuthorityTypeEnum controlPanelAuthorityType = default(ControlPanelAuthorityTypeEnum), bool? viewUnassignedRegUserTransactions = default(bool?), string federatedUsername = default(string), bool? requirePasswordChangeOnFirstUse = default(bool?), string password = default(string), bool? isLockedOut = default(bool?), bool? isExpired = default(bool?), int? passwordChangeInDays = default(int?), List<Object> permissions = default(List<Object>))
        {
            // to ensure "iD" is required (not null)
            if (iD == null)
            {
                throw new InvalidDataException("iD is a required property for UserUpdateModel and cannot be null");
            }
            else
            {
                this.ID = iD;
            }
            // to ensure "prontoID" is required (not null)
            if (prontoID == null)
            {
                throw new InvalidDataException("prontoID is a required property for UserUpdateModel and cannot be null");
            }
            else
            {
                this.ProntoID = prontoID;
            }
            // to ensure "username" is required (not null)
            if (username == null)
            {
                throw new InvalidDataException("username is a required property for UserUpdateModel and cannot be null");
            }
            else
            {
                this.Username = username;
            }
            // to ensure "signingAuthorityType" is required (not null)
            if (signingAuthorityType == null)
            {
                throw new InvalidDataException("signingAuthorityType is a required property for UserUpdateModel and cannot be null");
            }
            else
            {
                this.SigningAuthorityType = signingAuthorityType;
            }
            // to ensure "firstName" is required (not null)
            if (firstName == null)
            {
                throw new InvalidDataException("firstName is a required property for UserUpdateModel and cannot be null");
            }
            else
            {
                this.FirstName = firstName;
            }
            // to ensure "lastName" is required (not null)
            if (lastName == null)
            {
                throw new InvalidDataException("lastName is a required property for UserUpdateModel and cannot be null");
            }
            else
            {
                this.LastName = lastName;
            }
            // to ensure "emailAddress" is required (not null)
            if (emailAddress == null)
            {
                throw new InvalidDataException("emailAddress is a required property for UserUpdateModel and cannot be null");
            }
            else
            {
                this.EmailAddress = emailAddress;
            }
            // to ensure "securityQuestion" is required (not null)
            if (securityQuestion == null)
            {
                throw new InvalidDataException("securityQuestion is a required property for UserUpdateModel and cannot be null");
            }
            else
            {
                this.SecurityQuestion = securityQuestion;
            }
            // to ensure "securityAnswer" is required (not null)
            if (securityAnswer == null)
            {
                throw new InvalidDataException("securityAnswer is a required property for UserUpdateModel and cannot be null");
            }
            else
            {
                this.SecurityAnswer = securityAnswer;
            }
            // to ensure "controlPanelAuthorityType" is required (not null)
            if (controlPanelAuthorityType == null)
            {
                throw new InvalidDataException("controlPanelAuthorityType is a required property for UserUpdateModel and cannot be null");
            }
            else
            {
                this.ControlPanelAuthorityType = controlPanelAuthorityType;
            }
            this.Title = title;
            this.Organization = organization;
            this.SignatureImage = signatureImage;
            this.ViewUnassignedRegUserTransactions = viewUnassignedRegUserTransactions;
            this.FederatedUsername = federatedUsername;
            this.RequirePasswordChangeOnFirstUse = requirePasswordChangeOnFirstUse;
            this.Password = password;
            this.IsLockedOut = isLockedOut;
            this.IsExpired = isExpired;
            this.PasswordChangeInDays = passwordChangeInDays;
            this.Permissions = permissions;
        }
        
        /// <summary>
        /// Gets or Sets ID
        /// </summary>
        [DataMember(Name="ID", EmitDefaultValue=false)]
        public int? ID { get; set; }

        /// <summary>
        /// Gets or Sets ProntoID
        /// </summary>
        [DataMember(Name="ProntoID", EmitDefaultValue=false)]
        public string ProntoID { get; set; }

        /// <summary>
        /// Gets or Sets Username
        /// </summary>
        [DataMember(Name="Username", EmitDefaultValue=false)]
        public string Username { get; set; }


        /// <summary>
        /// Gets or Sets FirstName
        /// </summary>
        [DataMember(Name="FirstName", EmitDefaultValue=false)]
        public string FirstName { get; set; }

        /// <summary>
        /// Gets or Sets LastName
        /// </summary>
        [DataMember(Name="LastName", EmitDefaultValue=false)]
        public string LastName { get; set; }

        /// <summary>
        /// Gets or Sets EmailAddress
        /// </summary>
        [DataMember(Name="EmailAddress", EmitDefaultValue=false)]
        public string EmailAddress { get; set; }

        /// <summary>
        /// Gets or Sets SecurityQuestion
        /// </summary>
        [DataMember(Name="SecurityQuestion", EmitDefaultValue=false)]
        public string SecurityQuestion { get; set; }

        /// <summary>
        /// Gets or Sets SecurityAnswer
        /// </summary>
        [DataMember(Name="SecurityAnswer", EmitDefaultValue=false)]
        public string SecurityAnswer { get; set; }

        /// <summary>
        /// Gets or Sets Title
        /// </summary>
        [DataMember(Name="Title", EmitDefaultValue=false)]
        public string Title { get; set; }

        /// <summary>
        /// Gets or Sets Organization
        /// </summary>
        [DataMember(Name="Organization", EmitDefaultValue=false)]
        public string Organization { get; set; }

        /// <summary>
        /// Gets or Sets SignatureImage
        /// </summary>
        [DataMember(Name="SignatureImage", EmitDefaultValue=false)]
        public byte[] SignatureImage { get; set; }


        /// <summary>
        /// Gets or Sets ViewUnassignedRegUserTransactions
        /// </summary>
        [DataMember(Name="ViewUnassignedRegUserTransactions", EmitDefaultValue=false)]
        public bool? ViewUnassignedRegUserTransactions { get; set; }

        /// <summary>
        /// Gets or Sets FederatedUsername
        /// </summary>
        [DataMember(Name="FederatedUsername", EmitDefaultValue=false)]
        public string FederatedUsername { get; set; }

        /// <summary>
        /// Gets or Sets RequirePasswordChangeOnFirstUse
        /// </summary>
        [DataMember(Name="RequirePasswordChangeOnFirstUse", EmitDefaultValue=false)]
        public bool? RequirePasswordChangeOnFirstUse { get; set; }

        /// <summary>
        /// Gets or Sets Password
        /// </summary>
        [DataMember(Name="Password", EmitDefaultValue=false)]
        public string Password { get; set; }

        /// <summary>
        /// Gets or Sets IsLockedOut
        /// </summary>
        [DataMember(Name="IsLockedOut", EmitDefaultValue=false)]
        public bool? IsLockedOut { get; set; }

        /// <summary>
        /// Gets or Sets IsExpired
        /// </summary>
        [DataMember(Name="IsExpired", EmitDefaultValue=false)]
        public bool? IsExpired { get; set; }

        /// <summary>
        /// Gets or Sets PasswordChangeInDays
        /// </summary>
        [DataMember(Name="PasswordChangeInDays", EmitDefaultValue=false)]
        public int? PasswordChangeInDays { get; set; }

        /// <summary>
        /// Gets or Sets Permissions
        /// </summary>
        [DataMember(Name="Permissions", EmitDefaultValue=false)]
        public List<Object> Permissions { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class UserUpdateModel {\n");
            sb.Append("  ID: ").Append(ID).Append("\n");
            sb.Append("  ProntoID: ").Append(ProntoID).Append("\n");
            sb.Append("  Username: ").Append(Username).Append("\n");
            sb.Append("  SigningAuthorityType: ").Append(SigningAuthorityType).Append("\n");
            sb.Append("  FirstName: ").Append(FirstName).Append("\n");
            sb.Append("  LastName: ").Append(LastName).Append("\n");
            sb.Append("  EmailAddress: ").Append(EmailAddress).Append("\n");
            sb.Append("  SecurityQuestion: ").Append(SecurityQuestion).Append("\n");
            sb.Append("  SecurityAnswer: ").Append(SecurityAnswer).Append("\n");
            sb.Append("  Title: ").Append(Title).Append("\n");
            sb.Append("  Organization: ").Append(Organization).Append("\n");
            sb.Append("  SignatureImage: ").Append(SignatureImage).Append("\n");
            sb.Append("  ControlPanelAuthorityType: ").Append(ControlPanelAuthorityType).Append("\n");
            sb.Append("  ViewUnassignedRegUserTransactions: ").Append(ViewUnassignedRegUserTransactions).Append("\n");
            sb.Append("  FederatedUsername: ").Append(FederatedUsername).Append("\n");
            sb.Append("  RequirePasswordChangeOnFirstUse: ").Append(RequirePasswordChangeOnFirstUse).Append("\n");
            sb.Append("  Password: ").Append(Password).Append("\n");
            sb.Append("  IsLockedOut: ").Append(IsLockedOut).Append("\n");
            sb.Append("  IsExpired: ").Append(IsExpired).Append("\n");
            sb.Append("  PasswordChangeInDays: ").Append(PasswordChangeInDays).Append("\n");
            sb.Append("  Permissions: ").Append(Permissions).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as UserUpdateModel);
        }

        /// <summary>
        /// Returns true if UserUpdateModel instances are equal
        /// </summary>
        /// <param name="input">Instance of UserUpdateModel to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(UserUpdateModel input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.ID == input.ID ||
                    (this.ID != null &&
                    this.ID.Equals(input.ID))
                ) && 
                (
                    this.ProntoID == input.ProntoID ||
                    (this.ProntoID != null &&
                    this.ProntoID.Equals(input.ProntoID))
                ) && 
                (
                    this.Username == input.Username ||
                    (this.Username != null &&
                    this.Username.Equals(input.Username))
                ) && 
                (
                    this.SigningAuthorityType == input.SigningAuthorityType ||
                    (this.SigningAuthorityType != null &&
                    this.SigningAuthorityType.Equals(input.SigningAuthorityType))
                ) && 
                (
                    this.FirstName == input.FirstName ||
                    (this.FirstName != null &&
                    this.FirstName.Equals(input.FirstName))
                ) && 
                (
                    this.LastName == input.LastName ||
                    (this.LastName != null &&
                    this.LastName.Equals(input.LastName))
                ) && 
                (
                    this.EmailAddress == input.EmailAddress ||
                    (this.EmailAddress != null &&
                    this.EmailAddress.Equals(input.EmailAddress))
                ) && 
                (
                    this.SecurityQuestion == input.SecurityQuestion ||
                    (this.SecurityQuestion != null &&
                    this.SecurityQuestion.Equals(input.SecurityQuestion))
                ) && 
                (
                    this.SecurityAnswer == input.SecurityAnswer ||
                    (this.SecurityAnswer != null &&
                    this.SecurityAnswer.Equals(input.SecurityAnswer))
                ) && 
                (
                    this.Title == input.Title ||
                    (this.Title != null &&
                    this.Title.Equals(input.Title))
                ) && 
                (
                    this.Organization == input.Organization ||
                    (this.Organization != null &&
                    this.Organization.Equals(input.Organization))
                ) && 
                (
                    this.SignatureImage == input.SignatureImage ||
                    (this.SignatureImage != null &&
                    this.SignatureImage.Equals(input.SignatureImage))
                ) && 
                (
                    this.ControlPanelAuthorityType == input.ControlPanelAuthorityType ||
                    (this.ControlPanelAuthorityType != null &&
                    this.ControlPanelAuthorityType.Equals(input.ControlPanelAuthorityType))
                ) && 
                (
                    this.ViewUnassignedRegUserTransactions == input.ViewUnassignedRegUserTransactions ||
                    (this.ViewUnassignedRegUserTransactions != null &&
                    this.ViewUnassignedRegUserTransactions.Equals(input.ViewUnassignedRegUserTransactions))
                ) && 
                (
                    this.FederatedUsername == input.FederatedUsername ||
                    (this.FederatedUsername != null &&
                    this.FederatedUsername.Equals(input.FederatedUsername))
                ) && 
                (
                    this.RequirePasswordChangeOnFirstUse == input.RequirePasswordChangeOnFirstUse ||
                    (this.RequirePasswordChangeOnFirstUse != null &&
                    this.RequirePasswordChangeOnFirstUse.Equals(input.RequirePasswordChangeOnFirstUse))
                ) && 
                (
                    this.Password == input.Password ||
                    (this.Password != null &&
                    this.Password.Equals(input.Password))
                ) && 
                (
                    this.IsLockedOut == input.IsLockedOut ||
                    (this.IsLockedOut != null &&
                    this.IsLockedOut.Equals(input.IsLockedOut))
                ) && 
                (
                    this.IsExpired == input.IsExpired ||
                    (this.IsExpired != null &&
                    this.IsExpired.Equals(input.IsExpired))
                ) && 
                (
                    this.PasswordChangeInDays == input.PasswordChangeInDays ||
                    (this.PasswordChangeInDays != null &&
                    this.PasswordChangeInDays.Equals(input.PasswordChangeInDays))
                ) && 
                (
                    this.Permissions == input.Permissions ||
                    this.Permissions != null &&
                    this.Permissions.SequenceEqual(input.Permissions)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.ID != null)
                    hashCode = hashCode * 59 + this.ID.GetHashCode();
                if (this.ProntoID != null)
                    hashCode = hashCode * 59 + this.ProntoID.GetHashCode();
                if (this.Username != null)
                    hashCode = hashCode * 59 + this.Username.GetHashCode();
                if (this.SigningAuthorityType != null)
                    hashCode = hashCode * 59 + this.SigningAuthorityType.GetHashCode();
                if (this.FirstName != null)
                    hashCode = hashCode * 59 + this.FirstName.GetHashCode();
                if (this.LastName != null)
                    hashCode = hashCode * 59 + this.LastName.GetHashCode();
                if (this.EmailAddress != null)
                    hashCode = hashCode * 59 + this.EmailAddress.GetHashCode();
                if (this.SecurityQuestion != null)
                    hashCode = hashCode * 59 + this.SecurityQuestion.GetHashCode();
                if (this.SecurityAnswer != null)
                    hashCode = hashCode * 59 + this.SecurityAnswer.GetHashCode();
                if (this.Title != null)
                    hashCode = hashCode * 59 + this.Title.GetHashCode();
                if (this.Organization != null)
                    hashCode = hashCode * 59 + this.Organization.GetHashCode();
                if (this.SignatureImage != null)
                    hashCode = hashCode * 59 + this.SignatureImage.GetHashCode();
                if (this.ControlPanelAuthorityType != null)
                    hashCode = hashCode * 59 + this.ControlPanelAuthorityType.GetHashCode();
                if (this.ViewUnassignedRegUserTransactions != null)
                    hashCode = hashCode * 59 + this.ViewUnassignedRegUserTransactions.GetHashCode();
                if (this.FederatedUsername != null)
                    hashCode = hashCode * 59 + this.FederatedUsername.GetHashCode();
                if (this.RequirePasswordChangeOnFirstUse != null)
                    hashCode = hashCode * 59 + this.RequirePasswordChangeOnFirstUse.GetHashCode();
                if (this.Password != null)
                    hashCode = hashCode * 59 + this.Password.GetHashCode();
                if (this.IsLockedOut != null)
                    hashCode = hashCode * 59 + this.IsLockedOut.GetHashCode();
                if (this.IsExpired != null)
                    hashCode = hashCode * 59 + this.IsExpired.GetHashCode();
                if (this.PasswordChangeInDays != null)
                    hashCode = hashCode * 59 + this.PasswordChangeInDays.GetHashCode();
                if (this.Permissions != null)
                    hashCode = hashCode * 59 + this.Permissions.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // ProntoID (string) maxLength
            if(this.ProntoID != null && this.ProntoID.Length > 64)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for ProntoID, length must be less than 64.", new [] { "ProntoID" });
            }

            // ProntoID (string) minLength
            if(this.ProntoID != null && this.ProntoID.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for ProntoID, length must be greater than 0.", new [] { "ProntoID" });
            }

            // Username (string) maxLength
            if(this.Username != null && this.Username.Length > 63)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Username, length must be less than 63.", new [] { "Username" });
            }

            // Username (string) minLength
            if(this.Username != null && this.Username.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Username, length must be greater than 0.", new [] { "Username" });
            }

            // FirstName (string) maxLength
            if(this.FirstName != null && this.FirstName.Length > 16)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for FirstName, length must be less than 16.", new [] { "FirstName" });
            }

            // FirstName (string) minLength
            if(this.FirstName != null && this.FirstName.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for FirstName, length must be greater than 0.", new [] { "FirstName" });
            }

            // LastName (string) maxLength
            if(this.LastName != null && this.LastName.Length > 30)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for LastName, length must be less than 30.", new [] { "LastName" });
            }

            // LastName (string) minLength
            if(this.LastName != null && this.LastName.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for LastName, length must be greater than 0.", new [] { "LastName" });
            }

            // EmailAddress (string) maxLength
            if(this.EmailAddress != null && this.EmailAddress.Length > 128)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for EmailAddress, length must be less than 128.", new [] { "EmailAddress" });
            }

            // EmailAddress (string) minLength
            if(this.EmailAddress != null && this.EmailAddress.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for EmailAddress, length must be greater than 0.", new [] { "EmailAddress" });
            }

            // EmailAddress (string) pattern
            Regex regexEmailAddress = new Regex(@"^(?![.])([^@,<>\\^]+@[^\\s<>,\\^]+\\.[^\\s<>,\\^]+)$", RegexOptions.CultureInvariant);
            if (false == regexEmailAddress.Match(this.EmailAddress).Success)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for EmailAddress, must match a pattern of " + regexEmailAddress, new [] { "EmailAddress" });
            }

            // SecurityQuestion (string) maxLength
            if(this.SecurityQuestion != null && this.SecurityQuestion.Length > 256)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for SecurityQuestion, length must be less than 256.", new [] { "SecurityQuestion" });
            }

            // SecurityQuestion (string) minLength
            if(this.SecurityQuestion != null && this.SecurityQuestion.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for SecurityQuestion, length must be greater than 0.", new [] { "SecurityQuestion" });
            }

            // SecurityAnswer (string) maxLength
            if(this.SecurityAnswer != null && this.SecurityAnswer.Length > 256)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for SecurityAnswer, length must be less than 256.", new [] { "SecurityAnswer" });
            }

            // SecurityAnswer (string) minLength
            if(this.SecurityAnswer != null && this.SecurityAnswer.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for SecurityAnswer, length must be greater than 0.", new [] { "SecurityAnswer" });
            }

            // Title (string) maxLength
            if(this.Title != null && this.Title.Length > 64)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Title, length must be less than 64.", new [] { "Title" });
            }

            // Title (string) minLength
            if(this.Title != null && this.Title.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Title, length must be greater than 0.", new [] { "Title" });
            }

            // Organization (string) maxLength
            if(this.Organization != null && this.Organization.Length > 64)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Organization, length must be less than 64.", new [] { "Organization" });
            }

            // Organization (string) minLength
            if(this.Organization != null && this.Organization.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Organization, length must be greater than 0.", new [] { "Organization" });
            }

            // FederatedUsername (string) maxLength
            if(this.FederatedUsername != null && this.FederatedUsername.Length > 150)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for FederatedUsername, length must be less than 150.", new [] { "FederatedUsername" });
            }

            // FederatedUsername (string) minLength
            if(this.FederatedUsername != null && this.FederatedUsername.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for FederatedUsername, length must be greater than 0.", new [] { "FederatedUsername" });
            }

            // Password (string) maxLength
            if(this.Password != null && this.Password.Length > 128)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Password, length must be less than 128.", new [] { "Password" });
            }

            // Password (string) minLength
            if(this.Password != null && this.Password.Length < 0)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Password, length must be greater than 0.", new [] { "Password" });
            }

            yield break;
        }
    }

}
